/* DUPLICATOR-PRO (PHP MULTI-THREADED BUILD MODE) MYSQL SCRIPT CREATED ON : 2020-05-11 02:03:09 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM AUTO_INCREMENT=97 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT 0,
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT 0,
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT 0,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=MyISAM AUTO_INCREMENT=49 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_crp_portfolios` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `corder` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `options` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `extoptions` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_crp_projects` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pid` int(11) NOT NULL,
  `title` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `description` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `url` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `cover` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `pics` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `categories` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `cdate` datetime DEFAULT NULL,
  `details` text COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_duplicator_pro_entities` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(255) DEFAULT NULL,
  `data` text DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type_idx` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_pro_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT 1,
  `link_rating` int(11) NOT NULL DEFAULT 0,
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=MyISAM AUTO_INCREMENT=7864 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM AUTO_INCREMENT=394 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT 0,
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT 0,
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT 0,
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT 0,
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=MyISAM AUTO_INCREMENT=146 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `term_order` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT 0,
  `count` bigint(20) NOT NULL DEFAULT 0,
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT 0,
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=MyISAM AUTO_INCREMENT=55 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT 0,
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


 /* SQL Chunk Header Index 1 */ 

/* INSERT TABLE DATA: wp_commentmeta */
INSERT INTO `wp_commentmeta` VALUES 
("63","48","_wp_trash_meta_status","0"),
("64","48","_wp_trash_meta_time","1589162419"),
("65","47","_wp_trash_meta_status","0"),
("66","47","_wp_trash_meta_time","1589162419"),
("67","46","_wp_trash_meta_status","0"),
("68","46","_wp_trash_meta_time","1589162419"),
("69","45","_wp_trash_meta_status","0"),
("70","45","_wp_trash_meta_time","1589162419"),
("71","44","_wp_trash_meta_status","0"),
("72","44","_wp_trash_meta_time","1589162419"),
("73","43","_wp_trash_meta_status","0"),
("74","43","_wp_trash_meta_time","1589162419"),
("75","42","_wp_trash_meta_status","0"),
("76","42","_wp_trash_meta_time","1589162419"),
("77","41","_wp_trash_meta_status","0"),
("78","41","_wp_trash_meta_time","1589162419"),
("79","40","_wp_trash_meta_status","0"),
("80","40","_wp_trash_meta_time","1589162420"),
("81","39","_wp_trash_meta_status","0"),
("82","39","_wp_trash_meta_time","1589162420"),
("83","38","_wp_trash_meta_status","0"),
("84","38","_wp_trash_meta_time","1589162420"),
("85","37","_wp_trash_meta_status","0"),
("86","37","_wp_trash_meta_time","1589162420"),
("87","36","_wp_trash_meta_status","0"),
("88","36","_wp_trash_meta_time","1589162420"),
("89","35","_wp_trash_meta_status","0"),
("90","35","_wp_trash_meta_time","1589162420"),
("91","34","_wp_trash_meta_status","0"),
("92","34","_wp_trash_meta_time","1589162420"),
("93","33","_wp_trash_meta_status","0"),
("94","33","_wp_trash_meta_time","1589162420"),
("95","32","_wp_trash_meta_status","0"),
("96","32","_wp_trash_meta_time","1589162420");


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES 
("33","2","Ücretsiz Kurumsal Tema – RED &#8211; blogmehmet","","http://blogmehmet.com/2020/01/06/ucretsiz-kurumsal-tema-red/","85.13.147.178","2020-01-06 21:25:56","2020-01-06 18:25:56","[&#8230;] Demo [&#8230;]","0","trash","The Incutio XML-RPC PHP Library -- WordPress/5.3.2","pingback","0","0"),
("34","2","Ücretsiz Kurumsal Tema – RED &#8211; Ücretsiz Scriptler indir php","","https://www.ucretsizscriptlerindir.site/ucretsiz-kurumsal-tema-red","141.98.207.18","2020-01-14 17:29:27","2020-01-14 14:29:27","[&#8230;] Demo [&#8230;]","0","trash","The Incutio XML-RPC PHP Library -- WordPress/5.3.2","pingback","0","0"),
("35","64","SEO Affiliate Program","noreply@exorank.com","https://exorank.com/affiliates.php","207.180.234.123","2020-01-23 08:16:57","2020-01-23 05:16:57","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("36","84","SEO Reseller Program","noreply@exorank.com","https://exorank.com/resellers.php","207.180.234.123","2020-01-25 14:38:02","2020-01-25 11:38:02","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("37","84","SEO Services","noreply@exorank.com","https://exorank.com","207.180.234.123","2020-01-25 17:29:05","2020-01-25 14:29:05","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("38","84","Best SEO Services","noreply@exorank.com","https://exorank.com","207.180.234.123","2020-01-27 15:15:44","2020-01-27 12:15:44","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("39","84","White Label SEO","noreply@exorank.com","https://exorank.com/resellers.php","207.180.234.123","2020-01-28 01:21:37","2020-01-27 22:21:37","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("40","64","SEO Service","noreply@exorank.com","https://exorank.com","207.180.234.123","2020-01-28 05:17:35","2020-01-28 02:17:35","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("41","84","ExoRank","noreply@exorank.com","https://exorank.com","207.180.234.123","2020-01-28 06:11:02","2020-01-28 03:11:02","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("42","84","SEO Referral Program","noreply@exorank.com","https://exorank.com/affiliates.php","207.180.234.123","2020-01-28 12:11:12","2020-01-28 09:11:12","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("43","84","SEO Affiliate","noreply@exorank.com","https://exorank.com/affiliates.php","207.180.234.123","2020-01-29 05:33:48","2020-01-29 02:33:48","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("44","64","Best SEO Company","noreply@exorank.com","https://exorank.com","207.180.234.123","2020-01-30 06:12:34","2020-01-30 03:12:34","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("45","72","MarkCully","markTub@aemail.xyz","http://cialibuy.com","5.188.84.130","2020-01-31 00:50:23","2020-01-30 21:50:23","Progesterone Germany Price Overseas  http://viacialisns.com/#502 - viagra vs cialis Mtabs Viagra  <a href=\"http://viacialisns.com/#812\" rel=\"nofollow\">Cialis</a> How To Buy Pills Online","0","trash","Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36 OPR/53.0.2907.68","","0","0"),
("46","84","SEO Reseller","noreply@exorank.com","https://exorank.com/resellers.php","207.180.234.123","2020-01-31 04:10:49","2020-01-31 01:10:49","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("47","82","Best SEO Company","noreply@exorank.com","https://exorank.com","207.180.234.123","2020-01-31 22:58:05","2020-01-31 19:58:05","Awesome post! Keep up the great work! :)","0","trash","ExoRank","","0","0"),
("32","2","Ücretsiz Kurumsal Tema – RED - HellorDTV - Kişisel Blog - Php Script - Torrent Oyun","","https://hellordtv.com/ucretsiz-kurumsal-tema-red/","176.53.69.2","2019-04-20 19:52:10","2019-04-20 16:52:10","[&#8230;] Demo İndir [&#8230;]","0","trash","The Incutio XML-RPC PHP Library -- WordPress/5.1.1","pingback","0","0"),
("48","1","StevTult","stevtwep@belan.space","https://cheapcialisir.com","5.188.84.76","2020-04-23 20:23:50","2020-04-23 17:23:50","Can I Purchase Bentyl Pills Ups Cod Only  https://cheapcialisir.com/# - generic cialis Viagra E Mal Di Schiena  <a href=\"https://cheapcialisir.com/#\" rel=\"nofollow\">Cialis</a> Virgra For Men","0","trash","Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36 OPR/54.0.2952.64","","0","0");


/* INSERT TABLE DATA: wp_crp_portfolios */
INSERT INTO `wp_crp_portfolios` VALUES 
("1","REFERANSLAR","6,5,4,3,2,1",NULL,"{\"type\":\"gallery\"}"),
("2","REFERANSLAR","8,7",NULL,"{\"type\":\"album\"}");


/* INSERT TABLE DATA: wp_crp_projects */
INSERT INTO `wp_crp_projects` VALUES 
("1","1","","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsSA=","http://www.wordpresstema.com","eyJpZCI6OTYsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNy0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","eyJpZCI6OTYsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNy0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","",NULL,"\"\""),
("2","1","UmVmZXJhbnMgxLBzbWk=","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsSA=","http://www.wordpresstema.com","eyJpZCI6OTMsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNC0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","eyJpZCI6OTMsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNC0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","",NULL,"\"\""),
("3","1","UmVmZXJhbnMgxLBzbWk=","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsSA=","http://www.wordpresstema.com","eyJpZCI6OTQsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNS0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","eyJpZCI6OTQsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNS0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","",NULL,"\"\""),
("4","1","UmVmZXJhbnMgxLBzbWk=","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsSA=","http://www.wordpresstema.com","eyJpZCI6OTUsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNi0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","eyJpZCI6OTUsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNi0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","",NULL,"\"\""),
("5","1","UmVmZXJhbnMgxLBzbWk=","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsSA=","http://www.wordpresstema.com","eyJpZCI6OTEsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GMi0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","eyJpZCI6OTEsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GMi0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","",NULL,"\"\""),
("6","1","UmVmZXJhbnMgxLBzbWk=","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsSA=","http://www.wordpresstema.com","eyJpZCI6OTIsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GMy0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","eyJpZCI6OTIsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GMy0zMDB4MjAwLmpwZyIsInR5cGUiOiJwaWMifQ==","",NULL,"\"\""),
("7","2","UmVmZXJhbnMgMQ==","UmVmZXJhbnMgYcOnxLFrbGFtYXPEsQ==","","eyJpZCI6OTYsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNy0zMDB4MjAwLmpwZyJ9","eyJpZCI6OTQsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNS0zMDB4MjAwLmpwZyJ9,eyJpZCI6OTMsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNC0zMDB4MjAwLmpwZyJ9,eyJpZCI6ODYsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9vcm5la2stMzAweDIwMC5qcGcifQ==","",NULL,"\"\""),
("8","2","UmVmZXJhbnMgMg==","UmVmZXJhbnMgQcOnxLFrbGFtYXPEsQ==","","eyJpZCI6OTEsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GMi0zMDB4MjAwLmpwZyJ9","eyJpZCI6OTEsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GMi0zMDB4MjAwLmpwZyJ9,eyJpZCI6OTUsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNi0zMDB4MjAwLmpwZyJ9,eyJpZCI6OTQsInNyYyI6Imh0dHA6Ly91Y3JldHNpei53b3JkcHJlc3N0ZW1hLmNvbS90ZXN0MS93cC1jb250ZW50L3VwbG9hZHMvMjAxOC8wOS9GNS0zMDB4MjAwLmpwZyJ9","",NULL,"\"\"");


/* INSERT TABLE DATA: wp_duplicator_pro_entities */
INSERT INTO `wp_duplicator_pro_entities` VALUES 
("1","DUP_PRO_Global_Entity","{\n    \"uninstall_settings\": false,\n    \"uninstall_packages\": false,\n    \"uninstall_tables\": true,\n    \"crypt\": true,\n    \"wpfront_integrate\": false,\n    \"package_ui_created\": 1,\n    \"package_mysqldump\": false,\n    \"package_mysqldump_path\": \"\",\n    \"package_phpdump_mode\": 0,\n    \"package_phpdump_qrylimit\": 500,\n    \"package_php_chunking\": null,\n    \"package_mysqldump_qrylimit\": 131072,\n    \"archive_build_mode\": 1,\n    \"archive_compression\": true,\n    \"ziparchive_validation\": false,\n    \"ziparchive_mode\": 0,\n    \"ziparchive_chunk_size_in_mb\": 6,\n    \"archive_build_mode_schedule\": -1,\n    \"archive_compression_schedule\": true,\n    \"server_load_reduction\": 0,\n    \"max_package_runtime_in_min\": 90,\n    \"php_max_worker_time_in_sec\": 18,\n    \"lock_mode\": 1,\n    \"json_mode\": 0,\n    \"ajax_protocol\": \"https\",\n    \"custom_ajax_url\": \"http:\\/\\/ucretsiz.wordpresstema.com\\/test1\\/wp-admin\\/admin-ajax.php\",\n    \"server_kick_off_sslverify\": true,\n    \"clientside_kickoff\": false,\n    \"basic_auth_enabled\": false,\n    \"basic_auth_user\": \"\",\n    \"basic_auth_password\": \"\",\n    \"installer_base_name\": \"installer.php\",\n    \"chunk_size\": 2048,\n    \"skip_archive_scan\": false,\n    \"send_email_on_build_mode\": 1,\n    \"notification_email_address\": \"\",\n    \"storage_htaccess_off\": false,\n    \"max_storage_retries\": 10,\n    \"max_default_store_files\": 20,\n    \"purge_default_package_record\": false,\n    \"dropbox_upload_chunksize_in_kb\": 2000,\n    \"dropbox_transfer_mode\": 1,\n    \"gdrive_upload_chunksize_in_kb\": 1000,\n    \"s3_upload_part_size_in_kb\": 6000,\n    \"manual_mode_storage_ids\": [\n        \"-2\"\n    ],\n    \"license_status\": 0,\n    \"license_expiration_time\": 1589162515,\n    \"license_no_activations_left\": false,\n    \"license_key_visible\": true,\n    \"lkp\": \"\",\n    \"license_limit\": -1,\n    \"last_edd_api_response\": null,\n    \"last_edd_api_timestamp\": 0,\n    \"last_system_check_timestamp\": 1589162526,\n    \"initial_activation_timestamp\": 1589162526,\n    \"ssl_useservercerts\": true,\n    \"ssl_disableverify\": true,\n    \"ipv4_only\": false,\n    \"debug_on\": false,\n    \"trace_profiler_on\": false,\n    \"unhook_third_party_js\": false,\n    \"unhook_third_party_css\": false,\n    \"profile_idea\": false,\n    \"profile_beta\": false,\n    \"dupHidePackagesGiftFeatures\": true,\n    \"type\": \"DUP_PRO_Global_Entity\",\n    \"notices\": {\n        \"dupArchiveSwitch\": true\n    }\n}"),
("2","DUP_PRO_Secure_Global_Entity","{\n    \"basic_auth_password\": null,\n    \"lkp\": \"\",\n    \"type\": \"DUP_PRO_Secure_Global_Entity\"\n}"),
("3","DUP_PRO_System_Global_Entity","{\n    \"recommended_fixes\": [],\n    \"schedule_failed\": false,\n    \"package_check_ts\": 1589162586,\n    \"type\": \"DUP_PRO_System_Global_Entity\"\n}"),
("4","DUP_PRO_Package_Template_Entity","{\"name\":\"Default\",\"notes\":\"The default template.\",\"filter_sites\":[],\"archive_export_onlydb\":0,\"archive_filter_on\":0,\"archive_filter_dirs\":\"\",\"archive_filter_exts\":\"\",\"archive_filter_files\":\"\",\"database_filter_on\":0,\"database_filter_tables\":\"\",\"database_compatibility_modes\":[],\"installer_opts_secure_on\":null,\"installer_opts_secure_pass\":null,\"installer_opts_skip_scan\":null,\"installer_opts_db_host\":null,\"installer_opts_db_name\":null,\"installer_opts_db_user\":null,\"installer_opts_cpnl_enable\":false,\"installer_opts_cpnl_host\":\"\",\"installer_opts_cpnl_user\":\"\",\"installer_opts_cpnl_pass\":\"\",\"installer_opts_cpnl_db_action\":\"create\",\"installer_opts_cpnl_db_host\":\"\",\"installer_opts_cpnl_db_name\":\"\",\"installer_opts_cpnl_db_user\":\"\",\"installer_opts_brand\":-2,\"is_default\":true,\"is_manual\":false,\"type\":\"DUP_PRO_Package_Template_Entity\"}"),
("5","DUP_PRO_Package_Template_Entity","{\n    \"name\": \"[Manual Mode]\",\n    \"notes\": \"The default template.\",\n    \"filter_sites\": \"\",\n    \"archive_export_onlydb\": 0,\n    \"archive_filter_on\": 0,\n    \"archive_filter_dirs\": \"\",\n    \"archive_filter_exts\": \"\",\n    \"archive_filter_files\": \"\",\n    \"database_filter_on\": 0,\n    \"database_filter_tables\": \"\",\n    \"database_compatibility_modes\": \"\",\n    \"installer_opts_secure_on\": 0,\n    \"installer_opts_secure_pass\": \"\",\n    \"installer_opts_skip_scan\": 0,\n    \"installer_opts_db_host\": \"\",\n    \"installer_opts_db_name\": \"\",\n    \"installer_opts_db_user\": \"\",\n    \"installer_opts_cpnl_enable\": 0,\n    \"installer_opts_cpnl_host\": \"\",\n    \"installer_opts_cpnl_user\": \"\",\n    \"installer_opts_cpnl_pass\": \"\",\n    \"installer_opts_cpnl_db_action\": \"create\",\n    \"installer_opts_cpnl_db_host\": \"\",\n    \"installer_opts_cpnl_db_name\": \"\",\n    \"installer_opts_cpnl_db_user\": \"\",\n    \"installer_opts_brand\": -2,\n    \"is_default\": false,\n    \"is_manual\": true,\n    \"type\": \"DUP_PRO_Package_Template_Entity\"\n}");


/* INSERT TABLE DATA: wp_duplicator_pro_packages */
INSERT INTO `wp_duplicator_pro_packages` VALUES 
("1","kurumsaltema","5fb33fb72f3c4dd74632_20200511020255","22","2020-05-11 05:03:05","wordpresstema","{\n    \"Created\": \"2020-05-11 02:02:55\",\n    \"Version\": \"3.8.6.2\",\n    \"VersionWP\": \"5.4.1\",\n    \"VersionDB\": \"10.2.31\",\n    \"VersionPHP\": \"7.4.5\",\n    \"VersionOS\": \"Linux\",\n    \"ID\": 1,\n    \"Name\": \"kurumsaltema\",\n    \"Hash\": \"5fb33fb72f3c4dd74632_20200511020255\",\n    \"NameHash\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255\",\n    \"Type\": 0,\n    \"Notes\": \"The default template.\",\n    \"StorePath\": \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\\/tmp\",\n    \"StoreURL\": \"https:\\/\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\\/\",\n    \"ScanFile\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255_scan.json\",\n    \"timer_start\": 1589162587.391459,\n    \"Runtime\": null,\n    \"ExeSize\": null,\n    \"ZipSize\": 0,\n    \"Brand\": \"Default\",\n    \"Brand_ID\": -2,\n    \"ziparchive_mode\": 0,\n    \"Archive\": {\n        \"ExportOnlyDB\": 0,\n        \"FilterDirs\": \"\",\n        \"FilterExts\": \"\",\n        \"FilterFiles\": \"\",\n        \"FilterDirsAll\": [\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/.opcache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/.tmb\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/ai1wm-backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backupwordpress\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/content\\/cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/contents\\/cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/infinitewp\\/backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/managewp\\/backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/old-cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/plugins\\/wordfence\\/tmp\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/updraft\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/aiowps_backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/backup-guard\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/backupbuddy_backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/backupbuddy_temp\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/mainwp\\/backup\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/pb_backupbuddy\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/snapshots\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/sucuri\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/wp-clone\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/wp_all_backup\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/wpbackitup_backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/wfcache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/wishlist-backup\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-snapshots\"\n        ],\n        \"FilterExtsAll\": [],\n        \"FilterFilesAll\": [\n            \".DS_Store\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/.htaccess\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-config.php\",\n            \"dbcache\",\n            \"debug_log\",\n            \"error.log\",\n            \"error_log\",\n            \"objectcache\",\n            \"pgcache\",\n            \"ws_ftp.log\"\n        ],\n        \"FilterOn\": 0,\n        \"File\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255_archive.zip\",\n        \"Format\": \"ZIP\",\n        \"PackDir\": \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\",\n        \"Size\": 89759696,\n        \"Dirs\": null,\n        \"DirCount\": 632,\n        \"RecursiveLinks\": [],\n        \"Files\": null,\n        \"FileCount\": 4140,\n        \"file_count\": -1,\n        \"FilterInfo\": {\n            \"Dirs\": {\n                \"Warning\": [],\n                \"Unreadable\": [],\n                \"AddonSites\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": []\n            },\n            \"Files\": {\n                \"Warning\": [],\n                \"Unreadable\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": []\n            },\n            \"Exts\": {\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": []\n            },\n            \"TreeSize\": null,\n            \"TreeWarning\": null\n        },\n        \"ListDelimiter\": \"\\n\",\n        \"throttleDelayInUs\": 0\n    },\n    \"Multisite\": {\n        \"FilterSites\": \"\"\n    },\n    \"Installer\": {\n        \"File\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255_installer.php\",\n        \"Size\": 0,\n        \"OptsSecureOn\": 0,\n        \"OptsSecurePass\": \"\",\n        \"OptsSkipScan\": 0,\n        \"OptsDBHost\": \"\",\n        \"OptsDBName\": \"\",\n        \"OptsDBUser\": \"\",\n        \"OptsCPNLHost\": \"\",\n        \"OptsCPNLUser\": \"\",\n        \"OptsCPNLPass\": \"\",\n        \"OptsCPNLEnable\": 0,\n        \"OptsCPNLConnect\": false,\n        \"OptsCPNLDBAction\": \"create\",\n        \"OptsCPNLDBHost\": \"\",\n        \"OptsCPNLDBName\": \"\",\n        \"OptsCPNLDBUser\": \"\",\n        \"numFilesAdded\": 0,\n        \"numDirsAdded\": 0\n    },\n    \"Database\": {\n        \"info\": {\n            \"buildMode\": \"PHPCHUNKING\",\n            \"charSetList\": [\n                \"utf8mb4\",\n                \"utf8\"\n            ],\n            \"collationList\": [\n                \"utf8mb4_unicode_520_ci\",\n                \"utf8_general_ci\"\n            ],\n            \"isTablesUpperCase\": 0,\n            \"isNameUpperCase\": 0,\n            \"name\": \"wordpres_ucr1\",\n            \"tablesBaseCount\": 16,\n            \"tablesFinalCount\": 16,\n            \"tablesRowCount\": 730,\n            \"tablesSizeOnDisk\": 875793,\n            \"tablesList\": {\n                \"wp_commentmeta\": {\n                    \"rows\": \"34\",\n                    \"size\": 12008\n                },\n                \"wp_comments\": {\n                    \"rows\": \"17\",\n                    \"size\": 11132\n                },\n                \"wp_crp_portfolios\": {\n                    \"rows\": \"2\",\n                    \"size\": 16384\n                },\n                \"wp_crp_projects\": {\n                    \"rows\": \"8\",\n                    \"size\": 16384\n                },\n                \"wp_duplicator_pro_entities\": {\n                    \"rows\": \"5\",\n                    \"size\": 32768\n                },\n                \"wp_duplicator_pro_packages\": {\n                    \"rows\": \"0\",\n                    \"size\": 32768\n                },\n                \"wp_links\": {\n                    \"rows\": \"0\",\n                    \"size\": 1024\n                },\n                \"wp_options\": {\n                    \"rows\": \"184\",\n                    \"size\": 513116\n                },\n                \"wp_postmeta\": {\n                    \"rows\": \"280\",\n                    \"size\": 81240\n                },\n                \"wp_posts\": {\n                    \"rows\": \"109\",\n                    \"size\": 110356\n                },\n                \"wp_term_relationships\": {\n                    \"rows\": \"41\",\n                    \"size\": 3933\n                },\n                \"wp_term_taxonomy\": {\n                    \"rows\": \"13\",\n                    \"size\": 4632\n                },\n                \"wp_termmeta\": {\n                    \"rows\": \"0\",\n                    \"size\": 4096\n                },\n                \"wp_terms\": {\n                    \"rows\": \"13\",\n                    \"size\": 13792\n                },\n                \"wp_usermeta\": {\n                    \"rows\": \"23\",\n                    \"size\": 13684\n                },\n                \"wp_users\": {\n                    \"rows\": \"1\",\n                    \"size\": 8476\n                }\n            },\n            \"varLowerCaseTables\": \"0\",\n            \"version\": \"10.2.31\",\n            \"versionComment\": \"MariaDB Server\",\n            \"tableWiseRowCounts\": {\n                \"wp_commentmeta\": \"34\",\n                \"wp_comments\": \"17\",\n                \"wp_crp_portfolios\": \"2\",\n                \"wp_crp_projects\": \"8\",\n                \"wp_duplicator_pro_entities\": \"5\",\n                \"wp_duplicator_pro_packages\": \"1\"\n            }\n        },\n        \"Type\": \"MySQL\",\n        \"Size\": null,\n        \"File\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255_database.sql\",\n        \"FilterTables\": \"\",\n        \"FilterOn\": 0,\n        \"DBMode\": \"PHPCHUNKING\",\n        \"Compatible\": \"\",\n        \"Comments\": \"MariaDB Server\",\n        \"dbStorePathPublic\": \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\\/tmp\\/kurumsaltema_5fb33fb72f3c4dd74632_20200511020255_database.sql\",\n        \"sameNameTableExists\": false,\n        \"indexProcessedSchemaSize\": [\n            0,\n            12008,\n            23140,\n            39524,\n            55908,\n            88676\n        ],\n        \"intFieldsStruct\": {\n            \"wp_commentmeta\": {\n                \"meta_id\": \"NULL\",\n                \"comment_id\": \"0\"\n            },\n            \"wp_comments\": {\n                \"comment_ID\": \"NULL\",\n                \"comment_post_ID\": \"0\",\n                \"comment_karma\": \"0\",\n                \"comment_parent\": \"0\",\n                \"user_id\": \"0\"\n            },\n            \"wp_crp_portfolios\": {\n                \"id\": \"NULL\"\n            },\n            \"wp_crp_projects\": {\n                \"id\": \"NULL\",\n                \"pid\": \"NULL\"\n            },\n            \"wp_duplicator_pro_entities\": {\n                \"id\": \"NULL\"\n            }\n        }\n    },\n    \"Status\": \"21.9\",\n    \"schedule_id\": -1,\n    \"build_progress\": {\n        \"thread_start_time\": 1589162590,\n        \"initialized\": true,\n        \"installer_built\": false,\n        \"archive_started\": false,\n        \"archive_has_database\": false,\n        \"archive_built\": false,\n        \"database_script_built\": false,\n        \"failed\": false,\n        \"next_archive_file_index\": 0,\n        \"next_archive_dir_index\": 0,\n        \"retries\": 0,\n        \"current_build_mode\": 1,\n        \"current_build_compression\": true,\n        \"custom_data\": null,\n        \"warnings\": []\n    },\n    \"db_build_progress\": {\n        \"tableIndex\": 0,\n        \"tableOffset\": 0,\n        \"totalRowOffset\": 0,\n        \"chunkIndex\": null,\n        \"validationStage1\": false,\n        \"bulkOffset\": 0,\n        \"bulkSizeOffset\": 0,\n        \"doneInit\": true,\n        \"doneFiltering\": true,\n        \"doneCreates\": true,\n        \"completed\": false,\n        \"tablesToProcess\": [\n            \"wp_commentmeta\",\n            \"wp_comments\",\n            \"wp_crp_portfolios\",\n            \"wp_crp_projects\",\n            \"wp_duplicator_pro_entities\",\n            \"wp_duplicator_pro_packages\",\n            \"wp_links\",\n            \"wp_options\",\n            \"wp_postmeta\",\n            \"wp_posts\",\n            \"wp_term_relationships\",\n            \"wp_term_taxonomy\",\n            \"wp_termmeta\",\n            \"wp_terms\",\n            \"wp_usermeta\",\n            \"wp_users\"\n        ],\n        \"startTime\": 1589162587.517468,\n        \"fileOffset\": 11204,\n        \"wasInterrupted\": true,\n        \"errorOut\": false,\n        \"failureCount\": 0,\n        \"totalSchemaSize\": 882009,\n        \"tablesSchemaSizes\": {\n            \"wp_commentmeta\": 12008,\n            \"wp_comments\": 11132,\n            \"wp_crp_portfolios\": 16384,\n            \"wp_crp_projects\": 16384,\n            \"wp_duplicator_pro_entities\": 32768,\n            \"wp_duplicator_pro_packages\": 32768,\n            \"wp_links\": 1024,\n            \"wp_options\": 519332,\n            \"wp_postmeta\": 81240,\n            \"wp_posts\": 110356,\n            \"wp_term_relationships\": 3933,\n            \"wp_term_taxonomy\": 4632,\n            \"wp_termmeta\": 4096,\n            \"wp_terms\": 13792,\n            \"wp_usermeta\": 13684,\n            \"wp_users\": 8476\n        }\n    },\n    \"upload_infos\": [\n        {\n            \"storage_id\": \"-2\",\n            \"archive_offset\": 0,\n            \"copied_installer\": false,\n            \"copied_archive\": false,\n            \"progress\": 0,\n            \"num_failures\": 0,\n            \"failed\": false,\n            \"cancelled\": false,\n            \"upload_id\": null,\n            \"failure_count\": 0,\n            \"data\": \"\",\n            \"data2\": \"\",\n            \"has_started\": false,\n            \"status_message_details\": \"\",\n            \"started_timestamp\": null,\n            \"stopped_timestamp\": null\n        }\n    ],\n    \"active_storage_id\": -1,\n    \"template_id\": 4\n}");


/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES 
("1","siteurl","http://ucretsiz.wordpresstema.com/test1","yes"),
("2","home","http://ucretsiz.wordpresstema.com/test1","yes"),
("3","blogname","Ücretsiz Wordpress Tema Demo Sitesi","yes"),
("4","blogdescription","Bir başka WordPress sitesi","yes"),
("5","users_can_register","0","yes"),
("6","admin_email","ucretsiz@wordpresstema.com","yes"),
("7","start_of_week","1","yes"),
("8","use_balanceTags","0","yes"),
("9","use_smilies","1","yes"),
("10","require_name_email","1","yes"),
("11","comments_notify","1","yes"),
("12","posts_per_rss","10","yes"),
("13","rss_use_excerpt","0","yes"),
("14","mailserver_url","mail.example.com","yes"),
("15","mailserver_login","login@example.com","yes"),
("16","mailserver_pass","password","yes"),
("17","mailserver_port","110","yes"),
("18","default_category","1","yes"),
("19","default_comment_status","open","yes"),
("20","default_ping_status","open","yes"),
("21","default_pingback_flag","1","yes"),
("22","posts_per_page","10","yes"),
("23","date_format","j F Y","yes"),
("24","time_format","H:i","yes"),
("25","links_updated_date_format","j F Y H:i","yes"),
("26","comment_moderation","0","yes"),
("27","moderation_notify","1","yes"),
("28","permalink_structure","/%year%/%monthnum%/%day%/%postname%/","yes"),
("29","rewrite_rules","a:107:{s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:42:\"wpos_portfolio/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:52:\"wpos_portfolio/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:72:\"wpos_portfolio/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:67:\"wpos_portfolio/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:67:\"wpos_portfolio/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:48:\"wpos_portfolio/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:31:\"wpos_portfolio/([^/]+)/embed/?$\";s:62:\"index.php?post_type=wpos_portfolio&name=$matches[1]&embed=true\";s:35:\"wpos_portfolio/([^/]+)/trackback/?$\";s:56:\"index.php?post_type=wpos_portfolio&name=$matches[1]&tb=1\";s:43:\"wpos_portfolio/([^/]+)/page/?([0-9]{1,})/?$\";s:69:\"index.php?post_type=wpos_portfolio&name=$matches[1]&paged=$matches[2]\";s:50:\"wpos_portfolio/([^/]+)/comment-page-([0-9]{1,})/?$\";s:69:\"index.php?post_type=wpos_portfolio&name=$matches[1]&cpage=$matches[2]\";s:39:\"wpos_portfolio/([^/]+)(?:/([0-9]+))?/?$\";s:68:\"index.php?post_type=wpos_portfolio&name=$matches[1]&page=$matches[2]\";s:31:\"wpos_portfolio/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\"wpos_portfolio/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\"wpos_portfolio/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"wpos_portfolio/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"wpos_portfolio/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:37:\"wpos_portfolio/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:38:\"index.php?&page_id=2&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:53:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/embed/?$\";s:91:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:61:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(?:/([0-9]+))?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:53:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}","yes"),
("30","hack_file","0","yes"),
("31","blog_charset","UTF-8","yes"),
("32","moderation_keys","","no"),
("33","active_plugins","a:9:{i:0;s:35:\"redux-framework/redux-framework.php\";i:1;s:36:\"contact-form-7/wp-contact-form-7.php\";i:2;s:53:\"customizer-export-import/customizer-export-import.php\";i:3;s:33:\"duplicator-pro/duplicator-pro.php\";i:4;s:47:\"one-click-demo-import/one-click-demo-import.php\";i:5;s:49:\"portfolio-and-projects/portfolio-and-projects.php\";i:6;s:24:\"simple-lightbox/main.php\";i:7;s:53:\"widget-importer-exporter/widget-importer-exporter.php\";i:8;s:35:\"wp-fastest-cache/wpFastestCache.php\";}","yes"),
("34","category_base","","yes"),
("35","ping_sites","http://rpc.pingomatic.com/","yes"),
("36","comment_max_links","2","yes"),
("37","gmt_offset","0","yes"),
("38","default_email_category","1","yes"),
("39","recently_edited","a:2:{i:0;s:91:\"/home/wordpresstema/ucretsiz.wordpresstema.com/test1/wp-content/plugins/akismet/akismet.php\";i:1;s:0:\"\";}","no"),
("40","template","Ucretsiz-WT-discovery","yes"),
("41","stylesheet","Ucretsiz-WT-discovery","yes"),
("42","comment_whitelist","1","yes"),
("43","blacklist_keys","","no"),
("44","comment_registration","0","yes"),
("45","html_type","text/html","yes"),
("46","use_trackback","0","yes"),
("47","default_role","subscriber","yes"),
("48","db_version","47018","yes"),
("49","uploads_use_yearmonth_folders","1","yes"),
("50","upload_path","","yes"),
("51","blog_public","1","yes"),
("52","default_link_category","2","yes"),
("53","show_on_front","page","yes"),
("54","tag_base","","yes"),
("55","show_avatars","1","yes"),
("56","avatar_rating","G","yes"),
("57","upload_url_path","","yes"),
("58","thumbnail_size_w","150","yes"),
("59","thumbnail_size_h","150","yes"),
("60","thumbnail_crop","1","yes"),
("61","medium_size_w","300","yes"),
("62","medium_size_h","300","yes"),
("63","avatar_default","mystery","yes"),
("64","large_size_w","1024","yes"),
("65","large_size_h","1024","yes"),
("66","image_default_link_type","none","yes"),
("67","image_default_size","","yes"),
("68","image_default_align","","yes"),
("69","close_comments_for_old_posts","0","yes"),
("70","close_comments_days_old","14","yes"),
("71","thread_comments","1","yes"),
("72","thread_comments_depth","5","yes"),
("73","page_comments","0","yes"),
("74","comments_per_page","50","yes"),
("75","default_comments_page","newest","yes"),
("76","comment_order","asc","yes"),
("77","sticky_posts","a:0:{}","yes"),
("78","widget_categories","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("79","widget_text","a:4:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;i:3;a:4:{s:5:\"title\";s:15:\"FİRMA HAKKINDA\";s:4:\"text\";s:204:\"\r\nFirmamız hizmet alanları ile kurumsal destek hizmetleri sunmaktayız. Lorem ipsum örnek metin alanı ile wordpress tema önizlemelerinde gerçekçi içerik efekti oluşturmanıza yardımcı oluyoruz.\";s:6:\"filter\";b:1;s:6:\"visual\";b:1;}i:4;a:4:{s:5:\"title\";s:12:\"Footer Metni\";s:4:\"text\";s:202:\"Firmamız hizmet alanları ile kurumsal destek hizmetleri sunmaktayız. Lorem ipsum örnek metin alanı ile wordpress tema önizlemelerinde gerçekçi içerik efekti oluşturmanıza yardımcı oluyoruz.\";s:6:\"filter\";b:1;s:6:\"visual\";b:1;}}","yes"),
("80","widget_rss","a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}","yes"),
("81","uninstall_plugins","a:1:{s:29:\"portfolio-wp/portfolio-wp.php\";s:18:\"crp_uninstall_hook\";}","no"),
("82","timezone_string","Europe/Istanbul","yes"),
("83","page_for_posts","0","yes"),
("84","page_on_front","2","yes"),
("85","default_post_format","0","yes"),
("86","link_manager_enabled","0","yes"),
("87","finished_splitting_shared_terms","1","yes"),
("88","site_icon","47","yes"),
("89","medium_large_size_w","768","yes"),
("90","medium_large_size_h","0","yes"),
("91","wp_page_for_privacy_policy","3","yes"),
("92","show_comments_cookies_opt_in","0","yes"),
("93","initial_db_version","38590","yes"),
("94","wp_user_roles","a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:61:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}","yes"),
("95","fresh_site","0","yes"),
("96","WPLANG","tr_TR","yes"),
("97","widget_search","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("98","widget_recent-posts","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("99","widget_recent-comments","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("100","widget_archives","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("101","widget_meta","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("102","sidebars_widgets","a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:1:{i:0;s:15:\"media_gallery-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:11:\"left_column\";a:1:{i:0;s:6:\"text-3\";}s:13:\"center_column\";a:1:{i:0;s:6:\"text-4\";}s:12:\"right_column\";a:1:{i:0;s:10:\"nav_menu-3\";}s:13:\"array_version\";i:3;}","yes"),
("103","widget_pages","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("104","widget_calendar","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("105","widget_media_audio","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("106","widget_media_image","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("107","widget_media_gallery","a:2:{i:2;a:6:{s:5:\"title\";s:0:\"\";s:7:\"columns\";i:1;s:4:\"size\";s:9:\"thumbnail\";s:9:\"link_type\";s:4:\"none\";s:14:\"orderby_random\";b:1;s:3:\"ids\";a:7:{i:0;i:96;i:1;i:93;i:2;i:94;i:3;i:95;i:4;i:91;i:5;i:92;i:6;i:79;}}s:12:\"_multiwidget\";i:1;}","yes"),
("108","widget_media_video","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("109","nonce_key","d$fC7;~]*;uB >2|5nv(vx|^fS:X^>j5Pi-Uz5fj<}@xx}<]!CnEs^}>4]lApHDb","no"),
("110","nonce_salt","M{fI:qgnF~B8(v[{k7%v;Ao5P|R<km2A:5rnvYDu_eI|lf87 Z2_]6l<QJ<Ec0qY","no"),
("111","widget_tag_cloud","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("112","widget_nav_menu","a:2:{s:12:\"_multiwidget\";i:1;i:3;a:2:{s:5:\"title\";s:13:\"Bağlantılar\";s:8:\"nav_menu\";i:3;}}","yes"),
("113","widget_custom_html","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("114","cron","a:6:{i:1589165119;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1589193919;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1589237402;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1589238666;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1589248654;a:2:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}","yes"),
("115","theme_mods_twentyseventeen","a:2:{s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1536015296;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}","yes"),
("125","auth_key","P08lPo9(Gu.GN{<@?k&^W=d]:K9 ._/J^o#n<$g_f5Ojen1/n8w5b=c-})FgO`W6","no"),
("258","slb_version","2.7.0","yes"),
("259","slb_options","a:27:{s:7:\"enabled\";b:1;s:12:\"enabled_home\";b:1;s:12:\"enabled_post\";b:1;s:12:\"enabled_page\";b:1;s:15:\"enabled_archive\";b:1;s:14:\"enabled_widget\";b:0;s:12:\"enabled_menu\";b:0;s:11:\"group_links\";b:1;s:10:\"group_post\";b:1;s:13:\"group_gallery\";b:0;s:12:\"group_widget\";b:0;s:10:\"group_menu\";b:0;s:10:\"ui_autofit\";b:1;s:10:\"ui_animate\";b:1;s:19:\"slideshow_autostart\";b:1;s:18:\"slideshow_duration\";s:1:\"6\";s:10:\"group_loop\";b:1;s:18:\"ui_overlay_opacity\";s:3:\"0.8\";s:16:\"ui_title_default\";b:0;s:11:\"txt_loading\";s:7:\"Loading\";s:9:\"txt_close\";s:5:\"Close\";s:12:\"txt_nav_next\";s:4:\"Next\";s:12:\"txt_nav_prev\";s:8:\"Previous\";s:19:\"txt_slideshow_start\";s:15:\"Start slideshow\";s:18:\"txt_slideshow_stop\";s:14:\"Stop slideshow\";s:16:\"txt_group_status\";s:25:\"Item %current% of %total%\";s:13:\"theme_default\";s:11:\"slb_default\";}","yes"),
("249","wpcf7","a:2:{s:7:\"version\";s:5:\"5.1.7\";s:13:\"bulk_validate\";a:4:{s:9:\"timestamp\";d:1536029412;s:7:\"version\";s:5:\"5.0.3\";s:11:\"count_valid\";i:1;s:13:\"count_invalid\";i:0;}}","yes"),
("270","cf7_style_no_temps","show_box","yes"),
("126","auth_salt","P=Mxc>9wt*yOEqw/-Xd G{)(4r#shd5wYXSn;*s-Xi(<.K(;U*YV)b#t~_,N#3&c","no"),
("127","logged_in_key","R09[|D7!#GN4,),;r[R(1_CX~6$I4]|LMq)9t2Kz9.3HDR)4n~;}=>=+4vFBIb#c","no"),
("128","logged_in_salt","i}7~bR^HFhEF0[60i8U4hRf`DAM%Km4;v%qjeQ)r`R3c}b~&NUOkuzHdM79ptm6n","no"),
("395","WpFastestCache","{\"wpFastestCacheStatus\":\"on\",\"wpFastestCachePreload\":\"on\",\"wpFastestCachePreload_number\":\"4\",\"wpFastestCacheLoggedInUser\":\"on\",\"wpFastestCacheMobile\":\"on\",\"wpFastestCacheNewPost\":\"on\",\"wpFastestCacheNewPost_type\":\"all\",\"wpFastestCacheUpdatePost\":\"on\",\"wpFastestCacheUpdatePost_type\":\"post\",\"wpFastestCacheMinifyHtml\":\"on\",\"wpFastestCacheMinifyCss\":\"on\",\"wpFastestCacheCombineCss\":\"on\",\"wpFastestCacheCombineJs\":\"on\",\"wpFastestCacheGzip\":\"on\",\"wpFastestCacheLBC\":\"on\",\"wpFastestCacheDisableEmojis\":\"on\",\"wpFastestCacheLanguage\":\"tr\"}","yes"),
("393","WpFc_api_key","c78691ba5d99376b3b3bc2d899359582","yes"),
("394","WpFastestCachePreLoad","{\"number\":\"4\"}","yes"),
("925","auto_core_update_notified","a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:26:\"ucretsiz@wordpresstema.com\";s:7:\"version\";s:6:\"4.9.14\";s:9:\"timestamp\";i:1588201044;}","no"),
("7841","db_upgraded","","yes"),
("7826","_transient_feed_868981a74fb045e2d866f14ee0dbf978","a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"WordPress  Türkiye\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"https://www.wp-tr.org\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress Türkiye Resmi sitesi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Feb 2018 10:24:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"tr\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=5.4.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"WordPress Türkçe 4.9.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/njg5BRbUSaY/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Feb 2018 10:24:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:14:\"Güncellemeler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:5:\"4.9.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:18:\"WordPress Türkçe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:24:\"WordPress Türkçe 4.9.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20207\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:481:\"Merhaba arkadaşlar, WordPress Türkçe 4.9.4 şu an indirilebilir durumda. 4.9.3 sürümünde ortaya çıkan bir hata nedeniyle WordPress otomatik güncelleme sistemi çalışmaz duruma geldi ve bunun için 4.9.4 sürümü çıkartıldı. Ne var ki bir önceki sürümü etkileyen bu hata nedeniyle siteniz otomatik olarak 4.9.4 sürümüne güncellenemeyecektir. Sitenizin yönetim panelinde Başlangıç &#62; Güncellemeler bölümünden 4.9.4 sürümüne güncelleme [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2160:\"<p><img class=\"aligncenter size-full wp-image-20208\" src=\"https://www.wp-tr.org/wp-content/uploads/2018/02/wordpress_4_9_4_site.png\" alt=\"\" width=\"670\" height=\"206\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2018/02/wordpress_4_9_4_site.png 670w, https://www.wp-tr.org/wp-content/uploads/2018/02/wordpress_4_9_4_site-200x61.png 200w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Merhaba arkadaşlar,</p>\n<p><a href=\"http://tr.wordpress.org/\"><img src=\"/static/img/wp-indir-son.jpg\" alt=\"WordPress Türkiye indir\" align=\"left\" /></a>WordPress Türkçe 4.9.4 şu an <a href=\"http://tr.wordpress.org/\">indir</a>ilebilir durumda.</p>\n<p>4.9.3 sürümünde ortaya çıkan bir hata nedeniyle WordPress otomatik güncelleme sistemi çalışmaz duruma geldi ve bunun için 4.9.4 sürümü çıkartıldı. Ne var ki bir önceki sürümü etkileyen bu hata nedeniyle siteniz otomatik olarak 4.9.4 sürümüne güncellenemeyecektir. Sitenizin yönetim panelinde <strong>Başlangıç</strong> &gt; <strong>Güncellemeler</strong> bölümünden 4.9.4 sürümüne güncelleme yapabilirsiniz.</p>\n<h2>Son olarak</h2>\n<p>WordPress.org üzerindeki resmi 4.9.4 duyurusuna da <a href=\"https://wordpress.org/news/2018/02/wordpress-4-9-4-maintenance-release/\">buradan</a> ulaşabilirsiniz. Teknik detaylar ile ilgili çekirdek ekibin makalesine <a href=\"https://make.wordpress.org/core/2018/02/06/wordpress-4-9-4-release-the-technical-details/\">buradan</a> ulaşabilirsiniz.</p>\n<p>Yine her zaman olduğu gibi yükseltme yapmadan önce mutlaka veritabanınızın ve dosyalarınızın yedeğini almanızı öneriyoruz. Sürüm yükseltmeyle ilgili olarak sizi <a href=\"/belgeler/wordpress/wordpress-surum-yukseltme/\">sürüm yükseltme belgemiz</a>e yönlendirebiliriz.</p>\n<p>Yeni sürümle ilgili sorunlarınızı <a href=\"https://www.facebook.com/WPTurkiye/\">facebook</a> ya da <a href=\"https://twitter.com/WP_Turkiye/\">twitter</a> üzerinden paylaşabilir, Türkçe pakette bulduğunuz çeviri hatalarını ve çeviri hakkında önerilerinizi bize bildirebilirsiniz.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/njg5BRbUSaY\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20207\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://www.wp-tr.org/wordpress-turkce-4-9-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"WordPress Türkçe 4.8.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/Npnhl-G6Zvs/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 02 Aug 2017 21:30:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:14:\"Güncellemeler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:5:\"4.8.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:18:\"WordPress Türkçe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:24:\"WordPress Türkçe 4.8.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20193\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:469:\"Merhaba arkadaşlar, WordPress Türkçe 4.8.1 şu an indirilebilir durumda. 4.8 sürümünün 13 milyondan fazla kez indirilmesinden sonra bir bakım sürümü olarak 4.8.1&#8217;i duyurmaktan mutluluk duyuyoruz. Bu dağıtım 29 bakım düzeltmesi ve iyileştirmesinin yanı sıra, zengin metin bileşeninde düzeltmeler ve yeni Özel HTML bileşenini de içeriyor. Tüm değişiklikler için dağıtım notlarını inceleyebilir ya da değişiklik listesine [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2019:\"<p><img src=\"https://www.wp-tr.org/wp-content/uploads/2017/08/wp-tr-4-8-1.png\" alt=\"WordPress Türkçe 4.8.1\" width=\"670\" height=\"206\" class=\"aligncenter size-full wp-image-20194\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2017/08/wp-tr-4-8-1.png 670w, https://www.wp-tr.org/wp-content/uploads/2017/08/wp-tr-4-8-1-200x61.png 200w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Merhaba arkadaşlar,</p>\n<p><a href=\"http://tr.wordpress.org/\"><img src=\"/static/img/wp-indir-son.jpg\" alt=\"WordPress Türkiye indir\" align=\"left\" /></a>WordPress Türkçe 4.8.1 şu an <a href=\"http://tr.wordpress.org/\">indir</a>ilebilir durumda.</p>\n<p>4.8 sürümünün 13 milyondan fazla kez indirilmesinden sonra bir bakım sürümü olarak 4.8.1&#8217;i duyurmaktan mutluluk duyuyoruz.</p>\n<p>Bu dağıtım 29 bakım düzeltmesi ve iyileştirmesinin yanı sıra, zengin metin bileşeninde düzeltmeler ve yeni Özel <acronym title=\"HyperText Markup Language\">HTML</acronym> bileşenini de içeriyor. Tüm değişiklikler için <a href=\"https://codex.wordpress.org/Version_4.8.1\">dağıtım notları</a>nı inceleyebilir ya da <a href=\"https://core.trac.wordpress.org/query?milestone=4.8.1\">değişiklik listesi</a>ne bir göz atabilirsiniz.</p>\n<h2>Son olarak</h2>\n<p>WordPress.org üzerindeki resmi 4.8.1 duyurusuna da <a href=\"https://wordpress.org/news/2017/08/wordpress-4-8-1-maintenance-release/\">buradan</a> ulaşabilirsiniz.</p>\n<p>Yine her zaman olduğu gibi yükseltme yapmadan önce mutlaka veritabanınızın ve dosyalarınızın yedeğini almanızı öneriyoruz. Sürüm yükseltmeyle ilgili olarak sizi <a href=\"/belgeler/wordpress/wordpress-surum-yukseltme/\">sürüm yükseltme belgemiz</a>e yönlendirebiliriz.</p>\n<p>Yeni sürümle ilgili sorunlarınızı <a href=\"/forum/\">forumda</a> paylaşabilir, Türkçe pakette bulduğunuz çeviri hatalarını ve çeviri hakkında önerilerinizi bize bildirebilirsiniz.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/Npnhl-G6Zvs\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20193\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://www.wp-tr.org/wordpress-turkce-4-8-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:69:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n\n\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress Türkçe 4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/GbcDiv6TQO4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 Dec 2016 08:59:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:14:\"Güncellemeler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:18:\"WordPress Türkçe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:22:\"WordPress Türkçe 4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20148\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:470:\"Merhabalar, WordPress Türkçe 4.7 şu an indirilebilir durumda. 4.7 sürümü, caz efsanesi Sarah &#8220;Sassy&#8221; Vaughan anısına “Vaughan” olarak adlandırıldı ve kolayca bir web sitesi ayağa kaldırmak üzerinde odaklandı. Karşınızda Yirmi Onyedi Sürükleyici öne çıkan görseller ve video başlıklar barındıran yepyeni bir varsayılan tema ile sitenizi canlandırın. Yirmi Onyedi kurumsal sitelere odaklanıyor ve bir çok bölüme [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:3:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:58:\"https://s.w.org/images/core/4.7/starter-content-v1.mp4?_=1\";s:6:\"length\";s:7:\"1635917\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:57:\"https://s.w.org/images/core/4.7/edit-shortcuts-v1.mp4?_=2\";s:6:\"length\";s:7:\"1195621\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:55:\"https://s.w.org/images/core/4.7/header-video-v1.mp4?_=3\";s:6:\"length\";s:7:\"1546685\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9459:\"<p><img src=\"https://www.wp-tr.org/wp-content/uploads/2016/12/WordPress-4.7-Vaughan-1024x577.png\" alt=\"Vaughan\" style=\"max-width: 670px; width: 100%;\" /></p>\n<p>Merhabalar,</p>\n<p>WordPress Türkçe 4.7 şu an <a href=\"http://tr.wordpress.org/\">indir</a>ilebilir durumda. 4.7 sürümü, caz efsanesi Sarah &#8220;Sassy&#8221; Vaughan anısına “Vaughan” olarak adlandırıldı ve kolayca bir web sitesi ayağa kaldırmak üzerinde odaklandı.</p>\n<div class=\"headline-feature feature-video\"><iframe src=\"https://videopress.com/embed/AHz0Ca46?hd=true&amp;defaultLangCode=tr\" width=\"1050\" height=\"591\" frameborder=\"0\" allowfullscreen=\"allowfullscreen\"></iframe><br />\n<script src=\"https://videopress.com/videopress-iframe.js\"></script></div>\n<hr />\n<div class=\"feature-section one-col\">\n<h2>Karşınızda Yirmi Onyedi</h2>\n<p class=\"lead-description\">Sürükleyici öne çıkan görseller ve video başlıklar barındıran yepyeni bir varsayılan tema ile sitenizi canlandırın.</p>\n<p><img src=\"https://s.w.org/images/core/4.7/twenty-seventeen-663.jpg\" alt=\"Yirmi Onyedi\" /></p>\n<p>Yirmi Onyedi kurumsal sitelere odaklanıyor ve bir çok bölüme sahip özelleştirilebilir bir ön sayfa ile beraber geliyor. Bileşenler, dolaşım ve sosyal menüler, logo, özel renkler ve daha fazlasını kullanarak kişiselleştirin. 2017 için yeni varsayılan temamız bir çok dilde, her türlü cihazda ve bir çok kullanıcı için harika çalışıyor.</p>\n</div>\n<hr />\n<h2>Sizin siteniz, sizin yolunuz</h2>\n<p class=\"lead-description\">WordPress 4.7 temanızın ilk kurulumunu yapmanız için, yıkıcı olmayan canlı önizlemeler ve kesintisiz iş süreci ile özelleştiriciye yeni özellikler ekliyor.</p>\n<h3>Tema Başlangıç ​​İçeriği</h3>\n<p>Yeni sitenizi özelleştirmek için harekete geçtiğinizde size sağlam bir taban sunmak için bazı temalar başlangıç içeriği ile beraber gelebilirler. Bu kimi zaman kurumsal bilgilerinizi içeren bir bileşeni iyi bir konuma yerleştirmek gibi bir içerik olabileceği gibi kimi zaman da sosyal bağlantılar için örnek bir menü olabilir. Merak etmeyin, siz kaydedip yayımlamadığınız sürece sitenizde yeni hiç bir şey ortaya çıkmayacak.</p>\n<p><video id=\"video-0-1\" class=\"wp-video-shortcode\" style=\"max-width: 670px; width: 100%; height: 100%;\" src=\"https://s.w.org/images/core/4.7/starter-content-v1.mp4?_=1\" poster=\"https://s.w.org/images/core/4.7/starter-content.jpg?v2\" preload=\"metadata\" autoplay=\"autoplay\" loop=\"loop\" width=\"496\" height=\"271\"><source type=\"video/mp4\" src=\"https://s.w.org/images/core/4.7/starter-content-v1.mp4?_=1\" /><a href=\"https://s.w.org/images/core/4.7/starter-content-v1.mp4\">https://s.w.org/images/core/4.7/starter-content-v1.mp4</a></video></p>\n<h3>Kısayollar ile düzenleme</h3>\n<p>Canlı önizleme yaparken sitenizin bazı bölümlerinde simgeler görünür olacaklar. Bu kısayollara tıklayarak direkt düzenlemeye başlayabilirsiniz. Başlangıç içeriği ile beraber sitenizi özelleştirmeye başlamak her zamankinden daha hızlı bir hale geldi.</p>\n<p><video id=\"video-0-2\" class=\"wp-video-shortcode\" style=\"max-width: 670px; width: 100%; height: 100%;\" src=\"https://s.w.org/images/core/4.7/edit-shortcuts-v1.mp4?_=2\" poster=\"https://s.w.org/images/core/4.7/edit-shortcuts.jpg?v2\" preload=\"metadata\" autoplay=\"autoplay\" loop=\"loop\" width=\"496\" height=\"286\"><source type=\"video/mp4\" src=\"https://s.w.org/images/core/4.7/edit-shortcuts-v1.mp4?_=2\" /><a href=\"https://s.w.org/images/core/4.7/edit-shortcuts-v1.mp4\">https://s.w.org/images/core/4.7/edit-shortcuts-v1.mp4</a></video></p>\n<h3>Videolu başlıklar</h3>\n<p>Bazen büyük atmosferik bir videoyu üst kısım görseli olarak kullanmak sunumunuzu yapmak için gerekli olabilir; devam edin ve Yirmi Onyedi ile bunu deneyin. Videolar için ilhama mı ihtiyacınız mı var? Videolu üst kısma sahip siteleri arayın ve kullanın.</p>\n<p><video id=\"video-0-3\" class=\"wp-video-shortcode\" style=\"max-width: 670px; width: 100%; height: 100%;\" src=\"https://s.w.org/images/core/4.7/header-video-v1.mp4?_=3\" poster=\"https://s.w.org/images/core/4.7/header-video.jpg?v2\" preload=\"metadata\" autoplay=\"autoplay\" loop=\"loop\" width=\"496\" height=\"286\"><source type=\"video/mp4\" src=\"https://s.w.org/images/core/4.7/header-video-v1.mp4?_=3\" /><a href=\"https://s.w.org/images/core/4.7/header-video-v1.mp4\">https://s.w.org/images/core/4.7/header-video-v1.mp4</a></video></p>\n<h3>Akıcı menü inşası</h3>\n<p>Bir çok menü sitenize ait sayfalara bağlantılar veriyor, fakat ya sitenizde henüz hiç sayfa yoksa? Artık özelleştiriciyi terketmenize ve değişikliklerini kaybetmenize gerek kalmadan menü oluştururken yeni sayfalar ekleyebilirsiniz. Özelleştirmelerinizi yayımladığınız zaman oluşturduğunuz sayfalar doldurmanız için sizi bekliyor olacaklar.</p>\n<p><img src=\"https://s.w.org/images/core/4.7/nav-menus-760.jpg\" style=\"max-width: 670px; width: 100%;\" alt=\"Akıcı menü inşası\" /></p>\n<h3>Özel <acronym title=\"Cascading Style Sheets\">CSS</acronym></h3>\n<p>Bazen sitenizi mükemmele ulaştırmak için bir kaç görsel iyileştirme yapmak gerekebilir. WordPress 4.7 özel <acronym title=\"Cascading Style Sheets\">CSS</acronym> ekleyip değişikliklerin sitenize nasıl yansıyacağını görebilmenizi sağlıyor. Canlı önizleme sayfayı yenilemenize gerek kalamdan hızlı bir çalışma imkanı sağıyor.</p>\n<p><img src=\"https://s.w.org/images/core/4.7/css-760.jpg\" style=\"max-width: 670px; width: 100%;\" alt=\"Özel CSS\" /></p>\n<hr />\n<h3><acronym title=\"Portable Document Format\">PDF</acronym> Küçük resim önizlemesi</h3>\n<p>WordPress 4.7 ile belgeleri yönetmek artık daha kolay. <acronym title=\"Portable Document Format\">PDF</acronym> yüklediğinizde belgelerinizi daha kolay ayırt edebilmeniz için küçük resimler oluşturacaktır.</p>\n<p><img src=\"https://s.w.org/images/core/4.7/pdf-760.jpg\" style=\"max-width: 670px; width: 100%;\" alt=\"PDF Küçük resim önizlemesi\" /></p>\n<h3>Panel sizin dilinizde</h3>\n<p>Sitenizin bir dilde yayın yapıyor olması ona içerik sağlayan herkesin yönetim panelinde aynı dili tercih edeceği anlamına gelmiyor. Sitenize daha çok dil ekleyin ve kullanıcı profillerinde kullanıcı dili ayarı ortaya çıkacaktır.</p>\n<p><img src=\"https://s.w.org/images/core/4.7/language-760.jpg\" style=\"max-width: 670px; width: 100%;\" alt=\"Panel sizin dilinizde\" /></p>\n<hr />\n<h2>REST <acronym title=\"Application Programming Interface\">API</acronym> içerik uç noktalarıyla tanışın</h2>\n<p>WordPress 4.7 yazılar, yorumlar, terimler, kullanıcılar, meta ve ayarlar için REST <acronym title=\"Application Programming Interface\">API</acronym> uç noktaları ile geliyor.</p>\n<p><img src=\"https://s.w.org/images/core/4.7/api-1034.jpg\" alt=\"REST API içerik uç noktaları\" style=\"max-width: 670px; width: 100%;\" /></p>\n<p>İçerik uçları WordPress siteniz için temiz, standartlara uygun arayüze sahip, eklentiler, temalar, uygulamalar ve daha fazlası için yeni ve gelişmiş yollar ile makine-okunabilir harici bir erişim sağlar. Geliştirmeye başlamak için hazır mısınız? <a href=\"https://developer.wordpress.org/rest-api/reference/\"> REST <acronym title=\"Application Programming Interface\">API</acronym> referanslarına bir göz atın.</a></p>\n<hr />\n<h2>Daha fazla geliştirici mutluluğu <img src=\"https://s.w.org/images/core/emoji/12.0.0-1/72x72/1f60a.png\" alt=\"😊\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></p>\n<h3><a href=\"https://make.wordpress.org/core/2016/11/03/post-type-templates-in-4-7/\">Yazı Tipi Şablonları</a></h3>\n<p>Tüm yazı tipleri için sayfa şablonu becerisinin açılmasıyla, tema geliştiricileri artık WordPress şablon hiyerarşisi üzerinde daha fazla esnekliğe sahip.</p>\n<h3>Daha fazla tema <acronym title=\"Application Programming Interface\">API</acronym> güzellikleri</h3>\n<p>WordPress 4.7 tema geliştiricileri için <a href=\"https://make.wordpress.org/core/2016/09/09/new-functions-hooks-and-behaviour-for-theme-developers-in-wordpress-4-7/\">yeni işlevler, çengeller ve davranışlar</a> içerir.</p>\n<h3><a href=\"https://make.wordpress.org/core/2016/10/04/custom-bulk-actions/\">Özel Toplu Eylemler</a></h3>\n<p>Tablolar listesi ile artık toplu düzenleme ve silme işlemlerinden fazlasını yapabilirsiniz.</p>\n<h3><a href=\"https://make.wordpress.org/core/2016/09/08/wp_hook-next-generation-actions-and-filters/\"><code>WP_Hook</code></a></h3>\n<p>Eylemlerin ve filtrelerin altında yatan kodlar yol boyunca modernize edildi, hatalar düzeltildi ve elden geçirilerek yenilendi.</p>\n<h3>Ayarlar kayıt <acronym title=\"Application Programming Interface\">API</acronym>&#8217;ı</h3>\n<p><code>register_setting()</code> <a href=\"https://make.wordpress.org/core/2016/10/26/registering-your-settings-in-wordpress-4-7/\">geliştirildi</a>, artık tip, açıklama ve REST <acronym title=\"Application Programming Interface\">API</acronym> görünürlüğü içeriyor.</p>\n<h3><a href=\"https://make.wordpress.org/core/2016/10/12/customize-changesets-technical-design-decisions/\">Özelleştirme değişiklik kümeleri</a></h3>\n<p>Özelleştirici içinde değişiklik kümelerini kaılıcı hale getirebiliyorsunuz, aynı otomatik kaydedilen taslaklar gibi. Bu sayede başlangıç içeriği gibi heyecan verici yeni özellikler de olanaklı hale geliyor.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/GbcDiv6TQO4\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20148\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"https://www.wp-tr.org/wordpress-turkce-4-7/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"Küresel WordPress Çeviri Günü #2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/JnOt3hg-kWg/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Nov 2016 10:51:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:8:\"Haberler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:14:\"Çeviri Günü\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:6:\"Global\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:23:\"Küresel Çeviri Günü\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20143\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:537:\"12 Kasım&#8217;da WordPress Tema ve Eklenti dizinlerinde Türkçe&#8217;ye çevrilmeyi bekleyen yüzlerce tema ve eklenti için tekrar bir araya geliyoruz. İstanbul&#8217;da Radore sponsorluğunda Metrocity&#8217;de 10:30 &#8211; 18:30 saatleri arasında ve Edirne&#8217;de Sisler Bulvarı Sanat&#038;Kafe&#8217;de (Karaağaç, İstasyon Cd. No:12, 22100 Merkez/Edirne) toplanacak gruplar, tüm gün boyunca WordPress&#8217;i olabildiğince Türkçe&#8217;ye çevirmek için çalışacak. Siz de çevrimiçi olarak etkinliğe [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3158:\"<p><img class=\"aligncenter size-full wp-image-20076\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/04/translationday.png\" alt=\"translationday\" width=\"470\" height=\"220\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/04/translationday.png 470w, https://www.wp-tr.org/wp-content/uploads/2016/04/translationday-200x94.png 200w\" sizes=\"(max-width: 470px) 100vw, 470px\" /></p>\n<p>12 Kasım&#8217;da WordPress Tema ve Eklenti dizinlerinde Türkçe&#8217;ye çevrilmeyi bekleyen yüzlerce tema ve eklenti için tekrar bir araya geliyoruz.</p>\n<p>İstanbul&#8217;da <a href=\"http://radore.com/\" target=\"_blank\">Radore</a> sponsorluğunda Metrocity&#8217;de 10:30 &#8211; 18:30 saatleri arasında ve Edirne&#8217;de Sisler Bulvarı Sanat&#038;Kafe&#8217;de (Karaağaç, İstasyon Cd. No:12, 22100 Merkez/Edirne) toplanacak gruplar, tüm gün boyunca WordPress&#8217;i olabildiğince Türkçe&#8217;ye çevirmek için çalışacak. Siz de çevrimiçi olarak etkinliğe katılabilirsiniz. Bize <a href=\"https://www.facebook.com/WPTurkiye\" target=\"_blank\">Facebook</a> ya da <a href=\"https://www.twitter.com/WP_Turkiye\" target=\"_blank\">Twitter</a> üzerinden ulaşarak katılmak istediğinizi bildirirseniz yapmanız gerekenler konusunda sizi hızlıca yönlendirebiliriz.</p>\n<h3>Etkinlik Planı</h3>\n<p>10:00 &#8211; 10:30 — Tanışma<br />\n10:30 &#8211; 11:00 — WordPress çeviri sisteminin tanıtılması (GlotPress), hesapların oluşturulması ve hazırlık<br />\n11:00 &#8211; 11:30 — Ekiplerin oluşturulması, iş bölümü yapılması<br />\n11:30 &#8211; 12:00 — Kahve molası<br />\n12:00 &#8211; 12:15 — WordPress.tv ile Skype görüşmesi<br />\n12:00 &#8211; 13:30 — Çeviri oturumu<br />\n13:30 &#8211; 14:30 — Öğle yemeği<br />\n14:30 &#8211; 16:00 — Çeviri oturumu<br />\n16:00 &#8211; 16:30 — Kahve molası<br />\n16:30 &#8211; 17:00 — Katılımcı konuşmaları<br />\n17:00 &#8211; 18:30 — Çeviri oturumu<br />\n18:30 &#8211; 19:00 — Kapanış</p>\n<p>Çeviri oturumları toplam üç tane olacak ve 1,5 saatlik sürelerde ekipler mümkün olduğunca çok çeviri bitirmeye çalışacaklar.</p>\n<p><img class=\"alignleft wp-image-20077\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/04/wp-tr-kcg-rozet.png\" alt=\"wp-tr-kcg-rozet\" width=\"189\" height=\"189\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/04/wp-tr-kcg-rozet.png 300w, https://www.wp-tr.org/wp-content/uploads/2016/04/wp-tr-kcg-rozet-100x100.png 100w, https://www.wp-tr.org/wp-content/uploads/2016/04/wp-tr-kcg-rozet-200x200.png 200w\" sizes=\"(max-width: 189px) 100vw, 189px\" />Etkinliğe ister yerinde katılın isterseniz çevrimiçi olarak katılın, solda yer alan rozeti gururla sitenizde kullanabilirsiniz. Görseli bilgisayarınıza indirmek için üzerine sağ tuşla tıklayıp kaydetme seçeneğini kullanabilirsiniz.</p>\n<p>Ayrıca sponsor firmamızın da katılımcılara ufak sürprizleri olacak.</p>\n<p>WordPress Türkiye ekibinin bir parçası olmak, Türkçe WordPress topluluğuna katkı sağlamak için bu fırsatı kaçırmayın.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/JnOt3hg-kWg\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20143\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://www.wp-tr.org/kuresel-wordpress-ceviri-gunu-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"WordPress Avrupa Katılımcı Günü\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/CQX3vn2BAUA/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 26 Jun 2016 08:13:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordCamp Avrupa 2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20127\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:515:\"WordPress Avrupa bitti fakat etkinlikler bitmedi. Bugün de düzenlenen katılımcı gününe katılıyorum. Dünyanın çeşitli şehirlerinden gelen 500&#8217;e yakın katılımcı bir gün boyunca WordPress&#8217;e yapabildiğimiz kadar katkı yapmaya çalışacağız. Şu an ekipler tanıtılıyor ve gün içinde neler yapılacağı anlatılıyor. 15 farklı alanda bir gün boyunca WordPress&#8217;e katkıda bulunacağız. &#160; Çeviri ekibine katılarak katılımcı gününde üzerime düşeni [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4071:\"<p><img class=\"aligncenter wp-image-20128\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3150-1024x768.jpg\" alt=\"IMG_3150\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3150-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3150-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3150-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>WordPress Avrupa bitti fakat etkinlikler bitmedi. Bugün de düzenlenen katılımcı gününe katılıyorum. Dünyanın çeşitli şehirlerinden gelen 500&#8217;e yakın katılımcı bir gün boyunca WordPress&#8217;e yapabildiğimiz kadar katkı yapmaya çalışacağız.</p>\n<p>Şu an ekipler tanıtılıyor ve gün içinde neler yapılacağı anlatılıyor. 15 farklı alanda bir gün boyunca WordPress&#8217;e katkıda bulunacağız.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20130\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3152-e1466937249245-1024x939.jpg\" alt=\"IMG_3152\" width=\"670\" height=\"615\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3152-e1466937249245-1024x939.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3152-e1466937249245-200x183.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3152-e1466937249245-768x704.jpg 768w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3152-e1466937249245.jpg 1583w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Çeviri ekibine katılarak katılımcı gününde üzerime düşeni yapmaya başladım. Üstte gördüğünüz Çevirmen Wapuu yapıştırması da bilgisayarıma çoktan yapıştı bile. WordPress Türkiye Çeviri Ekibinden arkadaşların (<a href=\"https://profiles.wordpress.org/gencmedya\">Halil</a>, <a href=\"https://profiles.wordpress.org/snr1071\">Soner</a> ve <a href=\"https://profiles.wordpress.org/trkr\">Türker</a>) da katılımıyla bugün WooCommerce eklentisini Türkçe&#8217;ye çevirmeye çalışacağız.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20131\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3154-1024x768.jpg\" alt=\"IMG_3154\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3154-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3154-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3154-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>WordCamp ve WordPress buluşmaları hakkında bir panel ile güne devam ediyorum. Panelden bazı notlar;</p>\n<blockquote><p>1 kişi bile olsanız buluşmalara başlayın, en azından başlamış olursunuz.</p>\n<p>50 kişi, wi-fi ve kahve varsa yaptığınız şey bir WordCamp’tir.</p>\n<p>Yerel konuşmacılara ağırlık vermeye çalışın.</p>\n<p>WordPress buluşması yapıyorsunuz diye sadece WordPress buluşmalarına katılmak zorunda değilsiniz. JavaScript, <acronym title=\"Pre-Hypertext Processing\">PHP</acronym> vb başka buluşmalara da katılın. Bu şekilde bir çevre oluşturduktan sonra yavaş yavaş WordCamp etkinliklerinde diğer konulara yer vermeye başlayabilirsiniz.</p>\n<p>İşin özü süreklilik ve tutarlılık. Her buluşmada katılımı artırmaya çalışın. Zamanla bu işin daha az emek gerektirdiğini göreceksiniz.</p></blockquote>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20132\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3158-1024x267.jpg\" alt=\"IMG_3158\" width=\"670\" height=\"174\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3158-1024x267.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3158-200x52.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3158-768x200.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Kapanış konuşmasıyla katılımcı günü de bitiyor. WordCamp Avrupa 2016 macerasının sonuna geldik. Bizi takip eden herkese Viyana&#8217;dan selamlar!</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/CQX3vn2BAUA\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20127\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://www.wp-tr.org/wordpress-avrupa-katilimci-gunu/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress Avrupa İkinci Gün öğleden sonrası\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/-t_Sl0DAEJw/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 25 Jun 2016 12:30:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordCamp Avrupa 2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20115\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:507:\"Günün ikinci yarısına Andrew Nacin&#8217;in sunumuyla başlamak üzere. &#160; WordPress&#8217;in çekirdek geliştiricilerinden Andrew Nacin &#8220;Inheriting large and legacy projects&#8221; sunumu ile sahnede. Köklü geçmişi olan büyük projelerin nasıl ele alınacağı ile ilgili bir sunuma başladı. &#160; Katılımcılar, görevliler vb herkesi saydığımızda toplam 2.500 kişiye yaklaşan katılım sayısıyla sunumlarda salonlar hınca hınç doluyor. Sunum yapanlarda kimi [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:8484:\"<p><img class=\"aligncenter wp-image-20116\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3119-1024x768.jpg\" alt=\"IMG_3119\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3119-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3119-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3119-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Günün ikinci yarısına Andrew Nacin&#8217;in sunumuyla başlamak üzere.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20118\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3120-1024x768.jpg\" alt=\"IMG_3120\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3120-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3120-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3120-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>WordPress&#8217;in çekirdek geliştiricilerinden Andrew Nacin &#8220;Inheriting large and legacy projects&#8221; sunumu ile sahnede. Köklü geçmişi olan büyük projelerin nasıl ele alınacağı ile ilgili bir sunuma başladı.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20119\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3121-e1466859492836-1024x768.jpg\" alt=\"IMG_3121\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3121-e1466859492836-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3121-e1466859492836-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3121-e1466859492836-768x576.jpg 768w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3121-e1466859492836.jpg 1280w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Katılımcılar, görevliler vb herkesi saydığımızda toplam 2.500 kişiye yaklaşan katılım sayısıyla sunumlarda salonlar hınca hınç doluyor. Sunum yapanlarda kimi zaman karşılarında bu kalabalığı gördüklerinde şaşırıyorlar ve sunuma başlamadan bahsediyorlar.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20120\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3122-1024x768.jpg\" alt=\"IMG_3122\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3122-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3122-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3122-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Sırada &#8220;Using the REST <acronym title=\"Application Programming Interface\">API</acronym> and JavaScript to create better WordPress interfaces&#8221; sunumuyla K. Adam White var. Calypso&#8217;nun ve REST <acronym title=\"Application Programming Interface\">API</acronym>&#8217;ın hız kazandığı bugünlerde ilginç bir sunum bekliyorum.</p>\n<blockquote><p>Neden 13 yaşındaki bir yazılımı kullanıyoruz diye kendinize sorduğunuzda, benim aklıma esnekliği geliyor.</p>\n<p style=\"text-align: right;\">&#8211; Adam White</p>\n</blockquote>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20121\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3124-1024x768.jpg\" alt=\"IMG_3124\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3124-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3124-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3124-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>&#8220;Using Composer to create manageable WordPress websites&#8221; sunumuyla Anna Ladoshkina sahnede. Composer kullanarak WordPress kurulumu hakkında bir sunum yapıyor. Anna 10 senedir Rusya&#8217;da WordPress ile gerek sivil toplum kuruluşlarına gerekse müşterilerine WordPress ile siteler hazırlıyor. Bugün bizlere Composer ile bir WordPress sitesini nasıl ayağa kaldırabileceğimizi anlatıyor.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20122\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3125-1024x768.jpg\" alt=\"IMG_3125\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3125-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3125-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3125-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p><span class=\"wcpt-session-speakers\">Daniel Bachhuber sırada, &#8220;My condolences, you’re now the maintainer of a popular open source project&#8221; sunumu için bekliyor.<br />\n</span></p>\n<blockquote><p>&#8220;Kodumun kalitesiz olduğunu düşünüyorum, insanların kodlarımı görmelerinden utanıyorum&#8221;<br />\nMerak etmeyin, herkes utanıyor.</p>\n<p style=\"text-align: right;\">&#8211; Daniel Bachhuber</p>\n</blockquote>\n<blockquote><p>Kendinizi fazla kaptırıp mutsuz olmayın. Kesin sınırlar koyarak proje üzerinde çalışırken önce kendiniz mutlu olmaya çalışın.</p>\n<p style=\"text-align: right;\">&#8211; Daniel Bachhuber</p>\n</blockquote>\n<p><img class=\"aligncenter wp-image-20123\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3126-1024x768.jpg\" alt=\"IMG_3126\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3126-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3126-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3126-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<blockquote><p>Bazen kendinizi çok yalnız hissedebilirsiniz. Projede sadece kendiniz çalışıyormuşsunuz gibi gelebilir. Bu durumda liderlik yapmaya odaklanın, diğerlerini katılıma teşvik edin.</p>\n<p style=\"text-align: right;\">&#8211; Daniel Bachhuber</p>\n</blockquote>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20124\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3128-1024x768.jpg\" alt=\"IMG_3128\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3128-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3128-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3128-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p><span class=\"wcpt-session-speakers\">Taylor Lovett&#8217;i dinliyoruz. &#8220;Modernizing WordPress Search with Elasticsearch&#8221; sunumuyla sahnede. WordPress kullanırken Elastic Search ile arama işini nasıl daha iyi bir hale getirebileceğimizi, nasıl modernleştirebileceğimizi anlatıyor. WordPress&#8217;te dahili arama sistemini kullanırken sadece başlık ve içerikte arama yapabilirken, Elastic Search ile aramanın yanı sıra öneriler, ilişkili yazılar vb daha bir çok konuda sonuçlar elde edilebiliyor.</span></p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20125\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3132-1024x768.jpg\" alt=\"IMG_3132\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3132-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3132-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3132-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>WordCamp Avrupa 2016 kapanış konuşması ile sonlanıyor. Tabi ki macera burada bitmiyor. Yarın katılımcı günü var ve ben de aktif bir katılımcı olarak yarın orada olacağım. Sizlere anlatmaya devam edeceğim. Bu arada gelecek sene planları da belli oldu;</p>\n<p><img class=\"aligncenter wp-image-20126\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3133-1024x768.jpg\" alt=\"IMG_3133\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3133-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3133-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3133-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>WordCamp Avrupa 2017 Paris&#8217;te gerçekleşecek. 16-18 Haziran tarihleri arasında gerçekleşecek etkinliğin web sitesi hazır ve biletler satışa çıkmış durumda. http://2017.europe.wordcamp.org adresinden ulaşabilirsiniz.</p>\n<p>&nbsp;</p>\n<p>Bu akşam WCEU Balosu var. Oradan da izlenimlerimi sizlerle paylaşacağım.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/-t_Sl0DAEJw\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20115\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://www.wp-tr.org/wordpress-avrupa-ikinci-gun-ogleden-sonrasi/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"WordPress Avrupa İkinci Gün\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/C287kQ4W2iM/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 25 Jun 2016 09:37:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:20:\"WordCamp Avrupa 2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:4:\"2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"Wordcamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:15:\"WordCamp Avrupa\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20109\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:494:\"İkinci gün sabah oturumları biraz zayıf olduğundan insanlarla kaynaşmayı tercih ettim. İlk oturum olarak &#8220;The WordPress REST API&#8221; sunumu ile Joe Hoyle&#8217;u dinlemeye başladım. WordPress altyapısında REST API&#8217;ın geçmişini ve bugüne kadar neler yapıldığını anlatıyor. &#160; Sırada &#8220;You are too cheap&#8221; sunumuyla Thomas Zaman var. Serbest çalışanların ücretlerini neden düşük tutmamaları gerektiğini anlatıyor. Thomas da [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3327:\"<p><img class=\"aligncenter wp-image-20110\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3112-1024x768.jpg\" alt=\"IMG_3112\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3112-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3112-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3112-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>İkinci gün sabah oturumları biraz zayıf olduğundan insanlarla kaynaşmayı tercih ettim. İlk oturum olarak &#8220;The WordPress REST <acronym title=\"Application Programming Interface\">API</acronym>&#8221; sunumu ile Joe Hoyle&#8217;u dinlemeye başladım. WordPress altyapısında REST <acronym title=\"Application Programming Interface\">API</acronym>&#8217;ın geçmişini ve bugüne kadar neler yapıldığını anlatıyor.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20112\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3114-1024x768.jpg\" alt=\"IMG_3114\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3114-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3114-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3114-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Sırada &#8220;You are too cheap&#8221; sunumuyla Thomas Zaman var. Serbest çalışanların ücretlerini neden düşük tutmamaları gerektiğini anlatıyor. Thomas da dünkü etkinlikte Yoast ailesinin yaptığı gibi ailesini ekrana yansıttı. Selamlarımızı ilettik. Thomas&#8217;ın ailesini aşağıda görebilirsiniz. :)</p>\n<p><img class=\"aligncenter wp-image-20113\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3115-1024x768.jpg\" alt=\"IMG_3115\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3115-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3115-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3115-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Eğlenceli göndermeler eşliğinde Thomas&#8217;ın sunumu devam ediyor. Mesela az önce Matt Mullenweg&#8217;i kötü adam ilan etti. :)</p>\n<p><img class=\"aligncenter wp-image-20114\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3116-1024x768.jpg\" alt=\"IMG_3116\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3116-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3116-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3116-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<blockquote>\n<p style=\"text-align: right;\">Bir müşteri bulabildiyseniz, 10 tane de bulabilirsiniz.<br />\nThomas Zaman</p>\n</blockquote>\n<p>Thomas&#8217;ın sunumu iki gün içindeki en eğlenceli sunum olarak devam ediyor.</p>\n<p>Günün ilk yarısını bu şekilde tamamladım. Öğle yemeğinden sonra Andrew Nacin&#8217;in sunumuyla devam edeceğim. Etkinlik alanını görüntülediğim kısa bir videoya <a href=\"https://www.facebook.com/WPTurkiye/videos/1325906624104133/\">buradan</a> ulaşabilirsiniz.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/C287kQ4W2iM\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20109\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://www.wp-tr.org/wordpress-avrupa-ikinci-gun/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:85:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:7:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordCamp Avrupa Birinci Gün öğleden sonrası\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/Lp8hM3U28pY/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://www.wp-tr.org/wordcamp-avrupa-birinci-gun-ogleden-sonrasi/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jun 2016 13:03:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:20:\"WordCamp Avrupa 2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"WCEU\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:8:\"Wordcamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:15:\"WordCamp Avrupa\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20102\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:449:\"Öğleden sonra Matt Mullenweg ile yapılan röportaj ile başladı. Soru cevap şeklinde ilerleyen panel ile ilgili önemli konu başlıklarını toplamaya çalışıyorum (BK &#8211; Brian Krogsgard, MW: Matt Mullenweg); MW: Automattic, 50 ülkede konuşlanmış 470 çalışanı olan bir firma haline geldi. BK: Geçtiğimiz Ekim ayında bir röportajda 23 kişiyi yönettiğini ve bunu 10&#8217;a düşürmek istediğini söylemiştin. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7588:\"<p><img class=\"aligncenter wp-image-20103\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3059-1024x768.jpg\" alt=\"IMG_3059\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3059-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3059-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3059-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Öğleden sonra Matt Mullenweg ile yapılan röportaj ile başladı. Soru cevap şeklinde ilerleyen panel ile ilgili önemli konu başlıklarını toplamaya çalışıyorum (BK &#8211; Brian Krogsgard, MW: Matt Mullenweg);</p>\n<blockquote><p>MW: Automattic, 50 ülkede konuşlanmış 470 çalışanı olan bir firma haline geldi.</p></blockquote>\n<blockquote><p>BK: Geçtiğimiz Ekim ayında bir röportajda 23 kişiyi yönettiğini ve bunu 10&#8217;a düşürmek istediğini söylemiştin. Bu konuda bir değişiklik oldu mu?<br />\nMW: Şimdi 27 kişi oldular sanırım.</p></blockquote>\n<blockquote><p>MW: Zamanımın üçte birini eleman bulmak için harcıyorum, üçte birini projelere harcıyorum ve kalanını da geliştirme ve diğer işlere harcıyorum.</p></blockquote>\n<blockquote><p>MW: Önümüzdeki beş yıl içinde bu salondaki her geliştiricinin JavaScript&#8217;i derinlemesine öğrenmesi gerekecek.</p></blockquote>\n<blockquote><p>BK: Medium.com&#8217;un bu günlerde yıldızı parlıyor. Bir çok yayımcı Medium&#8217;a taşınıyor ve hatta bazıları WordPress&#8217;i felaket olarak görüyorlar. Sen bu konuda ne düşünüyorsun?<br />\nMW: Bir çok yayımcı dediğin 5 kişi ve onların da taşınması için para ödüyorlar.<br />\nBK: Sen de Movable Type&#8217;dan birilerini devşirmiştin.<br />\nMW: Ama ben onlara para ödemedim.<br />\nBK: Sence WordPress Medium&#8217;dan daha iyi bir yayımcılık deneyimi mi sunuyor?<br />\nMW: Hiç şüphesiz. WordPress iki şey ile öne çıkıyor, esnekliği ve etrafındaki topluluğu.</p></blockquote>\n<blockquote><p>MW: Tumblr&#8217;la biraz dalga geçtin sanki.<br />\nBK: Evet, biraz.<br />\nMW: Aslına bakarsan son beş yıl içinde, yayımcılık anlamında bakarsan en ciddi rakibimiz Tumblr olmuştu.</p></blockquote>\n<blockquote><p>S: WordPress 13 yaşında, tebrikler.<br />\nMW: Artık genç bir çocuğum var.<br />\nBK: Ne yöne ilerleyeceğine karar vermek gerekmiyor mu?<br />\nMW: Sen buna 13 yaşında mı karar vermiştin?<br />\nBK: Ben üniversiteye bile karar vermiştim ama bu röportaj benim hakkımda değil.<br />\nMW: Markette payımız arttıkça webi daha açık bir yer haline getiriyoruz.</p></blockquote>\n<blockquote><p>BK: WordPress&#8217;in içinde özelleştiriciden içerik sistemine bir çok bölüm var. Gelecekte bunların hangilerine ağırlık verileceğine nasıl karar veriliyor?<br />\nMW: Sanırım soruna cevabı sen daha iyi verdin.<br />\nBK: Hayır hayır, senin cevabını bekliyorum.<br />\nMW: Otonomi ve otorite ile. Ekibi ben yönetmediğimde yönetenlere elimden geldiğince yardımcı olmaya çalışıyorum.</p></blockquote>\n<p>Topluluk sorularına geçildi;</p>\n<blockquote><p>BK: Tema ve eklenti geliştiricileri için önümüzdeki beş yılda olabilecekler ile ilgili vizyon sunabilir misiniz?<br />\nMW: Tema geliştiricileri, temanızı pazarladığınız sitelerdeki görüntüyü oluşturmak kolay değil. Buradaki kullanıcı deneyimini iyileştirmeye çalışın. Henüz bunu hakkıyla yapan bir tema görmedim. Belgeler hazırlayın, video çekin. Geliştirin.</p></blockquote>\n<blockquote><p>MW: Önümüzdeki beş seneden daha ileri bakmak isterseniz InterPlanetery File System&#8217;e bir göz atın.</p></blockquote>\n<blockquote><p>BK: WordPress sürekli değişiyor. Değişmeyen en güzel şey nedir?<br />\nMW: Açık kaynaklı olması.</p></blockquote>\n<blockquote><p>Salondaki bir seyirci: Google&#8217;da çalışıyorum ve takip ettiğimiz kadarıyla yayın hayatına başlayan sitelerin %28&#8217;i WordPress ile başlıyor. Fakat masaüstü temalar ile başlıyorlar. Mobil dostu temaların kullanılması konusunda ne yapabiliriz?<br />\nMW: Ne dersin Brian?<br />\nBK: Filtre seçenekleri arasında duyarlı seçeneği var?<br />\nMW: O seçeneğin zorunlu olması lazım işte!<br />\n(Alkış ve gülüşmeler)</p></blockquote>\n<p>15:20 itibarı ile röportaj sonlandı.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20105\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3064-1024x768.jpg\" alt=\"IMG_3064\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3064-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3064-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3064-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Sırada New York Times&#8217;da geliştirici olarak çalışan Andrew Lewis&#8217;in &#8220;Editing Text at The New York Times&#8221; sunumu var. Yayımcılık açısından bir metin düzenleyicide olması gerekenler hakkında sunumunu yapıyor. Bu alandaki gelişmeler ve seçenekler hakkında New York Times özelinde kendi deneyimlerini aktarıyor.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20106\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3066-1024x768.jpg\" alt=\"IMG_3066\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3066-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3066-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3066-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Kısa bir aranın ardından WordPress&#8217;in geleceği olarak ön görülen Calypso projesi ile ilgili &#8220;A look into Calypso&#8221; sunumuyla Matias Ventura&#8217;yı dinliyoruz. 8 aydır geliştirilmekte olan Calypso ile ilgili Matt Mullenweg&#8217;den bir alıntı;</p>\n<blockquote><p>Bir çok insan, bu projeyi kendimize saklamamız gerektiğini düşünüyordu ama şu hayatımda bir şey öğrendiysem o da ne kadar çok verirsen o kadar çok geri aldığındır.</p></blockquote>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20107\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3068-1024x768.jpg\" alt=\"IMG_3068\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3068-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3068-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3068-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Günün kapanışını &#8220;Beyond SEO: copywriting for professionals&#8221; sunumunu yapan karı-koca Marieke van de Rakt ve Joost de Valk ile yapıyorum. Profesyoneller için SEO ve telif hakları konularından bahsediyorlar. Arama motorlarının (özellikle Google) hayatımızda nasıl bir yer edindiği, indeksleme konusunda gelinen noktadan bahsediyorlar. Sunumun başında dört çocuklarını en büyük başarıları olarak ekrana yansıtmaları da tüm salonu kahkahalara boğdu.</p>\n<p>&nbsp;</p>\n<p>Facebook üzerinden canlı yayın yapmak için Marius&#8217;la buluşmak üzere yola çıkıyorum. Henüz beğenmediyseniz Facebook sayfamızdaki <a href=\"https://www.facebook.com/WPTurkiye/photos/a.336819856346153.93510.248932931801513/1325091827518946/?type=3\">şu yazıyı</a> beğenmek için acele edin. 10 kişi 149$ değerinde ThemeIsle hazine paketi kazanacaklar.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/Lp8hM3U28pY\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://www.wp-tr.org/wordcamp-avrupa-birinci-gun-ogleden-sonrasi/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20102\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://www.wp-tr.org/wordcamp-avrupa-birinci-gun-ogleden-sonrasi/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:69:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"WordCamp Avrupa Birinci Gün\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/DuQm01x9tik/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Jun 2016 08:05:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:20:\"WordCamp Avrupa 2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:4:\"2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"WCEU\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:8:\"Wordcamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:15:\"WordCamp Avrupa\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20093\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:466:\"WordCamp Avrupa açılış konuşmalarının ardından başladı. Üç ayrı salonda devam edecek sunumlara canlı yayın bağlantıları üzerinden ulaşıp sizler de takip edebilirsiniz. 1. Salon canlı yayın bağlantısı 2. Salon canlı yayın bağlantısı 3. Salon canlı yayın bağlantısı Yine WordCamp Europe sayfasından her bir salonun programına ulaşabilir, bizimle beraber etkinliği takip edebilirsiniz. &#160; Gary Pendergast açık bir [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6278:\"<p><img class=\"aligncenter wp-image-20094\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/wceu_acilis.jpg\" alt=\"Açılış\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/wceu_acilis.jpg 960w, https://www.wp-tr.org/wp-content/uploads/2016/06/wceu_acilis-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/wceu_acilis-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>WordCamp Avrupa açılış konuşmalarının ardından başladı. Üç ayrı salonda devam edecek sunumlara canlı yayın bağlantıları üzerinden ulaşıp sizler de takip edebilirsiniz.</p>\n<p><a href=\"https://2016.europe.wordcamp.org/schedule/track-1-livestream/\">1. Salon canlı yayın bağlantısı</a></p>\n<p><a href=\"https://2016.europe.wordcamp.org/schedule/track-2-livestream/\">2. Salon canlı yayın bağlantısı</a></p>\n<p><a href=\"https://2016.europe.wordcamp.org/schedule/track-3-livestream/\">3. Salon canlı yayın bağlantısı</a></p>\n<p>Yine <a href=\"https://2016.europe.wordcamp.org/\">WordCamp Europe</a> sayfasından her bir salonun programına ulaşabilir, bizimle beraber etkinliği takip edebilirsiniz.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20096\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/13528109_1325088167519312_2235230475491202373_o.jpg\" alt=\"Gary Pendergast\" width=\"671\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/13528109_1325088167519312_2235230475491202373_o.jpg 2048w, https://www.wp-tr.org/wp-content/uploads/2016/06/13528109_1325088167519312_2235230475491202373_o-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/13528109_1325088167519312_2235230475491202373_o-768x576.jpg 768w, https://www.wp-tr.org/wp-content/uploads/2016/06/13528109_1325088167519312_2235230475491202373_o-1024x768.jpg 1024w\" sizes=\"(max-width: 671px) 100vw, 671px\" /></p>\n<p>Gary Pendergast açık bir platform olarak WordPress&#8217;in nasıl kullanbileceğinden bahsetti. Sosyal etkileşim, güvenlik ve paylaşım açılarından ele alındığında WordPress&#8217;in bir platform olarak nasıl konumlanabileceğini ve gelecekte bizleri nelerin beklediğini eğlenceli bir dille bizlere aktardı.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20097\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3046.jpg\" alt=\"IMG_3046\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3046.jpg 3264w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3046-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3046-768x576.jpg 768w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3046-1024x768.jpg 1024w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Benzer şekilde <span class=\"wcpt-session-speakers\">John Blackbourn&#8217;da &#8220;Moving forward with a mature platform&#8221; sunumunda WordPress&#8217;in farklı yapılarını ele alarak, bir platform olarak nasıl daha iyi bir yolda ilerleyebileceğimiz ile ilgili kendi görüşlerini aktardı.</span></p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20098\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3047.jpg\" alt=\"IMG_3047\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3047.jpg 3264w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3047-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3047-768x576.jpg 768w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3047-1024x768.jpg 1024w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Sırada bir ofise sahip olmayan firmaların kurucularının katıldığı bir panel vardı. Panelde uzaktan çalışmanın çalışanlar ve firma açısından nasıl işlediği, çalışanların sadakati için neler yaptıkları vb konulardan bahsedildi.</p>\n<p>&nbsp;</p>\n<p>Ne yazık ki Leopold Müzesindeki salon dolduğundan bir sunuma giremedim. Devamında ise Tema ve eklentiler arasındaki uyum sunumunu yakaladım.</p>\n<p><img class=\"aligncenter wp-image-20099\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3048-1024x768.jpg\" alt=\"IMG_3048\" width=\"670\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3048-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3048-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3048-768x576.jpg 768w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<p>Arkalardan da olsa kendime yer bulabildim ve Ulrich Pogson&#8217;ın &#8220;Themes &amp; Plugins in harmony&#8221; sunumuna girdim. Tema ve eklentilerde ön takı kullanımı (prefix) isim alanları kullanımı (namespace) gibi geliştiricilerin dikkat etmesi gereken konular hakkında güzel bir sunum yaptı.</p>\n<p>&nbsp;</p>\n<p><img class=\"aligncenter wp-image-20100\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3051-1024x768.jpg\" alt=\"IMG_3051\" width=\"671\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3051-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3051-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3051-768x576.jpg 768w\" sizes=\"(max-width: 671px) 100vw, 671px\" /></p>\n<p>Matt Geri sahneye &#8220;The ultimate WordPress development environment&#8221; sunumunu yapmak için çıktı. Aktif bir geliştirici olarak WordPress geliştirme konusunda oldukça doyurucu bir sunumla beş farklı açıdan yaklaşarak geliştirme ortamının nasıl olması gerektiğini anlattı. Sunumun detaylarına <a href=\"https://mattgeri.com/wceu/\">kendi sitesi üzerindeki sayfadan</a> ulaşabilirsiniz.</p>\n<p>Ve yemek molası!</p>\n<p><img class=\"aligncenter wp-image-20101\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3055-e1466772763484-1024x768.jpg\" alt=\"IMG_3055\" width=\"671\" height=\"503\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3055-e1466772763484-1024x768.jpg 1024w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3055-e1466772763484-200x150.jpg 200w, https://www.wp-tr.org/wp-content/uploads/2016/06/IMG_3055-e1466772763484-768x576.jpg 768w\" sizes=\"(max-width: 671px) 100vw, 671px\" /></p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/DuQm01x9tik\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20093\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://www.wp-tr.org/wordcamp-avrupa-birinci-gun/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:73:\"\n		\n		\n					\n		\n		\n		\n				\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:7:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Yolculuk başladı\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://feedproxy.google.com/~r/wp-turkiye/~3/cZAbXzoTMDc/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://www.wp-tr.org/yolculuk-basladi/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jun 2016 12:03:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordCamp Avrupa 2016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://www.wp-tr.org/?p=20089\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:497:\"Merhaba! Ben Emre Erkan. 2005 yılından beri aktif olarak WordPress kullanıyor ve 2008 yılından beri WordPress Türkiye ekibini yönetiyorum. Türkçe paketin hazırlanması, topluluk yönetimi, etkinliklerin düzenlenmesi, WordPress.org ile iletişim gibi bir çok alanda gönüllü olarak çalışıyorum. WordCamp Avrupa 2016 yarın başlıyor. Üç gün sürecek etkinliği WordPress Türkiye takipçilerine aktarmak için Turhost sponsorluğunda Viyana&#8217;da olacağım. Blog [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Emre Erkan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2576:\"<p><img class=\"size-full wp-image-20090\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/wceu16_departure.jpg\" alt=\"SAW\" width=\"670\" height=\"336\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/wceu16_departure.jpg 670w, https://www.wp-tr.org/wp-content/uploads/2016/06/wceu16_departure-200x100.jpg 200w\" sizes=\"(max-width: 670px) 100vw, 670px\" /></p>\n<h2>Merhaba!</h2>\n<p>Ben Emre Erkan. 2005 yılından beri aktif olarak WordPress kullanıyor ve 2008 yılından beri WordPress Türkiye ekibini yönetiyorum. Türkçe paketin hazırlanması, topluluk yönetimi, etkinliklerin düzenlenmesi, WordPress.org ile iletişim gibi bir çok alanda gönüllü olarak çalışıyorum.</p>\n<p>WordCamp Avrupa 2016 yarın başlıyor. Üç gün sürecek etkinliği WordPress Türkiye takipçilerine aktarmak için <a href=\"http://www.turhost.com/\">Turhost</a> sponsorluğunda Viyana&#8217;da olacağım. Blog yazıları, Facebook üzerinden canlı yayınlar ve sosyal medya paylaşımları ile elimden geldiğince etkinliği sizlere aktarmaya çalışacağım.</p>\n<p>Viyana&#8217;da olacağım 5 gün boyunca her gün sponsorlarımızın sağladığı hediyeleri de sizlerle buluşturacağım. Örneğin bugün Turhost tarafından 5 kişiye hediye edilecek Bireysel Limitsiz WordPress paketini kazanmak için <a href=\"https://www.facebook.com/WPTurkiye/photos/a.336819856346153.93510.248932931801513/1324518720909590/?type=3\">Facebook sayfamızı</a> takip edin.</p>\n<p><a href=\"http://www.turhost.com\" target=\"_blank\"><img class=\"aligncenter wp-image-20091 size-full\" src=\"https://www.wp-tr.org/wp-content/uploads/2016/06/turhost.png\" alt=\"turhost\" width=\"500\" height=\"125\" srcset=\"https://www.wp-tr.org/wp-content/uploads/2016/06/turhost.png 500w, https://www.wp-tr.org/wp-content/uploads/2016/06/turhost-200x50.png 200w\" sizes=\"(max-width: 500px) 100vw, 500px\" /></a></p>\n<p>2004 yılında kurulmuş olan Turhost.com 2006 yılından bu yana kullanıcılarına yüksek performanslı paylaşımlı hosting, wordpress hosting, bulut sunucu, kiralık sunucu ve alan adı tescil hizmetleri vermektedir. Domain tescilinde <acronym title=\"Internet Corporation for Assigned Names and Numbers\">ICANN</acronym> akreditasyonu olan Turhost.com, 40.000 üzerinde aktif kullanıcısına; 50.000 üzerinde alanadı için paylaşımlı hosting hizmeti sağlamaktadır.</p>\n<p>24 çalışanı ile Turhost.com Türkiye&#8217;de hosting hizmeti sağlayan önde kuruluşlarından biridir.</p><img src=\"http://feeds.feedburner.com/~r/wp-turkiye/~4/cZAbXzoTMDc\" height=\"1\" width=\"1\" alt=\"\"/>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://www.wp-tr.org/yolculuk-basladi/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"20089\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:8:\"origLink\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://www.wp-tr.org/yolculuk-basladi/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:4:\"site\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"67772354\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:2:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";s:4:\"href\";s:38:\"http://feeds.feedburner.com/wp-turkiye\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:2:{s:3:\"rel\";s:3:\"hub\";s:4:\"href\";s:32:\"http://pubsubhubbub.appspot.com/\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:42:\"http://rssnamespace.org/feedburner/ext/1.0\";a:1:{s:4:\"info\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:3:\"uri\";s:10:\"wp-turkiye\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:10:{s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:4:\"etag\";s:27:\"/rS6ChYs3LdWlQjfEdZeKBfB+MA\";s:13:\"last-modified\";s:29:\"Mon, 11 May 2020 01:33:28 GMT\";s:16:\"content-encoding\";s:4:\"gzip\";s:4:\"date\";s:29:\"Mon, 11 May 2020 01:57:02 GMT\";s:7:\"expires\";s:29:\"Mon, 11 May 2020 01:57:02 GMT\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:22:\"x-content-type-options\";s:7:\"nosniff\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:6:\"server\";s:3:\"GSE\";}}s:5:\"build\";s:14:\"20180903223853\";}","no"),
("7860","_site_transient_community-events-daa81b9093cd4a22ed5555c05e38f8b0","a:3:{s:9:\"sandboxed\";b:0;s:8:\"location\";a:1:{s:2:\"ip\";s:12:\"77.111.247.0\";}s:6:\"events\";a:0:{}}","no"),
("7837","_site_transient_timeout_theme_roots","1589164057","no"),
("7838","_site_transient_theme_roots","a:3:{s:21:\"Ucretsiz-WT-discovery\";s:7:\"/themes\";s:14:\"twentynineteen\";s:7:\"/themes\";s:12:\"twentytwenty\";s:7:\"/themes\";}","no"),
("7850","_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a","1589173145","no"),
("7851","_site_transient_poptags_40cd750bba9870f18aada2478b24840a","O:8:\"stdClass\":100:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";i:4687;}s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";i:4085;}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";i:2666;}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";i:2549;}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";i:1960;}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";i:1805;}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";i:1788;}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";i:1483;}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";i:1471;}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";i:1470;}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";i:1448;}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";i:1423;}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";i:1414;}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";i:1301;}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";i:1188;}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";i:1186;}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";i:1119;}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";i:1116;}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";i:1089;}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";i:987;}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";i:877;}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";i:873;}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";i:871;}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";i:859;}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";i:791;}s:10:\"e-commerce\";a:3:{s:4:\"name\";s:10:\"e-commerce\";s:4:\"slug\";s:10:\"e-commerce\";s:5:\"count\";i:773;}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";i:765;}s:6:\"slider\";a:3:{s:4:\"name\";s:6:\"slider\";s:4:\"slug\";s:6:\"slider\";s:5:\"count\";i:764;}s:9:\"analytics\";a:3:{s:4:\"name\";s:9:\"analytics\";s:4:\"slug\";s:9:\"analytics\";s:5:\"count\";i:753;}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";i:744;}s:4:\"form\";a:3:{s:4:\"name\";s:4:\"form\";s:4:\"slug\";s:4:\"form\";s:5:\"count\";i:717;}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";i:716;}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";i:709;}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";i:698;}s:6:\"search\";a:3:{s:4:\"name\";s:6:\"search\";s:4:\"slug\";s:6:\"search\";s:5:\"count\";i:685;}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";i:659;}s:4:\"menu\";a:3:{s:4:\"name\";s:4:\"menu\";s:4:\"slug\";s:4:\"menu\";s:5:\"count\";i:652;}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";i:649;}s:6:\"editor\";a:3:{s:4:\"name\";s:6:\"editor\";s:4:\"slug\";s:6:\"editor\";s:5:\"count\";i:644;}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";i:640;}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"ajax\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";i:626;}s:5:\"embed\";a:3:{s:4:\"name\";s:5:\"embed\";s:4:\"slug\";s:5:\"embed\";s:5:\"count\";i:626;}s:3:\"css\";a:3:{s:4:\"name\";s:3:\"css\";s:4:\"slug\";s:3:\"css\";s:5:\"count\";i:583;}s:12:\"contact-form\";a:3:{s:4:\"name\";s:12:\"contact form\";s:4:\"slug\";s:12:\"contact-form\";s:5:\"count\";i:582;}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";i:578;}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";i:574;}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";i:570;}s:7:\"payment\";a:3:{s:4:\"name\";s:7:\"payment\";s:4:\"slug\";s:7:\"payment\";s:5:\"count\";i:566;}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";i:554;}s:5:\"theme\";a:3:{s:4:\"name\";s:5:\"theme\";s:4:\"slug\";s:5:\"theme\";s:5:\"count\";i:547;}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";i:546;}s:9:\"affiliate\";a:3:{s:4:\"name\";s:9:\"affiliate\";s:4:\"slug\";s:9:\"affiliate\";s:5:\"count\";i:540;}s:10:\"responsive\";a:3:{s:4:\"name\";s:10:\"responsive\";s:4:\"slug\";s:10:\"responsive\";s:5:\"count\";i:535;}s:9:\"dashboard\";a:3:{s:4:\"name\";s:9:\"dashboard\";s:4:\"slug\";s:9:\"dashboard\";s:5:\"count\";i:531;}s:6:\"custom\";a:3:{s:4:\"name\";s:6:\"custom\";s:4:\"slug\";s:6:\"custom\";s:5:\"count\";i:529;}s:3:\"ads\";a:3:{s:4:\"name\";s:3:\"ads\";s:4:\"slug\";s:3:\"ads\";s:5:\"count\";i:523;}s:10:\"categories\";a:3:{s:4:\"name\";s:10:\"categories\";s:4:\"slug\";s:10:\"categories\";s:5:\"count\";i:511;}s:3:\"api\";a:3:{s:4:\"name\";s:3:\"api\";s:4:\"slug\";s:3:\"api\";s:5:\"count\";i:506;}s:7:\"contact\";a:3:{s:4:\"name\";s:7:\"contact\";s:4:\"slug\";s:7:\"contact\";s:5:\"count\";i:502;}s:4:\"user\";a:3:{s:4:\"name\";s:4:\"user\";s:4:\"slug\";s:4:\"user\";s:5:\"count\";i:498;}s:15:\"payment-gateway\";a:3:{s:4:\"name\";s:15:\"payment gateway\";s:4:\"slug\";s:15:\"payment-gateway\";s:5:\"count\";i:498;}s:6:\"button\";a:3:{s:4:\"name\";s:6:\"button\";s:4:\"slug\";s:6:\"button\";s:5:\"count\";i:490;}s:4:\"tags\";a:3:{s:4:\"name\";s:4:\"tags\";s:4:\"slug\";s:4:\"tags\";s:5:\"count\";i:489;}s:9:\"gutenberg\";a:3:{s:4:\"name\";s:9:\"gutenberg\";s:4:\"slug\";s:9:\"gutenberg\";s:5:\"count\";i:484;}s:5:\"users\";a:3:{s:4:\"name\";s:5:\"users\";s:4:\"slug\";s:5:\"users\";s:5:\"count\";i:475;}s:6:\"mobile\";a:3:{s:4:\"name\";s:6:\"mobile\";s:4:\"slug\";s:6:\"mobile\";s:5:\"count\";i:473;}s:6:\"events\";a:3:{s:4:\"name\";s:6:\"events\";s:4:\"slug\";s:6:\"events\";s:5:\"count\";i:469;}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";i:438;}s:4:\"chat\";a:3:{s:4:\"name\";s:4:\"chat\";s:4:\"slug\";s:4:\"chat\";s:5:\"count\";i:437;}s:9:\"marketing\";a:3:{s:4:\"name\";s:9:\"marketing\";s:4:\"slug\";s:9:\"marketing\";s:5:\"count\";i:436;}s:9:\"slideshow\";a:3:{s:4:\"name\";s:9:\"slideshow\";s:4:\"slug\";s:9:\"slideshow\";s:5:\"count\";i:428;}s:10:\"navigation\";a:3:{s:4:\"name\";s:10:\"navigation\";s:4:\"slug\";s:10:\"navigation\";s:5:\"count\";i:427;}s:5:\"popup\";a:3:{s:4:\"name\";s:5:\"popup\";s:4:\"slug\";s:5:\"popup\";s:5:\"count\";i:426;}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";i:423;}s:8:\"calendar\";a:3:{s:4:\"name\";s:8:\"calendar\";s:4:\"slug\";s:8:\"calendar\";s:5:\"count\";i:423;}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";i:422;}s:10:\"statistics\";a:3:{s:4:\"name\";s:10:\"statistics\";s:4:\"slug\";s:10:\"statistics\";s:5:\"count\";i:409;}s:5:\"forms\";a:3:{s:4:\"name\";s:5:\"forms\";s:4:\"slug\";s:5:\"forms\";s:5:\"count\";i:406;}s:10:\"newsletter\";a:3:{s:4:\"name\";s:10:\"newsletter\";s:4:\"slug\";s:10:\"newsletter\";s:5:\"count\";i:405;}s:4:\"news\";a:3:{s:4:\"name\";s:4:\"news\";s:4:\"slug\";s:4:\"news\";s:5:\"count\";i:396;}s:10:\"shortcodes\";a:3:{s:4:\"name\";s:10:\"shortcodes\";s:4:\"slug\";s:10:\"shortcodes\";s:5:\"count\";i:395;}s:14:\"contact-form-7\";a:3:{s:4:\"name\";s:14:\"contact form 7\";s:4:\"slug\";s:14:\"contact-form-7\";s:5:\"count\";i:394;}s:12:\"social-media\";a:3:{s:4:\"name\";s:12:\"social media\";s:4:\"slug\";s:12:\"social-media\";s:5:\"count\";i:385;}s:8:\"redirect\";a:3:{s:4:\"name\";s:8:\"redirect\";s:4:\"slug\";s:8:\"redirect\";s:5:\"count\";i:384;}s:7:\"plugins\";a:3:{s:4:\"name\";s:7:\"plugins\";s:4:\"slug\";s:7:\"plugins\";s:5:\"count\";i:377;}s:4:\"code\";a:3:{s:4:\"name\";s:4:\"code\";s:4:\"slug\";s:4:\"code\";s:5:\"count\";i:376;}s:9:\"multisite\";a:3:{s:4:\"name\";s:9:\"multisite\";s:4:\"slug\";s:9:\"multisite\";s:5:\"count\";i:373;}s:11:\"performance\";a:3:{s:4:\"name\";s:11:\"performance\";s:4:\"slug\";s:11:\"performance\";s:5:\"count\";i:370;}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"url\";s:4:\"slug\";s:3:\"url\";s:5:\"count\";i:368;}s:12:\"notification\";a:3:{s:4:\"name\";s:12:\"notification\";s:4:\"slug\";s:12:\"notification\";s:5:\"count\";i:360;}s:4:\"meta\";a:3:{s:4:\"name\";s:4:\"meta\";s:4:\"slug\";s:4:\"meta\";s:5:\"count\";i:357;}s:4:\"list\";a:3:{s:4:\"name\";s:4:\"list\";s:4:\"slug\";s:4:\"list\";s:5:\"count\";i:356;}s:5:\"block\";a:3:{s:4:\"name\";s:5:\"block\";s:4:\"slug\";s:5:\"block\";s:5:\"count\";i:354;}s:9:\"elementor\";a:3:{s:4:\"name\";s:9:\"elementor\";s:4:\"slug\";s:9:\"elementor\";s:5:\"count\";i:345;}s:8:\"shipping\";a:3:{s:4:\"name\";s:8:\"shipping\";s:4:\"slug\";s:8:\"shipping\";s:5:\"count\";i:344;}s:8:\"tracking\";a:3:{s:4:\"name\";s:8:\"tracking\";s:4:\"slug\";s:8:\"tracking\";s:5:\"count\";i:343;}s:16:\"google-analytics\";a:3:{s:4:\"name\";s:16:\"google analytics\";s:4:\"slug\";s:16:\"google-analytics\";s:5:\"count\";i:338;}s:16:\"custom-post-type\";a:3:{s:4:\"name\";s:16:\"custom post type\";s:4:\"slug\";s:16:\"custom-post-type\";s:5:\"count\";i:337;}s:11:\"advertising\";a:3:{s:4:\"name\";s:11:\"advertising\";s:4:\"slug\";s:11:\"advertising\";s:5:\"count\";i:335;}s:5:\"cache\";a:3:{s:4:\"name\";s:5:\"cache\";s:4:\"slug\";s:5:\"cache\";s:5:\"count\";i:332;}}","no"),
("7861","duplicator_pro_reset_user_settings_required","0","yes"),
("7859","_site_transient_timeout_community-events-daa81b9093cd4a22ed5555c05e38f8b0","1589205718","no"),
("148","current_theme","Discovery","yes"),
("149","theme_mods_Ucretsiz-WT-discovery","a:54:{i:0;b:0;s:18:\"nav_menu_locations\";a:1:{s:7:\"primary\";i:2;}s:18:\"custom_css_post_id\";i:-1;s:20:\"homepage_slider_hide\";b:0;s:19:\"homepage_slider_cat\";s:1:\"7\";s:25:\"homepage_promotional_bool\";b:0;s:22:\"header-one-file-upload\";s:90:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/img1-e1536015506397.jpg\";s:14:\"header_one_url\";s:1:\"#\";s:16:\"featured_textbox\";s:59:\"Kurumsal Ücretsiz Wordpress Tema Örnek Promo Metin Alanı\";s:19:\"featured_button_url\";s:1:\"#\";s:22:\"homepage_service_title\";s:16:\"HİZMETLERİMİZ\";s:27:\"featured_textbox_header_one\";s:19:\"Kurumsal İletişim\";s:25:\"featured_textbox_text_one\";s:202:\"Firmamız hizmet alanları ile kurumsal destek hizmetleri sunmaktayız. Lorem ipsum örnek metin alanı ile wordpress tema önizlemelerinde gerçekçi içerik efekti oluşturmanıza yardımcı oluyoruz.\";s:22:\"header-two-file-upload\";s:90:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/img1-e1536015506397.jpg\";s:27:\"featured_textbox_header_two\";s:17:\"Güçlü Altyapı\";s:14:\"header_two_url\";s:1:\"#\";s:25:\"featured_textbox_text_two\";s:202:\"Firmamız hizmet alanları ile kurumsal destek hizmetleri sunmaktayız. Lorem ipsum örnek metin alanı ile wordpress tema önizlemelerinde gerçekçi içerik efekti oluşturmanıza yardımcı oluyoruz.\";s:24:\"header-three-file-upload\";s:90:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/img1-e1536015506397.jpg\";s:29:\"featured_textbox_header_three\";s:19:\"Efektif Çözümler\";s:16:\"header_three_url\";s:1:\"#\";s:27:\"featured_textbox_text_three\";s:202:\"Firmamız hizmet alanları ile kurumsal destek hizmetleri sunmaktayız. Lorem ipsum örnek metin alanı ile wordpress tema önizlemelerinde gerçekçi içerik efekti oluşturmanıza yardımcı oluyoruz.\";s:21:\"homepage_recent_title\";s:23:\"Güncel Blog Yazıları\";s:23:\"homepage_partners_title\";s:23:\"Çözüm Ortaklarımız\";s:12:\"logo_one_url\";s:1:\"#\";s:20:\"logo-one-file-upload\";s:80:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/orneklogo.png\";s:20:\"logo-two-file-upload\";s:80:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/orneklogo.png\";s:12:\"logo_two_url\";s:1:\"#\";s:22:\"logo-three-file-upload\";s:80:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/orneklogo.png\";s:14:\"logo_three_url\";s:1:\"#\";s:21:\"logo-four-file-upload\";s:80:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/orneklogo.png\";s:13:\"logo_four_url\";s:1:\"#\";s:11:\"authors_ids\";s:10:\"zsdfsdfsdf\";s:20:\"authors_hide_content\";s:1:\"1\";s:21:\"authors_content_below\";s:1:\"1\";s:14:\"discovery_logo\";s:77:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/LOGORR.png\";s:28:\"telnumber_textbox_header_one\";s:14:\"0850 840 98 08\";s:25:\"mobile_textbox_header_one\";s:14:\"0506 415 33 82\";s:24:\"email_textbox_header_one\";s:26:\"ucretsiz@wordpresstema.com\";s:26:\"address_textbox_header_one\";s:43:\"Hanımeli sk. no:14 Beylükdüzü İSTANBUL\";s:7:\"twitter\";s:1:\"#\";s:8:\"facebook\";s:1:\"#\";s:10:\"googleplus\";s:1:\"#\";s:7:\"youtube\";s:1:\"#\";s:22:\"discovery_color_scheme\";s:3:\"red\";s:12:\"header_image\";s:13:\"remove-header\";s:24:\"discovery_global_favicon\";s:85:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/robrady-r-icon.jpg\";s:27:\"discovery_global_apple_icon\";s:85:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/robrady-r-icon.jpg\";s:16:\"background_image\";s:94:\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/800px_COLOURBOX22078175.jpg\";s:21:\"background_position_x\";s:4:\"left\";s:21:\"background_position_y\";s:3:\"top\";s:15:\"background_size\";s:4:\"auto\";s:17:\"background_repeat\";s:6:\"repeat\";s:19:\"featured_button_txt\";s:17:\"BİZİMLE ULAŞIN\";s:14:\"copyright_text\";s:35:\"Wordpress ile güçlendirilmiştir.\";}","yes"),
("150","theme_switched","","yes"),
("164","nav_menu_options","a:1:{s:8:\"auto_add\";a:0:{}}","yes"),
("221","category_children","a:0:{}","yes"),
("250","recently_activated","a:0:{}","yes"),
("271","cf7_style_welcome","show_box","yes"),
("272","cf7_style_update_saved","no","yes"),
("273","cf7_style_allow_tracking","1","yes"),
("274","cf7_style_add_categories","1","yes"),
("275","cf7_style_adminbar","1","yes"),
("276","cf7_style_plugin_version","3.1.7","yes"),
("280","style_category_children","a:0:{}","yes"),
("281","cf7_style_cookie","1","yes"),
("291","colio_group_children","a:0:{}","yes"),
("1073","wpos_anylc_site_uid","db89db5a4899bd5652e1edc47606c8df","yes"),
("402","wpclone_directory_scan","a:4:{s:6:\"dbsize\";s:9:\"764.39 KB\";s:4:\"size\";s:8:\"20.19 MB\";s:5:\"files\";i:955;s:4:\"time\";i:1536850416;}","yes"),
("339","gkit_log_last_ts","1536239494","yes"),
("347","wppap_portfolio_cat_children","a:0:{}","yes"),
("406","wpclone_backups","a:1:{i:1536850419;a:4:{s:4:\"name\";s:55:\"wpclone_backup_13th_Sep_2018_05-53PM_Üc_snP9htwOx5.zip\";s:3:\"log\";s:55:\"wpclone_backup_13th_Sep_2018_05-53PM_Üc_snP9htwOx5.log\";s:7:\"creator\";s:7:\"wtadmin\";s:4:\"size\";i:15696874;}}","yes"),
("1076","wpos_anylc_pdt_65","a:1:{s:6:\"status\";i:1;}","yes"),
("7825","_transient_timeout_feed_868981a74fb045e2d866f14ee0dbf978","1589205422","no"),
("7821","secure_auth_key","x38)GMq9]|]]Xxr.q|,RIRdh=Lcm>:1v8~|q`^-oXVC1ohI ^tIst%dQVH5}<c-e","no"),
("7822","secure_auth_salt","<m?ux2F-#&j%.1qIPek=iJUh/d}}8_r=-mu#la|4&I~BsLu_yBqd&@[)aeui6)hg","no"),
("7823","_site_transient_timeout_browser_31f552011cd49d12bc3cd930bb193459","1589767020","no"),
("7824","_site_transient_browser_31f552011cd49d12bc3cd930bb193459","a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"81.0.4044.138\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}","no"),
("7827","_transient_timeout_feed_mod_868981a74fb045e2d866f14ee0dbf978","1589205422","no"),
("7828","_transient_feed_mod_868981a74fb045e2d866f14ee0dbf978","1589162222","no"),
("7829","_site_transient_timeout_community-events-5eef22228dbaf23758041bc29f9a88e8","1589205422","no"),
("7830","_site_transient_community-events-5eef22228dbaf23758041bc29f9a88e8","a:3:{s:9:\"sandboxed\";b:0;s:8:\"location\";a:1:{s:2:\"ip\";s:11:\"88.230.30.0\";}s:6:\"events\";a:0:{}}","no"),
("7831","_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9","1589205423","no"),
("7832","_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9","a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"WPTavern: WordCamp Spain 2020 Q&amp;A: Matt Mullenweg Discusses Virtual Events, Decoupled WordPress, and the Future of Page Builders\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99452\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:293:\"https://wptavern.com/wordcamp-spain-2020-qa-matt-mullenweg-discusses-virtual-events-decoupled-wordpress-and-the-future-of-page-builders?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-spain-2020-qa-matt-mullenweg-discusses-virtual-events-decoupled-wordpress-and-the-future-of-page-builders\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6424:\"<p>Matt Mullenweg joined Mat&iacute;as Ventura at WordCamp Spain yesterday for a lively Q&amp;A session. The virtual event drew 5,000 registered users, and attendees came prepared with some thought-provoking questions about the future of WordPress. Here are a few highlights on some recent topics of interest.</p>\n\n\n\n<p>WordCamps around the globe have been going virtual, embracing the challenge of keeping communities connected through the screen. Mullenweg shared thoughts on how WordCamps have changed during the pandemic and what might be worthwhile to maintain after things go back to normal:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>WordCamps were always exclusionary. If you couldn&rsquo;t make it to be in a physical point at a physical time, you couldn&rsquo;t be there. Tickets were cheap but travel and other costs could be expensive. To our mission of democratizing publishing, if we could radically open up some of the value of WordCamps, not just the talks because the talks you could always watch later online, but some of that person-to-person connection and relationship-building that would happen at WordCamps &ndash; if we can recreate that online I feel like that could be something that would be amazing for the WordPress community.  I feel like we used our in-person events as a crutch, actually. Because they were so good, and I love them, we overweighted towards them. This time allows us to reflect and also try new things that we might not have been pushed to otherwise. I hope that we don&rsquo;t stop any of these new things. I hope there are more WordCamp events in every language.</p></blockquote>\n\n\n\n<p>Large regional events like WordCamp Europe and WordCamp US will be going virtual in the coming months and it will be interesting to see how they work to reproduce the intimate, in-person connections that are often forged at these events. </p>\n\n\n\n<p>One of the first questions was regarding <a href=\"https://wptavern.com/frontity-raises-e1m-with-automattic-and-k-fund\">Automattic&rsquo;s recent investment in Frontity</a>.  Does Automattic&rsquo;s interest mean that React might be implemented in the public part of WordPress? Mullenweg highlighted a few of the positive and negative aspects of decoupled WordPress setups but also confirmed that a React frontend is not on the roadmap for core:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>I&rsquo;m excited to be able to support Frontity. Automattic tries to support as many of the WordPress ecosystem companies as possible. If there is a company doing something interesting in WordPress, we would love to invest and support it. In terms of a React theme in default WordPress, I think that to me that stays in plugin and theme territory for the foreseeable future. The downside of that approach is that you lose all the capabilities of the decades of WordPress plugins and themes and integrations and everything when you move to that more decoupled React frontend. I don&rsquo;t know if what you gain is that much better for a normal content website. In fact, so many single page applications in React when they get to version 2 or 3 usually work on server side rendering. We have server side rendering by default, and it&rsquo;s really fast and really good, especially when you layer in AMP or some other things that can speed it up. It can actually be probably the best possible thing for content driven sites, the best practice, versus application driven sites where something like React might be better. If you take a really optimized PHP-served AMP page, performance-wise versus the same thing going through React, it&rsquo;s hard for me to imagine the React page being faster. In fact, I think it would be much slower. That&rsquo;s how I think about the defaults. But for people who are building more advanced applications or have some sort of constraint on their website where they need the React frontend, I think the decoupled use case of WordPress is stronger than ever. I don&rsquo;t know why anyone would use a proprietary backend, like Contentful or something like that, when you have all the open source security, scalability, and robustness of WordPress available in a decoupled infrastructure as well.</p></blockquote>\n\n\n\n<p>Ventura noted that just because WordPress uses these technologies in the backend, doesn&rsquo;t mean it has to be used on the frontend as well. Based on these comments, it doesn&rsquo;t seem likely that WordPress will be adopting a React-based default theme anytime in the near future.</p>\n\n\n\n<p>The fate of page builders in the Gutenberg era is always a popular topic during Q&amp;A sessions and WordCamp Spain was no exception. The general concern is whether Gutenberg&rsquo;s full site editing capabilities will make these plugins obsolete, but Mullenweg seemed optimistic about WordPress leaving page builders a piece of the market:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>I&rsquo;m really excited for the future of page builders. Before every single page builder would have to do a fair amount of work to recreate their version of blocks. There was a lot of wasted effort with many talented and great developers all over the world essentially rebuilding the wheel or recreating the block over and over. Now that we have these rails in the core of this block infrastructure, it&rsquo;s been widely adopted and implemented with thousands of blocks being created and many more to come, they don&rsquo;t have to create that core fundamental infrastructure and can instead innovate on top of it, because there are so many cool things you can do in page builders that are out of scope of where we want to take Gutenberg.</p></blockquote>\n\n\n\n<p>Mullenweg also said he anticipates that page builders that are not built with Gutenberg in mind will likely be used less and less over time. However, it should be reassuring that there will still be a place in the WordPress ecosystem for products that build on top of the core standard.</p>\n\n\n\n<p>The Q&amp;A session included many more questions on topics of interest, including when multi-language is coming to core, the future of themes, the present and future of the WP REST API, and what new business options may be coming to the WordPress ecosystem. Check out the recorded session embedded below to find out what Matt and Mat&iacute;as would improve in WordPress if they had a magic wand. </p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 08 May 2020 22:41:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WPTavern: Drag and Drop Nav Menu Items in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99477\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"https://wptavern.com/drag-and-drop-nav-menu-items-in-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=drag-and-drop-nav-menu-items-in-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2941:\"<p class=\"has-drop-cap\">Earlier this week, Sajjad Hossain Sagor released the first version of his <a href=\"https://wordpress.org/plugins/drag-drop-menu-items/\">Drag &amp; Drop Menu Items</a> plugin in the WordPress plugin repository. The plugin is a one-off, single-use plugin that does exactly what its name describes &mdash; it allows end-users to drag menu items from the meta boxes on the nav menu screen to the menu they are currently editing.</p>\n\n\n\n<p>Sagor is a freelance web developer from Bangladesh. Drag &amp; Drop Menu Items is the latest of his 18 contributions to the free plugin directory.</p>\n\n\n\n<p>The plugin is simple in nature and does its one job well. To use it, users merely need to open the Appearance &gt; Menus screen in the WordPress admin. Menu items from the meta boxes under the &ldquo;Add menu items&rdquo; section can then be dragged into the menu under the &ldquo;Menu structure&rdquo; section.</p>\n\n\n\n<img />Dragging an item into a custom menu.\n\n\n\n<p>When dragging a menu item over, a drop-box appears between each of the existing items in the menu. It is worth noting that you cannot drag items into a sub-menu slot directly from the meta boxes. This is on par with the default functionality and could be a limitation of WordPress. However, sub-menu organization works as usual.</p>\n\n\n\n<p>The Drag &amp; Drop Menu Items plugin is limited to the Menus screen in the WordPress admin. It does not work in the customizer, which sports a different interface and method of adding menu items.</p>\n\n\n\n<p>The plugin code is minimal and does not appear to have any issues. The additional JavaScript, at less than 4 kb, should not add much weight to the page either.</p>\n\n\n\n<p>By default, WordPress requires two mouse clicks to add an item to a menu: one click to tick the checkbox and a button click to add the item. However, the default method also allows users to append multiple items at once.</p>\n\n\n\n<p>On the whole, the plugin is a good option for users who prefer the drag-and-drop method of adding items or those who prefer to have both methods at their disposal. It adds a nice touch that would make sense as an existing part of WordPress.</p>\n\n\n\n<h2>An Uncertain Future</h2>\n\n\n\n<img />Experimental Navigation screen from the Gutenberg plugin.\n\n\n\n<p class=\"has-drop-cap\">Eventually, Drag &amp; Drop Menu Items may no longer function. The Gutenberg plugin team has already built an early experimental version of a <a href=\"https://github.com/WordPress/gutenberg/pull/21036\">new Navigation screen</a> in the admin. The plan is to incorporate this new screen into core WordPress in the future.</p>\n\n\n\n<p>The new screen will work within the block system and likely use the work that has gone into the existing Navigation block. This will provide consistency in how menus are added across the site.</p>\n\n\n\n<p>For now, if you would like the ability to drag and drop menu items, this plugin is a solid solution.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 08 May 2020 19:15:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: Bringing Back Blogs in the Age of Social Media Censorship\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99380\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:179:\"https://wptavern.com/bringing-back-blogs-in-the-age-of-social-media-censorship?utm_source=rss&utm_medium=rss&utm_campaign=bringing-back-blogs-in-the-age-of-social-media-censorship\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8292:\"<p class=\"is-style-default\">You&rsquo;ve probably never heard of Robert B. Strassler. That&rsquo;s OK, you&rsquo;re not alone.</p>\n\n\n\n<p>Early in his career, Strassler worked in oil fields, but he always had an interest in&nbsp;<em>the classics</em>&nbsp;(the formal designation for the studies of ancient Greek and Roman civilizations). Eventually, Strassler&rsquo;s hobby became an obsession. He went so far as to author his own translation of Thucydides, the Athenian historian of the Peloponnesian War.</p>\n\n\n\n<p>The problem was nobody wanted to read Strassler&rsquo;s book. This was in the 1990s.  It was more difficult to publish to the web and there was no social media. Strassler approached every Ivy League institution he could find. Nobody was interested in reading a manuscript about Thucydides penned by an oilman with no formal credentials. That was the situation until Strassler contacted Victor Davis Hanson, a classicist professor in Fresno, California. Hanson agreed to look at the manuscript and was astounded by Strassler&rsquo;s work: a brilliant, highly readable translation of Thucydides including maps, diagrams, and charts. Hanson helped the disconnected oilman get in touch with a literary agent. Strassler&rsquo;s landmark edition became the standard translation of Thucydides. Still read today, <a rel=\"noreferrer noopener\" href=\"https://www.amazon.com/Landmark-Thucydides-Comprehensive-Guide-Peloponnesian/dp/0684827905/ref=sr_1_4?dchild=1&keywords=strassler&qid=1588787709&sr=8-4\" target=\"_blank\"><em>The Landmark Thucydides: A Comprehensive Guide to the Peloponnesian War</em></a> is as successful as any book on the classics can be&mdash;in the age of Twitter.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p>Those of us who take the idea of democratic publishing seriously rejoice at how the field has opened to include anyone who has something to say and is willing to write it down. That&rsquo;s why we should be more alarmed when we see social media companies crowd the spaces once occupied by blogs and do-it-yourself content creators. We see a decline in diverse opinions as the web quickly becomes less free and more autocratic.</p>\n\n\n\n<p>How many Robert B. Strasslers are being stifled today by biased algorithms and arbitrary &ldquo;community guidelines&rdquo;?</p>\n\n\n\n<p>In March, as COVID-19 exploded into a worldwide panic, the web gatekeepers we&rsquo;ve come to rely on quickly massed around a singular interpretation of events and&nbsp;<a href=\"https://www.wsj.com/articles/controlling-the-virus-narrative-11584899715\">stifled dissenting voices</a>&mdash;even mild ones.</p>\n\n\n\n<p>YouTube, the second largest search engine in the world, demonetized all videos that mentioned &ldquo;COVID-19,&rdquo; &ldquo;Coronavirus,&rdquo; or any term related to the pandemic, and herded viewers away from content creators and toward the Center for Disease Control (CDC) &mdash; the same&nbsp;<a href=\"https://www.usatoday.com/story/news/politics/2020/04/01/coronavirus-surgeon-general-says-cdc-asked-review-mask-guidance/5101884002/\">CDC that first advised&nbsp;<em>against</em>&nbsp;wearing masks</a>. Even medical practitioners who deviated slightly from the prevailing vision&nbsp;<a href=\"https://www.turnto23.com/news/coronavirus/video-interview-with-dr-dan-erickson-and-dr-artin-massihi-taken-down-from-youtube\">were removed from the platform</a>&nbsp;after gaining millions of views.</p>\n\n\n\n<p>Experienced journalists who questioned official decrees (surely, the role journalists are expected to perform) were targeted with hit pieces and character assassination by their own peers.</p>\n\n\n\n<p>As author/professor Cal Newport noted in an&nbsp;<a href=\"https://www.wired.com/story/opinion-expert-twitter-only-goes-so-far-bring-back-blogs/\">op-ed for&nbsp;<em>Wired</em></a>, much of the dissenting viewpoints and on-the-ground data have become part of the mainstream conversation even after being suppressed by a small group of decision-makers: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>We don&rsquo;t necessarily want to trust engineers at one company to make the decisions about what topics the public should and should not be able to read about.</p></blockquote>\n\n\n\n<p>How many times have you clicked on a link in a tweet and received a message as shown in the following screenshot?</p>\n\n\n\n<img />Twitter unsafe link warning.\n\n\n\n<p>Adults should be trusted to determine what kind of content is harmful (if such a thing exists) without the assistance of Twitter employees and their &ldquo;partners.&rdquo; And, are these warnings actually meant to protect people or simply to shield Twitter from corporate liability? I think we can guess what the answer is.</p>\n\n\n\n<p>It&rsquo;s not only those without official-sounding credentials who are being barred from sharing content. Creators who clearly have experience in their fields of study are also facing arbitrary censorship.</p>\n\n\n\n<p><a rel=\"noreferrer noopener\" href=\"https://www.thegreatcoursesplus.com/\" target=\"_blank\">The Great Courses Plus</a>, a streaming service that produces college-level video courses taught by actual professors, was threatened with a ban from Google if they did not remove COVID-19-related content from their app. In an email to subscribers, the team wrote:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Google informed us they would ban The Great Courses apps if we continued to make [Covid-19] in-app content available. We are working with Google to ensure that they understand our content is factual, expert-led, and thoroughly vetted, so that we can remedy this misunderstanding as soon as possible.</p></blockquote>\n\n\n\n<p>The videos in question included content from Dr. Roy Benaroch, Adjunct Assistant Professor of Pediatrics at the Emory University School of Medicine; Dr. David Kung, Professor of Mathematics at St. Mary&rsquo;s College of Maryland; and Dr. Kevin Ahern, Professor of Biochemistry and Biophysics at Oregon State University. How or why these scholars were found unworthy of Google&rsquo;s imprimatur is a mystery. As the public does not presume to give Google programming advice, perhaps Google could return the favor by not pretending to be experts on epidemiology, immunology, and virology.</p>\n\n\n\n<p>The only way to see these offending videos is on the <a href=\"https://www.thegreatcoursesdaily.com/\" target=\"_blank\" rel=\"noreferrer noopener\">Great Courses website</a>, where Google&rsquo;s authority is not absolute. <em>It happens to be a WordPress-powered site.</em> For intellectuals and laymen who value free expression, having your own website is becoming the only way to make sure you can keep it.</p>\n\n\n\n<p><strong>The problem of pitting credentials against experience in a zero-sum conflict is fixable, and WordPress is a big part of the solution.</strong></p>\n\n\n\n<p>WordPress allows capable scientists, economists, and medical professionals in other fields to write at length about their ideas without fear of being blocked by arbitrary restrictions. Also, the five-minute install (which does take a little more than five minutes for many people) imposes enough of a barrier to entry to discourage cranks. </p>\n\n\n\n<p>We like to think of the internet as a true egalitarian system, where every voice is given equal consideration, but deep down we know that&rsquo;s not exactly how it works. Network effects tend to form hubs of concentrated influence around a handful of websites. This isn&rsquo;t always a bad thing. A recipe blog with poor taste and no pictures deserves fewer readers than a blog with great-tasting recipes and high-resolution images.</p>\n\n\n\n<p>There is still room enough in the network for certain nodes to grow in size and influence based on the quality of their content. A node with enough backlinks, good organic search rankings, and high-quality content will gain an audience, and be able to keep it, without fear of corporate reprisals or aggressive algorithm updates.</p>\n\n\n\n<p>If we really care about democratizing publishing, we won&rsquo;t always like what we read. There will be disagreements, but democracy requires a literate population eager for debate. We can challenge, discuss, and learn.</p>\n\n\n\n<p>There are a lot of Robert B. Strasslers out there in the network, waiting patiently to be heard.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 08 May 2020 15:41:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Chris Maiorana\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: WP Engine Launches Genesis Pro Add-On for Customers, More Features in the Works\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99440\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:221:\"https://wptavern.com/wp-engine-launches-genesis-pro-add-on-for-customers-more-features-in-the-works?utm_source=rss&utm_medium=rss&utm_campaign=wp-engine-launches-genesis-pro-add-on-for-customers-more-features-in-the-works\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6549:\"<p class=\"has-drop-cap\">Managed web hosting company WP Engine launched the new <a href=\"https://studiopress.blog/announcing-genesis-pro/\">Genesis Pro add-on</a> for customers of its hosting service today. The add-on brings additional block editor features for users who are using a Genesis-based WordPress theme.</p>\n\n\n\n<p>Genesis is a parent theme developed by StudioPress. WP Engine <a href=\"https://wptavern.com/wp-engine-acquires-studiopress\">acquired the theme development company</a> in 2018. Later that year, the company took the first steps toward <a href=\"https://wptavern.com/genesis-framework-and-studiopress-themes-add-gutenberg-compatibility-more-gutenberg-features-coming-soon\">adding compatibility with the block editor</a> for Genesis customers, becoming an early adopter of the new editing experience.</p>\n\n\n\n<p>&ldquo;Beyond just being &lsquo;compatible,&rsquo; Genesis will play a big role in being Gutenberg-First,&rdquo; Jason Cohen, CTO of WP Engine, said of future plans nearly two years ago. &ldquo;That means not only supporting the software and ideals of Gutenberg but using them for new features. In doing so, it&rsquo;s our intention to light the way for the countless agencies and developers who use WordPress to fuel incredible digital experiences that are made even easier with Gutenberg.&rdquo;</p>\n\n\n\n<p>Today&rsquo;s <a href=\"https://wpengine.com/genesis-pro\">Genesis Pro</a> launch is another step on that journey. WP Engine is currently rolling out the add-on as part of its managed hosting service. The cost is $30/month ($360/year) for an unlimited number of sites.</p>\n\n\n\n<p>The current plan is to also make the Genesis Pro plugin available via the StudioPress website in the early summer. The company is not formally committing to that timeframe yet, but users not on WP Engine&rsquo;s hosting service should expect it this year. The price for Genesis Pro will be available for $360/year, which is at the same rate as the hosting add-on.</p>\n\n\n\n<p>The reason behind the early launch for web hosting clients seems to be twofold based on the announcement post. David Vogelpohl, VP of Web Strategy for WP Engine, said the company could launch the product faster and increment with the launch for its hosting customers. They are also able to make sure the payment system scales, which StudioPress now uses.</p>\n\n\n\n<p>&ldquo;Genesis Pro&rsquo;s capabilities are expressed in a single plugin today, but may be provided in multiple plugins, WP adjacent services, or other means in the future based on architectural decisions of any particular feature,&rdquo; said Vogelpohl.</p>\n\n\n\n<p>Watch a quick video on Genesis Pro:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<div class=\"embed-vimeo\"></div>\n</div>\n\n\n\n<h2>Genesis Pro Features</h2>\n\n\n\n<img />Example layout from the Genesis Pro add-on.\n\n\n\n<p class=\"has-drop-cap\">The add-on includes a robust set of options that are primarily aimed at helping users build their webpages with custom blocks and designs. The following features are the foundation of the add-on:</p>\n\n\n\n<ul><li><strong>Block Library:</strong> Includes 17 custom blocks, such as a testimonial and pricing block.</li><li><strong>Page Layouts:</strong> Offers 22 full layouts for product, portfolio, team, and other pages.</li><li><strong>Content Sections:</strong> Adds 38 customizable content sections.</li><li><strong>Permissions System:</strong> Allows admins to set editing permissions on a per-block basis.</li><li><strong>Customization:</strong> Users can create and share custom sections and layouts with content creators.</li></ul>\n\n\n\n<p>Most of the options seem to be under a pop-up modal on the post-editing screen that should allow users to insert blocks directly into their post or page content. More blocks, sections, layouts, and other content-creation tools are currently in the works.</p>\n\n\n\n<img />Layout selector from the Genesis Pro add-on.\n\n\n\n<p>The add-on features are mostly standard fare in comparison to many of the block libraries and suites available throughout the WordPress ecosystem. Of course, these will have the StudioPress spin on them and likely be of high quality based if past work is any indication. With the launch out of the way and the foundation in place, it should be much easier for the team to churn out more customization options for end-users.</p>\n\n\n\n<p>The most unique feature is probably around the block permissions system, which few companies have truly tackled. For site administrators who work with multiple creators, setting up editing permissions for individual blocks can be useful. If the user experience for this system works well, it will be a huge selling point for some site owners.</p>\n\n\n\n<img />Block permissions settings for Genesis Pro.\n\n\n\n<h2>Genesis X</h2>\n\n\n\n<p class=\"has-drop-cap\">Vogelpohl teased another project the team has been working on titled &ldquo;Genesis X,&rdquo; which is separate from the Genesis Pro project. It is an experimental plugin version of Genesis that will be available to StudioPress customers at no additional charge. The work thus far has centered on what Genesis will look like in a world where full-site editing is available through WordPress itself.</p>\n\n\n\n<p>&ldquo;The current version of Genesis X focuses on helping site creators easily manage global styles across their site, customize and manage blocks, as well as other capabilities to help users win with full-site editing in WordPress core,&rdquo; said Vogelpohl. &ldquo;Genesis X is being built core-adjacent and is not a replacement for the block editor. It is designed to work with the block editor.&rdquo;</p>\n\n\n\n<p>Vogelpohl said the first objective of the project is to provide analogs for features in Genesis that would not work in a parent theme structure within the full-site editing context. &ldquo;After achieving that parity in ways that make sense, we will be focused on the advanced block capabilities as well as other features currently on our roadmap,&rdquo; he said.</p>\n\n\n\n<p>The company is putting a lot of weight and resources behind the transition from pre-block WordPress and the upcoming features that WordPress will offer via the block system. Right now, they have a team of 15 employees working on solutions with Genesis.</p>\n\n\n\n<p>&ldquo;The overarching theme is that Genesis X is being architected not to just help the Genesis community adapt to full-site editing in core, but for any user of WordPress to adopt full-site editing in a way that sets them up for the best chance of success,&rdquo; said Vogelpohl.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 07 May 2020 20:52:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: GitHub Introduces Codespaces IDE, Discussions, and Code Scanning\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99374\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:189:\"https://wptavern.com/github-introduces-codespaces-ide-discussions-and-code-scanning?utm_source=rss&utm_medium=rss&utm_campaign=github-introduces-codespaces-ide-discussions-and-code-scanning\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4529:\"<p><a href=\"https://githubsatellite.com/\">GitHub Satellite</a>, the company&rsquo;s annual product and community event, went virtual this year for the first time but marched forward with the usual major product announcements.  GitHub is ramping up its offerings with <a href=\"https://github.blog/2020-05-06-new-from-satellite-2020-github-codespaces-github-discussions-securing-code-in-private-repositories-and-more/\">four new products</a>: an IDE, a discussion platform, code scanning, and private instances. </p>\n\n\n\n<p><a href=\"https://github.com/features/codespaces/\">Codespaces</a> is the platform&rsquo;s new built-in IDE that lets users code in the browser with minimal setup. The product is based on the VS Code editor and includes terminal access, support for code completion, and extensions: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Codespaces can be configured to load your code and dependencies, developer tools, extensions, and dotfiles. Switching between environments is simple&mdash;you can navigate away at any time, and when you switch back, your codespace is automatically reopened.</p></blockquote>\n\n\n\n<p>The IDE was created to facilitate contribution but it also enables better development on mobile devices. GitHub design lead Joel Califa shared a demo of how he uses Codespaces on his iPad:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">People have been asking about using Codespaces on the iPad. Here\'s what it looks like: <a href=\"https://t.co/5UQHtzMwZh\">pic.twitter.com/5UQHtzMwZh</a></p>&mdash; Joel Califa (@notdetails) <a href=\"https://twitter.com/notdetails/status/1258120708212785154?ref_src=twsrc%5Etfw\">May 6, 2020</a></blockquote>\n</div>\n\n\n\n<p>GitHub plans to implement a pay-as-you-go pricing model for Codespaces, but it will be free during the limited beta. This product should compliment the recent launch of <a href=\"https://github.com/mobile/\">GitHub&rsquo;s mobile apps for iOS and Android</a> in March, which allows users to manage projects, tasks, feedback, and pull requests.</p>\n\n\n\n<p>Discussions is a new feature that stands to have a more meaningful impact on open source communities. GitHub issues and pull requests have long been the home of most conversations, but oftentimes this type of collaboration would be better served with features more tailored to a knowledge base. Discussions offer a threaded format where questions can be marked as answered. Participation in discussions counts towards users&rsquo; contribution graphs. GitHub plans to put the feature into beta for public repositories soon.</p>\n\n\n\n<img />\n\n\n\n<p>GitHub also announced code scanning, powered by CodeQL, a semantic analysis engine trained to find vulnerabilities. When code scanning is enabled, every `git push` is inspected by CodeQL for potential vulnerabilities and the results are displayed in the pull request. Code scanning is free for open source software. </p>\n\n\n\n<p>Secret scanning, which has been enabled on public repositories since 2018, is now available for private repositories. It scans code for known secret formats and notifies developers upon finding something. At the beginning. of 2019, GitHub announced that it was giving free users access to <a href=\"https://wptavern.com/github-announces-free-unlimited-private-repositories\">unlimited private repositories</a>.  Adding secret scanning to private repositories is the next natural step, as these have likely grown in number after being added to the free tier.</p>\n\n\n\n<p>While many of GitHub&rsquo;s new features are aimed at free users and open source communities, this week&rsquo;s announcements also include a new enterprise product called Private Instances:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Today we introduced our plans for GitHub Private Instances, a new, fully-managed option for our enterprise customers. Private Instances provides enhanced security, compliance, and policy features including bring-your-own-key encryption, backup archiving, and compliance with regional data sovereignty requirements.&nbsp;</p></blockquote>\n\n\n\n<p>After Microsoft acquired GitHub for $7.5 billion in 2018, the company has aggressively worked to make its product more compelling in the highly competitive space of code sharing platforms, starting with the free tier. Pricing has not yet been finalized for any of the revenue-generating products announced this week, as GitHub may be testing the waters to gauge the community&rsquo;s reaction before launch.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 07 May 2020 14:42:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: Apply to Speak at the JavaScript for WordPress Conference\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99026\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:179:\"https://wptavern.com/apply-to-speak-at-the-javascript-for-wordpress-conference?utm_source=rss&utm_medium=rss&utm_campaign=apply-to-speak-at-the-javascript-for-wordpress-conference\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2066:\"<p>The third annual <a href=\"https://javascriptforwp.com/conference/\">JavaScript for WordPress Conference</a> is gearing up for three days of online talks and workshops on July 8-10, 2020. The event is free to attend and organizer Zac Gordon is working to put together a diverse speaker lineup.</p>\n\n\n\n<p>Day 1 will be devoted to workshops that help beginners get up and running with JavaScript and React. Day 2 will focus on building Gutenberg blocks and block-based themes. Day 3 will include topics and projects that use WordPress as a Headless CMS.</p>\n\n\n\n<p>&ldquo;Last year we did 4 tracks all at once.&rdquo; Gordon said. &ldquo;That was a lot. So this year we&rsquo;re doing two days, one track each day. We decided on Blocks and Headless as our two tracks, because that seems to be where most of the JavaScript development is happening at the moment in the WordPress space.&rdquo;</p>\n\n\n\n<p>Previous editions of the conference have pulled in approximately 1,000 viewers, similar to the size of a large WordCamp. Gordon said the event is open for all JavaScript-related topics related to WordPress beyond Gutenberg and headless setups and they are trying to encourage new speakers.</p>\n\n\n\n<p>&ldquo;Each year we&rsquo;re trying to do more to have the conference reflect a range of speakers, and this year we&rsquo;re hoping that a few of the brilliant and industrious younger folks coding or building with WordPress might speak,&rdquo; he said.</p>\n\n\n\n<p><a href=\"https://javascriptforwp.com/conference/register/\">Registration is free</a> on the event website and <a href=\"https://javascriptforwp.com/conference/apply-to-speak/\">applications for speakers</a> will be open until June 1. </p>\n\n\n\n<p>&ldquo;I&rsquo;m not sure how many speakers we will do exactly, but we will have a few folks leading workshops day one and then maybe 5-8 speakers the two other days,&rdquo; Gordon said. &ldquo;It will be fewer speakers than last year, but hopefully still a lot of quality focused talks. The applications we&rsquo;ve seen come in so far are exciting.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 06 May 2020 21:43:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WPTavern: ACF Blocks Provides Assortment of Blocks Built from Advanced Custom Fields Pro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99376\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:221:\"https://wptavern.com/acf-blocks-provides-assortment-of-blocks-built-from-advanced-custom-fields-pro?utm_source=rss&utm_medium=rss&utm_campaign=acf-blocks-provides-assortment-of-blocks-built-from-advanced-custom-fields-pro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8487:\"<p class=\"has-drop-cap\">Over the weekend, Munir Kamal released version 2.0 of his <a href=\"https://wordpress.org/plugins/acf-blocks/\">ACF Blocks plugin</a>, a project that creates a suite of blocks for the editor. The plugin offers 18 custom blocks in its free version and 15 more in the <a href=\"https://www.acfblocks.com/pro/\">pro upgrade</a>. It is built on top of <a href=\"https://www.advancedcustomfields.com/pro/\">Advanced Custom Fields Pro</a> (ACF Pro).</p>\n\n\n\n<p>The latest update of the plugin added support for typography, including options for using various Google Fonts for in-block text. Kamal also included base styling options for design features like margin and padding for every block in the plugin.</p>\n\n\n\n<p>With ACF Pro as a hard dependency, it limits the audience of ACF Blocks. In large part, this plugin will be useful for agencies and freelancers who need to quickly build features for clients within their budget. For that purpose, the plugin does a solid job.</p>\n\n\n\n<p>The tight coupling with ACF Pro hurts the user experience for the plugin. However, the ideas behind ACF Blocks and its custom options make up for the shortcomings of relying on its dependent parent plugin. Decoupling the two is unlikely, but it would make for a smoother experience and open the plugin to a wider audience.</p>\n\n\n\n<p>Kamal took inspiration for the plugin from ACF and its pro version. He described the process of building blocks with the framework &ldquo;super easy,&rdquo; even for an intermediate-level developer. &ldquo;It has been such an amazing WordPress framework for years to create custom fields,&rdquo; he said. &ldquo;And when [Elliot Condon] announced the block creation feature in ACF, that quickly triggered me to build this collection of ready-to-use ACF Blocks.&rdquo;</p>\n\n\n\n<p>The biggest technical limitation is that Kamal cannot build nested blocks, which is a current limitation of ACF. &ldquo;I have already discussed it with [Condon], and he is already working on bringing that functionality hopefully soon,&rdquo; he said. &ldquo;Once that comes to ACF, we may create more amazing and powerful Gutenberg Blocks.&rdquo;</p>\n\n\n\n<p>Watch a short walkthrough of how the plugin works:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\n\n\n\n<h2>Useful Assortment of Blocks</h2>\n\n\n\n<p class=\"has-drop-cap\">While primarily testing the free version of ACF Blocks, I found that it has several useful blocks that could immediately address common needs for end-users. With 18 free blocks available, users have plenty to work with before deciding whether they want to move along the upgrade path to the pro version.</p>\n\n\n\n<p>One of the best blocks in the collection is the Photo Collage block. It is ACF Blocks&rsquo; answer to the core Gallery block. The grid options for this block alone make this plugin worth checking out. The block offers between 2 and 15 grid layouts, depending on the grid option the user selects.</p>\n\n\n\n<img />Setting the grid for the Photo Collage block.\n\n\n\n<p>My second favorite of the assortment is the Testimonial block. Coupled with the typography options, which are available for all blocks, you can have a lot of fun designing a testimonial section.</p>\n\n\n\n<img />Tinkering with Google Fonts in the Testimonial block.\n\n\n\n<p>This is a small sampling of what the plugin can do. The Price List block can help restaurant sites set up their menu. The Pricing Box block, particularly when nested into the core Columns block, makes it easy to set up a pricing section with multiple product options. And, the Team block makes it simple to create profile sections on a company&rsquo;s team/about page.</p>\n\n\n\n<p>The following blocks are available in the free version (with several more in the pro version):</p>\n\n\n\n<ol><li>Scrollable Image Block</li><li>Tab Block</li><li>Toggle Block</li><li>Accordion Block</li><li>Image Slider Block</li><li>Social Sharing Block</li><li>Photo Collage Block</li><li>Posts Block</li><li>Testimonial Block</li><li>Team Block</li><li>Multi Buttons Block</li><li>Pricing Box Block</li><li>Price List Block</li><li>Start Rating Block</li><li>Progress Bar Block</li><li>Counter Number Block</li><li>Click to tweet Block</li><li>Business Hours Block</li></ol>\n\n\n\n<p>Kamal&rsquo;s favorite blocks from the overall suite are Image Hotspot, which allows users to set an image background with &ldquo;pointers&rdquo; to pop up content; Before After Image, which lets users compare two images using a sliding bar; and Photo Collage, the plugin&rsquo;s grid-based gallery block. The first two are available only in the pro version of the plugin. The plugin creator said he thinks all the blocks are useful but these were the most fun to build.</p>\n\n\n\n<h2>Room for Improvement</h2>\n\n\n\n<p class=\"has-drop-cap\">ACF Blocks is a nice concept. It gets a lot of things right. However, there are minor issues that dampen the experience of working with its blocks. These issues are not insurmountable, and I expect Kamal will address them in upcoming versions based on familiarity with his past work and drive toward building great products for users.</p>\n\n\n\n<p>The most immediate issue and likely the simplest to fix is the plugin&rsquo;s styles for left and right margins on every block. The plugin resets these margins to <code>0</code> by default. Depending on the active theme on a site, this could shift the blocks to the edge of the screen instead of the content area on the front end. Some themes use left/right margins to align content. This is not an issue with only ACF Blocks. It is prevalent among plugins with front-end output.</p>\n\n\n\n<p>One quick solution for the margin issue is to wrap any of the plugin&rsquo;s blocks within the core Group block. This will put margins back under the theme&rsquo;s control.</p>\n\n\n\n<p>Editing block content happens in the block options panel instead of directly in the block. I am unsure if this is a limitation of using the ACF Pro framework or a design decision on Kamal&rsquo;s part. It feels odd to jump between editing content in the content area to editing content in the sidebar.</p>\n\n\n\n<p>One example of my confusion with block content was with the Photo Collage block. I clicked on the block, hoping to have the media library appear for uploading. Nothing happened. I clicked again because, well, maybe I did not get a good click in that first time. Nothing happened. I eventually found the image upload button under the block&rsquo;s option panel on the right.</p>\n\n\n\n<p>Setting block options can feel a little sluggish at times with the block output in the editor not reflecting changes immediately. This is primarily because ACF Blocks relies on the server-side rendering capabilities of ACF Pro. It is unlikely this can be addressed in the blocks plugin. Some users may find the delayed rendering to be tedious when editing multiple options.</p>\n\n\n\n<h2>Final Thoughts</h2>\n\n\n\n<p class=\"has-drop-cap\">Kamal has put together a useful set of blocks that will help many end-users build sections of content they cannot create out of the box. Between the free and pro versions, there is a total of 33 blocks. The creator is committed to adding more blocks over time based on user feedback. In the immediate future, he plans to keep hacking away at bug fixes and improving the code.</p>\n\n\n\n<p>I still feel like how ACF Pro works is a hindrance to how good this plugin could be if built from scratch. With that said, the framework helped make Kamal&rsquo;s plugin a reality. ACF Blocks is a showcase in what is possible via ACF Pro, which should inspire other developers who are looking for solutions built on top of one of the most widely-used frameworks in the WordPress ecosystem.</p>\n\n\n\n<p>Kamal understands that some ACF Pro users may try their hands at creating similar blocks but feels like his team&rsquo;s knowledge and dedication to offering support are the most important parts of the equation. &ldquo;ACF Blocks saves time and effort for creating blocks yourself for the most common web design elements,&rdquo; he said.</p>\n\n\n\n<p class=\"is-style-highlight has-white-color has-blue-700-background-color has-text-color has-background text-white bg-blue-700\">Note:  this plugin review and feedback were requested by the plugin author. Read our post about <a href=\"https://wptavern.com/product-reviews-in-the-wordpress-ecosystem-honesty-and-genuine-experiences\">honest feedback based on genuine experiences</a> for more information on how reviews are handled.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 06 May 2020 20:36:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WPTavern: Jetpack 8.5 Adds New Podcast Player Block\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99327\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"https://wptavern.com/jetack-8-5-adds-new-podcast-player-block?utm_source=rss&utm_medium=rss&utm_campaign=jetack-8-5-adds-new-podcast-player-block\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3066:\"<p><a href=\"https://jetpack.com/2020/05/05/jetpack-8-5-new-podcast-block/\">Jetpack 8.5</a> was released today with a new podcast player block for sharing audio content. Configuring the block is as simple as entering the podcast RSS feed URL. This will automatically bring in the cover art and recent episodes. Block options allow for further customization of the display, including the number of episodes, colors, and the ability to show/hide cover art and episode descriptions. </p>\n\n\n\n<img />\n\n\n\n<p>Jetpack&rsquo;s new podcast player has arrived just in time, as podcasting has gotten a little boost in recent months due to the large numbers of people under stay-at-home orders. iHeartRadio, an American audio company with more than 350 podcasts, reports that <a href=\"https://www.iheartmedia.com/press/new-iheartpodcast-insights-show-increase-listening-more-americans-quarantine-during-covid-19\">listenership for its podcasting network is up 6%</a> month-over-month, with California and New York jumping 13% and 8% respectively.  iHeartRadio&rsquo;s insights also showed that certain genres are more popular than others:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>During a time of economic uncertainty, Americans are listening to more business and finance podcasts &ndash; for which downloads and streams are up 78 percent week-over-week among the iHeartRadio Original podcasts. Listeners are also turning to music, entertainment and comedy during this time, where iHeartPodcasts have shown an increase in listening as well.</p></blockquote>\n\n\n\n<p>Selling ads and marketing a new podcast may be more of a struggle during this economic downturn, but those with extra time on their hands may have an easier time producing and publishing episodes. Jetpack&rsquo;s new block makes it easy to share your own episodes or podcasts you enjoy from other websites.</p>\n\n\n\n<p>The 8.5 release also includes significant improvements to the <a href=\"https://jetpack.com/2020/04/07/re-introducing-jetpack-search-for-wordpress-sites/\">new Search feature</a>, which is powered by Elasticsearch, to provide better indexing and a simpler onboarding experience. </p>\n\n\n\n<p>Automattic developer Brandon Kraft published a post today that <a href=\"https://kraft.blog/2020/05/jetpacks-publicize-now-uses-twitter-cards/\">details recent changes to the Publicize feature</a>. In the past, Publicize would attach an image from the post when sending out its automatic tweet to Twitter. This has now been changed for Jetpack and WordPress.com sites so that Publicize no longer attaches a picture but defaults to allowing Twitter to display its Twitter card instead. Developers can use a filter to return the plugin to its previous behavior, if necessary.</p>\n\n\n\n<p>Jetpack 8.5 also makes more widgets and embed tools AMP-compatible, expands options for the Revue block, and fixes layout issues with several other blocks. Check out the <a href=\"https://wordpress.org/plugins/jetpack/#developers\">changelog on WordPress.org</a> for a full list of the enhancements and bug fixes.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 05 May 2020 23:09:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WPTavern: Need to Smile Today? Stay WordPress Strong\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99333\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"https://wptavern.com/need-to-smile-today-stay-wordpress-strong?utm_source=rss&utm_medium=rss&utm_campaign=need-to-smile-today-stay-wordpress-strong\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5173:\"<div class=\"wp-block-embed__wrapper\">\n\n</div><strong>Lyrics:</strong> Zack Katz, Jonathan Mann | <strong>Music:</strong> Jonathan Mann<br />Video licensed under&nbsp;<a href=\"https://creativecommons.org/licenses/by/3.0/us/\">Creative Commons &ndash; Attribution</a>\n\n\n\n<p class=\"has-drop-cap\">For the first time, at least 19 people from the WordPress community can literally call themselves WordPress rock stars without it sounding like an outdated marketing gimmick.</p>\n\n\n\n<p><a href=\"https://gravityview.co/\">GravityView</a> dropped a community music video and website named <a href=\"https://wpstrong.org/\">WordPress Strong</a> earlier today. It is fun. It is inspirational. It will leave a smile on your face. The video features a wide range of faces, voices, and musical talent from around the planet.</p>\n\n\n\n<p>Much of the world is looking for small ways to cope with the ongoing COVID-19 pandemic. Each day is about finding the things we should be thankful for while waiting for life to feel like normal. The WordPress community has been a beacon of hope for many. It has continued providing purpose to people despite their daily lives being upended. This project is one more way to show the strength of our community.</p>\n\n\n\n<p>&ldquo;People were scrambling to adjust to the new reality of living in a pandemic, and there was a rush of uncertainty,&rdquo; said Zack Katz, the creator of GravityView, on starting the project. &ldquo;In the middle of all that uncertainty, I felt lucky to be part of the WordPress community: doing what we do, working on an open and thriving platform, with a culture of people who are kind to each other and support each other.&rdquo;</p>\n\n\n\n<p>Many GravityView customers began using the plugin to enable COVID-19 responses, such as sites like <a href=\"https://supportredditch.net/\">Support Redditch</a>, which coordinates relief efforts. &ldquo;I sensed a movement of coming together to help each other, and I wanted to get the word out: if you need help, ask the community,&rdquo; said Katz. &ldquo;We&rsquo;re here for you. We&rsquo;ll get through this together.&rdquo;</p>\n\n\n\n<p>A total of 19 volunteers contributed to the music video, including WordPress co-founder Matt Mullenweg. However, the true star of the group was Tracy Apps, the owner of <a href=\"http://tracyappsdesign.com/\">tracy apps design</a>, who laid down the beat on the drums.</p>\n\n\n\n<p>&ldquo;It involved asking a lot of people!&rdquo; said Katz of finding willing subjects. &ldquo;I get why people are reluctant. I even waited until the last minute to record my video! Something special happens when people are invited to go beyond their comfort zone, especially when it comes to creative endeavors. It was moving to have the emails come in with their videos. People were willing to share a different part of themselves.&rdquo;</p>\n\n\n\n<p>The <a href=\"https://twitter.com/hashtag/WordPressStrong\">#WordPressStrong</a> hashtag is open for anyone to contribute to on Twitter. The project is calling for volunteers to join in on the fun. If you can sing, play an instrument, or dance &mdash; or if you can&rsquo;t &mdash; you can be a part of this movement for our community to become stronger. If nothing else, it will give you something to do to pass the time. Tag yourself doing something and share it. I am certain it will brighten at least one person&rsquo;s day.</p>\n\n\n\n<h2>The WordPress Strong Project</h2>\n\n\n\n<p class=\"has-drop-cap\">Katz began the project in March. He shared some initial lyric ideas with <a href=\"https://www.jonathanmann.net/\">Jonathan Mann</a> who then wrote and recorded WordPress Strong. The GravityView team reached out to members of the WordPress community and asked them to lend their voices.</p>\n\n\n\n<p>&ldquo;I deeply respect [Mann] as a musician and how he exposes himself through his music,&rdquo; said Katz. &ldquo;His album <em>I Used to Love My Body</em> was my soundtrack for last year.&rdquo;</p>\n\n\n\n<p>Mann is the voice of the GravityView brand and has previously created a <a href=\"https://www.youtube.com/watch?v=nmUWfA56TqA\">song for the product</a>. Katz and Mann also worked on the <a href=\"https://www.youtube.com/watch?v=cqdDo_W8CVE\">WordPress Wiggle</a> song in 2017.</p>\n\n\n\n<p>&ldquo;When creating WordPress Strong, I shared a poem with [Mann] and expressed the tone that I wanted to convey,&rdquo; said Katz. &ldquo;The email had the subject line &lsquo;WordPress Hope Song.&rsquo; He wrote and recorded WordPress Strong, and I think you agree, it&rsquo;s a great WordPress Hope Song.&rdquo;</p>\n\n\n\n<p>The plan for the WordPress Strong website goes beyond releasing a song. Katz wants to expand the site to be a place where people from the community can ask and receive help during the pandemic. The team is currently working on a part of the site where community members can request assistance or offer help anonymously.</p>\n\n\n\n<p>&ldquo;I was hoping artists of all stripes would be interested in sharing their work on the WordPress Strong website,&rdquo; said Katz. &ldquo;Sharing creativity together empowers us to be vulnerable in our despair as well as our hope. I would like to help foster that.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 05 May 2020 20:36:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"Mark Jaquith: WordPress/Jetpack Driver for Laravel Valet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://markjaquith.wordpress.com/?p=7213\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://markjaquith.wordpress.com/2020/05/05/wordpress-jetpack-driver-for-laravel-valet/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1082:\"<p>Recently I&#8217;ve found myself using <a href=\"https://laravel.com/docs/valet\">Laravel Valet</a> for local PHP development on my Mac. I love how fast and low-maintenance it is.</p>\n\n\n\n<p>One thing that is a little tricky about Valet is that you can&#8217;t really write custom Nginx configs. That means that I couldn&#8217;t use my favorite technique of routing missing images to the production site, via Jetpack&#8217;s Site Accelerator (formerly &#8220;Photon&#8221;) CDN.</p>\n\n\n\n<p>Normally, when doing local development on a WordPress site, you need three things: the codebase, a copy of the database, and the <code>wp-content/uploads</code> directory. But if you just redirect missing image files to your production site, you don&#8217;t need to laboriously copy all those files and clutter up your local machine.</p>\n\n\n\n<p>I found myself really missing that technique today, so I wrote a driver for Laravel Valet that handles it!</p>\n\n\n\n<p>You can get it here: <a href=\"https://github.com/markjaquith/WordPress-Jetpack-Valet-Driver\">WordPress Jetpack Valet Driver</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 05 May 2020 19:11:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: Find My Blocks Plugin Shows All Blocks in Use on a WordPress Site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98953\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"https://wptavern.com/find-my-blocks-plugin-shows-all-blocks-in-use-on-a-wordpress-site?utm_source=rss&utm_medium=rss&utm_campaign=find-my-blocks-plugin-shows-all-blocks-in-use-on-a-wordpress-site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3144:\"<p>How do you know what blocks are in use on a WordPress site?  I recently saw a tweet asking this question in regards to knowing whether it is safe to turn off a plugin. This seems like it could become a common question, especially for those who have hundreds or thousands of blog posts as well as those using WordPress as a CMS.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">How hard would it be to create a plugin that let\'s me know how many and which blocks I\'m using site wide? Sometimes I wonder if I can deactivate a block plugin but I don\'t know if I\'m using a block it provides.</p>&mdash; Nick Hamze (@NickHamze) <a href=\"https://twitter.com/NickHamze/status/1253343502316064771?ref_src=twsrc%5Etfw\">April 23, 2020</a></blockquote>\n</div>\n\n\n\n<p>When looking at content in the editor, it isn&rsquo;t immediately evident which blocks are in use. You can click on the block navigation at the top of the editor, but that will only show you the blocks in use on that particular page. If you have a lot of plugins installed and many pages of content to wade through, figuring out if it&rsquo;s safe to remove a plugin can be a time-consuming process.</p>\n\n\n\n<p>Fortunately, there is already a plugin that will give you a quick overview of where blocks are being used on your site. <a href=\"https://wordpress.org/plugins/find-my-blocks/\">Find My Blocks</a> is the one that was suggested to Nick Hamze in response to the question in his tweet. I had not heard of it before, so I took it for a test drive today. </p>\n\n\n\n<p>Find My Blocks is basically a utility plugin that lists the blocks being used on your WordPress site, along with the posts/pages where they are in use. It includes core blocks and blocks from third-party plugins. The plugin&rsquo;s settings also give the option to sort the block menu display alphabetically or by most/least popular.</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>Frontend developer <a href=\"https://eddysims.com/\">Eddy Sims</a> created Find My Blocks to solve one of his own problems and released it on WordPress.org in January. </p>\n\n\n\n<p>&ldquo;I was working on a site that required a few custom Gutenberg blocks,&rdquo; Sims said. &ldquo;After a week, updating became a hassle. I didn&rsquo;t know where the blocks were used. Find My Blocks is a plugin I created to hopefully help someone else with this issue.&rdquo; So far it has received several five-star reviews in the plugin directory. </p>\n\n\n\n<p>&ldquo;We&rsquo;ve been using this plugin to help us figure out where we&rsquo;ve used blocks on pages so we can deprecate them and replace them with shiny new blocks!&rdquo; WordPress developer Tammy Lee said. &ldquo;This plugin makes tracking down blocks really easy! I don&rsquo;t want to think about how much time it would have taken us, otherwise.&rdquo;</p>\n\n\n\n<p><a href=\"https://wordpress.org/plugins/find-my-blocks/\">Find My Blocks</a> is a plugin you may want to add to your favorites on WordPress.org for the next time you inherit a site that you didn&rsquo;t build, or for cleaning out your own installed plugins.   </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 04 May 2020 22:54:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: The Future of WordPress: The Block Editor Is Here to Stay\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99271\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:177:\"https://wptavern.com/the-future-of-wordpress-the-block-editor-is-here-to-stay?utm_source=rss&utm_medium=rss&utm_campaign=the-future-of-wordpress-the-block-editor-is-here-to-stay\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6577:\"<p class=\"has-drop-cap\">It is inevitable that when we publish a story on the Tavern that is remotely related to the block editor or the Gutenberg project, we receive negative comments. Despite sprinting along in its second year as part of core WordPress, there are still those who liken posts on the editor to <em>Soviet-style mind manipulation</em> and <em>propaganda</em> for certain unnamed companies.</p>\n\n\n\n<p>It is not all negative. Far more comments are from people who are ecstatic about the current editor and the upcoming features that will expand the block system to other areas of WordPress.</p>\n\n\n\n<p>However, I felt the need to address a recent request that we stop covering the block editor. While I cannot speak for our entire staff, there are two simple truths about why I write about blocks.</p>\n\n\n\n<h2>Truth #1: Blocks are Here to Stay</h2>\n\n\n\n<p class=\"has-drop-cap\">The block system is not going anywhere. WordPress has moved beyond the point where we should consider the block editor as a separate entity. It is an integral part of WordPress and will eventually touch more and more areas outside of the editing screen.</p>\n\n\n\n<p>Frankly, it would be poor journalism to <em>not</em> cover stories related to blocks.</p>\n\n\n\n<p>Some of the most exciting things happening in the WordPress ecosystem is around what developers are doing with blocks. Whether it is a <a href=\"https://wptavern.com/block-a-saurus-embeds-a-side-scrolling-t-rex-game-via-the-block-editor\">fun T-rex game</a>, a <a href=\"https://wptavern.com/godaddys-go-wordpress-theme-offers-a-page-building-experience-via-the-block-editor\">block-ready theme</a>, or a team of block developers being <a href=\"https://wptavern.com/block-lab-team-joins-wp-engine-looks-to-the-future-of-block-building\">hired by a major company</a>, there is always something interesting happening in the world of blocks.</p>\n\n\n\n<p>Every day, more users are embracing the block editor. Even the percentage of holdouts still running WordPress 4.9, which was the last version without the block editor, is decreasing. Currently, only 12.8% of <a href=\"https://wordpress.org/about/stats/\">WordPress installs</a> are on 4.9.  Nearly 73% are running WordPress 5.0 or newer.  Some of those users are running plugins like Classic Editor, which has maintained a steady growth rate in the neighborhood of 0.5% &ndash; 1.0% in recent months.  Currently, the plugin has over 5 millions installs, which is a drop in the ocean in comparison to total WordPress sites.</p>\n\n\n\n<p>At the moment, WordPress.com and self-hosted Jetpack users are creating content via blocks on 44.5 million WordPress sites. Yesterday, those users <a href=\"https://gutenstats.blog/\">wrote 302,000 posts</a> in the block editor.</p>\n\n\n\n<p>Blocks are the future of the platform. What we need to do as a community is avoid putting our heads in the sand or railing against the powers-that-be. Instead, we should ask ourselves what we could do to continue improving the system. <em>How can we move forward? How can we present our ideas, even dislikes, in a constructive manner? How can we create better software?</em></p>\n\n\n\n<p>Criticism of the editor is fair. Make it constructive so we can dissect and address that criticism. That is an essential part of building great software.</p>\n\n\n\n<h2>Truth #2: Love of Blocks</h2>\n\n\n\n<p class=\"has-drop-cap\">Believe it or not, I actually love blocks. While I may criticize some decisions about the editor, summoning an internal facepalm emoji at times, this is the most excited I have been about WordPress in years. But, it is not about me. I have enough familiarity with dozens of editors that I can live with even the most mediocre of experiences. And, if I am not satisfied, I can build my own.</p>\n\n\n\n<p>What it is about is seeing the face of an inexperienced WordPress user light up for the first time because they <em>get it</em>.</p>\n\n\n\n<p>For years, I helped an older family member run an outdoors site. I had no interest in hunting, fishing, or most other topics covered on the blog. However, he was passionate about what he was doing. I wanted to help fuel that passion in any way I could. <em>The problem?</em> He simply never learned how WordPress worked. He never had that lightbulb moment. His face never glowed when he finally figured out how to lay out his content in the editor.</p>\n\n\n\n<p>He had big ideas and no way to accomplish them.</p>\n\n\n\n<p>At the time, most page builders were little more than shortcode soup, which I knew would eventually mean I would be the one to clean up the mess. There were few options other than the classic editor. My older cousin stuck it out for longer than most. After a few years, he finally let the site go.</p>\n\n\n\n<p>Even some of what I would consider the most basic of things were too frustrating for him. It was also frustrating for me because I could not understand why he could never learn what I was teaching.</p>\n\n\n\n<p>However, the block editor changed things. He was thinking of starting a new site but was asking about non-WordPress platforms. I spun up a demo install and a basic block-ready theme for him not long ago. Suddenly, this guy who routinely broke links and accidentally made all of his blog post content bold &mdash; twice &mdash; was piecing together media-filled content with few issues. That initial passion that he had all those years ago seemed to come back. Maybe, just maybe, WordPress might now be the CMS for him.</p>\n\n\n\n<p>I am fully aware that this is not everyone&rsquo;s experience. However, what I have found working with new and less-than-tech-savvy users is that the block editor is a stepping stone toward them being able to create the sites they want more easily. Right now, those users have far more control over their content than ever before. In the future, they will have that control over their entire site.</p>\n\n\n\n<p>When I share a story about blocks, it is because I am excited about them. More so, I want to share that excitement with others who are on this journey. Whether they want something on the <a href=\"https://wptavern.com/the-wacky-world-of-sorta-brilliants-sorta-fun-block-plugins\">wacky and weird</a> side of things or want to <a href=\"https://wptavern.com/create-custom-patterns-with-the-block-pattern-builder-plugin\">build custom patterns</a> for reuse in their posts, I want them to find those tools.</p>\n\n\n\n<p>If I am a bit optimistic about the future at times, I will not apologize for that. I look forward to the next block-related story that we have the opportunity to cover here at the Tavern.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 04 May 2020 20:52:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WordPress.org blog: The Month in WordPress: April 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8571\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2020/05/the-month-in-wordpress-april-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8157:\"<p>April continued to be a challenging time for the WordPress community, with many under stay-at-home recommendations. However, it was also an exciting month in which we created new ways to connect with and inspire each other! This month, amazing contributors moved more WordCamps online and shipped new releases for WordPress and Gutenberg. For the latest, read on. </p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordPress 5.4.1 released</h2>\n\n\n\n<p>On April 24th,&nbsp; <a href=\"https://make.wordpress.org/core/2020/04/24/wordpress-5-4-1-rc1/\">WordPress 5.4.1 Release Candidate 1</a> (RC1) was released for testing, quickly followed by the official <a href=\"https://wordpress.org/news/2020/04/wordpress-5-4-1/\">release of WordPress 5.4.1</a> on April 29th. This security release features 17 bug fixes and seven security fixes, so we recommend updating your sites immediately. To download WordPress 5.4.1, visit your Dashboard, click on Updates, then Update Now, or download the latest version directly from WordPress.org. For more information, visit <a href=\"https://wordpress.org/news/2020/04/wordpress-5-4-1/\">this post</a>, review the <a href=\"https://core.trac.wordpress.org/query?milestone=5.4.1&group=component&col=id&col=summary&col=milestone&col=owner&col=type&col=status&col=priority&order=priority\">full list of changes on Trac</a>, or check out the <a href=\"https://wordpress.org/support/wordpress-version/version-5-4-1/\">version 5.4.1 HelpHub documentation page</a>.</p>\n\n\n\n<p>Want to get involved in building WordPress Core? Follow<a href=\"https://make.wordpress.org/core/\"> the Core team blog</a>, and join the #core channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Gutenberg 7.9 and 8.0 released</h2>\n\n\n\n<p>It was another exciting month for Gutenberg, with the release of <a href=\"https://make.wordpress.org/core/2020/04/15/whats-new-in-gutenberg-15-april/\">7.9</a> and <a href=\"https://make.wordpress.org/core/2020/04/29/whats-new-in-gutenberg-29-april/\">8.0</a>! Version 7.9 brought new block design tools, three new patterns, and improved block markup. Gutenberg 8.0 continued to refine the new block patterns feature, with additional options for inline formatting, and extending the functionality of the Code Editor. In addition to these new features, both releases included new enhancements and APIs, along with a number of bug fixes, performance improvements, some experiments, and more! You can read all the details about the latest Gutenberg releases in the announcement posts for <a href=\"https://make.wordpress.org/core/2020/04/15/whats-new-in-gutenberg-15-april/\">7.9</a> and <a href=\"https://make.wordpress.org/core/2020/04/29/whats-new-in-gutenberg-29-april/\">8.0</a>.&nbsp;</p>\n\n\n\n<p>Want to get involved in building Gutenberg? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the #core-editor channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>BuddyPress 6.0.0</h2>\n\n\n\n<p><a href=\"https://buddypress.org/2020/04/buddypress-6-0-0-beta2/\">BuddyPress 6.0.0-beta2</a> was released for testing in mid-April, leading to the <a href=\"https://buddypress.org/2020/04/buddypress-6-0-0-release-candidate/\">BuddyPress 6.0.0 Release Candidate</a>, announced on April 29. This is an important step before&nbsp; the final release of BuddyPress 6.0.0, which is slated for Thursday, May 14. Changes and new features in this release include moving the profile photo and user cover image under the BP Members component, and a new BP Rest API. Additionally, this release will introduce the first round of BuddyPress Blocks! Last, but not least, BuddyPress 6.0.0 will require at least PHP 5.6 and WordPress 4.8.&nbsp;</p>\n\n\n\n<p>Want to get involved? <a href=\"https://buddypress.org/2020/04/buddypress-6-0-0-release-candidate/\">Test the 6.0.0-RC here</a>! You can also help by <a href=\"https://translate.wordpress.org/projects/wp-plugins/buddypress/dev/\">translating BuddyPress into another language</a>, or let the team know of any issues you find, either in <a href=\"https://buddypress.org/support\">the support forums</a> and/or in their <a href=\"https://buddypress.trac.wordpress.org/\">development tracker</a>.&nbsp;</p>\n\n\n\n<h2>WordCamp US goes online, apply to speak!</h2>\n\n\n\n<p>WordCamp US will <a href=\"https://2020.us.wordcamp.org/2020/04/30/wordcamp-us-will-be-virtually-awesome/\">take place online due to the COVID-19 pandemic</a>. The event still runs from October 27-29, 2020, and will be free to anyone who wishes to attend. The team plans to offer&nbsp; what WCUS has historically brought to the community in person: sessions and workshops, Contributor Day, a hallway track, and of course, State of the Word.&nbsp;</p>\n\n\n\n<p>Interested in speaking at WCUS? The <a href=\"https://2020.us.wordcamp.org/2020/03/16/call-for-speakers-is-now-open/\">Call for Speakers</a> is still open! You can apply to speak on the <a href=\"https://2020.wcus-speakers.org/\">speaker application site</a> until May 31, 2020 at 11:59 pm CDT (UTC-5).&nbsp;</p>\n\n\n\n<p>Additionally, the <a href=\"https://2020.us.wordcamp.org/2020/03/23/call-for-cities-for-wcus-2021-2022/\">Call for Cities is also open</a>. If your community is interested in hosting WordCamp US in 2021 &amp; 2022, please <a href=\"https://wordcampcentral.survey.fm/wcus-2021-2022\">fill out this application</a>.&nbsp;</p>\n\n\n\n<p>For the latest information about WordCamp US, sign up for updates on the <a href=\"https://2020.us.wordcamp.org/\">website</a>, or follow <a href=\"https://www.facebook.com/WordCampUSA/\">Facebook</a>, <a href=\"https://twitter.com/WordCampUS\">Twitter</a>, or <a href=\"https://www.instagram.com/wordcampus/?hl=en\">Instagram</a>.&nbsp;</p>\n\n\n\n<h2>WordCamp Europe 2020 goes virtual&nbsp;</h2>\n\n\n\n<p>Last month, WordCamp Europe decided to postpone its Porto event to 2021. This April, the WCEU organizing team announced that the <a href=\"https://2020.europe.wordcamp.org/2020/04/06/wordcamp-europe-2020-is-moving-online/\">2020 WordCamp will be online</a>! WordCamp Europe 2020 Online will take place from June 4-6, 2020, and tickets will be free. There will be a <a href=\"https://make.wordpress.org/updates/2020/04/15/wordcamp-europe-2020-contributor-day-update/\">virtual Contributor Day</a> on June 4, and then two half days of live-streamed talks and workshops. To participate, get your free ticket <a href=\"https://2020.europe.wordcamp.org/tickets/\">here</a>.&nbsp;</p>\n\n\n\n<p>To get the latest news for WordCamp Europe 2020 Online, follow on <a href=\"https://www.facebook.com/WCEurope/\">Facebook</a>, <a href=\"https://twitter.com/wceurope?lang=en\">Twitter</a>, <a href=\"https://www.linkedin.com/company/wordcampeurope/\">LinkedIn</a>, or on <a href=\"https://www.instagram.com/wceurope/?hl=en\">Instagram</a>.&nbsp;</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>Further Reading</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2020/04/08/wordpress-5-5-call-for-tickets/\">The WordPress 5.5 release cycle has officially been kicked off with a Call for Tickets</a>.</li><li><a href=\"https://make.wordpress.org/themes/2020/04/03/proposal-github-theme-review/\">Read the proposal for a new GitHub Theme review process.</a>.</li><li><a href=\"https://wordpress.tv/event/wpblocktalk-april-2020/\">Did you miss WPBlockTalk, or want to watch that really interesting session again? All talks are available on WordPress.tv!</a></li><li><a href=\"https://make.wordpress.org/core/2020/04/01/feature-plugin-proposal-wp-consent-api/\">The Core team has introduced a proposal for a new Consent API as a feature plugin</a>.</li><li><a href=\"https://make.wordpress.org/updates/2020/04/30/quarterly-updates-q1-2020/\">All WordPress contribution teams have reported on their recent work in the first quarterly update of 2020</a>.</li></ul>\n\n\n\n<p><em>Have a story that we should include in the next “Month in WordPress” post? Please </em><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><em>submit it here</em></a><em>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 04 May 2020 09:31:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Angela Jin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"WPTavern: FOSS Responders Group Brings Financial Help to Open Source Ecosystem Affected by COVID-19\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99213\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:243:\"https://wptavern.com/foss-responders-group-brings-financial-help-to-open-source-ecosystem-affected-by-covid-19?utm_source=rss&utm_medium=rss&utm_campaign=foss-responders-group-brings-financial-help-to-open-source-ecosystem-affected-by-covid-19\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2003:\"<p>The pandemic has caused economic hardships and upheaval in nearly every industry. Open source communities and contributors have been affected in a myriad of ways &ndash; whether it&rsquo;s a loss of donations, the burden of nonrefundable travel expenses for canceled conferences, or severely diminished business and fundraising opportunities. </p>\n\n\n\n<p><a href=\"https://fossresponders.com/\">FOSS Responders</a> is a working group of volunteers that aims to future-proof the open source infrastructure we rely on by helping sustain those who maintain the software. The group&rsquo;s website allows those in need to apply for emergency funds. FOSS Responders is <a href=\"https://opencollective.com/foss-responders\">raising money on Open Collective</a> and 100% of donations go to open source technologists in need. So far the group has an estimated annual budget of $8,145.05. Open Collective is also waiving its platform fees on COVID-19 solidarity collectives until the end of June.</p>\n\n\n\n<p>On May 22, FOSS Responders plans to host a <a href=\"https://opencollective.com/foss-responders/events/virtual-funding-event-q2-2020-4edd1e3a\">virtual funding event</a> to provide financial support for organizations affected by the profound economic disruptions caused by the pandemic. Organizers have a $5,000 goal for ticket revenue from general event ticket sales.</p>\n\n\n\n<p>In addition to providing emergency funds, the FOSS Responders group is aiming to address non-financial needs. Open source projects that relied heavily on events for fundraising need help amplifying their projects and recruiting volunteers. FOSS Responders is also creating a Resource Center for projects to find tips and tricks on how to manage fully virtual community interactions and events. Anyone with a skill or service to volunteer can get in touch on the <a href=\"https://fossresponders.com/\">FOSS Responders website</a> and the team will work as matchmakers to connect experts with projects that need help.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 01 May 2020 23:04:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Block Lab Team Joins WP Engine, Looks to the Future of Block Building\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98935\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:201:\"https://wptavern.com/block-lab-team-joins-wp-engine-looks-to-the-future-of-block-building?utm_source=rss&utm_medium=rss&utm_campaign=block-lab-team-joins-wp-engine-looks-to-the-future-of-block-building\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5636:\"<p class=\"has-drop-cap is-style-default\">The three-person Block Lab team of Luke Carbis, Ryan Kienstra, and Rob Stinson is <a href=\"https://getblocklab.com/the-block-lab-team-are-joining-wp-engine/\">joining WP Engine</a> to work on the company&rsquo;s block editor projects. WP Engine approached the team members after seeing how successful the <a href=\"https://getblocklab.com/\">Block Lab project</a> had grown and made them an offer.  The team will be able to continue building projects with solid financial backing.</p>\n\n\n\n<p><a href=\"https://wordpress.org/plugins/block-lab/\">Block Lab</a> is a plugin that was created to allow other developers to build blocks without needing to wade through the depths of complex JavaScript programming. It is a way to get your feet wet in the block development pool without diving in head first. The plugin has built a solid reputation based on user reviews. Out of 39 submissions, it has received 38 five-star ratings.</p>\n\n\n\n<p>&ldquo;From the start, Block Lab has been our answer to the question of &lsquo;how can I lower the barrier to entry for creating custom blocks,\'&rdquo; said Stinson. He said the plugin has done two important things for developers. It has given them an easy-to-use admin interface to work from and a simplified templating experience that is aligned with traditional workflows. &ldquo;It&rsquo;s helped folk who haven&rsquo;t had the time to summit the JS-all-the-things mountain or simply provide those that are looking for a standardized system that does a lot of the heavy lifting for them.&rdquo;</p>\n\n\n\n<p>The Block Lab plugin is being phased out, but the team assures that the plugin&rsquo;s current users will not be left in the dust. The plan is to continue supporting the plugin through bug and compatibility fixes for the next year. Pro users will also receive the same support until their license expires. In the long term outlook, the team plans to build a migration path to the new tools they will be building under the WP Engine banner.</p>\n\n\n\n<p>Stinson said that the plugin should work well for a long time to come because it was built by Carbis and Kienstra, two of the best engineers he has worked with. However, he stresses that the work they will be doing with WP Engine will exceed anything they have done with Block Lab.</p>\n\n\n\n<p>&ldquo;We&rsquo;ll be working on technology there that is focused on the Block Editor though, and a part of that will be taking what we&rsquo;ve done with Block Lab and introducing the feature set to the WP Engine suite of products,&rdquo; he said. &ldquo;The alignment will be close and will offer existing Block Lab users an easy migration experience.&rdquo;</p>\n\n\n\n<p>While the Block Lab plugin will see an end, the features the team has worked on will live on in some form.</p>\n\n\n\n<h2>A New Beginning</h2>\n\n\n\n<p class=\"has-drop-cap\">Before taking on roles with WP Engine, each member of the Block Lab team was paying the bills through agency and freelance work. Block Lab was merely a side project they were handling in their free time, but it was slowly growing both in scale and financially.</p>\n\n\n\n<p>&ldquo;Getting to a place where we could give it full-time focus was easily two to three years away though,&rdquo; said Stinson, &ldquo;and we have always been incredibly conscious of the things we wanted to be doing with it and how much the time factor was a limitation. With WP Engine, we&rsquo;re equipped to take the product vision we had for Block Lab and basically strap a rocket to it. Not only are we able to devote our full attention, but we also have the incredible support and resources of WP Engine behind us.&rdquo;</p>\n\n\n\n<p>Stinson is looking forward to the transition within the state of the current WordPress ecosystem. The team can walk into a fresh beginning with the full weight of a major company behind them. &ldquo;Between the classic way of building with WordPress and this new block-first frontier, being set up right now to build and contribute is incredible!&rdquo; he said.</p>\n\n\n\n<p>The team had an existing roadmap and backlog of features they wanted to develop. However, with Block Lab being only a side project, it meant those features would have taken much longer to build. They can now pursue them full time.</p>\n\n\n\n<p>&ldquo;We saw what Block Lab has currently as a necessary baseline for a plugin that equipped folks to create custom blocks, but what we have planned and are dreaming about goes so much further,&rdquo; said Stinson. &ldquo;Joining WP Engine unleashes us to chase down that work faster and with more focus. Another really exciting piece of this is that with our focus we are better positioned to offer insights and contribution to the larger block editor project through core and community contributions.&rdquo;</p>\n\n\n\n<p>The team now has the opportunity to be a pioneer in the years to come. They have proved they can build a useful tool on top of the block editor. The next step is seeing where they take it and whether they can get more developers to join them into a world of building blocks.</p>\n\n\n\n<p>&ldquo;The shift in thinking around how a website is structured towards one that is powered by &lsquo;blocks&rsquo; is a journey that the majority of the WP community is still on,&rdquo; said Stinson. &ldquo;A big part of my vision is having a larger portion of the community up to speed and onboard with this. With more people operating within that zone, more great work and tooling will be produced. By lowering the barrier to entry through Block Lab and what we have planned at WP Engine, it will help to get more people in that zone.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 01 May 2020 17:16:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: WordCamp US 2020 Goes Online, Cancels In-Person Event\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99149\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"https://wptavern.com/wordcamp-us-2020-goes-online-cancels-in-person-event?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-us-2020-goes-online-cancels-in-person-event\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3758:\"<p>WordCamp US 2020 organizers have <a href=\"https://2020.us.wordcamp.org/2020/04/30/wordcamp-us-will-be-virtually-awesome/\">cancelled the in-person event</a> in favor of hosting it as an online-only conference. With more than a million confirmed coronavirus cases in the U.S. today, 63,000+ deaths, and <a href=\"https://www.cnn.com/2020/04/30/health/us-coronavirus-thursday/index.html\">31 states set to partially reopen</a> this weekend, the pandemic&rsquo;s trajectory throughout the country has become increasingly uncertain. </p>\n\n\n\n<p>Many statewide stay-at-home orders are expiring tomorrow, despite <a href=\"https://www.nbcnews.com/health/health-news/guidelines-call-14-day-drop-cases-reopen-no-state-has-n1194191\">no state having met the federal guidelines for reopening</a>. Some businesses are opting to reopen in a limited capacity, but the general populace is still wary of returning to their previous way of life. In the state of Missouri, where WordCamp US was to be hosted in 2020, there will be no limitations on social gatherings as of May 4, as long as individuals maintain social distancing. It&rsquo;s not yet possible to predict what will be happening in the area in October or how it might impact an event with international attendees. </p>\n\n\n\n<p>After organizers extended the WCUS speaker application deadline for another 1.5 months on April 17,  it seemed the general disinclination towards traveling and gathering in large groups had already taken hold. Booking hotels and travel arrangements five months in advance is still too much of a gamble for speakers and attendees. </p>\n\n\n\n<p>The WCUS organizing team emphasized the longterm health and safety of the WordPress community as their primary concern in today&rsquo;s <a href=\"https://2020.us.wordcamp.org/2020/04/30/wordcamp-us-will-be-virtually-awesome/\">announcement</a> about moving to an online-only event:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>The WCUS organizing team has been working with WordCamp Central and local health authorities to try to make sense of the current COVID-19 pandemic and what it means for our event in St. Louis this October. Throughout this, we have held the longterm health and safety of the WordPress community as the highest priority of our event. To move forward in a way that honors what is best for our community &ndash; both locally and globally &ndash; we have made the hard choice to convert WordCamp US 2020 to an online only event.&nbsp;</p></blockquote>\n\n\n\n<p>WCUS will still happen on the originally scheduled dates, October 27th &ndash; 29th. Organizers plan to run sessions, workshops, and a virtual Contributor Day, along with the annual State of the Word address from Matt Mullenweg. They are also putting together a hallway track, some form of swag, and creative ways for attendees to connect, which will be announced at a later date. </p>\n\n\n\n<p>WCUS is now free for anyone who wants to attend. Without the necessity to rent a venue, provide lunches, and other physical aspects of the event, sponsorships are easily able to cover the cost of streaming to an unlimited number of attendees. </p>\n\n\n\n<p>The <a href=\"https://2020.wcus-speakers.org/\">call for speakers</a> is open until May 31, 2020 at 11:59 pm CDT. WCUS is still accepting sponsorships and will be publishing a set of unique sponsorship packages for the virtual event. Organizers plan to put out a call for volunteers in the near future.  </p>\n\n\n\n<p>WordCamp US follows other major regional WordCamps in Asia and Europe that have canceled in-person events due to the pandemic. Several other upcoming WordCamps, including events in Spain, Kent, Denver, and Minneapolis / Saint Paul,&nbsp;have also announced that they are transitioning to online-only events.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Apr 2020 22:49:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"WPTavern: Gutenberg 8.0 Merges Block and Pattern Inserter, Adds Inline Formats, and Updates Code Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99130\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:247:\"https://wptavern.com/gutenberg-8-0-merges-block-and-pattern-inserter-adds-inline-formats-and-updates-code-editor?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-8-0-merges-block-and-pattern-inserter-adds-inline-formats-and-updates-code-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5033:\"<p class=\"has-drop-cap\">The team behind the Gutenberg plugin <a href=\"https://make.wordpress.org/core/2020/04/29/whats-new-in-gutenberg-29-april/\">shipped version 8.0 yesterday</a>. The update adds some nice user-facing changes, including a merged block and pattern inserter, new inline formatting options, and visual changes to the code editor. Over two dozen bug fixes were included in the release, along with several enhancements.</p>\n\n\n\n<p>Designers on the project <a href=\"https://github.com/WordPress/gutenberg/pull/21515\">updated the welcome box illustrations</a> to match the current UI. Because the welcome modal should already be dismissed for current users, only new users should see these changes.</p>\n\n\n\n<p>For theme authors, the post title and placeholder paragraph text for the block appender will <a href=\"https://github.com/WordPress/gutenberg/pull/21749\">inherit body font styles</a>. Previously, they had specific styles attached to them in the editor. The current downside is that the post title is not an <code>&lt;h1&gt;</code> element so it cannot automatically inherit styles for that element. However, that will change once the post title becomes a true block in the editor.</p>\n\n\n\n<p>The editor also now <a href=\"https://github.com/WordPress/gutenberg/pull/21608\">clears centered blocks</a> following a floated block. This is an opinionated design change, but it should not negatively affect most themes. However, theme authors should double-check their theme styles to be sure.</p>\n\n\n\n<h2>Updated Block and Pattern Inserter</h2>\n\n\n\n<img />Patterns available in the inserter.\n\n\n\n<p class=\"has-drop-cap\">The development team <a href=\"https://github.com/WordPress/gutenberg/pull/20951\">added patterns to the existing inserter</a>. Now, both blocks and patterns have an individual tab within a unified interface. This is yet another step in the evolution of the pattern system that should land in core WordPress this year.</p>\n\n\n\n<p>Right now, the experience is a two-steps-forward-one-step-back deal. The inserter&rsquo;s behavior has improved and it is great to see patterns merged into it. However, all blocks and patterns are within long lists that require scrolling to dig through. Block categories are no longer tabbed in version 8.0, which is a regression from previous versions. I am certain this will be resolved soon enough, but it is a little frustrating locating a block in the list at the moment.</p>\n\n\n\n<p>Merging patterns into the inserter is an ongoing process. There is still a lot of work to do before the final product is polished and included in core WordPress.</p>\n\n\n\n<p>The following are some key items that need to be addressed in upcoming versions of Gutenberg:</p>\n\n\n\n<ul><li>Patterns should be categorized the same as blocks.</li><li>The block search box should switch to a pattern search box when viewing patterns.</li><li>Pattern titles should be reintroduced in the interface (removed in 8.0).</li></ul>\n\n\n\n<p>Of course, there is a host of other minor and major issues the team will need to cover to nail down the user experience. For now, the interface for patterns continues to improve.</p>\n\n\n\n<h2>Subscript and Superscript Formats</h2>\n\n\n\n<img />Adding superscript text to the editor.\n\n\n\n<p class=\"has-drop-cap\">Gutenberg developers added <a href=\"https://github.com/WordPress/gutenberg/pull/21819\">two new inline formatting options</a> to the editor toolbar: subscript and superscript. These options allow users to add text such as X<sub>2</sub> and X<sup>2</sup>.  They work the same as bold, italic, inline code, and other options.</p>\n\n\n\n<p>The two formatting options represent their respective inline HTML tags, <code>&lt;sub&gt;</code> for subscript and <code>&lt;sup&gt;</code> for superscript. With the addition of the elements, the toolbar now covers most of the widely-used inline HTML tags. The only other tags that are low on my wish list are <code>&lt;abbr&gt;</code>, <code>&lt;del&gt;</code>, and <code>&lt;ins&gt;</code>, but I could live with those remaining firmly in plugin territory.</p>\n\n\n\n<h2>Improved Code Editor</h2>\n\n\n\n<img />Updated code-editing view.\n\n\n\n<p class=\"has-drop-cap\">The code editor <a href=\"https://github.com/WordPress/gutenberg/pull/21643\">received a much-needed overhaul</a> in the 8.0 update. Everything from the post title to the content is set in a monospace font, and the width of the code editing box spans the editing area. It should be a welcome change for those who need to switch to code view once in a while.</p>\n\n\n\n<p>The next step to polishing the code editor (and the HTML block) would be to add syntax highlighting. In the current version, the HTML output is plain text. Given the extra markup that the block editor produces, it can be a bit of a jumbled mess to wade through. Basic syntax highlighting would improve the experience several times over. There is a <a href=\"https://github.com/WordPress/gutenberg/issues/10423\">GitHub ticket</a> for adding the feature, but it has not seen any movement in several months.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Apr 2020 19:48:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WordPress 5.4.1 Addresses 7 Security Issues and Fixes Several Bugs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99123\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:197:\"https://wptavern.com/wordpress-5-4-1-addresses-7-security-issues-and-fixes-several-bugs?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-5-4-1-addresses-7-security-issues-and-fixes-several-bugs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5888:\"<p class=\"has-drop-cap\">WordPress 5.4.1, <a href=\"https://wordpress.org/news/2020/04/wordpress-5-4-1/\">a security and maintenance release</a>, dropped today. The release addresses seven security issues, which were all responsibly disclosed to the WordPress security team. Core developers also included several fixes for code regressions in the previous version 5.4 release and ported bug fixes to the block editor from the Gutenberg plugin.</p>\n\n\n\n<p>End-users with automatic updates enabled should begin seeing their sites updated shortly. Other users should update as soon as possible to make sure they are running a version of WordPress with the latest security fixes.</p>\n\n\n\n<p>The WordPress support team has published the <a href=\"https://wordpress.org/support/wordpress-version/version-5-4-1/\">full release documentation</a> for those who wish to view it.</p>\n\n\n\n<p>Security fixes were added to every major version of WordPress from 5.4 back to 3.7.  The following vulnerabilities were addressed:</p>\n\n\n\n<ul><li>Password reset tokens were not correctly invalidated.</li><li>Some private posts could be viewed without authentication.</li><li>Two cross-site scripting (XSS) vulnerabilities in the customizer.</li><li>XSS issue in the search block.</li><li>XSS issue in the WordPress object cache.</li><li>XSS issue with file uploads.</li><li>XSS issue in the block editor for WordPress 5.4 Release Candidates 1 and 2 (fixed in 5.4 RC5).</li></ul>\n\n\n\n<h2>Block Editor Updates</h2>\n\n\n\n<p class=\"has-drop-cap\">Several fixes were high priority enough from the Gutenberg plugin to port to the WordPress 5.4.1 release. The biggest user-facing issues were a broken block duplication keyboard shortcut, misaligned buttons blocks, and odd scrolling behavior when attempting to edit text in a long block.</p>\n\n\n\n<p>The following is a full list of the issues the development team addressed:</p>\n\n\n\n<ul><li>Fixed the <code>Ctrl</code> + <code>Shift</code> + <code>D</code> keyboard shortcut for duplicating a block, which no longer throws an error.</li><li>Adds correct margins when aligning the buttons block left or right.</li><li>Prevents the editor from scrolling to the top when clicking to edit a large block, such as a long list.</li><li>No longer hides the toolbar for plugins that have text inputs in the toolbar.</li><li>Stops a JavaScript crash with the latest posts block when an image has missing dimensions.</li><li>Escapes the HTML class for the RSS and search blocks to prevent malformed markup.</li></ul>\n\n\n\n<p>To review the code changes to the block editor in-depth, see the <a href=\"https://github.com/WordPress/gutenberg/pulls?q=is%3Apr+sort%3Aupdated-desc+label%3A%22Backport+to+WP+Core%22+is%3Aclosed\">full ticket list</a>.</p>\n\n\n\n<h2>Other Core WordPress Changes</h2>\n\n\n\n<p class=\"has-drop-cap\">Users who run their browsers in dark mode can rejoice if they also use the core WordPress favicon. The team <a href=\"https://core.trac.wordpress.org/ticket/49798\">introduced an updated favicon</a> with a light background so that it no longer washes out. It is a minor fix but makes the famed WordPress logo look more professional.</p>\n\n\n\n<p>The heading level, which was previously set to <code>&lt;h3&gt;</code>, has been <a href=\"https://core.trac.wordpress.org/ticket/49838\">bumped up one level</a> on the WordPress admin freedoms screen (<code>wp-admin/freedoms.php</code>). This change provides the proper heading level and should help screen-reading users better navigate the page.</p>\n\n\n\n<p>For users on the Edge or iOS Safari browsers who <a href=\"https://core.trac.wordpress.org/ticket/49753\">could not select files in the media library</a>, it was due to a CSS issue that hid the input. This should no longer be an issue in the new update.</p>\n\n\n\n<p>WordPress 5.4.1 addressed some regressions from the previous version. One revolves around posting by email when no post title was added. In that scenario, the <a href=\"https://core.trac.wordpress.org/ticket/49853\">email subject should have been used as the title</a>, but this was broken by a code change in WordPress 5.4. For developers, the <code>category_link</code> and <code>tag_link</code> filter hooks were <a href=\"https://core.trac.wordpress.org/ticket/49759\">mistakenly deprecated</a> previously and are now once again good to use without throwing a notice.</p>\n\n\n\n<p>Plugin developers have a few bug fixes to look forward to. The <code>WP_Site_Health</code> object is now instantiated after the <code>plugins_loaded</code> and <code>after_setup_theme</code> hooks, which means they can perform necessary actions <a href=\"https://core.trac.wordpress.org/ticket/49824\">before the site health is checked</a>. The deprecated <code>wp_get_user_request_data()</code> function is now <a href=\"https://core.trac.wordpress.org/ticket/49802\">correctly loaded on the front end</a>, which was causing errors with plugins such as BuddyPress.</p>\n\n\n\n<p>In a larger design change, plugin authors who <a href=\"https://core.trac.wordpress.org/ticket/49772\">add custom content to the privacy policy guide</a> can use more HTML elements. In WordPress 5.4, the guide design was updated to add a white background behind the suggested text. However, the new code only applied to paragraphs. Now, the design supports tables, lists, and other elements that are commonly used. Unordered lists also have bullet points to distinguish them from paragraphs.</p>\n\n\n\n<p>The development team fixed two issues with the REST API. The first <a href=\"https://core.trac.wordpress.org/ticket/49645\">corrected an issue</a> with the <code>get_item</code> permissions check. The second fixed the <code>_fields</code> filtering. The core code now uses the <code>rest_is_field_included()</code> function to <a href=\"https://core.trac.wordpress.org/ticket/49648\">determine which fields to include</a> to permit filtering by nested field properties.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Apr 2020 20:39:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress.org blog: WordPress 5.4.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8553\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2020/04/wordpress-5-4-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6915:\"<p>WordPress 5.4.1 is now available!</p>\n\n\n\n<p>This security and maintenance release features 17 <a href=\"https://core.trac.wordpress.org/query?milestone=5.4.1&group=component&col=id&col=summary&col=milestone&col=owner&col=type&col=status&col=priority&order=priorityhttps://core.trac.wordpress.org/query?milestone=5.4.1&group=component&col=id&col=summary&col=milestone&col=owner&col=type&col=status&col=priority&order=priority\">bug fixes</a> in addition to 7 security fixes. Because this is a <strong>security release</strong>, it is recommended that you update your sites immediately. All versions since WordPress 3.7 have also been updated.</p>\n\n\n\n<p>WordPress 5.4.1 is a short-cycle security and maintenance release. The next major release will be version 5.5.</p>\n\n\n\n<p>You can download WordPress 5.4.1 by downloading from WordPress.org, or visit your Dashboard → Updates and click Update Now.</p>\n\n\n\n<p>If you have sites that support automatic background updates, they’ve already started the update process.</p>\n\n\n\n<h3>Security Updates</h3>\n\n\n\n<p>Seven security issues affect WordPress versions 5.4 and earlier. If you haven’t yet updated to 5.4, all WordPress versions since 3.7 have also been updated to fix the following security issues:</p>\n\n\n\n<ul><li>Props to <a href=\"https://hackerone.com/hijibiji\">Muaz Bin Abdus Sattar</a> and <a href=\"https://hackerone.com/dyennez\">Jannes</a> who both independently reported an issue where password reset tokens were not properly invalidated</li><li>Props to <a href=\"https://github.com/ka1n4t\">ka1n4t</a> for finding an issue where certain private posts can be viewed unauthenticated</li><li>Props to <a href=\"https://evanricafort.com/\">Evan Ricafort</a> for discovering an XSS issue in the Customizer</li><li>Props to Ben Bidner from the WordPress Security Team who discovered an XSS issue in the search block</li><li>Props to Nick Daugherty from <a href=\"https://wpvip.com\">WordPress VIP</a> / WordPress Security Team who discovered an XSS issue in <code>wp-object-cache</code></li><li>Props to Ronnie Goodrich (<a href=\"https://hackerone.com/kahoots\">Kahoots</a>) and <a href=\"http://pentestusa.com/\">Jason Medeiros</a> who independently reported an XSS issue in file uploads.</li><li>Props to <a href=\"https://weston.ruter.net/\">Weston Ruter</a> for fixing a stored XSS vulnerability in the WordPress customizer.</li><li>Additionally, an authenticated XSS issue in the block editor was discovered by Nguyen The Duc (<a href=\"https://twitter.com/ducnt_\">ducnt</a>) in WordPress 5.4 RC1 and RC2. It was fixed in 5.4 RC5. We wanted to be sure to give credit and thank them for all of their work in making WordPress more secure.</li></ul>\n\n\n\n<p>Thank you to all of the reporters for <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">privately disclosing the vulnerabilities</a>. This gave the security team time to fix the vulnerabilities before WordPress sites could be attacked.</p>\n\n\n\n<p>For more information, browse the <a href=\"https://core.trac.wordpress.org/query?milestone=5.4.1&group=component&col=id&col=summary&col=milestone&col=owner&col=type&col=status&col=priority&order=priority\">full list of changes</a> on Trac, or check out the <a href=\"https://wordpress.org/support/wordpress-version/version-5-4-1/\">version 5.4.1 HelpHub documentation page</a>.</p>\n\n\n\n<p>In addition to the security researchers mentioned above, thank you to everyone who helped make WordPress 5.4.1 happen:</p>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/aduth/\">Andrew Duthie</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/afragen/\">Andy Fragen</a>, <a href=\"https://profiles.wordpress.org/apeatling/\">Andy Peatling</a>, <a href=\"https://profiles.wordpress.org/arnaudbroes/\">arnaudbroes</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/dhrrob/\">DhrRob</a>, <a href=\"https://profiles.wordpress.org/dono12/\">Dono12</a>, <a href=\"https://profiles.wordpress.org/dudo/\">dudo</a>, <a href=\"https://profiles.wordpress.org/ehtis/\">Ehtisham Siddiqui</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/garrett-eclipse/\">Garrett Hyder</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/kadamwhite/\">K. Adam White</a>, <a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/markrh/\">MarkRH</a>, <a href=\"https://profiles.wordpress.org/mattyrob/\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/mcsf/\">Miguel Fonseca</a>, <a href=\"https://profiles.wordpress.org/batmoo/\">Mohammad Jangda</a>, <a href=\"https://profiles.wordpress.org/mukesh27/\">Mukesh Panchal</a>, <a href=\"https://profiles.wordpress.org/nickdaugherty/\">Nick Daugherty</a>, <a href=\"https://profiles.wordpress.org/noahtallen/\">noahtallen</a>, <a href=\"https://profiles.wordpress.org/pbiron/\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/westi/\">Peter Westwood</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/pikamander2/\">pikamander2</a>, <a href=\"https://profiles.wordpress.org/r-a-y/\">r-a-y</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/otto42/\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sorenbronsted/\">Søren Brønsted</a>, <a href=\"https://profiles.wordpress.org/sstoqnov/\">Stanimir Stoyanov</a>, <a href=\"https://profiles.wordpress.org/isabel_brison/\">tellthemachines</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs/\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/toro_unit/\">Toro_Unit (Hiroshi Urabe)</a>, <a href=\"https://profiles.wordpress.org/treecutter/\">treecutter</a>, and <a href=\"https://profiles.wordpress.org/yohannp/\">yohannp</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Apr 2020 19:56:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jake Spurlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Akismet: Version 4.1.5 of the Akismet WordPress Plugin is Now Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=2068\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"https://blog.akismet.com/2020/04/29/version-4-1-5-of-the-akismet-wordpress-plugin-is-now-available/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1339:\"Version 4.1.5 of <a href=\"http://wordpress.org/plugins/akismet/\">the Akismet plugin for WordPress</a> is now available. It contains the following changes:\n\n<!-- /wp:paragraph --><!-- wp:list -->\n<ul>\n 	<li>Based on user feedback, we have dropped the in-admin notice explaining the availability of the &#8220;privacy notice&#8221; option in the AKismet settings screen. The option itself is available, but after displaying the notice for the last 2 years, it is now considered a known fact.</li>\n 	<li>Updated the &#8220;Requires at least&#8221; to WP 4.6, based on recommendations from <a href=\"https://wp-info.org/tools/checkplugini18n.php?slug=akismet\" rel=\"nofollow\">https://wp-info.org/tools/checkplugini18n.php?slug=akismet</a></li>\n 	<li>Moved older changelog entries to a separate file to keep the size of this readme reasonable, also based on recommendations from <a href=\"https://wp-info.org/tools/checkplugini18n.php?slug=akismet\" rel=\"nofollow\">https://wp-info.org/tools/checkplugini18n.php?slug=akismet</a></li>\n</ul>\n<!-- /wp:list --><!-- wp:paragraph -->\n\nTo upgrade, visit the Updates page of your WordPress dashboard and follow the instructions. If you need to download the plugin zip file directly, links to all versions are available in <a href=\"http://wordpress.org/plugins/akismet/\">the WordPress plugins directory</a>.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Apr 2020 13:12:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Stephane Daury\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"WPTavern: Tectonic Shifts in Retail Industry are Creating Unprecedented Opportunities for Independent Stores\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98957\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:261:\"https://wptavern.com/tectonic-shifts-in-retail-industry-are-creating-unprecedented-opportunities-for-independent-stores?utm_source=rss&utm_medium=rss&utm_campaign=tectonic-shifts-in-retail-industry-are-creating-unprecedented-opportunities-for-independent-stores\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12689:\"<p>Major retailers that are part of the critical infrastructure for distributing household essentials, healthcare items, and shelf-stable food, are raking in the cash during this pandemic. While consumer spending at bars, restaurants, and places of entertainment has dropped precipitously, spending at Amazon and Walmart has increased considerably in the past few weeks. The companies cannot hire workers fast enough to meet consumer demand.</p>\n\n\n\n<p>According to a report from <a href=\"https://first.facteus.com/\">Facteus,</a> a firm that provides data from billions of transactions from over 1,000 financial services companies, Amazon and Walmart&rsquo;s year-over-year growth recently hit 80% and 18%, respectively in the past few weeks.</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>The pandemic has worked as a catalyst for pre-existing trends, &ldquo;accelerating the retail reckoning,&rdquo; as Derek Thompson predicts in his recent article on how <a href=\"https://www.theatlantic.com/ideas/archive/2020/04/how-pandemic-will-change-face-retail/610738/\">The Pandemic Will Change American Retail Forever</a>. Brick and mortar storefronts are rapidly becoming obsolete in a world that is forcibly consigned to shopping from home.</p>\n\n\n\n<p>There are still many uncertainties about <em>SARS</em>&ndash;<em>CoV-2</em> and how humanity will safely find its way out of lockdown. Recovery from the virus may not confer long-term immunity and a vaccine may be more than a year away, likely pushing social distancing measures into 2021. Consumer behavior may be forever altered by this experience, as many people may continue to avoid in-person browsing at stores long after the worst is over. </p>\n\n\n\n<p class=\"is-style-highlight\">While it might seem like the retail titans are still uncontested in their domination, there are tectonic shifts happening in the retail industry that are giving smaller, independent stores an unprecedented opportunity to gain new customers online. Merchants that can adapt and excel at getting products to a homebound population stand to be the most resilient during this pandemic.</p>\n\n\n\n<p>In order to keep up with demand, Amazon has had to delay shipments of non-essential items by up to a month in some cases, prioritizing household basics and medical supplies. Major grocery retailers are <a href=\"https://www.digitalcommerce360.com/article/coronavirus-impact-online-retail/\">competing against one another to hire furloughed workers</a> in order to keep up with the demand for groceries with so many people eating at home. Independent stores that can be found online have the opportunity to step up and fill in the gaps where major retailers cannot meet the demand fast enough.</p>\n\n\n\n<p>People are more inclined to support small businesses right now in light of current circumstances. Amazon&rsquo;s severely strained relationship with buyers, sellers, affiliates, and employees is also contributing to consumers&rsquo; eagerness to support independent stores.</p>\n\n\n\n<p>On April 21, <a href=\"https://www.cnbc.com/2020/04/14/amazon-slashes-commission-rates-for-affiliate-program.html\">Amazon slashed commission rates</a> nearly in half for most product categories, negatively impacting media companies and publishers that have not diversified their affiliate revenue sources.</p>\n\n\n\n<p>Amazon&rsquo;s essential workers are planning to join others from Instacart, Whole Foods, Walmart, Target, and FedEx in <a href=\"https://theintercept.com/2020/04/28/coronavirus-may-1-strike-sickout-amazon-target-whole-foods/\">a strike on Friday</a>. They are protesting their employers&rsquo; record corporate profits which they say have come at the expense of workers&rsquo; health and safety. Many consumers have already grappled with a question of conscience in continuing to shop on Amazon after hearing reports of grueling labor conditions for years.</p>\n\n\n\n<p>Another major development in the retail industry has come to light as the result of a recent Wall Street Journal investigation, which revealed that <a href=\"https://www.wsj.com/articles/amazon-scooped-up-data-from-its-own-sellers-to-launch-competing-products-11587650015\">Amazon is using data from its sellers to launch competing products</a>. Merchants selling successfully on Amazon are not safe from having their products copied and their businesses effectively cannibalized.</p>\n\n\n\n<p>Documents obtained by the WSJ, along with interviews from more than 20 former employees of Amazon&rsquo;s private-label business, described how the marketplace operator uses third-party sellers&rsquo; data to gain a competitive advantage: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>In one instance, Amazon employees accessed documents and data about a bestselling car-trunk organizer sold by a third-party vendor. The information included total sales, how much the vendor paid Amazon for marketing and shipping, and how much Amazon made on each sale. Amazon&rsquo;s private-label arm later introduced its own car-trunk organizers.</p></blockquote>\n\n\n\n<p>The WSJ expos&eacute; details the great pressure that Amazon executives are under to deliver successful private-label products:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Former executives said they were told frequently by management that Amazon brands should make up more than 10% of retail sales by 2022.&nbsp;Managers of different private-label product categories have been told to create $1 billion businesses for their segments, they said.</p></blockquote>\n\n\n\n<p>This practice of launching competing products with access to third-party sellers&rsquo; data has been happening for years but is an especially hostile tactic to employ in a time when Amazon&rsquo;s revenue is skyrocketing and small businesses are struggling to stay afloat. It is a sobering reminder of the value of hosting your own online store and the importance of owning your own data.</p>\n\n\n\n<p>There are some positive developments in the industry that should give small business owners confidence in maintaining independence from the dominant forces in online retail. </p>\n\n\n\n<p>Wired published an article this week titled <a href=\"https://www.wired.com/story/coronavirus-book-sales-indie/\">The Coronavirus Pandemic Is Changing How People Buy Books</a> by Kate Knibbs. She describes how one indie bookseller&rsquo;s e-commerce startup has found unlikely success in positioning itself as &ldquo;an easy way to buy books online without further enriching Jeff Bezos:&rdquo;</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Bookshop went from a well-intentioned startup facing an uphill battle to one of the most popular ways to buy books online in a matter of weeks.&nbsp;<em>The</em>&nbsp;<em>New York Times</em>, BuzzFeed, Vox, and&nbsp;<em>The New Republic</em>&nbsp;are all affiliate partners now. Its headcount has doubled in size. Hunter expects to hit $6 million in sales by May, eons ahead of its loftiest projections from January. If the company&rsquo;s performance holds steady, it could do $60 million in sales a year, although Hunter is assuming post-quarantine life will be different. &ldquo;I&rsquo;m sure that when things open back up, our sales will drop, maybe even cut in half,&rdquo; he says. &ldquo;But even then, we&rsquo;re still one of the top 10 bookstores in the US.&rdquo;</p></blockquote>\n\n\n\n<p>Yesterday, <a href=\"https://techcrunch.com/2020/04/28/shopify-launches-shop-a-new-mobile-shopping-app/\">Shopify launched its new Shop app</a>, touting modularized, distributed marketplaces as the future of e-commerce. The app allows shoppers to browse local merchants and make purchases. It provides a new vehicle of exposure for the company&rsquo;s 1m+ merchants on its platform. Businesses do not have to pay to have access to the app, nor do they pay commissions on the sales it generates.</p>\n\n\n\n<p>Google is also making it easier for smaller stores to be found on the web by <a href=\"https://wptavern.com/google-shopping-is-now-open-to-free-product-listings\">opening up the Shopping tab to free listings</a> and partnering with WooCommerce, Shopify, and BigCommerce. This essentially gives more free traffic to small businesses whose listings will break up the longstanding dominance of major online retailers in the Shopping tab. </p>\n\n\n\n<p>WordPress developers with e-commerce experience have the opportunity to build products and stores that will help traditional brick-and-mortar businesses&nbsp;start selling online quickly, so they can continue to find success in. the brave new world of online-first retail. WordPress has a plethora of plugin options for making e-commerce accessible to store owners, no matter how simple or complex the store&rsquo;s requirements.</p>\n\n\n\n<h2>Independent WooCommerce Stores Are Booming</h2>\n\n\n\n<p>One user in the WooCommerce community&rsquo;s Facebook group <a href=\"https://www.facebook.com/groups/advanced.woocommerce/permalink/3429259367088458/\">asked</a> how the coronavirus is impacting members&rsquo; e-commerce stores. Responses were varied based on the types of products that the merchants were selling, but the vast majority of responses from store owners and developers were positive reports of increased sales: </p>\n\n\n\n<ul><li>&ldquo;I have a client selling cleaning products. He got several pallets of hand sanitizer in and sold out in a week. He was doing about $2000 in sales a day.&rdquo;</li><li>&ldquo;My client does fruit and veg online. Went from &pound;4k a month trickling along as a side part of his business, to &pound;150k last month and the heading for the same this month.&rdquo;</li><li>&ldquo;We are selling plumbing and home improvement tools and items sales have quadrupled.&rdquo;</li><li>&ldquo;Positive impact. Highest sales for me on my indoor activities niche (puzzles, board games).&rdquo;</li><li>&ldquo;Sales are up more than 1000% &ndash; natural supplements&rdquo;</li><li>&ldquo;Built a cake delivery service to sell slices of cake locally&hellip;&hellip; &pound;4K in a day and sold out. It&rsquo;s crazy.&rdquo;</li><li>&ldquo;800% increase on a niche plant site I host&rdquo;</li><li>&ldquo;Compared to same month last year, up approx 250% (garden products)&rdquo;</li><li>&ldquo;3000% increase during the last month compared to monthly average over the last year. Natural health products&rdquo;</li><li>&ldquo;Our canvas printing site is up 20%&rdquo;</li><li>&ldquo;We are selling more Glass Bongs than ever. People are staying home and getting stoned.&rdquo;</li></ul>\n\n\n\n<p>Saad Munir, the CEO of an e-commerce marketing agency, manages 28 stores for their clients with $30-$500k sales per month in various niches. </p>\n\n\n\n<p>&ldquo;Some of them are popular brands of their niche,&rdquo; Munir said. &ldquo;We have seen a drop in sales of up to 80% in non-essential and medium luxury products, and a 400% increase in essential products. However, now non-essential and daily-use products have also started getting good sales since everyone is home and sticking to their devices during this social distancing. We also have clients of furniture e-commerce stores. This means high-ticket items. They have even seen increased sales in bedsets, sofas, etc. So, for sure online sales are increasing. We also on-boarded several new clients and most of these stores are in WooCommerce.&rdquo;</p>\n\n\n\n<p>In the WooCommerce Help &amp; Share group, one member <a href=\"https://www.facebook.com/groups/woohelp/permalink/3028955177330917/\">asked for help collating all his orders into one list</a> after his artisan cheese business increased exponentially overnight. Another member <a href=\"https://www.facebook.com/groups/woohelp/permalink/3024332674459834/\">asked for help optimizing his client&rsquo;s store</a> after their pre-COVID-19 revenue went from less than &pound;1k/month to almost &pound;2k sales per day.</p>\n\n\n\n<p>If independent self-hosted stores are able to perform well during this crisis, they have the opportunity to earn customers&rsquo; loyalty for continued business long after social distancing requirements are no longer necessary. It&rsquo;s a unique opportunity that may not have been possible on such an accelerated timeline without this exact set of circumstances.</p>\n\n\n\n<p>These recent shifts in online retail are the first cracks in the ice towards a web that is more friendly for smaller, independent stores. The trend towards buying all of life&rsquo;s necessities online has evolved overnight to include a wider spectrum of consumer demographics than ever before. Diverse independent stores are crucial for meeting this demand without losing the unique and varied shopping landscape that the pandemic has forced to be temporarily closed.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Apr 2020 08:17:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"Post Status: Professional WordPress Plugin Development: Interview with the authors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=78739\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://poststatus.com/professional-wordpress-plugin-development-interview-with-the-authors/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1671:\"<p><em>Professional WordPress Plugin Development</em> was one of the most helpful books I\'ve ever read. To see a new edition with two returning authors, nine years after the original, is very exciting.</p>\n\n\n\n<p>This edition of the book will be sure to offer a great resource for developer education for years to come. Brad Williams, Justin Tadlock, and John James Jacoby are each extremely talented developers and communicators. The work they can accomplish together is even greater.</p>\n\n\n\n<p>Cory talks to them about their histories, the book, the process, and much more. We hope you enjoy this episode of Post Status Draft.</p>\n\n\n\n\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\n\n\n\n<p>You can <a href=\"https://amzn.to/3cWMJlB\">pre-order <em>Professional WordPress Plugin Development</em> now on Amazon</a>. It is slated to be released June 10th.</p>\n\n\n\n<ul><li><a href=\"https://strangework.com/2020/01/06/announcing-professional-wordpress-plugin-development-2nd-edition/\">Brad\'s announcement</a></li><li><a href=\"http://justintadlock.com/archives/2020/01/06/writing-a-wordpress-book-again\">Justin\'s announcement</a></li><li><a href=\"https://jjj.blog/2020/01/coauthoring-a-wordpress-plugin-development-book/\">John\'s announcement</a></li></ul>\n\n\n\n<h3>Episode Partner: <a href=\"https://poststatus.com/gravity\">Gravity Forms</a></h3>\n\n\n\n<p>Gravity Forms is the easiest-to-use and most trusted tool for creating advanced forms for your WordPress-powered website. I use Gravity Forms on every WordPress site I own, and I know I can always rely on its power, flexibility, and reliability.</p>\n\n\n\n<p><a href=\"https://poststatus.com/gravity\">Try Gravity Forms today.</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Apr 2020 04:27:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: David Vongries Takes Over as New Owner of the Kirki Customizer Framework\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99016\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:209:\"https://wptavern.com/david-vongries-takes-over-as-new-owner-of-the-kirki-customizer-framework?utm_source=rss&utm_medium=rss&utm_campaign=david-vongries-takes-over-as-new-owner-of-the-kirki-customizer-framework\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8410:\"<p class=\"has-drop-cap\">Ari Stathopoulos sold <a href=\"https://kirki.org/\">Kirki</a>, his 6-year-old customizer framework, last week. The plugin is a widely-used tool for theme authors and currently has over 400,000 installations. It is also bundled as a drop-in package within an unknown number of themes, likely numbering in the hundreds. David Vongries, the owner of the <a href=\"https://wp-pagebuilderframework.com/\">Page Builder Framework theme</a>, has taken over the project.</p>\n\n\n\n<p>All of Kirki&rsquo;s customizer controls, including those that were previously commercial/premium, are now open under the <a href=\"https://github.com/kirki-framework\">Kirki Framework</a> GitHub organization.</p>\n\n\n\n<p>Stathopoulos <a href=\"https://twitter.com/aristath/status/1247931690162544640\">tweeted his decision</a> to seek a buyer on April 8. &ldquo;This is an announcement I never thought I&rsquo;d make,&rdquo; he wrote.  &ldquo;As much as it saddens me, I have decided to sell the Kirki #WordPress plugin.  With 500,000+ installations and included in hundreds of themes I no longer have the ability &ndash; as an individual developer &ndash; to maintain it. And even though I had big dreams and wanted to facilitate things for the WordPress editor as well, the plugin has grown beyond me&hellip;It is no longer possible for a single person to maintain such a beast.&rdquo;</p>\n\n\n\n<p>Between his fulltime day job, a representative role for the theme review team, and maintaining other open-source projects, Stathopoulos was pulling 16-hour days of work. Not to mention, he had the usual life elements he needed to make time for in his routine. The Kirki project was not something he could devote any extra time to. Stathopoulos said he knew that spending too much time behind the screen was detrimental to his mental and physical health. He needed to make changes for his personal well-being. Still, it was tough to let go of a project he had invested years into.</p>\n\n\n\n<p>&ldquo;Letting go of a project like that feels extremely weird!&rdquo; he said. &ldquo;It&rsquo;s a weird mix of sadness, stress, and relief. I feel sad because it&rsquo;s out of my control. I feel stressed because it&rsquo;s out of my control. And I feel relieved because it&rsquo;s out of my control.&rdquo;</p>\n\n\n\n<p>While he suspects the sadness and stress of letting go of his project will subside, he said he already feels relieved to no longer have the responsibility of managing such a huge project alone. &ldquo;I am no longer responsible for the hundreds of themes that use it; it&rsquo;s liberating,&rdquo; he said.</p>\n\n\n\n<h2>No Deal for the Highest Bidder</h2>\n\n\n\n<p class=\"has-drop-cap\">Stathopoulos did not want to let this passion project go to anyone. He wanted someone with the vision to see the project evolve. He had several offers for Kirki. Over 400,000 installations can make for a lucrative opportunity for someone with the right marketing skills. It would have been easy for him to take the highest bid and jump ship, but that is not his style.</p>\n\n\n\n<p>&ldquo;Kirki is a weird case,&rdquo; he said. &ldquo;It may have 400,000 installations and used by hundreds of themes both free and premium, but the actual &lsquo;clients&rsquo; are the theme authors, not the end-users. That fact limits the potential for monetizing the plugin ethically. There were quite a few bids, some were high, some were low, but what surprised me is that a lot of them were not interested in helping the community in any way.&rdquo;</p>\n\n\n\n<p>Stathopoulos said the majority of the offers were from buyers with no interest in growing the plugin. Most of them seemed to be looking for a quick buck. He steered clear of them because he did not want to see end-users blasted with obtrusive ads, upsells, or spam.</p>\n\n\n\n<p>&ldquo;In the end, I didn&rsquo;t go with the highest bid, which was 2.5 times the price I gave it for,&rdquo; he said. &ldquo;Though I admit I was seriously tempted to &lsquo;take the money and run.&rsquo; I went with what I felt was an ethical choice, someone who actually uses the project on a daily basis, wants to evolve it, and I feel will honor the open-source spirit and the six years of sweat.&rdquo;</p>\n\n\n\n<p>Stathopoulos decided to sell to Vongries. The two had previously worked together on multiple occasions on the Kirki project and he felt it was the right move.</p>\n\n\n\n<p>&ldquo;Once I decided that he should get it, the process went pretty smooth, and there were no hiccups,&rdquo; said Stathopoulos. &ldquo;The hard part was deciding who should get it.&rdquo;</p>\n\n\n\n<p>Vongries was almost a natural choice as a new owner. He and his team had been using Kirki since its inception. &ldquo;I think it&rsquo;s an incredible framework and it makes working with the WordPress customizer so much easier,&rdquo; he said.</p>\n\n\n\n<p>He reached out to Stathopoulos immediately upon seeing it was for sale. The two had a conversation soon thereafter and shared similar visions for the plugin.</p>\n\n\n\n<p>&ldquo;I always looked at Kirki as something special and wanted to get involved,&rdquo; said Vongries. &ldquo;Until recently though, I wouldn&rsquo;t have had the resources to do so, but since the team around MapSteps has grown it just all happened at the right time. Being a Kirki user myself, I looked at this from both perspectives &mdash; from a developer standpoint and as someone that has been using the plugin for years.&rdquo;</p>\n\n\n\n<h2>The Future of Kirki</h2>\n\n\n\n<p class=\"has-drop-cap\">Over the past 18 months, Stathopoulos has rewritten the plugin and split it into around 50 Composer packages. The plan was to make these packages installable as individual components for plugin and theme authors. Instead of bundling the entire Kirki library, developers can use the pieces they need. At this point, these components should be stable, but they have not been widely tested by theme authors, who are accustomed to working with the full framework.</p>\n\n\n\n<p>He was also excited about the potential move away from the customizer and working with full-site editing and global styles. Right now, it is unclear how the future of the Gutenberg project will impact the customizer. Many theme authors are now looking at it as a dying piece of the platform. Stathopoulos felt like there was still room to grow and transition into the new era.</p>\n\n\n\n<p>&ldquo;My vision for Kirki was to combine some things with full-site editing, and allow themes that were using Kirki to automatically get global styles when they land in WordPress core,&rdquo; he said. &ldquo;That would be truly amazing, and I&rsquo;m sure it will be possible to do once there is an API for global styles. If [Vongries] goes in that direction, there&rsquo;s definitely potential for monetization there, while at the same time he&rsquo;ll help people build better things. Can you imagine a painless transition to global styles for themes that use Kirki? That would be a great thing to see!&rdquo;</p>\n\n\n\n<p>However, the project is out of the former owner&rsquo;s hands now. It is Vongries&rsquo; vision that must lead the project moving forward.</p>\n\n\n\n<p>&ldquo;I respect Ari a lot and he has done an amazing job with Kirki,&rdquo; said Vongries. &ldquo;[Stathopoulos] said he would love to continue to contribute to the project, and he is more than welcome to do so.&rdquo;</p>\n\n\n\n<p>The immediate plan is to launch Kirki 4.0. It is nearly ready to roll out, awaiting some fine-tuning and final testing. Vongries and his team are also about to begin work on new extensions that bring more controls and functionality to the framework and, potentially, Gutenberg.</p>\n\n\n\n<p>&ldquo;We are going to explore how we can make the connection between the existing functionality in Kirki and the upcoming features in Gutenberg and Gutenberg in general,&rdquo; he said. &ldquo;At this point, we have some ideas about how we can adapt Kirki to the ever-changing WordPress platform. But for now, they are only ideas. We are certain that we will be able to provide a useful tool for developers, regardless of the direction WordPress and Gutenberg goes.&rdquo;</p>\n\n\n\n<p>The new team behind Kirki is still working on the long-term roadmap. It will be exciting to see where they take it. For now, it is still the go-to customizer framework for many theme authors. And, it is in the hands of someone who has been using the project for years.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Apr 2020 18:39:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: WordCamp Europe 2020 Online Registration Now Open: Tickets are Free\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98976\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:197:\"https://wptavern.com/wordcamp-europe-2020-online-registration-now-open-tickets-are-free?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-europe-2020-online-registration-now-open-tickets-are-free\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2514:\"<p><a href=\"https://2020.europe.wordcamp.org/\">WordCamp Europe 2020</a> is just 37 days away. Organizers announced in April that the event, which was supposed to be hosted in Porto, is moving to be 100% online this year due to the COVID-19 pandemic. WCEU will kick off with a virtual Contributor Day on June 4, followed by two half days of talks and workshops broadcasted via livestream.</p>\n\n\n\n<p>WordCamp Europe is one of the largest regional WordCamps on the planet and has been hosted in many magnificent venues and inspiring cities over the years. The event routinely sells out of tickets and sponsor packages, as companies and attendees rally around this unique opportunity to connect across boundaries, uniting Europe through a shared love of WordPress. </p>\n\n\n\n<p>For the first time in the event&rsquo;s eight-year history, the European WordPress community will have to forego the in-person networking time that many have come to value as both a personal and professional highlight of the year. WCEU Organizers have worked for the better part of a decade to make it one of the most polished and efficient WordCamps. Now the team is forced to pivot and use their expertise to host a top-notch virtual event.</p>\n\n\n\n<p>Past local organizing teams have been successful at creating an intimate atmosphere that facilitates rewarding connections with a focus on hospitality. These in-person connections add context to remote interactions and conversations long after the event concludes. Reaching this same high level of interpersonal connectivity between attendees is going to be a challenge for this online edition, but WCEU organizers have a long track record of adapting to different environments.  Dozens of other WordPress meetups, WordCamps, and educational events are currently facing the same challenges and are <a href=\"https://make.wordpress.org/community/events/\">moving online</a>.</p>\n\n\n\n<p>Registering for a ticket to WCEU is optional but attendees who want to participate in the virtual networking, Q&amp;A sessions, and contributor day will have be registered. Organizers were expecting approximately 3,000 attendees but hosting the event online may affect those numbers in either direction.  <a href=\"https://2020.europe.wordcamp.org/tickets/\">Tickets are available for free</a> on the WCEU website, thanks to the event&rsquo;s sponsors. After eight hours of open registration, there are 4,257&nbsp;tickets remaining.  The event will return to Porto, Portugal, on June 3-5, 2021.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Apr 2020 23:10:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: Should the Block Editor Have a Grid System?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=99028\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"https://wptavern.com/should-the-block-editor-have-a-grid-system?utm_source=rss&utm_medium=rss&utm_campaign=should-the-block-editor-have-a-grid-system\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5456:\"<p class=\"has-drop-cap\">Laying out a webpage design and getting every element aligned perfectly can be a tough job. Even many developers rely on CSS grid frameworks. Granted, with the introduction of the flexbox and grid systems in the CSS language, such frameworks are becoming unnecessary. Whether it is getting the vertical and horizontal rhythm down or simply aligning an image next to a bit of text, page layouts are often done best via some sort of grid system.</p>\n\n\n\n<p>This becomes even more apparent when building a page layout visually through the WordPress block editor. The current iteration of the editor does a fine job of being a general content editor while providing the ability to insert various elements into the page.</p>\n\n\n\n<p>However, it is not by any means a page builder &mdash; <em>yet</em>.</p>\n\n\n\n<p>The question is, before we engage in full-site editing, global styles, block patterns, and other upcoming tools, whether a grid system should be a part of the equation. If so, how should that system work? Will it be configurable by theme authors? How will it handle tablet and mobile views? Will the grid be visible to users or a hidden thing in the background?</p>\n\n\n\n<p>As more block plugins are released, particularly with those that may have multiple elements that may need to be aligned, it might be time we consider a grid system. Such a system may benefit existing core blocks right now, such as Columns and Media &amp; Text. Or, it may be better as a separate, standalone block.</p>\n\n\n\n<p>Including a grid system also has the additional benefit of standardizing on layout-related class names that theme authors can use in their CSS, even outside the content editor. This would bring better compatibility across the board when users inevitably switch themes.</p>\n\n\n\n<h2>A Starting Point: Layout Grid Block</h2>\n\n\n\n<img />Three-column layout with Layout Grid Block.\n\n\n\n<p class=\"has-drop-cap\">Automattic, as part of its <a href=\"https://github.com/Automattic/block-experiments\">Block Experiments</a> project, has released the <a href=\"https://wordpress.org/plugins/layout-grid/\">Layout Grid Block</a> plugin. It is essentially a beefed-up version of the core Columns block. The major difference is that column alignment snaps to a specific point in the grid. This grid is also displayed in the background while editing the post.</p>\n\n\n\n<p>The tricky thing with grids is not simple alignment in columns in desktop view. It is dealing with how those columns transform on smaller devices like tablets and smartphones. Sometimes that is a guessing game from a theme design perspective because the theme author is not privy to the actual content that needs to be aligned. In turn, designers make best-guess decisions and hope it works for most.</p>\n\n\n\n<p>The Layout Grid block has a &ldquo;Responsive Breakpoints&rdquo; tab under the block options panel that allows users to configure this based on device. Users can decide how individual columns span the grid. The grid system is based on a varying number of grid sections based on the device:</p>\n\n\n\n<ul><li>Desktop: 12 Sections</li><li>Tablet: 8 Sections</li><li>Mobile: 4 Sections</li></ul>\n\n\n\n<p>Imagine wanting to display a simple image with text to the next of it. There are various ways to do this currently in the block editor. Each has its pros and cons, depending on what you want to do. From a user experience and visual standpoint, I love seeing the grid lines in place as I determine how it should be displayed.</p>\n\n\n\n<img />Aligning an image and text on a grid.\n\n\n\n<p>Another upside of having a grid system is consistency in design. If users can scale the width of columns based on arbitrary numbers, much like they can now do with the Media &amp; Text block, there is no consistency with sizing items horizontally on the page. A grid system changes that.</p>\n\n\n\n<p>Layout Grid Block still needs some polishing at this point. There are some trivial pain points in the UI that could be improved. On the whole, my experience with this block offered a compelling argument for including a grid system in core.</p>\n\n\n\n<p>The plugin addresses simple one, two, three, and four columns right now. The grid system in CSS is much more powerful than basic horizontal columns. However, starting with the basics would give us a place to build from.</p>\n\n\n\n<h2>Should Core Include a Grid?</h2>\n\n\n\n<p class=\"has-drop-cap\">There is at least one <a href=\"https://github.com/WordPress/gutenberg/issues/16271\">open ticket on the Gutenberg repository</a> for addressing a grid system. Mark Uraine, the author of the ticket, posted seven key questions:</p>\n\n\n\n<ol><li>Should the grid system be responsive?</li><li>Should there be a default Gutenberg grid system, but allow themes to register their own?</li><li>Should the grid system conform to the current structure of Gutenberg blocks, or should it be its own thing that we need to restructure the blocks to in the editor?</li><li>Should the grid include gutters?</li><li>Should the grid include, or allow, any vertical alignment snaps?</li><li>What should the grid be based on? (ie. 12 columns, pixel grid, etc.)</li><li>Should the grid allow toggling on/off? And also include a setting to show, or not, when resizing objects in the editor?</li></ol>\n\n\n\n<p>The ticket had some solid discussion nearly a year ago but not much as of late. Would you like to see a grid system in the editor? If so, how would you want it to work?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Apr 2020 20:24:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"Matt: Tulsa Remote Worker Experiment\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=51280\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://ma.tt/2020/04/tulsa-remote-worker-experiment/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1120:\"<p>Sarah Holder at Citylab has an interesting article on a program that <a href=\"https://www.citylab.com/life/2020/02/tulsa-incentives-work-remotely-coworking/604873/\">paid people $10,000, a year of co-working, and a subsidized apartment to move to Tulsa, Oklahoma</a>.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Traditionally, cities looking to spur their economies may offer incentives to attract businesses. But at a time when Americans are <a href=\"https://www.citylab.com/life/2019/05/moving-location-new-city-how-much-cost-mobile-rooted-stuck/590521/\">moving less frequently</a> than they have in more than half a century, and the anticlimactic race to host an Amazon HQ2 <a href=\"https://www.citylab.com/equity/2018/12/amazon-hq2-corporate-tax-incentives-technology/578422/\">soured some governments on corporate tax breaks</a>, Tulsa is one of several locales testing out a new premise:  Pay <em>people</em> instead.</p></blockquote>\n\n\n\n<p>I love this idea, and hope that after the permanent step-up in remote work from the virus we see much more internal mobility between cities in the United States.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 Apr 2020 17:55:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: Watch the Women of React Conference for Free on Saturday, April 25\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98982\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"https://wptavern.com/watch-the-women-of-react-conference-for-free-on-saturday-april-25?utm_source=rss&utm_medium=rss&utm_campaign=watch-the-women-of-react-conference-for-free-on-saturday-april-25\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4140:\"<p>While much of the world is in lockdown, public gatherings and conferences have been cancelled, leaving a void in the lives of people who enjoy meeting their fellow open source contributors and colleagues in person throughout the year.  Virtual events, which were already on the rise, are enjoying a bit of a renaissance by necessity. </p>\n\n\n\n<p>On Saturday, April 25, the <a href=\"https://womenofreact.com/\">Women of React</a> conference will stream live with seven speakers, along with Q&amp;A and lightning sessions from React core contributors and leaders in the community. The event will include a single-stream of talks with breaks for socializing and connecting with other attendees, as well as an invite-only Discord chat server. </p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">This Saturday (Apr 25) Women of React has a special Q and A session with our favorite React core contributors past &amp; present <a href=\"https://twitter.com/sophiebits?ref_src=twsrc%5Etfw\">@sophiebits</a> <a href=\"https://twitter.com/ProvablyFlarnie?ref_src=twsrc%5Etfw\">@ProvablyFlarnie</a> <a href=\"https://twitter.com/lunaruan?ref_src=twsrc%5Etfw\">@lunaruan</a> and Chrome collaborators <a href=\"https://twitter.com/shubhie?ref_src=twsrc%5Etfw\">@shubhie</a> and <a href=\"https://twitter.com/stubbornella?ref_src=twsrc%5Etfw\">@stubbornella</a>! RSVP for free at <a href=\"https://t.co/GksJeHLvF6\">https://t.co/GksJeHLvF6</a> <a href=\"https://t.co/0bho86YVe6\">pic.twitter.com/0bho86YVe6</a></p>&mdash; R \'Nearest\' Nabors &#128153; (@rachelnabors) <a href=\"https://twitter.com/rachelnabors/status/1253400764359286785?ref_src=twsrc%5Etfw\">April 23, 2020</a></blockquote>\n</div>\n\n\n\n<p>Women of React was organized as a sort of pop-up tech event in response to current events. Co-organizers Rachel Nabors, Kevin Lewis, Sara Vieira, and Jenn Creighton did not put out a request for speakers but rather opted to invite women from around the world who would provide quality presentations on diverse topics of interest to the React community. </p>\n\n\n\n<p>&ldquo;I think I woke up one morning and was watching the pandemic news and realized all the cool women I would usually see on the conference circuit cannot give their talks and I&rsquo;m not going to see them,&rdquo; Rachel Nabors said on  a recent episode of the <a href=\"http://insidefacebookmobile.libsyn.com/23-organising-the-women-of-react-remote-conf\">Inside Facebook Mobile</a> podcast. &ldquo;I&rsquo;m not going to see any of my favorite women in the React community this year and it was super depressing.&rdquo; She contacted her colleagues and together they quickly spun up a conference that would allow women in React to connect online.</p>\n\n\n\n<p>Last week the organizers reported more than 1,000 registered attendees. They expect that number to be over 2,000 on the day of the conference. Fortunately, they don&rsquo;t have to have a hard count on attendees ahead of time, since virtual events don&rsquo;t have a limited number of seats. Organizers have even created printable swag for all who attend.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">The cuteness has landed! We will be shipping out coloring pages for <a href=\"https://twitter.com/hashtag/womenofreact2020?src=hash&ref_src=twsrc%5Etfw\">#womenofreact2020</a> attendees tonight&mdash;something for you or your little ones to do while watching the talks tomorrow! Art by the phenomenal <a href=\"https://twitter.com/miuki_miu?ref_src=twsrc%5Etfw\">@miuki_miu</a>! <a href=\"https://t.co/49byxsCeWW\">pic.twitter.com/49byxsCeWW</a></p>&mdash; R \'Nearest\' Nabors &#128153; (@rachelnabors) <a href=\"https://twitter.com/rachelnabors/status/1253667155972931584?ref_src=twsrc%5Etfw\">April 24, 2020</a></blockquote>\n</div>\n\n\n\n<p><a href=\"https://womenofreact.com/\">Women of React</a> will run from 12:30pm&mdash;8:00pm EST. Attendees can sign up on the website and will receive a link for the livestream. Organizers are also planning to record the sessions so that people who are unable to attend can watch it at a later time.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Apr 2020 21:35:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WPTavern: WP Feedback Kicks off Free Virtual Summit for WordPress Professionals on April 27\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98970\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:227:\"https://wptavern.com/wp-feedback-kicks-off-free-virtual-summit-for-wordpress-professionals-on-april-27?utm_source=rss&utm_medium=rss&utm_campaign=wp-feedback-kicks-off-free-virtual-summit-for-wordpress-professionals-on-april-27\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5564:\"<img />\n\n\n\n<p class=\"has-drop-cap\">WP Feedback is running a <a href=\"https://wpfeedback.co/summit/\">virtual event from April 27 &ndash; May 1</a>. The event is primarily geared toward WordPress professionals who are looking to scale their business. It will feature CEOs, designers, freelancers, and more from the WordPress space. Between five and seven video sessions will be available each new day of the event.</p>\n\n\n\n<p>The sessions are free to watch for the full 24-hour period on the day they are scheduled. Once that window closes, visitors must purchase an all-access pass to view them, which is currently available for $67 but will go up to $97 once the event begins. A one-time purchase provides lifetime access.</p>\n\n\n\n<p>&ldquo;Due to the outbreak of Coronavirus, otherwise known as COVID-19, every event has been postponed or outright canceled for the foreseeable future,&rdquo; said Vito Peleg, founder of WP Feedback. &ldquo;Seeing that the opportunity to learn and network with like-minded professionals was taken away from us at the last second, we decided to step in to provide the true conference experience all without leaving your desk.&rdquo;</p>\n\n\n\n<p>The goal of the summit is provide value by teaching attendees how to scale their agency or freelance business by having experts in their respective fields share advice.</p>\n\n\n\n<p>&ldquo;Above all, the best part is that it&rsquo;s completely free to attend, and although some of us can&rsquo;t wait to get out, I&rsquo;m sure others will agree it&rsquo;s also really nice that you can attend all from the comfort of your home office &mdash; or living rooms!&rdquo; said Peleg.</p>\n\n\n\n<p>The WP Feedback team hopes that everyone from freelancers to large agencies and businesses can learn something. &ldquo;So to that end, the event is geared towards WordPress professionals who are looking to scale their business beyond themselves (without losing all of their hair), people struggling during the quarantine/lockdown as a result of an impact that this has had on their business, and people who are just looking to meet and network with other like-minded people in the community,&rdquo; said Peleg.</p>\n\n\n\n<p>The goal for <a href=\"https://wpfeedback.co/\">WP Feedback</a> is to help WordPress professionals succeed and scale their business via the site&rsquo;s network and feedback plugin. &ldquo;This effort is two-fold,&rdquo; said Peleg. &ldquo;We primarily do this with our software that simplifies and organizes client communication for web designers. But, we also do so with summits just like this one, educating people through our content and community platform.&rdquo;</p>\n\n\n\n<p>For those interested in seeing what type of content the summit offers, Piccia Neri&rsquo;s session from 2019, <a href=\"https://wpfeedback.co/summit/piccia-neri/\">The Main Ingredient of Great UX</a>, is available to watch for free.</p>\n\n\n\n<h2>Continuation of WP Agency Summit</h2>\n\n\n\n<p class=\"has-drop-cap\">Last December, before joining the WP Feedback team, Jan Koch launched the <a href=\"https://wptavern.com/wp-agency-summit-kicks-off-december-6\">first version of this event</a>. Over 2,000 attendees registered and recorded 15,000 session views. Strictly by the numbers, the event was successful.</p>\n\n\n\n<p>&ldquo;Measuring the success of the 2019 summit event in numbers would not even tell half of the story,&rdquo; said Peleg. &ldquo;Most exciting were all the ripple effects the event caused. So many new connections were made not just from Jan&rsquo;s perspective but also in the community that formed around the event on Facebook. We&rsquo;re all still leveraging these new friendships and hope that, with the improved networking area for the new summit, we&rsquo;ll see even more connections being made.&rdquo;</p>\n\n\n\n<p>With Koch joining WP Feedback, the team felt like it was a natural move to continue the event. &ldquo;One of the main reasons Jan joined the team was to be heavily involved with our summit plans due to his experience and success with the WP Agency Summit last year,&rdquo; said Peleg. &ldquo;As this is WP FeedBack&rsquo;s first summit, having Jan on the team has made it possible for us to organize it in such a short amount of time. He&rsquo;s taught us a lot and we will 100% be using everything we&rsquo;ve learned to do more like this in the future.&rdquo;</p>\n\n\n\n<p>One of the issues with the 2019 event was the lack of gender diversity. There was a 20:4 male-to-female speaker ratio. The team has attempted to address this for the 2020 event by adding more women to the lineup.</p>\n\n\n\n<p>&ldquo;Yes, that was a hard lesson learned for Jan,&rdquo; Peleg said in response to the low number of women speakers. &ldquo;He and the entire team at WP FeedBack leveraged our connections to get a more even ratio this time. Obviously, there are many successful women in the WordPress space, and now we were able to bring a few of our friends on thanks to our combined networks.&rdquo;</p>\n\n\n\n<p>The WP Feedback team has been collectively working to make this year&rsquo;s event a success. Peleg said that many on the team have had to quickly adapt and learn how to run such an event. &ldquo;Thankfully, Jan&rsquo;s experience has massively helped in how we have been planning everything, and he is the one heading up all of the sessions too,&rdquo; he said. &ldquo;The vision was to create a summit experience online that replicates how it feels to go to a summit in real life, and we are really taking huge steps to provide that experience for all of our attendees.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Apr 2020 18:50:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: Chatterbox Plugin Uses WordPress Blocks to Show Conversations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98923\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:187:\"https://wptavern.com/chatterbox-plugin-uses-wordpress-blocks-to-show-conversations?utm_source=rss&utm_medium=rss&utm_campaign=chatterbox-plugin-uses-wordpress-blocks-to-show-conversations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2361:\"<p><a href=\"https://wordpress.org/plugins/chatterbox/\">Chatterbox</a> is a new plugin with a fun and creative use for the block editor. It displays chat or text threads using blocks that are styled as conversations. Users can type in a record of a chat, including timestamps, with a live preview in the editor. </p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>Since written conversations are essentially little blocks of text and media, the block editor lends itself nicely to composing and displaying this type of content. The Chatterbox block can be found under Layout Elements in the block inserter. It includes the option to select a style (Inbound, Outbound, or Event) and add a timestamp.</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p><a href=\"https://daveryan.io/\">Dave Ryan</a>, a WordPress developer at Bluehost, said he created the plugin in order to test Gutenberg&rsquo;s Block Context API and borrowed the <a href=\"https://www.lightningdesignsystem.com/components/chat/\">chat component</a> from Salesforce&rsquo;s Lightning Design System. He suggested that Chatterbox could be useful for showing demos of chat bots, publishing chat records in news stories, or simply adding an engaging visual display to conversations.</p>\n\n\n\n<p>Once the Block Context API matures, Ryan plans to add message background and text colors, message sender with name and avatar, and the ability to override the message sender on a per-message basis for group chats. The next steps beyond that on the roadmap include the following:</p>\n\n\n\n<ul><li>&nbsp;Implement Bookends and other&nbsp;<a href=\"https://www.lightningdesignsystem.com/components/chat/#About-Chat\">SFDS Chat</a>&nbsp;options</li><li>&nbsp;Animated chat sequences</li><li>&nbsp;Automated animated sequences, using character lengths for timing</li><li>&nbsp;Automate hiding of message meta based on adjacent blocks</li><li>&nbsp;Message Images</li><li>&nbsp;Message Files</li></ul>\n\n\n\n<p>Ryan said some of the planned features will rely on new features in the Gutenberg project. Once those have been released he will update Chatterbox to include more customization options. The plugin is <a href=\"https://wordpress.org/plugins/chatterbox/\">available for free on WordPress.org</a> and contributors can find the code on <a href=\"https://github.com/0aveRyan/chatterbox\">GitHub</a>.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Apr 2020 03:55:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: You Deserve to Wear Sweatpants; Don’t Let Anyone Tell You Any Different\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98783\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:203:\"https://wptavern.com/you-deserve-to-wear-sweatpants-dont-let-anyone-tell-you-any-different?utm_source=rss&utm_medium=rss&utm_campaign=you-deserve-to-wear-sweatpants-dont-let-anyone-tell-you-any-different\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5468:\"<img />\n\n\n\n<p class=\"has-drop-cap\">Lounge in your Baby Yoda sweats. Break out those knee-high Santa socks that you love to wear during the holidays. Slide into your Rocket City Trash Pandas tee and pretend the baseball season is going to happen this year.</p>\n\n\n\n<p>Sure, you can wear a suit and tie when you&rsquo;re working from home. However, I invite you to ditch the fresh-pressed trousers for your comfy sweatpants.</p>\n\n\n\n<p>The COVID-19 pandemic has forced many of you into working from the home office. Depending on your situation, that might be the kitchen table, the loveseat in the living room, or a closet if your kids are irritating enough. The worst thing we can do is put too much pressure on ourselves to be the model of perfection in this setting. Do not let anyone tell you that you must put on the suit and tie in lieu of that comfortable pullover you&rsquo;ve had since college.</p>\n\n\n\n<p>Balance that statement with some common sense. If you are meeting with the big boss over a Zoom video call, you will want to take your company culture into account. If your boss is expecting you to dress as if in the office, what he or she sees onscreen should reflect that expectation. The same may be true for client calls, depending on how you want to present your service.</p>\n\n\n\n<p>For all other situations, your dress code is entirely up to you.</p>\n\n\n\n<p>Adam Tschorn, deputy fashion editor for the Los Angeles Times, <a href=\"https://www.latimes.com/lifestyle/story/2020-04-17/working-from-home-regular-work-wardrobe-dress-up\">argues that you should ditch the sweatpants</a> and &ldquo;dress like the adult you&rsquo;re getting paid to be&rdquo;:</p>\n\n\n\n<blockquote class=\"wp-block-quote is-style-default\"><p>Please, can we all put away those sweatpants, ratty, gray, decades-old collegiate sweatshirts and obscure minor league baseball caps and start our workdays looking like we deserve the paychecks we&rsquo;re lucky enough to be earning while the world around us burns? Especially, for the love of all that&rsquo;s holy, if there&rsquo;s a group video conference involved?</p></blockquote>\n\n\n\n<p><a href=\"https://twitter.com/ARTschorn/status/1251139655447150593\">Twitter was not kind.</a></p>\n\n\n\n<p>Some of us who have been doing this remote work thing for a few years and have come to love our loungewear. We are not going to let the rookies ruin it for the rest of us, a sentiment shared by a friend on Facebook.</p>\n\n\n\n<p>I am sitting in my basketball shorts and a sleeveless T-shirt.</p>\n\n\n\n<p>Taking off your shoes is a hard requirement when entering my home, a practical cleanliness tip I learned from time spent with Korean friends. It is the respectful thing to do. Plus, it is so much more relaxing. I want you to feel at home at my home.</p>\n\n\n\n<p>Some people have trouble balancing work and home life when they are merged into one space. In those cases, &ldquo;dressing for success&rdquo; may help you mentally push through the day. However, it is a personal choice.</p>\n\n\n\n<p>The one thing Tschorn and I agree on wholeheartedly is ritual. If even one thing about my daily ritual gets thrown off by unforeseen circumstances, I lose focus. It can often ruin the whole day.  Those little rituals are a part of what set me up for success. Everyone&rsquo;s are different. Some will want their morning coffee. Others need to shower, shave, and put on their Sunday best to feel like everything is right with the world.</p>\n\n\n\n<p>There are rare days when I feel the need to switch it up. Put on a nice suit. Grab my seldom-worn fedora and place it firmly atop my head. It makes me feel like a 1920s-esque reporter who is ready to dig up some dirt on the local crime boss. Those days are about making me feel good about myself.</p>\n\n\n\n<p>However, most days, it is about feeling comfortable at home.</p>\n\n\n\n<p>It does not matter if you wear a Call of Duty T-shirt when building a new WooCommerce add-on plugin. Most people are not going to care if you don Sailor Moon sweatpants while running a successful managed WordPress hosting service. And, if you feel comfortable enough doing it, strip down to your undies while designing the next big WordPress theme. <em>You may want to add a top while video conferencing in that last case &mdash; there are limits.</em></p>\n\n\n\n<p>Life is tough enough right now without fashion gurus telling us what to wear.</p>\n\n\n\n<p>Even work-from-home veterans are <a href=\"https://wptavern.com/finding-balance-in-these-uncertain-times-remote-work-and-sharing-our-struggles\">off our game at the moment</a>. The world has changed practically overnight. We are still catching our breath from the gut-punch of this unique virus. We deserve to <em>let ourselves go</em> a bit while dealing with the stress of these changes.</p>\n\n\n\n<p>I do not know much about fashion. I still break out my cargo pants from time to time, which are apparently a fashion <em>faux pas</em> today.</p>\n\n\n\n<p>What I do know a little something about is working comfortably from home.</p>\n\n\n\n<p>And that, my friends, is all about what makes you feel good about yourself.</p>\n\n\n\n<p>I am probably preaching to the choir of remote developers, designers, and team managers. Many of us have been down this road and found that sweet spot that helps us get through the day. For the newcomers, welcome to our world. Kick your heels off at the door. There is no fashion-shaming here.  Enjoy our guilt-free software and community in your lazy pants.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Apr 2020 19:18:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WPTavern: Frontity Raises €1M with Automattic and K Fund\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98846\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:157:\"https://wptavern.com/frontity-raises-e1m-with-automattic-and-k-fund?utm_source=rss&utm_medium=rss&utm_campaign=frontity-raises-e1m-with-automattic-and-k-fund\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4732:\"<p><a href=\"https://frontity.org/\">Frontity</a>, a free, open source framework for building WordPress themes with React, has raised &euro;1M in funding in a round led by <a href=\"https://kfund.co\">K Fund</a>, with <a href=\"https://automattic.com/\">Automattic</a> covering 22%. The team behind the framework officially made it open source in May 2019, after battle testing it internally. In one year the framework has more than 12,700 npm downloads and has built a community of 250 developers who use it. </p>\n\n\n\n<p>Frontity lowers the barrier to creating fast-loading, React-powered WordPress themes by removing the hassle of setting up and configuring all the tooling. The framework seems to have captured Automattic&rsquo;s interest as a homegrown WordPress solution for facilitating decoupled setups that use React on the frontend.</p>\n\n\n\n<p>&ldquo;We decided to build the framework as a response to the demand of all the big publishers we were working with,&rdquo; Frontity CEO Pablo Postigo said. &ldquo;This trend can drastically change the way many WordPress websites are built in the future. From my point of view, Automattic&rsquo;s support means that they are also aware of this trend, and want to be close to us. In the end we are trying to make WordPress keep up with the latest technologies, and the stronger WordPress is, the better for all the companies that depend on it, including Automattic.&rdquo;</p>\n\n\n\n<p>Frontity is not yet profitable and Postigo said the company is not developing a business model during this initial phase. </p>\n\n\n\n<p>&ldquo;This funding round was the best way for us to make the project sustainable,&rdquo; he said. &ldquo;Possible monetizations that we are thinking of to generate revenue in the future are a hosting solution, premium support, or a marketplace of paid themes.&rdquo;</p>\n\n\n\n<h2>Frontity&rsquo;s Biggest Challenge: Becoming a Compelling Alternative to PHP Themes  </h2>\n\n\n\n<p>Postigo identified Gatsby and Next.js as Frontity&rsquo;s chief competitors in the sea of React frameworks vying for developers&rsquo; attention. He said his team takes inspiration from these frameworks and appreciates how they are raising awareness of new ways of building websites.&nbsp;</p>\n\n\n\n<p>&ldquo;Our biggest challenge right now is to position Frontity not as an alternative to other frameworks, but as an alternative to PHP themes,&rdquo; he said. &ldquo;So when developers start looking for the best way to build a superior UX they consider Frontity amongst their options.&rdquo;</p>\n\n\n\n<p>Those who are already familiar with other JS frameworks like Gatsby will find that Frontity has fewer new concepts to learn, since it is 100% focused on WordPress and its APIs. Postigo identified a few other major differences between Frontity and other popular JS frameworks:</p>\n\n\n\n<ul><li>It&rsquo;s rendered dynamically: this means people don&rsquo;t have to rebuild the HTML each time they edit or publish content. Frontity&rsquo;s preferred approach is <a href=\"https://vercel.com/blog/serverless-pre-rendering\">Serverless Pre-Rendering</a>, although there are many ways to configure it. It&rsquo;s as fast as a static site (e.g. <a href=\"https://mars.frontity.org\">https://mars.frontity.org</a>).</li><li>It&rsquo;s opinionated: it has its own state manager and uses Emotion for the CSS. Thanks to that people don&rsquo;t need to learn things like Redux and, at the same time, it powers a very flexible extensibility pattern, more similar to the one of WordPress itself than to the rest of JS frameworks. Themes and extensions can be activated and deactivated without code changes.</li><li>There&rsquo;s no need to learn GraphQL or the REST API, you get the data using the state manager.</li></ul>\n\n\n\n<p>Even with fewer new concepts to learn, Frontity remains squarely within the developers&rsquo; toolbox and is not currently a product that would appeal to non-technical users. Expanding Frontity&rsquo;s user base beyond developers and breaking into the wider WordPress market is a long-term goal for the company. </p>\n\n\n\n<p>&ldquo;With Frontity Framework we are on a mission to help developers build performant, scalable websites with WordPress and React easily,&rdquo; Postigo said. &ldquo;But the company&rsquo;s ultimate goal is to make building delightful user experiences universally accessible.<br /><br />&ldquo;We have plans to lower the technical barrier so any WordPress user can benefit from our technology. We consider that after having released the framework the next step towards this is to build a community of developers around it, so that they can help us build themes and extensions that will make it easier for non-technical users to start using Frontity.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Apr 2020 20:26:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Gutenberg Hub Launches Online Block Template Builder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98780\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"https://wptavern.com/gutenberg-hub-launches-online-block-template-builder?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-hub-launches-online-block-template-builder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5301:\"<p class=\"has-drop-cap\">Gutenberg Hub <a href=\"https://gutenberghub.com/introducing-gutenberg-template-builder/\">launched the first version</a> of its block template builder last week. The <a href=\"https://builder.gutenberghub.com/\">template builder</a> allows users to select from the team&rsquo;s existing library of nearly 200 templates. It is essentially an online builder that allows users to craft a full page layout by mixing and matching various sections. They can then copy the resulting output at the click of a button and paste it into the editor on their sites.</p>\n\n\n\n<p>&ldquo;I intend to speed up the workflow for WordPress users to spin up beautiful Gutenberg pages, even full websites, faster,&rdquo; said Munir Kamal, founder of Gutenberg Hub. &ldquo;So all I am trying to do is headed in that direction.&rdquo;</p>\n\n\n\n<p>Kamal has also released a <a href=\"https://chrome.google.com/webstore/detail/gutenberghub/pkjhekakadbpmpehgkdndgmpepphekbk\">Chrome browser extension</a> that allows end-users to add templates from the growing library of options.</p>\n\n\n\n<p>&ldquo;The idea is to help DIYers, freelancers, or anyone with creating new website pages faster,&rdquo; he said. &ldquo;I have many feature ideas to make this builder great, but I want to hear out the feedback and suggestions from the community about it.&rdquo;</p>\n\n\n\n<p>Currently, Kamal is calling this version of the builder a &ldquo;prototype&rdquo; because he wants to validate the idea with the community before moving forward with new features.</p>\n\n\n\n<h2>Using the Template Builder</h2>\n\n\n\n<p class=\"has-drop-cap\">Building a template or full page is simple. Users merely need to visit the template builder page. On the page, the builder has an &ldquo;Add Section&rdquo; button, which will slide the template library panel open. From that point, users can choose from an extensive list of templates that includes designs for hero sections, testimonials, sliders, and more.</p>\n\n\n\n<img />Gutenberg Hub&rsquo;s templates library.\n\n\n\n<p>The idea is to build a full page by combining multiple sections. Users will want to add new sections and organize them for their needs. Each section can be trashed, duplicated, or moved up/down using the available buttons.</p>\n\n\n\n<p>Trying my hand at building a simple product page, I was able to pick and choose the sections I wanted to add in just a few minutes.</p>\n\n\n\n<img />Custom combination of templates with the builder.\n\n\n\n<p>Once everything is in place, users can copy the full template code and paste it their block editor.  From that point, they can edit it on their own site.  </p>\n\n\n\n<p>Sometimes, it may be necessary to copy additional CSS and insert it via the WordPress customizer or through a plugin like <a href=\"https://wordpress.org/plugins/blocks-css/\">Blocks CSS</a>.  Some options also require users to install a plugin to use specific blocks.</p>\n\n\n\n<p>This is the type of power I want in the hands of WordPress users. Plug-and-play template systems like this will push the platform into the future. However, such systems need to be integrated directly into WordPress. Copying and pasting from a third-party website is merely a stepping stone toward that future, catering to user needs in the here and now.</p>\n\n\n\n<h2>The Future of the Builder and More</h2>\n\n\n\n<p class=\"has-drop-cap\">Long term, Gutenberg Hub&rsquo;s work may be a better fit into the upcoming <a href=\"https://wptavern.com/block-patterns-will-change-everything\">pattern system</a>. The team could release a plugin that would integrate seamlessly into the block editor. That way, end-users could build their templates without ever leaving the comfort of the post-editing screen, or at least avoid switching between browser tabs. However, patterns are still months away from inclusion in core WordPress. In the meantime, this feels like a solid stop-gap. Plus, the team can build a nice library and garner feedback and data from users on the most popular templates/patterns.</p>\n\n\n\n<p>While Kamal wants to hear feedback before moving forward, he does have some big ideas of his own for the builder. &ldquo;For example, this builder may let you create projects, and under projects, you may create multiple pages,&rdquo; he said. &ldquo;For each project, you may define custom branding (typography, color scheme, etc.), and all the templates from the library will adapt to that branding when you create pages under a specific project.&rdquo;</p>\n\n\n\n<p>The most important thing he wants to accomplish is to build tools that speed up workflows for everyone.</p>\n\n\n\n<p>He will also open the template library to third-party developers and designers soon. There will be a public submission process. If enough people contribute, the library could balloon to an untold number of options that would be directly available as part of the builder.</p>\n\n\n\n<p>&ldquo;Besides the templates and builder, I am planning something around the Gutenberg Templates API,&rdquo; said Kamal. He stresses that it is still in the planning phase. If the previous work that he has put out is any indication, this could be an interesting project. He is also working on a <a href=\"https://wordpress.org/plugins/forms-gutenberg/\">form builder plugin</a> for the block editor, which is currently seeing regular updates.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Apr 2020 20:03:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Google Shopping Is Now Open to Free Product Listings\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98848\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:169:\"https://wptavern.com/google-shopping-is-now-open-to-free-product-listings?utm_source=rss&utm_medium=rss&utm_campaign=google-shopping-is-now-open-to-free-product-listings\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2768:\"<p>Google <a href=\"https://blog.google/products/shopping/its-now-free-to-sell-on-google/\">announced</a> today that it is bringing free listings to the Shopping tab in the United States before the end of April and will expand globally by the end of the year. Previously, merchants were required to pay for ad placement and product listings, which led to major online retailers dominating the Shopping tab.</p>\n\n\n\n<p>&ldquo;Beginning next week, search results on the Google Shopping tab will consist primarily of free listings, helping merchants better connect with consumers, regardless of whether they advertise on Google,&rdquo; Bill Ready, Google&rsquo;s president of commerce, said. &ldquo;With hundreds of millions of shopping searches on Google each day, we know that many retailers have the items people need in stock and ready to ship, but are less discoverable online.&rdquo;</p>\n\n\n\n<p>This change comes at a critical time when the retail industry has taken a significant hit due to shelter-in-place orders aimed at mitigating the spread of the coronavirus. Free listings make showing up in the Google Shopping tab more accessible for independent stores.</p>\n\n\n\n<p>&ldquo;For retailers, this change means free exposure to millions of people who come to Google every day for their shopping needs,&rdquo; Ready said. &ldquo;For shoppers, it means more products from more stores, discoverable through the Google Shopping tab.&rdquo;&nbsp; Existing Merchant Center users will retain their ads for specific products as promoted listings but will also now be able to list their full inventories for free.</p>\n\n\n\n<p>Google also announced a new partnership with PayPal that will streamline the onboarding process for merchants who want to link their accounts. The announcement identified WooCommerce, Shopify, and BigCommerce as existing partners that offer platforms to help businesses sell online. In light of the current crisis, WooCommerce has ramped up its efforts to make e-commerce more approachable. The team recently hosted a free webinar on <a href=\"https://zoom.us/webinar/register/8615868833115/WN_4TTi3KPWQZG5HCchf81LEg\">how to start selling online</a> and produced a <a href=\"https://woocommerce.com/posts/add-online-store-to-wordpress/\">guide to adding a store to an existing WordPress website</a>.</p>\n\n\n\n<p>Although Google cites the coronavirus pandemic as a factor in advancing the company&rsquo;s plans to make it free for merchants to sell on Google, the move is a strategic step towards wooing back the overwhelming amount of traffic it sends to Amazon. If Google&rsquo;s Shopping tab can become a better source for price comparisons with a diversity of stores, consumers may return to searching Google first when intending to make a purchase.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Apr 2020 02:46:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"WPTavern: WordPress Dashicons Project to Discontinue Development in Favor of New Icon Component\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98810\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:235:\"https://wptavern.com/wordpress-dashicons-project-to-discontinue-development-in-favor-of-new-icon-component?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-dashicons-project-to-discontinue-development-in-favor-of-new-icon-component\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3652:\"<p><a href=\"https://github.com/WordPress/dashicons\">Dashicons</a>, the WordPress admin icon font, is now closed to new icon requests. After the block editor adopted the approach of using SVG icons directly, WordPress design contributors have recently reevaluated the efforts going into the Dashicons project. The team decided to wrap up existing tickets for new icons, push out a final release, and then pool their efforts on the <a href=\"https://github.com/WordPress/gutenberg/tree/master/packages/components/src/icon\">new Icon component</a>.</p>\n\n\n\n<p>&ldquo;One of the challenges with an icon font is that it&rsquo;s one big compiled &lsquo;sprite,&rsquo; and so even though it gets cached well, for every icon you add the sprite grows bigger,&rdquo; WordPress design contributor Joen Asmussen said in a <a href=\"https://make.wordpress.org/design/2020/04/20/next-steps-for-dashicons/\">post</a> announcing the change. &ldquo;With SVG you include just the icons you need.&rdquo;</p>\n\n\n\n<p>A recently-merged <a href=\"https://github.com/WordPress/dashicons/pull/411\">pull request</a> brings the project&rsquo;s collection of 303 icons to a total of 340, with final additions including items like airplane, beer, coffee, and more, based on the remaining open issues.</p>\n\n\n\n<p>With just a handful of contributors, Dashicons had been subject to infrequent updates. Prior to WordPress 5.2 (May 2019), which <a href=\"https://wptavern.com/wordpress-5-2-will-add-13-new-icons-to-the-dashicon-library\">updated</a> the icon font to use WOFF2 (Web Open Font Format 2) and added 13 new icons, Dashicons had gone dormant for three years. This means that developers who needed a specific icon were sometimes waiting a long time for it to get added and often opted to use a different library. </p>\n\n\n\n<p>The new Icon component isn&rsquo;t subject to the same limitations. During the design team&rsquo;s recent discussion about Dashicon&rsquo;s next steps, Asmussen noted that the new Icon component comes with a set of icons but developers can also feed it a custom SVG.</p>\n\n\n\n<p>&ldquo;An icon doesn&rsquo;t have to be part of the set for it to be treated like any other icons in the system,&rdquo; Asmussen said. &ldquo;Which makes it easier to say no to some social icons &mdash; we can say &lsquo;No, but you can do this: {code example}.\'&rdquo; This flexibility prevents developers from having to spend time lobbying for a particular icon to get added or working to demonstrate its popularity.</p>\n\n\n\n<p>Asmussen thanked Dashicons creator Ben Dunkle for his work in maintaining the icon font over the years. Dunkle will join the effort to improve the new Icon component as it is still being fleshed out. </p>\n\n\n\n<p>&ldquo;And a lot of the lessons Ben and I learned from Dashicons could probably help spell out some principles for what fits in the component,&rdquo; Asmussen said. &ldquo;In some ways, I think we can be much more open to accepting icons because it doesn&rsquo;t balloon a sprite. In others, as mentioned, we can decide it&rsquo;s not WordPress&rsquo; place.&rdquo;</p>\n\n\n\n<p>Dashicons will be maintained in core indefinitely but no new icons will be added after this point. Plugin developers have the option to continue using the icon font or embrace the new Icon component. </p>\n\n\n\n<p>&ldquo;Switching to SVG in WP-admin, and perhaps the new Icon component, is a discussion definitely worth having at some point,&rdquo; Asmussen said. &ldquo;But [it&rsquo;s] worth noting that it&rsquo;s not necessarily part of today&rsquo;s discussion. This is first and foremost to ensure Dashicons is in a solid place for everyone relying on it.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Apr 2020 01:16:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WPTavern: WPBlockTalk Videos Now Available on WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98727\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:161:\"https://wptavern.com/wpblocktalk-videos-now-available-on-wordpress-tv?utm_source=rss&utm_medium=rss&utm_campaign=wpblocktalk-videos-now-available-on-wordpress-tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2497:\"<p>All of the recordings from the free <a href=\"https://wpblocktalk.wordpress.stream/\">WPBlockTalk</a> virtual event are <a href=\"https://wordpress.tv/event/wpblocktalk-april-2020/\">now available on WordPress.tv</a>. In case you missed it, WPBlockTalk was a WordPress community event sponsored by Automattic, and produced by Brian Richards, creator of WPSessions. It took place earlier this month on April 2, though some of its momentum may have been lost in the torrent of pandemic news. Fortunately, all the sessions that were streamed that day have been uploaded for anyone to watch. </p>\n\n\n\n<p>WPBlockTalk created moderate <a href=\"https://twitter.com/hashtag/WPBlocktalk?src=hashtag_click\">buzz on Twitter</a>, but the caliber of the speakers and the density of their block editor expertise make these videos a must-watch for anyone involved in WordPress product and website development. Some of the speakers were involved in designing and building the block editor and others were early adopters who ran full speed ahead to create some of the most successful block-based plugins in the ecosystem.</p>\n\n\n\n<p>The event kicked off with a session titled <a href=\"https://wordpress.tv/2020/04/16/matt-mullenweg-matias-ventura-the-roadmap-for-gutenberg-plus-a-demo/\">The Gutenberg Roadmap</a> led by Matt Mullenweg and Matias Ventura. It included an overview of what is coming in the full-site editing project, along with an exciting hands-on demo that fully integrates theme templates into a unified interface. Ventura estimates this basic UI will be &ldquo;in a very decent state in a couple months.&rdquo; </p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>The other 11 sessions that follow provide an interesting look at where the block editor has been and where we can expect it to go in the near future. Topics include extensibility, case studies, accessibility, block development, and more.</p>\n\n\n\n<p>Although WPBlockTalk was originally <a href=\"https://wordpress.com/blog/2020/03/18/wpblocktalk-block-editor-event/\">announced</a> on the WordPress.com News blog, the majority of the content featured in the event was geared towards those creating block-based products. More than 1,000 viewers attended WPBlockTalk, similar to the turnout for a large traditional WordCamp. These types of nimble, niche-focused virtual events were already gaining traction in 2019 and are likely to become more common in the wake of prolonged restrictions on large gatherings due to the coronavirus. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Apr 2020 22:47:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: On Digital Gardens, Blogs, Personal Spaces, and the Future\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98695\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:175:\"https://wptavern.com/on-digital-gardens-blogs-personal-spaces-and-the-future?utm_source=rss&utm_medium=rss&utm_campaign=on-digital-gardens-blogs-personal-spaces-and-the-future\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8960:\"<div class=\"wp-block-cover alignfull has-background-dim-70 has-gray-900-background-color has-background-dim has-parallax bg-gray-900\"><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-group\"><div class=\"wp-block-group__inner-container\">\n<p class=\"has-drop-cap has-text-align-left has-extra-large-font-size text-xl text-left\">Ihave been thinking a lot about digital gardens this week. A blog post by Tom McFarlin <a href=\"https://tommcfarlin.com/digital-gardens-and-blogs/\">re-introduced me to the term</a>, which led me down a rabbit hole of interesting ideas on creating a digital space that is more personalized and tended in a way that is antithetical to the chronological blog.</p>\n</div></div>\n</div></div>\n\n\n\n<p>The concept of digital gardens is not new. It predates the modern blog, but there may be a resurgence, albeit small, of the sort of curated content that grows within a digital garden.</p>\n\n\n\n<p>The term &ldquo;digital garden&rdquo; is not well-defined. In general, it is a collection of thoughts, unfinished projects, links, and much more. However, it can be different and wholly unique to the individual. I would like to broaden the term to enclose any sort of website that allows you to truly browse without viewing posts chronologically. Digital gardens, collections, spaces &mdash; call it what you want.</p>\n\n\n\n<p>I began my personal website in 2003. I hacked together a main page with a few internal links. I began blogging before I knew what blogging was. This was all done with basic <code>.txt</code> files that I edited in Notepad on Windows. I knew enough PHP to load and display those files. My <em>blog</em> posts were merely random thoughts &mdash; bits and pieces of my life.</p>\n\n\n\n<p>Despite having something that worked sort of like a blog, I maintained various resources and links of other neat ideas I found around the web. It was a digital garden that I tended, occasionally plucking weeds and planting new ideas that may someday blossom into something more.</p>\n\n\n\n<p>I created a films page in which I shared 30-second trailers of short films I was planning. I maintained a list of my DVD collection. I had a page in which I showcased hate messages I received on my guestbook. <em>All in good fun, of course.</em> I kept a curated list of cool webpages to visit.</p>\n\n\n\n<p>All of this was a painstaking, manual process before WordPress crashed into my life, but it was still fun.</p>\n\n\n\n<p>Over the years, WordPress changed everything for me. I officially became a blogger. The problem was that, at a certain point, blogging became <em>work</em>. I needed to think about keywords, perfecting a post title, and making sure that each word was carefully crafted. The initial joy I had with my personal space had waned.</p>\n\n\n\n<p>&ldquo;The idea of a &lsquo;blog&rsquo; needs to get over itself,&rdquo; wrote Joel Hooks in a post titled <a href=\"https://joelhooks.com/on-writing-more\">Stop Giving af and Start Writing More</a>. &ldquo;Everybody is treating writing as a &lsquo;content marketing strategy&rsquo; and using it to &lsquo;build a personal brand&rsquo; which leads to the fundamental flawed idea that everything you post has to be polished to perfection and ready to be consumed.&rdquo;</p>\n\n\n\n<p>It is almost as if he had reached down into my soul and figured out why I no longer had the vigor I once had for sharing on my personal blog. For far too long, I was trying to brand myself. Posts became few and far between. I still shared a short note, aside, once in a while, but much of what I shared was for others rather than myself.</p>\n\n\n\n<p>I still love the idea of a personal blog, but there is room for this space to be reshaped. Personal websites can be so much more than a progression of posts over time, newer posts showing up while everything from the past is neatly tucked on &ldquo;page 2&rdquo; and beyond.</p>\n\n\n\n<p>Amy Hoy, in <a href=\"https://stackingthebricks.com/how-blogs-broke-the-web/\">How the Blog Broke the Web</a>, describes the downfall of the digital gardens that once grew across the landscape of the web. It is a history of how personal websites, particularly through the ease of use of the modern CMS, changed for the worse. Instead of carefully tending to our gardens, we became lazy caretakers of our space, molding our content based on the tools the system provided.</p>\n\n\n\n<p>She concluded with:</p>\n\n\n\n<blockquote><p>&ldquo;There are no more quirky homepages.  There are no more amateur research librarians. All thanks to a quirky bit of software produced to alleviate the pain of a tiny subset of a very small audience. That&rsquo;s not cool at all.&rdquo;</p></blockquote>\n\n\n\n<p>She shares my <a href=\"https://wptavern.com/rebirth-of-creativity-gutenberg-and-the-future-of-wordpress-themes\">nostalgia for the early web</a> in which webmasters poured everything about themselves into their little slice of it. It was done over the sweat and tears of late-night HTML mastery. It was about fighting weird CSS quirks just to align something on the center of the page. <em>No grid or flex-box existed in those days.</em></p>\n\n\n\n<p>While I lament the loss of some of the artistry of the early web and lay much of the blame at the feet of blogging platforms like WordPress, such platforms also opened the web to far more people who would not have otherwise been able to create a website. <em>Democratizing publishing</em> is a far loftier goal than dropping animated GIFs across personal spaces.</p>\n\n\n\n<p>WordPress is in a position to reshape the web into whatever we want.</p>\n\n\n\n<p>Throughout the platform&rsquo;s history, end-users have remained at the mercy of their WordPress theme. Most themes are built around what WordPress allows out of the box. They follow a similar formula. Some may have a fancy homepage or other custom page templates. But, on the whole, themes have been primarily built around the idea of a blog. Such themes do not give the user true control over where to place things on their website. While some developers have attempted solutions to this, most have never met the towering goal of putting the power of HTML and CSS into the hands of users through a visual interface. This lack of tools has given rise to <a href=\"https://wptavern.com/will-page-builders-remain-competitive-in-the-block-era\">page builders and the block editor</a>.</p>\n\n\n\n<p>WordPress has not been, by and large, an ideal platform for building a unique digital space, unless you had the technical know-how to wrangle its front-end output into something unique. At times, that is more frustrating than building a simple HTML page.</p>\n\n\n\n<p>This is the reason that I continually push the Gutenberg project. I write about some of the <a href=\"https://wptavern.com/the-wacky-world-of-sorta-brilliants-sorta-fun-block-plugins\">wild and wacky ideas</a>. I share things like a <a href=\"https://wptavern.com/block-a-saurus-embeds-a-side-scrolling-t-rex-game-via-the-block-editor\">T-Rex game</a> within a block.</p>\n\n\n\n<p>I want end-users to be able to create their own digital gardens. I want them to put a large yellow box on their homepage to share a notice that everyone should read &ldquo;this important page&rdquo; on their site. I want them to be able to do this without having to learn how to code or ask their theme author how to make such customizations. It should be as simple as clicking a few buttons.</p>\n\n\n\n<p>I also want them to be able to easily build something like Tom Critchlow&rsquo;s <a href=\"https://tomcritchlow.com/wiki/\">wikifolder</a>, a digital collection of links, random thoughts, and other resources.</p>\n\n\n\n<p>More than anything, I want personal websites to be more <em>personal</em>.</p>\n\n\n\n<p>We&rsquo;re still in a somewhat frustrating transitional period where WordPress is not even halfway to becoming the platform that it will be. We are still beholden to our themes, though less so than before.</p>\n\n\n\n<p>Whether it is a digital garden, a plain ol&rsquo; blog, or some new thing we do not have a term for yet, we will all be able to put our unique spin on our personal spaces. It is part of the web that we lost in the last couple of decades with the emergence of the CMS. However, WordPress is on the right path.</p>\n\n\n\n<p>It may be a rough ride for some agencies and businesses around the platform, but I am OK with that. They will manage and pull through on the other side, mostly unscathed. I am more concerned about our mission statement of democratizing publishing. And, that mission is not simply about having the ability to write content via a <em>$free</em> system. It is about the freedom to create whatever types of digital homes that we desire without learning to code or breaking the bank.</p>\n\n\n\n<p>Pre-Gutenberg WordPress got us part of the way there. It is the post-Gutenberg world that will get us the rest of the way. I am ready to see what people create when they gain the freedom that particular world promises.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Apr 2020 20:00:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Leave at Door: New Free WooCommerce Plugin Enables Contact-free Delivery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98679\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:207:\"https://wptavern.com/leave-at-door-new-free-woocommerce-plugin-enables-contact-free-delivery?utm_source=rss&utm_medium=rss&utm_campaign=leave-at-door-new-free-woocommerce-plugin-enables-contact-free-delivery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3199:\"<p class=\"is-style-default\">As many countries around the world are currently in some form of lockdown to mitigate the spread of the coronavirus, the hospitality industry has been one of the hardest hit by the new restrictions. Restaurants and breweries in particular have had to radically change how they do business and either lay off or furlough the majority of their employees. Many of those that have survived the mandated dine-in closures are jump-starting delivery services in order to stay afloat.</p>\n\n\n\n<p>Scott DeLuzio, a WordPress plugin developer and founder of <a href=\"https://amplifyplugins.com/\">Amplify Plugins</a>, recently noticed a &ldquo;leave at door&rdquo; option when ordering food from a local restaurant. He thought it would be a helpful option for WooCommerce store owners to add and created a plugin that makes it easy.</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p><a href=\"https://wordpress.org/plugins/leave-at-door-for-woocommerce/\">Leave at Door</a> is now available for free from the official WordPress Plugin Directory. It enables customers to maintain social distancing while receiving deliveries. The plugin adds a checkbox before the Place Order button at checkout, which reveals an optional text input for additional delivery instructions. If the customer chooses contact-free delivery, store owners will see it displayed on the admin order edit screen and in the order email. It will also be displayed on the customer&rsquo;s order invoice.</p>\n\n\n\n<p>DeLuzio&rsquo;s Amplify Plugins shop focuses on plugins that improve the customer experience in WooCommerce. He reported that his products have seen more activity since social distancing  recommendations were put in place. With the pandemic slowing down shipments from Amazon and other major retailers, local and independent stores have an opportunity to gain the confidence of new customers. </p>\n\n\n\n<p>&ldquo;I have definitely seen an uptick in plugin sales over the last month or so,&rdquo; DeLuzio said. &ldquo;I think, through talking to a few customers, this can probably be attributed to traditional brick and mortar stores and restaurants that are looking to move online to compensate for the lack of foot traffic that they are getting in their stores.&rdquo;</p>\n\n\n\n<p>The availability of contact-free delivery may be the deciding factor for some customers in quarantine, which could make all the difference for small business owners.</p>\n\n\n\n<p> &ldquo;There are probably a good number of local businesses that are struggling these days,&rdquo; DeLuzio said. &ldquo;Their customers are probably very concerned with the virus and maintaining social distancing, so if something like this plugin can help them out, even in a small way, I&rsquo;m happy to have been able to put it together for them.&rdquo;</p>\n\n\n\n<p>Even when some economies begin opening up, there will undoubtedly be customers who will still be keen on having a contact-free delivery option, especially those among the populations most vulnerable to COVID-19. The notion of contact-free delivery may have a longer run beyond this current crisis and perhaps even become a permanent fixture on e-commerce checkout screens. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Apr 2020 21:00:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: GitHub Opens Free Plan to Unlimited Collaborators on Private Repositories\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98641\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:211:\"https://wptavern.com/github-opens-free-plan-to-unlimited-collaborators-on-private-repositories?utm_source=rss&utm_medium=rss&utm_campaign=github-opens-free-plan-to-unlimited-collaborators-on-private-repositories\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4411:\"<p class=\"has-drop-cap\">On Tuesday, GitHub <a href=\"https://github.blog/2020-04-14-github-is-now-free-for-teams/\">announced a change to its plans</a> that would make collaboration between developers much cheaper. Free, in fact. Anyone can launch an organization for at no charge with unlimited public and private repositories. The change also includes an unlimited number of collaborators.</p>\n\n\n\n<p>This will be good news for small WordPress development teams without the cashflow to upgrade to the paid Team pricing tier or higher. I have worked with several small plugin and theme businesses who could not foot the per-user billing and sought other solutions such as GitLab and Bitbucket. This move should make GitHub more enticing.</p>\n\n\n\n<p>According to the <a href=\"https://help.github.com/en/github/getting-started-with-github/faq-about-changes-to-githubs-plans#how-long-will-github-free-allow-unlimited-collaborators\">FAQs page</a>, this pricing change is a permanent one.</p>\n\n\n\n<p>&ldquo;Until now, if your organization wanted to use GitHub for private development, you had to subscribe to one of our paid plans,&rdquo; wrote Nat Friedman, CEO of GitHub, in the announcement. &ldquo;But every developer on earth should have access to GitHub. Price shouldn&rsquo;t be a barrier.&rdquo;</p>\n\n\n\n<img />GitHub&rsquo;s lowest pricing tiers.\n\n\n\n<p>The Free pricing tier now offers:</p>\n\n\n\n<ul><li>Unlimited public and private repositories.</li><li>Unlimited collaborators.</li><li>2,000 Actions minutes/month.</li><li>500MB of GitHub Packages storage.</li></ul>\n\n\n\n<p>For a full overview of all changes, GitHub has created a <a href=\"https://help.github.com/en/github/getting-started-with-github/faq-about-changes-to-githubs-plans#what-plans-and-pricing-changes-did-github-announce-on-april-14\">question-and-answer section</a> in its FAQs that covers each detail.</p>\n\n\n\n<p>&ldquo;This means teams can now manage their work together in one place: CI/CD, project management, code review, packages, and more,&rdquo; said Friedman. &ldquo;We want everyone to be able to ship great software on the platform developers love.&rdquo;</p>\n\n\n\n<p>The paid Team plan still exists. Like the Free plan, it is cheaper for a team of developers. GitHub reduced the pricing from $9/month for each user to $4/month. The plan also includes 3,000 GitHub Actions minutes each month, which will go into effect on May 14.</p>\n\n\n\n<p>GitHub seems to be moving away from its previous pay-for-private model.  Instead, they have focused more on pricing based on features.  In January 2019, several months after Microsoft acquired GitHub, the company announced <a href=\"https://wptavern.com/github-announces-free-unlimited-private-repositories\">unlimited free private repositories</a>. However, only three collaborators were allowed on a project before being required to upgrade to a pro plan.</p>\n\n\n\n<p>GitHub has essentially cornered the market on open-source in which most code is maintained in public repositories. With the recent <a href=\"https://wptavern.com/github-acquires-npm-plans-to-improve-infrastructure-and-experience\">acquisition of npm</a>, it will only grow stronger in this space. This pricing change should make it far more competitive for hosting private projects. The free tier puts the company on par with GitLab&rsquo;s <a href=\"https://about.gitlab.com/pricing/\">free level</a>.  Bitbucket is now looking a little more costly. It would not be surprising if the site removed its five-collaborator limit on its <a href=\"https://bitbucket.org/product/pricing\">free plan</a> if it sees a dip in usage.</p>\n\n\n\n<p>On the whole, this will be a good thing for commercial WordPress theme and plugin authors. From several companies I have knowledge of or have worked with, many of them have kept their public repositories on GitHub. However, they would use a different site for private repositories. It was a pain they had to deal with to cut costs. With no limits on the number of collaborators, GitHub&rsquo;s free plan may mean that some can move all of their repositories to a single home. Even if they wanted to upgrade to the Team plan for access to more tools, the reduced cost may be worth it if they prefer working with GitHub.</p>\n\n\n\n<p>The biggest change is there is no initial cost barrier for teams that are kicking off a private project with no funding on hand. This is a good thing for small businesses.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Apr 2020 19:49:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"WPTavern: Gutenberg 7.9 Adds Gradients to More Blocks, Extra Typography Controls, and New Patterns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98498\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:237:\"https://wptavern.com/gutenberg-7-9-adds-gradients-to-more-blocks-extra-typography-controls-and-new-patterns?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-7-9-adds-gradients-to-more-blocks-extra-typography-controls-and-new-patterns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5813:\"<p class=\"has-drop-cap\">For Gutenberg junkies, the three-week wait between major releases has been rough, especially during this time when many are looking for new things to fill the gaps in our social calendars. Not to fret, the team <a href=\"https://make.wordpress.org/core/2020/04/15/whats-new-in-gutenberg-15-april/\">dropped version 7.9 of the plugin</a> earlier today. This release includes several goodies such as new typography-related controls for blocks, extra patterns for testing, and even more work toward a lighter DOM for theme authors.</p>\n\n\n\n<p>With the added time, version 7.9 is a larger release than usual. It includes over two dozen bug fixes and almost as many minor enhancements. The team continued work on full-site editing, which has moved along at a steady pace and is currently slated to land in WordPress 5.6 later this year.</p>\n\n\n\n<p>The development team has made several tweaks to the user interface. This is a continuation of the work that has landed in the previous couple of major releases. WordPress users who are not running the Gutenberg plugin can expect to see the refreshed UI in August this year when WordPress 5.5 drops.</p>\n\n\n\n<p>One nice change is to the link inserter. Instead of outputting the URL from an existing post, it will output the post title instead. This should make it far quicker for users to insert links to their posts or pages in the editor.</p>\n\n\n\n<p>Fullscreen mode can now be toggled on and off via the <code>Ctrl</code> + <code>Shift</code> + <code>Alt</code> + <code>F</code> keyboard shortcut. That is assuming you consider remembering which four keys to press a <em>shortcut</em>. At least the option exists for those who need it. I suppose I will acquire the muscle memory to toggle it over time.</p>\n\n\n\n<p>On the whole, this a major release in every sense. Everything from documentation to code quality has seen improvements. Developers can enjoy new APIs. Theme authors should also have an easier time styling buttons &mdash; the editor HTML should now be consistent with front-end output.</p>\n\n\n\n<h2>Gradient All the Things</h2>\n\n\n\n<img />Custom gradient background for the Media &amp; Text block.\n\n\n\n<p class=\"has-drop-cap\">Until now, users could add gradient backgrounds to the cover and button blocks. Gutenberg 7.9 extends this option to the group, columns, and media &amp; text blocks.</p>\n\n\n\n<p>I have yet to see many theme authors take advantage of gradients. Granted, gradient backgrounds only landed in WordPress 5.4. I am hoping some of the top designers in the theme space can tackle this, if for no other reason than providing me some new eye candy when writing posts such as this that discuss gradients in Gutenberg.</p>\n\n\n\n<p>On the whole, the addition of the gradients option to new blocks is a good thing. The next step is to continue expanding it to other blocks.</p>\n\n\n\n<h2>Typography for Headings and Paragraphs</h2>\n\n\n\n<img />Adjusting the font size of a heading block.\n\n\n\n<p class=\"has-drop-cap\">The Gutenberg team has finally checked off one of my longstanding pet peeves. The heading block now has a font-size option. Instead of users using an H1-level heading to make their text larger, they can stick with an appropriate-level heading for the document structure while using the font-size option to adjust how large it appears.</p>\n\n\n\n<p>I am concerned about the addition of a new setting to allow users to adjust the line-height for paragraphs and headings. Currently, the setting does not allow theme authors to add choices based on their design system or disable the feature altogether.</p>\n\n\n\n<p>We also get some new inline styles instead of classes. At this point, that ship has already sailed and sunk with Gutenberg.</p>\n\n\n\n<p>The usefulness of a line-height setting is clear when designing a full-page layout, such as a single-page brochure. However, changing the line-height for most text on a site could have dire consequences in the long term, especially when an end-user switches themes and finds that their chosen line-height is completely out of sync with their new theme. I would not wish the pain of updating dozens or more old blog posts to adjust paragraph design on anyone. Of course, the same could be said of font sizes and similar settings. This is the one setting that I want to see with more theme author feedback as part of the decision.</p>\n\n\n\n<h2>Three New Block Patterns</h2>\n\n\n\n<img />Inserting the Numbered Features block pattern into the editor.\n\n\n\n<p class=\"has-drop-cap\">Gutenberg 7.9 removed the block patterns icon from the top right and tucked it behind the editor options menu. Users can pin the patterns sidebar, which will move the patterns icon back to the top for quick access.</p>\n\n\n\n<p>The update also introduces three additional block patterns, bringing the total to six.</p>\n\n\n\n<ul><li><strong>Hero Two Columns:</strong> Displays a group that encloses an italic paragraph, a heading, and two columns of text.</li><li><strong>Numbered Features:</strong> Displays several groups of columns with a number on the left and text on the right.</li><li><strong>It&rsquo;s Time:</strong> Outputs a paragraph, two columns, and a large paragraph that reads &ldquo;it&rsquo;s time.&rdquo;</li></ul>\n\n\n\n<p>The Numbered Features pattern is by far the most intricate pattern the Gutenberg team has put together while building the block patterns system. It is nice to see them exploring some designs that users will find useful.</p>\n\n\n\n<p>At this point, most of the patterns are relatively boring and not representative of how feature-rich this system will become in the future. It is important to remember that patterns are still at an early stage of development. By the time the feature lands in core WordPress, we should see more advanced and beautiful patterns for use on websites.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Apr 2020 20:14:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"HeroPress: Helping Small Businesses During A Pandemic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=3109\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"https://heropress.com/essays/helping-small-businesses-during-a-pandemic/#utm_source=rss&utm_medium=rss&utm_campaign=helping-small-businesses-during-a-pandemic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11544:\"<img width=\"960\" height=\"480\" src=\"https://s20094.pcdn.co/wp-content/uploads/2021/04/041320-min.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"WordPress is a powerful tool that can quickly be levereged to help people in need.\" /><p>In mid March 2020 it was clear that the coronvirus pandemic was going to have drastic consequences for daily life. Many local shops, market stalls and other food outlets would struggle to keep in touch with their regular customers. It was also worrying that lots of people would be stuck at home with only the internet and phone as ways to keep in touch with their local shops.</p>\n<h3>Getting Started</h3>\n<p>I decided to create a small site for local shops (and other related businesses) to put their contact info on so that people could get in touch. I bought the domain name <a href=\"https://www.cambridgelocalshops.co.uk\">www.cambridgelocalshops.co.uk</a> and got started. I decided to have several main sections &#8211; shops, food outlets, local support, delivery companies and activities.</p>\n<p>I add most shops that request to be added &#8211; small national brand supermarkets as well as independent shops. The only shops I&#8217;ve decided not to include are ones that could be misconstrued as giving medical advice.</p>\n<blockquote><p>This whole site is required because of a medical emergency and clear messaging on that topic is vital.</p></blockquote>\n<p>Some pubs and restaurants have started doing take-away food from their kitchens, and in addition offer a grocery ordering service. It&#8217;s a great way to keep their business open and offer really useful support to their community. Watching businesses change how they operate to help their communities is inspiring. I&#8217;ve heard that many neighbourhood &#8216;mutual aid groups&#8217; have found the site a useful way to get information about shops out to people who are isolated at home.</p>\n<h3>Spreading The Word</h3>\n<p>I shared the site on twitter and various other local groups I&#8217;m a member of. The number of hits I was getting on the site daily showed there was a need. The local <a href=\"https://www.em.admin.cam.ac.uk/what-we-do/estate-operations/facilities-services/reprographics\">university printing office</a>, just before closing for lockdown, ran off 10,000 leaflets about the site. The local <a href=\"https://www.zedify.co.uk/cambridge\">bike courier company</a> delivered them door to door free of charge. For them it was a way of supporting local businesses and shops that are their key customers in more normal times, and providing an important community service right now. The photos are all from <a href=\"https://unsplash.com/\">unsplash.com</a> &#8211; free of charge and great quality.  Jo at <a href=\"https://www.kabocreative.com/\">Kabocreative</a> designed the great logo and shared it with me.</p>\n<blockquote><p>Having designed the site in a morning using TwentySeventeen as the theme and using <a href=\"https://wordpress.org/plugins/atomic-blocks/\">Atomic Profile Blocks</a> for the individual shops I realised I needed something a bit more streamlined.</p></blockquote>\n<p>Juggling this clunky way of editing a site alongside home schooling two children and facing the challenges of life under lockdown was not viable. I started redeveloping the site behind the scenes, using posts instead of pages for each shop, categorising them according to type of shop and their location, and then building a site structure out of that categorising system. I also switched to <a href=\"https://generatepress.com/\">GeneratePress</a> for the theme (I love it). It all kind of worked.</p>\n<h3>Reaching Out</h3>\n<p>Then I got in touch with Topher DeRosia asking if he&#8217;d like me to write this up for his wonderful HeroPress blog aimed at the WordPress community. Many towns and districts around the world could do with a site like this and it&#8217;s a perfect way for a WordPress person to support their local shops and neighbours at this time.</p>\n<p>Topher did way more than that, coming on board to take a look at the back end of the site, make some brilliant changes and also contacting <a href=\"https://wsform.com/\">WSForm</a> for a pro plugin to help with the process.</p>\n<blockquote><p>Now, when someone completes the form to request an entry on the site it automatically creates a post with that shops&#8217; details already pre drafted.</p></blockquote>\n<p>I just need to add the categories, check the details, and publish it. It is a dream to manage as it is so fast to add a new shop. I am hugely grateful to Topher for dedicating so much time and care to this when all I expected was the chance to share an idea with others.</p>\n<p>The site already has a sibling &#8211; <a class=\"defanged3-moz-txt-link-abbreviated\" href=\"http://www.stivesandvillages.co.uk\" target=\"_blank\" rel=\"noopener noreferrer\">www.stivesandvillages.co.uk</a> &#8211; set up by my friends Penni and Jo at <a href=\"https://www.kabocreative.com/\">KaboCreative</a>. If you&#8217;re interested in creating something similar to support your community while under lockdown check out Topher&#8217;s <a href=\"https://topher1kenobe.com/cambridge-local-shops-help-during-covid-19/\">technical tips</a> and some special offers we&#8217;ve negotiated with <a href=\"https://wsform.com/\">WSForm</a> and <a href=\"https://generatepress.com/\">GeneratePress</a> to make your life easier and a bit cheaper! Thanks to these companies for their support.</p>\n<h3>What We Learned</h3>\n<p>Here are a few key tips I gave Penni when she got in touch to ask about using my idea for her local area:</p>\n<ul>\n<li>don&#8217;t use logos &#8211; everyone will want their logo used and file quality will vary. So it doesn&#8217;t look like favouritism just make a blanket ban. Choose nice pictures from unsplash.com instead, or simply have one single photo of your town or village in a banner image place. Maybe feature a local photographer who can donate a picture.</li>\n<li>try to focus, at least at first, on shops that are selling vital food stuffs and household goods &#8211; this is what people are looking for urgently.</li>\n<li>don&#8217;t just request info about how they deliver; in a rapidly changing environment shops will be adapting and doing different things. In my area many are doing &#8216;timed collections&#8217; where staff pack your goods for you based on a phone order, and you collect at a specific time by agreement so social contact / crowds / queues are minimised. Some shops are also doing special hours for key workers. Make sure your form is flexible enough to cope with variety and change in how shops are operating.</li>\n<li>be open to including places that don&#8217;t normally sell groceries &#8211; eg pubs have been doing fresh food deliveries to local people and providing a valuable service in my town. They get listed under both &#8216;pubs&#8217; and &#8216;groceries&#8217; on my site.</li>\n<li>create a leaflet that people can print off and share with others, that shops can send out with deliveries &#8211; here&#8217;s <a href=\"https://cambridgelocalshops.co.uk/wp-content/uploads/2020/03/Cant-get-out_-1.pdf\">an example</a> (opens as a PDF).</li>\n<li>many shops won&#8217;t have an online ordering system &#8211; offering them the chance to put a Word document or a PDF order form on your site can be a vital way for them to get information out about their products and contact info. It also means people can print these off and share them with neighbours who don&#8217;t have computers or smart phones.</li>\n<li>make it useful beyond shops &#8211; include local community groups by linking to any reliable pages (eg local municipality / council site) that list them.</li>\n<li>include some medical links to reliable sources (World Health Organisation or national government sites, for example).</li>\n<li>include some activities for those stuck at home &#8211; we have a knitting shop, a martial arts class that&#8217;s now online by video, some arts resources and a dance school doing online lessons! It keeps it local and friendly and relatable for people who know their local area and are looking for reassurance.</li>\n</ul>\n<p>I&#8217;ve enjoyed putting this site together, interacting with all the business owners who&#8217;ve entered their details, and making new friends when other people got involved. I highly recommend it as a way of doing something useful in these strange times.</p>\n<hr />\n<h3><em>Editor&#8217;s Note</em></h3>\n<p><em>Topher here. Part of the plan all along was to make it so other people can easily replicate what Elisabeth did. <a href=\"https://topher1kenobe.com/cambridge-local-shops-help-during-covid-19/\">You can find a post on my personal blog</a> detailing how it all works, and you can download the plugins, theme, and export files.</em></p>\n<p><em>If you think your local business area could use something like what Elisabeth built, now you can easily do it yourself.</em></p>\n<p><em>GeneratePress and WSForm are both commercial products, but for this project they generously offer a 20% discount to anyone building something like Elisabeth&#8217;s project. You can find the discount codes on the blog post I mentioned above.</em></p>\n<p><em>Thank you Elisabeth for doing such a great work, and thank you for allowing me to be a part of it!</em></p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Helping Small Businesses During A Pandemic\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Helping%20Small%20Businesses%20During%20A%20Pandemic&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fhelping-small-businesses-during-a-pandemic%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Helping Small Businesses During A Pandemic\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fhelping-small-businesses-during-a-pandemic%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fhelping-small-businesses-during-a-pandemic%2F&title=Helping+Small+Businesses+During+A+Pandemic\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Helping Small Businesses During A Pandemic\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/helping-small-businesses-during-a-pandemic/&media=https://heropress.com/wp-content/uploads/2021/04/041320-min-150x150.jpg&description=Helping Small Businesses During A Pandemic\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Helping Small Businesses During A Pandemic\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/helping-small-businesses-during-a-pandemic/\" title=\"Helping Small Businesses During A Pandemic\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/helping-small-businesses-during-a-pandemic/\">Helping Small Businesses During A Pandemic</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Apr 2020 09:00:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Elisabeth Klaar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: Block-a-saurus Embeds a Side-Scrolling T-Rex Game via the Block Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98606\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:205:\"https://wptavern.com/block-a-saurus-embeds-a-side-scrolling-t-rex-game-via-the-block-editor?utm_source=rss&utm_medium=rss&utm_campaign=block-a-saurus-embeds-a-side-scrolling-t-rex-game-via-the-block-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6574:\"<div class=\"wp-block-cover alignfull has-background-dim-80 has-black-background-color has-background-dim bg-black\"><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-blockasaurus-blockasaurus\"><div id=\"bas-messageBox\" class=\"sendmessage\"><h1>Click to Play</h1><div class=\"niokbutton\"></div></div><div id=\"main-frame-error\" class=\"bas-interstitial-wrapper\"><div id=\"main-content\"><div class=\"bas-icon bas-icon-offline\" alt=\"\"></div></div><div id=\"bas-offline-resources\"><img id=\"offline-resources-1x\" class=\"skip-lazy\" src=\"https://wptavern.com/wp-content/plugins/block-a-saurus/src/img/default_100_percent/100-offline-sprite.png\" /><img id=\"offline-resources-2x\" class=\"skip-lazy\" src=\"https://wptavern.com/wp-content/plugins/block-a-saurus/src/img/default_200_percent/200-offline-sprite.png\" /></div></div></div>\n</div></div>\n\n\n\n<p class=\"has-drop-cap\">It is no secret that I love testing out the sort of <a href=\"https://wptavern.com/the-wacky-world-of-sorta-brilliants-sorta-fun-block-plugins\">fun WordPress blocks</a> that hark back to my early days of the web. I have <a href=\"https://wptavern.com/rebirth-of-creativity-gutenberg-and-the-future-of-wordpress-themes\">written on the subject</a> once or twice. Imagine my surprise when I came across a side-scrolling dinosaur game that users could simply plop into the block editor and provide something fun for their visitors to do.</p>\n\n\n\n<p><a href=\"https://wordpress.org/plugins/block-a-saurus/\">Block-a-saurus</a> is a simple game in which you play a T-Rex whose goal is to survive a course of obstacles such as jumping cactuses and ducking birds. To play, you merely need to control the T-Rex via your keyboard&rsquo;s D-pad. It should also work via touch control on mobile devices.</p>\n\n\n\n<p>The only bad thing is that I did not notice this gem eight months ago when it was first released to the public.</p>\n\n\n\n<p>&ldquo;When I started learning about blocks, I realized they could be basically miniature JavaScript applications,&rdquo; said Keanan Koppenhaver, the developer behind Block-a-saurus. &ldquo;I thought this was super interesting as opposed to how WordPress plugins relied more heavily on PHP, so I wanted to see what I could do with basically a blank JavaScript canvas and how that could enable experiences that would have been really difficult to do seamlessly pre-Gutenberg. It slowly went from a &lsquo;Is this even possible?&rsquo; to &lsquo;Let&rsquo;s release it and see if it can inspire people to build something even more out of the box.\'&rdquo;</p>\n\n\n\n<p>Give the game a whirl. Let us know your high score in the comments!</p>\n\n\n\n<h2>Using the Block-a-saurus Plugin</h2>\n\n\n\n<p class=\"has-drop-cap\">The plugin is straightforward. Once installed, it adds a new &ldquo;Block-a-saurus!&rdquo; block in the common blocks section of the block inserter.  The block currently has two options under the block settings panel:</p>\n\n\n\n<ul><li><strong>Dino Speed:</strong> Allows you to speed up or slow down the movement of the T-Rex in the game.</li><li><strong>Mute Audio:</strong> Allows you to enable or disable the game audio.</li></ul>\n\n\n\n<img />Inserting the Block-a-saurus block in the editor.\n\n\n\n<p>By default, the front-end output is bland. Do not expect a graphical powerhouse. However, sometimes, the simplest games can make for hours of fun.</p>\n\n\n\n<img />Default output of Block-a-saurus on the front end.\n\n\n\n<p>I wanted to spruce up my game&rsquo;s design on the front end. Therefore, I first inserted a cover block with a dinosaur background, as can be seen at the beginning of this post. I then dropped the plugin&rsquo;s block within the cover block. </p>\n\n\n\n<p>This works well with a variety of image backgrounds. Plus, it allows users to put a unique spin on their game.</p>\n\n\n\n<img />A custom background using the cover block around Block-a-saurus.\n\n\n\n<p>There is at least one missing piece that I would like to see in a future version of the plugin. It would be nice to integrate alignment options for the block, such as center, wide, and full alignments that are common with many other blocks.</p>\n\n\n\n<p>On the plus side, the plugin developer took the few moments necessary to load scripts and styles only on pages where the game is in use. If you want to run the game, you do not have to worry about it loading unnecessary files on every page of your website.</p>\n\n\n\n<h2>Future Plugin and Block Plans</h2>\n\n\n\n<p class=\"has-drop-cap\">Currently, Block-a-saurus is still sitting at version 1.0. However, Koppenhaver has plans to add extra features to the plugin, such as saving high scores for logged-in users and potentially making the game playable in the backend. The holdup with admin-side playing is some JavaScript conflicts with the native Gutenberg controls.</p>\n\n\n\n<p>&ldquo;Work is moving along pretty steadily,&rdquo; he said of new features. &ldquo;It&rsquo;s nice to have something relatively small and self-contained to work on in between larger client projects. The saving of scores has been the majority of the work so far, and I&rsquo;m hoping to have that released in the next couple of weeks.&rdquo;</p>\n\n\n\n<p>Koppenhaver does not have any immediate plans for similar types of blocks. The plan was for this particular plugin to showcase a fun, one-off block. &ldquo;I&rsquo;ve seen JavaScript implementations of Snake and Tetris, which would be cool to see converted to blocks,&rdquo; he said. &ldquo;I might have to give one of those a try.&rdquo; Perhaps Block-a-saurus is not the end of the road.</p>\n\n\n\n<p>If he wraps up the work on a front-end, JavaScript-based saving feature for high scores, it would be nice to see that offered as a standalone package for other block developers to use. It would certainly make porting other games such as Snake and Tetris to the block system easier.</p>\n\n\n\n<p>Koppenhaver and his team primarily work on more serious endeavors. &ldquo;We have been working on some other block experiments to allow for things like integrating data sourced from Google Drive as D3 visualizations as well as a block to allow agencies to create better case studies by creating those responsive screenshot mockups you see everywhere and being able to create them completely in Gutenberg,&rdquo; he said. &ldquo;We&rsquo;re very excited about the experiences the new editor has allowed us to create and are always experimenting and trying to learn more.&rdquo;</p>\n\n\n\n<p>More than anything, I want to see other plugin authors launch a few more <a href=\"https://wordpress.org/plugins/tags/game/\">games</a> for the block editor.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Apr 2020 18:57:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: The Road Ahead: What’s in Store for WordPress for the Rest of 2020?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98522\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:193:\"https://wptavern.com/the-road-ahead-whats-in-store-for-wordpress-for-the-rest-of-2020?utm_source=rss&utm_medium=rss&utm_campaign=the-road-ahead-whats-in-store-for-wordpress-for-the-rest-of-2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9338:\"<div class=\"wp-block-cover alignfull has-background-dim-70 has-gray-900-background-color has-background-dim has-parallax bg-gray-900\"><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-group\"><div class=\"wp-block-group__inner-container\">\n<p class=\"has-drop-cap has-text-align-left has-extra-large-font-size text-xl text-left\">Full-site editing, automatic theme and plugin updates, global styles, and more await. With the release of <a href=\"https://wptavern.com/wordpress-5-4-adderley-released-includes-improved-editor-new-blocks-and-developer-apis\">WordPress 5.4</a> and an open call for <a href=\"https://wptavern.com/open-call-for-wordpress-5-5-tickets-whats-on-your-wish-list\">version 5.5 tickets</a>, it is time to peer into the future and catch a glimpse of what is to come. It is shaping up to be an exciting year thus far.</p>\n</div></div>\n</div></div>\n\n\n\n<p>Josepha Haden, executive director of WordPress, provided a <a href=\"https://make.wordpress.org/updates/2020/03/06/update-progress-on-goals/\">progress update on the 2020 goals</a> in early March. As always, the timeline to hit certain goals can change based on roadblocks the development team hits and other factors. On the whole, the tentative roadmap looks feasible.</p>\n\n\n\n<p>Currently, WordPress 5.5 is set to ship on August 11, 2020. Version 5.6 is scheduled to follow on December 8, 2020.  Some major changes are forthcoming. Let us take a moment to look ahead and see where the WordPress ship is sailing.</p>\n\n\n\n<h2>Automatic Updates for Everything</h2>\n\n\n\n<img />Automatic updates column on the plugin management screen.\n\n\n\n<p class=\"has-drop-cap\">We have enjoyed automatic updates for minor versions of core WordPress since version 3.7. However, until recently, it has felt like progress on auto-updating everything had stalled. From mobile phones to smart TVs, the average end-user is accustomed to their software simply staying updated. In 2020, it is time WordPress continues pushing forward, particularly when staying updated is one component of maintaining a secure website.</p>\n\n\n\n<p>There are two separate changes centered on automatic updates in the pipeline. The first, which is set to ship in WordPress 5.5, is <a href=\"https://wptavern.com/automatic-theme-and-plugin-updates-slated-for-wordpress-5-5\">automatic updates for plugins and themes</a>. The feature plugin has been in development for several months and should be stable enough to launch with the next version of WordPress.</p>\n\n\n\n<p>Plugin and theme developers will need to adopt a development strategy that aligns more with the WordPress philosophy of maintaining backward compatibility, at least to the point where an automatic update does not break a user&rsquo;s site. This change is a welcome one because it will lead to a more secure web. However, it will be interesting to see how this plays out in the months to come. I am certain there will be a road bump or two that the developer community will need to overcome.</p>\n\n\n\n<p>Automatic updates of core WordPress is slated to officially land in version 5.6. It should be an opt-in feature when it rolls out. The feature plugin should also be ready by the time WordPress 5.5 lands.</p>\n\n\n\n<h2>Block Directory Integration</h2>\n\n\n\n<img />WordPress.org&rsquo;s <a href=\"https://wordpress.org/plugins/browse/block/\">block directory page</a>.\n\n\n\n<p class=\"has-drop-cap\">The block directory first <a href=\"https://wptavern.com/gutenberg-6-5-adds-experimental-block-directory-search-to-inserter-and-new-social-links-block\">landed in Gutenberg 6.5</a> as an experimental feature. For those of us running the plugin, it is almost easy to forget that it is not already a part of WordPress.</p>\n\n\n\n<p>The <a href=\"https://wordpress.org/plugins/browse/block/\">block directory</a> is a listing of a special type of plugin that adds only a single block. In WordPress 5.5, users should be able to search and install blocks from this directory via the post editing screen. If you need a block that is not installed, you can install and begin using it without going through the normal routine with installing a plugin.</p>\n\n\n\n<h2>Full-Site Editing</h2>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>Live Demo Q&amp;A from <a href=\"https://gutenbergtimes.com/theme-templates-full-site-editing-experience-enrique-piqueras/\">The Gutenberg Times</a>.\n\n\n\n<p class=\"has-drop-cap\">I am excited about the prospect of full-site editing landing in WordPress. I am concerned that a target date within 2020 may be rushing a feature that may not be ready. I want this to be a successful <a href=\"https://wptavern.com/initial-documentation-for-block-based-wordpress-themes-proposed\">transition of how themes work</a> and how users interact with their sites. I am optimistic about this future, but I am not convinced it will be good enough by the time WordPress 5.6 ships.</p>\n\n\n\n<p>Aside from the introduction of the block editor itself, this will be one of the largest changes to how WordPress works in its history. Arguably, it is a more wide-reaching change because it touches both the backend user interface and how the theme templating system functions. It needs time to age before it&rsquo;s dropped into the laps of end-users and developers alike.</p>\n\n\n\n<p>I will be the first to jump for joy if I am wrong.</p>\n\n\n\n<p>Currently, the plan is to complete the full-site editing feature in the Gutenberg plugin by the time WordPress 5.5 launches. It should still be behind the experimental flag in the plugin at that point. Then, ship the finished product in version 5.6.</p>\n\n\n\n<h2>Block Areas (Widgets)</h2>\n\n\n\n<img />Using blocks on the experimental block areas screen.\n\n\n\n<p class=\"has-drop-cap\">One of the features that has not gotten near enough attention is the conversion of traditional sidebars into block areas. This is a much-needed change in the mission to turn everything into a block.</p>\n\n\n\n<p>Currently, it is planned to ship in WordPress 5.6, alongside full-site editing. I would rather see block areas as a stepping stone toward full-site editing. It would be less painful for theme authors to have at least a major release to ease into the next step.</p>\n\n\n\n<p>The development of this feature could have been much smoother if WordPress would have simply deprecated sidebars and widgets. The Gutenberg team has had to pigeonhole a block-based system into the old widgets system. It is a little messy. Instead of the current approach, they should have created a separate system and allowed theme developers to begin opting into it. Because theme authors are the ones who will be handling support requests from end-users, they should have been given the power to handle that transition gracefully.</p>\n\n\n\n<p>Overall, there should be no issue making sure block areas are feature-complete by 5.6. Much of the work is finished at this point, and we should be getting a more accurate picture of this feature in the coming months.</p>\n\n\n\n<h2>Global Styles</h2>\n\n\n\n<img />Example mockup from the primary <a href=\"https://github.com/WordPress/gutenberg/issues/19255\">global styles ticket</a>.\n\n\n\n<p class=\"has-drop-cap\">A new <a href=\"https://github.com/WordPress/gutenberg/issues/19611\">global styles feature</a> is set to ship for WordPress 5.6 later this year. The feature is currently undergoing heavy development. We should begin to see early iterations of it in upcoming versions of the Gutenberg plugin over the next several months.</p>\n\n\n\n<p>Global styles will allow theme authors to create several default values, likely via a JSON file. In turn, users will be able to overwrite those styles through an interface in the admin.</p>\n\n\n\n<p>My biggest concern about this feature is that it could go overboard with options that end-users should not have to concern themselves with. For example, most users should have no need to adjust the line-height for their text. Instead, line-height values should automatically be calculated based on a font&rsquo;s x-height and size. The question is going to be where the global styles feature will draw the line. At a certain point, it is better to learn CSS. We certainly cannot expose every possibility via an option.</p>\n\n\n\n<h2>Other Notable Features</h2>\n\n\n\n<p class=\"has-drop-cap\">Lazy loading of images, which was <a href=\"https://wptavern.com/native-lazy-loading-support-coming-to-wordpress\">originally planned for WordPress 5.4</a>, will be shipping alongside a <a href=\"https://wptavern.com/xml-sitemaps-feature-plugin-open-for-testing-and-feedback\">built-in XML sitemaps</a> feature in version 5.5. Both features have been under active development for months and are stable at this point.</p>\n\n\n\n<p>The <a href=\"https://wptavern.com/gutenberg-7-0-launches-stable-navigation-block-post-blocks-and-template-parts\">navigation block</a> was complete enough to ship in the previous WordPress release. The block is intended to primarily be used with full-site editing, so the block was not included. However, it is supposed to be available in WordPress 5.5.</p>\n\n\n\n<p>As always, we should see a new default theme to propel us into the next year. My guess is that the core leads will want to ship a theme that is built completely on top of the upcoming full-site editing feature. If development goes as currently scheduled, <em>Twenty Twenty-One</em> could be a 100% block-based theme.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 13 Apr 2020 20:54:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: Open Call for WordPress 5.5 Tickets: What’s on Your Wish List?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98435\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:183:\"https://wptavern.com/open-call-for-wordpress-5-5-tickets-whats-on-your-wish-list?utm_source=rss&utm_medium=rss&utm_campaign=open-call-for-wordpress-5-5-tickets-whats-on-your-wish-list\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3580:\"<p class=\"has-drop-cap\">Now that <a href=\"https://wptavern.com/wordpress-5-4-adderley-released-includes-improved-editor-new-blocks-and-developer-apis\">WordPress 5.4</a> has successfully launched, it is time to begin thinking about version 5.5, which has a tentative release date of August 8, 2020. On Wednesday, Josepha Haden, Executive Director of WordPress, <a href=\"https://make.wordpress.org/core/2020/04/08/wordpress-5-5-call-for-tickets/\">put out a call for tickets</a>.</p>\n\n\n\n<p>Naturally, the block editor is the top focus as we continually inch toward new features such as a refreshed interface, block patterns, and eventually full-site editing. However, there is room to put a small dent in the thousands of tickets that are still awaiting the right people to move them forward.</p>\n\n\n\n<p>Currently, there are 223 tickets <a href=\"https://core.trac.wordpress.org/tickets/major\">assigned to the 5.5 milestone</a>. We are early in the release cycle, so now is the time to advocate for the inclusion of that particular bug fix or enhancement you have had your eye on.</p>\n\n\n\n<p>What tickets do you want to see addressed?</p>\n\n\n\n<h2>Wish List: Finished Custom Post Status API</h2>\n\n\n\n<p class=\"has-drop-cap\">While I have no expectations that my personal wish list item will make the WordPress 5.5 cut, it does not mean that I cannot hope. After <a href=\"https://core.trac.wordpress.org/ticket/12706\">10 years in the making</a>, with a fix here and there, I would love to see custom post statuses become feature complete.</p>\n\n\n\n<p>A good example use case for custom post statuses is forum plugins. Topics or threads can either have an open or closed status. There are other cases such as archive, spam, hidden, and orphan statuses. Management of forums typically happens on the site front end, so plugin authors usually build custom front-end solutions to handle statuses.</p>\n\n\n\n<p>The scenarios where users need to assign a post status in the admin is where things get tricky. In the past, it was a <em>simple</em> matter of recreating the &ldquo;publish&rdquo; meta box on the edit post screen with a custom status dropdown. With the block editor, I am sure it is possible to do something similar with JavaScript. If so, this still leaves plugin authors in a bind. They will need to code at least two methods to pigeonhole custom statuses into the WordPress editor &mdash; three if also doing so on the front end.</p>\n\n\n\n<p>It is time we have a complete post status API.</p>\n\n\n\n<p>The lack of custom status support in the core user interface has created several roadblocks for projects I have worked on through the years. At one point, there seemed to be some traction to make this a reality, but it seems to have fallen to the wayside as more important and shinier features have been given the green light.</p>\n\n\n\n<p>Custom post statuses are as easy to register as custom post types and taxonomies. The primary missing element is the UI integration on the post editing screen.</p>\n\n\n\n<p>There is a real need for this feature as outlined by developers in a <a href=\"https://github.com/WordPress/gutenberg/issues/3144\">related Gutenberg ticket</a>. Some agencies and organizations with a more complex editing workflow cannot move forward with the block editor on some projects, even if they want to do so.</p>\n\n\n\n<p>The <a href=\"https://github.com/imath/wp-statuses\">WP Statuses</a> plugin by Mathieu Viet could ease the pain for developers with its integration with both the block and classic editors. However, this level of integration belongs in the core software.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Apr 2020 19:54:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: State of the Meetup Under Lockdown\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98421\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:133:\"https://wptavern.com/state-of-the-meetup-under-lockdown?utm_source=rss&utm_medium=rss&utm_campaign=state-of-the-meetup-under-lockdown\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6466:\"<p class=\"has-drop-cap\">By now we&rsquo;re all getting weary of the phrase &ldquo;new normal.&rdquo; Much ink has been spilled over the question of what that new normal will look like after the pandemic has passed over us. There&rsquo;s a stubborn streak in the American national character that admits of little change but, like an assiduous puppy, finds what works.</p>\n\n\n\n<p>I&rsquo;ve been attending the&nbsp;<a href=\"https://www.meetup.com/Asheville-Area-WordPress-Group\">local WordPress Meetup</a>&nbsp;since moving to Asheville, North Carolina, three years ago. Finding myself in a new city, getting out into the community and meeting people in the same industry seemed like a good opportunity to get connected. And it worked. I&rsquo;ve lived in a handful of cities, and nothing has worked faster and better in getting me acclimated to a new locale. As I write now from a sort of exile, present circumstances make clear why the meetup matters.</p>\n\n\n\n<p>The WordPress community is a naturally diverse one. But diversity itself is neither inherently good nor bad. Developers all over the world may commit to the same codebase, but that doesn&rsquo;t mean they&rsquo;re all together. Working among GitHub avatars and social media accounts alone, it&rsquo;s easy to allow in-group preference to collect and fester and eventually spill out; as it did recently with a&nbsp;<a href=\"https://wptavern.com/on-maga-caps-and-wordcamps\">brouhaha about a certain baseball cap</a>.</p>\n\n\n\n<p>The WordPress meetup is an in-group breaker. People of wildly different backgrounds manage to come together around a common theme (sometimes literally a&nbsp;<em>theme</em>). We meet in person, face to face, catch up on old things, and learn all new things. Depending on who you sit next to, you might even hear a dirty joke. We get the all-important sense of being in what the ancient Greeks called the&nbsp;<em>polis</em>, the city-state. We&rsquo;re all different, but Asheville is our city-state, and WordPress is why, twice a month, we get out of our homes and assemble. When we talk about democratizing publishing that means for&nbsp;<em>everyone</em>. This is why the meetup is important, and why it must go on even during a pandemic.</p>\n\n\n\n<img />\n\n\n\n<p>At the meetup, we&rsquo;re not just learning about WordPress. We&rsquo;re learning about each other. Business cards change hands. Smiles and handshakes lighten the air. Asheville is a beer town, so there&rsquo;s often a brew before, sometimes during, and always after. This kind of fellowship is a critical ingredient to building a tight-knit group, yet it&rsquo;s what we sacrifice first when the order to keep &ldquo;social distance&rdquo; comes down.</p>\n\n\n\n<p><em>Social distance?</em> I thought. <em>How is it possible to even have a meetup under such frosty circumstances?</em> But have a meetup we did&mdash;at least virtually.</p>\n\n\n\n<p>As the order to distance and stay at home came down, I canceled my &ldquo;Basics of SEO&rdquo; presentation and pondered whether the meetup will simply have to wait until the virus clears. John Dorner, a local developer and arch-organizer, decided we must give the virtual thing a try. Who knows how long we&rsquo;ll be barred from gathering?</p>\n\n\n\n<p>These days we&rsquo;re all familiar with&nbsp;<a href=\"https://meet.google.com/\">Google Meet</a>,&nbsp;<a href=\"https://www.skype.com/en/\">Skype</a>, and a host of other video conference tools. I&rsquo;ve been working remotely for three years now, and regular video meetings are part of my weekly routine. It&rsquo;s not that the video conference software isn&rsquo;t perfectly adequate, but there is a lack of warmth about it. It&rsquo;s perfunctory, a means to an end. But maybe I was wrong.</p>\n\n\n\n<p>As the virtual meeting launches, we have the usual throat-clearing and the customary hiccups. Ambient noise. Broken microphones and webcams require certain attendees to post chat comments. But we finally get down to business. Dorner encourages all the new people to join the Slack channel, where members can post questions, get help, and continue the conversation after the meetup. We spin a digital wheel of fortune to decide who gets the free JetBrains license&mdash;our regular giveaway, which I&rsquo;ve won twice now.</p>\n\n\n\n<p>Soon, John presents his screen and shows us how we can better manage large clusters of media files in our WordPress sites. It all goes off without a hitch. I volunteer to give my talk at the next meeting.</p>\n\n\n\n<p>Our Asheville area group has a long list of subscribers. Yet, we only see a fraction of that RSVP regularly. Often, people will RSVP but not be able to attend. More universal topics tend to bring out larger crowds. For some, making it out to a 6 PM meeting on a weeknight is a big ask.</p>\n\n\n\n<p>The benefit of the virtual meetup is that it gives those with busier schedules and longer travel times a chance to attend a topic they&rsquo;re interested in but may have otherwise skipped. We miss out on the fellowship, but we get the knowledge.</p>\n\n\n\n<img />John Dorner performs impressive card magic.\n\n\n\n<p>As time and space allow, we can consider what the long term outlook might be. Right now, it&rsquo;s just a series of if/then statements. We&rsquo;re all waiting.</p>\n\n\n\n<p>As the virtual meetup came to a close, it occurred to me that we could probably expand our boundaries a little bit. I can invite coworkers in Virginia Beach to check out our local meetup. I could invite family from Florida if they were interested. But then, would the Asheville WordPress Meetup lose its local flavor? Is that a bad thing?</p>\n\n\n\n<p>Eventually, the pandemic will pass, as all pandemics do. The meetup may land on the hybrid model, having virtual meetings from time to time while keeping the live thing going. I hope we&rsquo;ll find a happy mix. A meetup without the local flavor, and the camaraderie, would not be the same.</p>\n\n\n\n<p>Even if handshakes are replaced with elbow bumps, and we learn to stop touching our faces and to sneeze into our shirts, we need a place to go where we can assemble to keep the polis lively. Change is inevitable, and there&rsquo;s nothing new about &ldquo;new normals,&rdquo; but we don&rsquo;t do ourselves any favors by canceling what we know works best. Our exile on our personal Elbas will end, and we must go back out into society not as frightened peasants but rather as Napoleons of the new normal&mdash;whatever that will be.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Apr 2020 16:03:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Chris Maiorana\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"Matt: Distributed Work’s Five Levels of Autonomy\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=51231\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://ma.tt/2020/04/five-levels-of-autonomy/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8880:\"<img />\n\n\n\n<p>I recently had the opportunity to sit down with <a href=\"https://samharris.org/\">Sam Harris</a>, author and host of the <em>Making Sense</em> podcast, <a href=\"https://samharris.org/podcasts/194-new-future-work/\">for a wide-ranging conversation</a>. Given the moment we’re currently living through, we naturally touched on the way companies are adapting to a new reality — one where remote work is a model to which they must adapt in a matter of days, rather than years.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\n\n\n\n<p>As I mentioned to Sam on the podcast, “any company that can enable their people to be fully effective in a distributed fashion, can and should do it far beyond after this current crisis has passed.” <em>It&#8217;s a moral imperative.</em> But that doesn’t mean it’s going to be easy, or that the chaotic and stressful first taste some workplaces are getting right now is one that inspires them to keep trying.</p>\n\n\n\n<p>To make sense of this journey — from a company’s cautious exploration of remote possibilities to a fully realized distributed experience — I like to think of how it plays out through the concept of levels of distributed work, which I modeled after <a href=\"https://en.wikipedia.org/wiki/Self-driving_car#Classification\">self-driving car levels of autonomy</a>. I’ve seen some solid recaps of my conversation with Sam from <a href=\"https://medium.com/swlh/the-five-levels-of-remote-work-and-why-youre-probably-at-level-2-ccaf05a25b9c\">Steve Glaveski</a> and <a href=\"https://www.flickr.com/photos/jurvetson/49755484227/\">Steve Jurvetson</a>, but here’s my gist of how distributed companies evolve:</p>\n\n\n\n<ol start=\"0\"><li><strong>Level Zero</strong> autonomy is a job which cannot be done unless you&#8217;re physically there. Imagine construction worker, barista, massage therapist, firefighter&#8230; Many companies assumed they had far more of these than it has turned out they really did.</li><li>The <strong>first level</strong> is where most colocated businesses are: there’s no deliberate effort to make things remote-friendly, though in the case of many knowledge workers, people can keep things moving for a day or two when there’s an emergency. More often than not, they’ll likely put things off until they’re back in the office. Work happens on company equipment, in company space, on company time. You don&#8217;t have any special equipment and may have to use a clunky VPN to access basic work resources like email or your calendar. Larger level one companies often have people in the same building or campus dialing into a meeting. Level one companies were largely unprepared for this crisis.</li><li><strong>Level two</strong> is where many companies have found themselves in the past few weeks with the COVID-19 pandemic. They’ve accepted that work is going to happen at home for a while, but they recreate what they were doing in the office in a &#8220;remote&#8221; setting, like <a href=\"https://www.marshallmcluhan.com/\">Marshall McLuhan</a> talked about new media mediums initially copying the generation before. You’re probably able to access information from afar, you’ve adapted to tools like Zoom or Microsoft Teams, but everything is still synchronous, your day is full of interruptions, no real-time meetings have been canceled (yet), and there’s a lot of anxiety in management around productivity — that’s the stage where companies sometimes install surveillance software on laptops. Pro tip: Don’t do that! And also: Don’t stop at level two!</li><li>At the <strong>third level</strong>, you’re really starting to benefit from being remote-first, or <strong>distributed</strong>. That’s when you see people invest in better equipment — from a good desk lamp to <a href=\"https://ma.tt/2020/03/dont-mute-get-a-better-headset/\">solid audio gear</a> — and in more robust asynchronous processes that start to replace meetings. It’s also the point at which you realize just how crucial written communication is for your success, and you start looking for great writers in your hiring. When you are on a Zoom, you often also have a Google Doc up with the other meeting participants so you can take and check real-time notes together. Your company has a <a href=\"https://cloud.google.com/beyondcorp\">zero-trust BeyondCorp security model</a>. In a non-pandemic world you plan meetups so teams can break bread and meet each other in person a week or two a year.</li><li><strong>Level four</strong> is when things go truly asynchronous. You evaluate people’s work on what they produce, not how or when they produce it. Trust emerges as the glue that holds the entire operation together. You begin shifting to better — perhaps slower, but more deliberate — decision-making, and you empower everyone, not just the loudest or most extroverted, to weigh in on major conversations. You tap into the global talent pool, the 99% of the world&#8217;s population and intelligence that doesn&#8217;t live near one of your legacy physical office locations. Employee retention goes way up, and you invest more in training and coaching. Most employees have home-office setups that would make office workers green with envy. You have a rich social life with people you choose. Real-time meetings are respected and taken seriously, almost always have agendas and pre-work or post-work. If you <a href=\"https://spikes.worldathletics.org/post/japans-secret-to-relay-success\">get good at baton passes</a> work will follow the sun 24/7 around the world. Your organization is truly inclusive because standards are objective and give people agency to accomplish their work their way.</li><li>Finally, I believe it’s always useful to have an ideal that’s not wholly attainable — and that’s <strong>level five, Nirvana!</strong> This is when you consistently perform better than any in-person organization could. You&#8217;re effortlessly effective. It’s when everyone in the company has time for wellness and mental health, when people bring their best selves and highest levels of creativity to do the best work of their careers, and just have fun. <img src=\"https://s.w.org/images/core/emoji/12.0.0-1/72x72/1f920.png\" alt=\"🤠\" class=\"wp-smiley\" /></li></ol>\n\n\n\n<p>A highly influential book for me in designing Automattic was <a href=\"https://www.danpink.com/books/drive/\">Daniel Pink’s <em>Drive</em></a>, where he eloquently introduces the three things that really matter in motivating people: mastery, purpose, and autonomy. <strong>Mastery</strong> is the urge to get better skills. <strong>Purpose</strong> is the desire to do something that has meaning, that&#8217;s bigger than yourself. These first two principles physically co-located companies can be great at. But the third, autonomy, is where even the best in-office company can never match a Level 4 or above distributed company.</p>\n\n\n\n<p><strong>Autonomy</strong> is our desire to be self-directed, to have agency over ourselves and our environment. Close your eyes and imagine everything around you in a physical office: the chair you&#8217;re in, the desk, distance from a window, the smells, the temperature, the music, the flooring, what&#8217;s in the fridge, the comfort and privacy of the bathrooms, the people (or pets) around you, the lighting. Now imagine an environment where you can choose and control every one of those to your liking — maybe it&#8217;s a room in your house, a converted garage, a shared studio, or really anything, the important thing is you&#8217;re able to shape the environment fit your personal preferences, not the lowest common denominator of everyone an employer has decided to squish together for 8 hours a day. The micro-interactions of the hundreds of variables of your work environment can charge you and give you creative energy, or make you dependent, infantilized, and a character in someone else&#8217;s story. Which do you want to spend half of your waking workday hours in?</p>\n\n\n\n<p>For a good summary of Dan Pink, <a href=\"https://www.youtube.com/watch?v=u6XAPnuFjJc\">check out this animation</a>. The other books I referenced in the podcast are <a href=\"https://www.amazon.com/Scale-Universal-Innovation-Sustainability-Organisms/dp/1594205582?tag=photomatt08-20\">Geoffrey West&#8217;s <em>Scale</em></a> and <a href=\"https://www.amazon.com/Antifragile-Things-That-Disorder-Incerto/dp/0812979680?tag=photomatt08-20\">Nassim Nicholas Taleb&#8217;s <em>Antifragile</em></a>. </p>\n\n\n\n<p>My talk with Sam covered many other topics, from communicating in distributed companies to the challenges businesses are facing due to COVID-19, so I hope you <a href=\"https://samharris.org/podcasts/194-new-future-work/\">head over and listen to the rest</a> or <a href=\"https://www.youtube.com/watch?v=mJSf2Clx6qY\">stream it on Youtube</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Apr 2020 14:33:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Fighting the Stay-At-Home Boredom: Time to Create Rather Than Consume\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:201:\"https://wptavern.com/fighting-the-stay-at-home-boredom-time-to-create-rather-than-consume?utm_source=rss&utm_medium=rss&utm_campaign=fighting-the-stay-at-home-boredom-time-to-create-rather-than-consume\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7324:\"<p class=\"has-drop-cap\">A common theme among my friend groups is the utter boredom of being under stay-at-home orders during the COVID-19 pandemic. Part of me wants to tell folks that there has never been a greater time in human history to find something to do at home. There is a plethora of content available at the touch of a finger or even voice command.</p>\n\n\n\n<p>We have built a system, the web, that provides education, entertainment, and art at near-instantaneous speeds. Our WordPress community is a large part of that human endeavor.</p>\n\n\n\n<p>Perhaps the problem lies with our consumerist culture. With large social media networks effectively taking over the web, the trend seems to suggest that people spend their free time glued to their mobile devices, consuming content created by others. Now that many are home full time, it is easy to grow tired of consuming content that would normally be reserved for free time at all hours of the day.</p>\n\n\n\n<p>When asking what the elders in my family did in their free time decades ago, before modern technological advances, I noticed a different trend. They created music. On my grandmother&rsquo;s side of the family, that musicality in our genes produced Hank Williams. On my grandfather&rsquo;s side, we had The Tadlock Quartet, a little-known gospel group. If our family had a motto, it would be: <em>if you don&rsquo;t sing or play an instrument, you are not a Tadlock</em>.</p>\n\n\n\n<p>I have an uncle who is a painter and magician. Some of my cousins are in a band. My sister creates vases, tabletops, and other pieces out of broken glass when she&rsquo;s not chasing her two-year-old. My father is a singer, songwriter, and multi-instrument musician. I could go on listing the art that my family creates.</p>\n\n\n\n<p>Maybe I was fortunate to grow up in an artistic environment. That artistry has never been about fame and fortune. Most of my family will never reach stardom. However, we continue creating because it is simply a part of who we are.</p>\n\n\n\n<p>I also reminisce over my childhood years. I grew up in a lower-middle-class household. We did not have the luxury of the internet. We could not afford cable or satellite television. The only channels on the tube were 8, 12, 20, and sometimes 32. It was the era of the Saturday morning cartoon block, which I gladly awoke to every weekend with my off-brand cereal.</p>\n\n\n\n<p>Like many kids of my generation, I had a video game console and a handful of games. But, there are only so many times you can play through <em>The Legend of Zelda: Ocarina of Time</em> before finding something else to do.</p>\n\n\n\n<p>Most of my childhood was spent creating things. I ran several issues of a homemade video game magazine, painstakingly drawing all the artwork by hand. Fortunately, my uncle had a printer and scanner so that I could make copies. I wrote short stories, crafted screenplays, and filmed movies on a borrowed camcorder. I built tree forts that probably would not have passed any level of building safety codes, but my friends and I survived.</p>\n\n\n\n<p>I had about a three-year stint in the mid-&rsquo;90s in which I fashioned myself a songwriter, following in my father&rsquo;s footsteps (he has never sold a song but continues writing music to this day). I do not think I wrote anything other than love songs. What else would a 12-year-old boy write about? My only experience with love was a peck on the cheek from a previous girlfriend. Despite my naivete in matters of the heart, the human soul knows what it needs, and I expressed that through lyrics in the style of whatever boyband was popular in the given month. My music was not Grammy-worthy material, but it was deeply human.</p>\n\n\n\n<p>As I grew into adulthood, I did not stop creating. My journey into the world of WordPress began only because I wanted to share my writing. Eventually, I learned to create a new type of art: WordPress plugins and themes.</p>\n\n\n\n<p>Over my near-15 years of working with WordPress, my primary interest became more about building things that would help others to create. Even today, as a writer for the Tavern, my hope is to spark discussions and response articles that others create on their own blogs. This should never be a one-way discussion.</p>\n\n\n\n<p>Like many others, I recently found myself in a position with &ldquo;nothing to do.&rdquo; For the previous several months, I had been working on a plugin development book during my free time. Suddenly, I found myself with an empty calendar for an entire weekend. No social gatherings. No book chapters due. That meant putting my artist hat firmly back on my head. It was time to enjoy the act of creation for the sake of it, <a href=\"https://wptavern.com/create-custom-patterns-with-the-block-pattern-builder-plugin\">which led to a new plugin</a>.</p>\n\n\n\n<p>It felt good to once again create something with no expectations. I was not getting paid to build this project. I wanted neither fame nor fortune. What I needed was a moment to express an idea.</p>\n\n\n\n<p>The act of creating art is a primal part of our nature. The plugin was my modern-day equivalent of sitting around the campfire and crafting a story of slaying a great beast that happened upon the village.</p>\n\n\n\n<p>I am a firm believer that every human has the capacity to create some form of artwork. A novel. A dance. A song. I have seen farmers with gardens so well-tended they would make you weep. I have watched a man with an intellectual disability hand-build intricate birdhouses. I have sat in astonishment, listening as a friend&rsquo;s mother put together an entire piano arrangement after hearing a song only once.</p>\n\n\n\n<p>For the same reason, I am proud to be a part of the WordPress community. I am surrounded by artists in their own right daily. We create software that allows others to share their creations.</p>\n\n\n\n<p>When someone tells me they are bored during this social quarantine, I break out my speech about using this moment to create something. <em>Anything.</em> It does not need to have value to others. It should simply be an expression of one&rsquo;s self. If they follow through, I give them a speech about building a site with WordPress to share what they have built.</p>\n\n\n\n<p>No, now is not the time for boredom. It should be a time of pure creation.</p>\n\n\n\n<p>Create a shop with <a href=\"https://wordpress.org/plugins/woocommerce/\">WooCommerce</a> for those handcrafted items you have been wanting to build for years. Build up your inventory right now so that it is ready to ship after the pandemic has passed. Write an e-book and sell it via <a href=\"https://wordpress.org/plugins/easy-digital-downloads/\">Easy Digital Downloads</a>. Start a local fundraising effort to help those in need in your neighborhood with the <a href=\"https://wordpress.org/plugins/give/\">Give WP</a> plugin. Create a new forum with <a href=\"https://wordpress.org/plugins/bbpress/\">bbPress</a> on your favorite TV series or some other topic that piques your interest. Start a regular ol&rsquo; <a href=\"https://wordpress.org/\">WordPress</a> blog and share your thoughts during this time.</p>\n\n\n\n<p>Use this brief moment in history to create something new. Whether it is a side hustle, a new business, or poetry, just create. Then, of course, share it via your WordPress website.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Apr 2020 20:11:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: WordCamp Europe 2020 Is Moving Online This Summer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98377\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:163:\"https://wptavern.com/wordcamp-europe-2020-is-moving-online-this-summer?utm_source=rss&utm_medium=rss&utm_campaign=wordcamp-europe-2020-is-moving-online-this-summer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3992:\"<p class=\"has-drop-cap\">On Monday, the WordCamp Europe team <a href=\"https://2020.europe.wordcamp.org/2020/04/06/wordcamp-europe-2020-is-moving-online/\">announced it would hold its annual event</a> online from June 4-6. The move comes after initially postponing this year&rsquo;s physical event because of the COVID-19 pandemic currently sweeping the globe. Like many other events, the organizing team is in the process of switching gears and moving everything to work over the internet.</p>\n\n\n\n<p>WordCamp Europe 2020 Online will hold a virtual contributor day on June 4. The last two days of the event will consist of live-streamed sessions and workshops for half days. The team is still working out the details and will keep everyone updated when possible.</p>\n\n\n\n<p>The reopening of the event to a virtual audience was met with enthusiasm when the team <a href=\"https://twitter.com/WCEurope/status/1247196801393885184\">announced it on Twitter</a>.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">&#128227; We&rsquo;re back! We are excited to announce WordCamp Europe 2020 Online &ndash; a virtual event taking place on 4-6 June &#127881; Add the dates back into your diaries and stay tuned for more details coming soon &#128197; <a href=\"https://t.co/JdEEHN0GMT\">https://t.co/JdEEHN0GMT</a></p>&mdash; WordCamp Europe (@WCEurope) <a href=\"https://twitter.com/WCEurope/status/1247196801393885184?ref_src=twsrc%5Etfw\">April 6, 2020</a></blockquote>\n</div>\n\n\n\n<p>Last month, the organizers delivered the news that they would be postponing the 2020 physical event. &ldquo;The decision to postpone WCEU 2020 was not made lightly, as each member of the organising team is deeply invested in the event, but it was made collectively,&rdquo; <a href=\"https://2020.europe.wordcamp.org/2020/03/12/important-notice-wordcamp-europe-postponed/\">wrote the team on the WordCamp EU blog</a>. &ldquo;[The community] is, by far, the most heartbreaking part of a cancellation: the fact that we won&rsquo;t get to gather together in person, to connect, share knowledge and inspire one another during our sessions, hallway tracks, and dinners.&rdquo;</p>\n\n\n\n<p>The organizers are rebooting the physical WordCamp EU event for 2021. Last month, the team <a href=\"https://2020.europe.wordcamp.org/2020/03/24/wordcamp-europe-2021-dates-confirmed/\">confirmed June 3-5</a> for next year&rsquo;s event. It will take place at the Super Bock Arena (Pavilh&atilde;o Rosa Mota) in Porto, Portugal.</p>\n\n\n\n<p>For those who purchased tickets to the 2020 event, they should have already received a refund or get one by April 10. Organizers are in the process of contacting sponsors to discuss refunds and getting involved in the online event.</p>\n\n\n\n<p>The silver lining in this news is that everyone can attend WordCamp EU at no cost, albeit virtually rather than in person.</p>\n\n\n\n<p>Based on the size of the event, WordCamp EU will be the standard that many other events and meetups will likely want to emulate and build upon. It will be a test of how the WordPress community can come together and show the world that we can continue doing great things during uncertain times.</p>\n\n\n\n<p>Given that the current virus outbreak will likely continue through the summer, everyone in the WordPress community should mark this event on their calendars. Make social plans with the people who love the same software. It is free, and you are probably going to be home anyway. I look forward to an exciting event from the European WordPress community.</p>\n\n\n\n<p>To stay up to date on WordCamp EU or contact the team, follow its social networking accounts:</p>\n\n\n\n<ul><li><a href=\"https://www.facebook.com/WCEurope/\">WCEU Facebook</a></li><li><a href=\"https://twitter.com/wceurope?lang=en\">WCEU Twitter</a></li><li><a href=\"https://www.linkedin.com/company/wordcampeurope/\">WCEU LinkedIn</a></li><li><a href=\"https://www.instagram.com/wceurope/?hl=en\">WCEU Instagram</a></li></ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 08 Apr 2020 19:18:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"HeroPress: Embrace Who You Are and Others Will Follow\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=3095\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:158:\"https://heropress.com/essays/embrace-who-you-are-and-others-will-follow/#utm_source=rss&utm_medium=rss&utm_campaign=embrace-who-you-are-and-others-will-follow\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10634:\"<img width=\"960\" height=\"480\" src=\"https://s20094.pcdn.co/wp-content/uploads/2021/04/040720-min.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: No one is excluded from carving their place in the WordPress industry.\" /><p><strong>Wondering how a university drop out with ADHD and a criminal record found a spot in the WordPress community? Read on to see why it’s often your “faults” that can make you a major asset to any product team.</strong></p>\n<p>For as long as I can remember, I’ve had a knack for spotting an opportunity to make money. Even as an industrious seven-year-old, I knew that if I spent my birthday money on a value-size container of gumballs, I could sell them off to my classmates for a profit.</p>\n<p>Soon, every school recess and bus ride was a chance to make a sale and as I grew, so did my appetite for the hustle. Eventually, I replaced gumballs with mowing lawns and later, importing and reselling electronics. As long as there was a demand, nothing was off-limits.</p>\n<p>At this point, you may be expecting the rest of my story to go something like “serial entrepreneur switches to digital products, joins the WordPress community, and lives happily ever after,” right?</p>\n<p>Well, there are a lot more twists and turns before that since my hustling did end up getting me into a lot of trouble. My WordPress origin story includes a tale of how I escaped government spies in China, served a prison sentence in Kansas, and ultimately turned my mixed bag of (decidedly non-technical) business and people skills into a marketing position at Sandhills Development.</p>\n<a href=\"https://s20094.pcdn.co/wp-content/uploads/2020/04/open-premiere-wcus-alain-schlesser-tyler-lau_700-min.jpg\"><img /></a>Tyler Lau with Alain Schlesser at the Open Film premiere at WCUS 2019 in St.Louis.\n<h3>Jack of all trades, master of fun</h3>\n<p>One of the many reasons I’m always on the lookout for new projects and business opportunities is my Attention Deficit Hyperactivity Disorder (ADHD), a diagnosis I received nearly 14 years ago. As the only child of a divorced couple, all the attention was on me, but I couldn’t seem to keep my attention on anything.</p>\n<p>Luckily, the disorder that made me a restless child has made me a creative and adaptable adult. In my current role, I’m a marketing relationship builder at Sandhills Development, a plugin company with a portfolio of brands including AffiliateWP, Easy Digital Downloads, and Restrict Content Pro. Unlike most people at Sandhills who focus on one or two of our products, my role spans across all our digital properties.</p>\n<p>Not only am I representing a portfolio of products, but for each, my tasks involve post-sales communication, partnership, and affiliate development, B2B sales, and event marketing. Behind the scenes, I also organize our company retreats, book WordCamp travel arrangements, and even helped open two Sandhills breweries in Kansas. That’s right, we branched out of tech into beer!</p>\n<p>In a way, I’m the people person at Sandhills Development and the face of the company to many in the WordPress community. In an industry built by programmers and developers with outstanding focus and attention to detail, someone with ADHD wouldn’t seem like a natural fit. And yet, the WordPress community really is one of those places where everyone can find the right spot for their unique mix of skills. For me, my skill was people, and that has translated into a slew of responsibilities.</p>\n<a href=\"https://s20094.pcdn.co/wp-content/uploads/2020/04/WordCamp-seattle-min.jpg\"><img /></a>Chatting with sponsors at WordCamp Seattle 2019\n<h3>Relationship-building as a career</h3>\n<p>On paper, there isn’t much that qualifies me to work for a tech company. Most of my previous experience was in the restaurant industry, something I’m still quite passionate about. That’s probably why I am always in charge of food at our company retreats. In fact, even though I was far from a Luddite, nothing on my CV pointed to a career in tech. And yet, that fast-paced, customer-facing service industry environment has actually prepared me the best for everything I’ve taken on since.</p>\n<p>When I’m at events on behalf of Sandhills, I’m meeting people from all over the world and developing personal and professional relationships with them, all while managing the logistics of event marketing. As an extrovert, I love it and I couldn’t imagine a job that didn’t involve relationship-building.</p>\n<p>Understanding people and being able to operate in any setting isn’t just an asset to grow a company, it can also be key to surviving in precarious environments. While my social tact is useful for making friends and building community in the WordPress space, at one point in my life, it was necessary for survival. Like the time I went to prison.</p>\n<h3>The true meaning of freedom</h3>\n<p>In the WordPress community, the concept of freedom comes up often. The GPL, free software, open-source communities&#8230;These are all fundamental values on which WordPress is built. Practically speaking, anyone can launch a company, become a freelancer, work remotely, or be their own boss to gain more freedom in their work and life. This is particularly appealing to me as someone who has never fit into the traditional work mold and as someone who now values my freedom more than ever.</p>\n<a href=\"https://s20094.pcdn.co/wp-content/uploads/2020/04/WCA2-Tracy-Josepha-DeRosia-girls-min.jpg\"><img /></a>With attendees at WordCamp Ann Arbor 2019\n<p>Six years ago, my inner opportunist got me into trouble with the law selling marijuana. It was a quick way to make good money and after dropping out of college following a brain aneurysm, I needed capital to fund my first startup. Between my shifts as a waiter, I worked on prototypes for my first product. The company was growing fast and to protect my patents and take R&amp;D to the next level, I had to work really hard.</p>\n<p>Everything came to a screeching halt when I went to prison. If you’re wondering if prison is like TV shows and movies, the answer is both yes and no. It’s harder in a lot of ways but my spirit never broke. Meeting other inmates reminded me that I was in a much better situation than most. I was educated, well-off, loved, and knew I had a future once I was released.</p>\n<p>Many inmates never graduated from high school and are completely computer illiterate. While on the inside, I taught science, math, writing, reading, and social studies. But still, I know many of them will struggle to get the mental health support and the job training they need to thrive after they serve their sentence. There’s more to freedom than just being on the outside. You also need a sense of agency and enfranchisement. As for me, my sense of purpose and my support network were plenty to keep me going and I was ready to take on my next (legal) business challenge as soon as I could.</p>\n<a href=\"https://s20094.pcdn.co/wp-content/uploads/2020/04/WordCamp-us-2019-min.jpg\"><img /></a>With sponsors and organizers at WCUS 2019 in St. Louis\n<h3>Your past doesn’t define you but you can choose to embrace it</h3>\n<p>I’m an outlier in many ways. From the day I was born, I was political. My father is a semi-dissident Chinese visual anthropologist and my mother is an art professor who left her home country of Japan to break from traditional Japanese gender roles. If you’re familiar with the history between these two nations, you’ll know a relationship between their citizens is rare and discouraged. I inherited a lot of that fearlessness, although I’m not sure if it’s nurture or nature. Most of my childhood was split, either following my father around the world, as he documented Chinese communities, or growing up as one of few Asian-Americans living in small-town Kansas.</p>\n<p>I’ve never fit in, and yet this is what makes me able to adapt to most situations and relate to just about anyone. I embrace my eclectic, dissonant past and see beauty in the person those experiences shaped me to be. Now, I’m able to put those skills to good use in the WordPress community and beyond. Regardless of your level of physical ability, your struggles with mental health, your upbringing, and even your run-ins with the law, no one is excluded from carving their place in the WordPress industry.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Embrace Who You Are and Others Will Follow\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Embrace%20Who%20You%20Are%20and%20Others%20Will%20Follow&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fembrace-who-you-are-and-others-will-follow%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Embrace Who You Are and Others Will Follow\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fembrace-who-you-are-and-others-will-follow%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fembrace-who-you-are-and-others-will-follow%2F&title=Embrace+Who+You+Are+and+Others+Will+Follow\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Embrace Who You Are and Others Will Follow\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/embrace-who-you-are-and-others-will-follow/&media=https://heropress.com/wp-content/uploads/2021/04/040720-min-150x150.jpg&description=Embrace Who You Are and Others Will Follow\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Embrace Who You Are and Others Will Follow\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/embrace-who-you-are-and-others-will-follow/\" title=\"Embrace Who You Are and Others Will Follow\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/embrace-who-you-are-and-others-will-follow/\">Embrace Who You Are and Others Will Follow</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 08 Apr 2020 09:00:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tyler Lau\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.org blog: People of WordPress: Mario Peshev\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8536\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2020/04/people-of-wordpress-mario-peshev/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10574:\"<p><em>You’ve probably heard that WordPress is open source software, and may know that it’s created and run by volunteers. Enthusiasts share many examples of how WordPress has changed people’s lives for the better. In this monthly series, we share some of those lesser-known, amazing stories.</em></p>\n\n\n\n<h2><strong>Computer science in the nineties</strong></h2>\n\n\n\n<div class=\"wp-block-image\"><img src=\"https://i2.wp.com/wordpress.org/news/files/2020/04/25de575216d3743f80181b2dca2cd7d9.jpeg?w=632&ssl=1\" alt=\"\" class=\"wp-image-8539\" />Mario Peshev</div>\n\n\n\n<p>Mario has been hooked on computers ever since he&nbsp;got his first one in 1996. He started with digging into MS-DOS and Windows 3.1 first and learned tons by trial and error. Following that adventure, Mario built his first HTML site in 1999. He found development so exciting that he spent day and night learning QBasic and started working at the local PC game club. Mario got involved with several other things related to website administration (translating security bulletins, setting up simple sites, etc) and soon found the technology field was full of activities he really enjoyed.</p>\n\n\n\n<h2><strong>The Corporate Lifestyle</strong></h2>\n\n\n\n<p>Mario started studying programming including an intensive high-level course for C#, Java development, and software engineering, and eventually got a job in a corporate environment. He soon became a team lead there, managing all the planning and paperwork for their projects.</p>\n\n\n\n<p>But he continued freelancing on the side. He grew his own network of technical experts through attending, volunteering at, and organizing conferences. He also ran a technical forum and regularly spoke at universities and enterprise companies.</p>\n\n\n\n<h2><strong>Remote Working and Business Opportunity</strong></h2>\n\n\n\n<p>The combination of a high workload and a daily three-hour-long commute made Mario’s life difficult. Many of his friends were still studying, traveling or unemployed. The blissful and calm lives they lived seemed like a fairy tale to him. And even while both his managers and his clients were abroad, he was unable to obtain permission to work remotely.&nbsp;</p>\n\n\n\n<p>So Mario decided to leave his job and start freelancing full time. But he found he faced a massive challenge.&nbsp;</p>\n\n\n\n<p>He discovered Java projects were pretty large and required an established team of people working together in an office. All job opportunities were on-site, and some even required relocation abroad. Certified Java programmers weren’t being hired on a remote basis.&nbsp;</p>\n\n\n\n<p>As Mario had some PHP experience from previous jobs, he used this to start his freelance career. For his projects, he used both plain PHP and PHP frameworks like CakePHP and CodeIgniter.&nbsp;</p>\n\n\n\n<p>For a while, Mario accepted work using commonly known platforms including Joomla, Drupal, and WordPress. In addition, he worked on PHP, Java, Python and some C# projects for a couple of years, after which he decided to switch to WordPress completely.</p>\n\n\n\n<h2><strong>Building products</strong></h2>\n\n\n\n<p>One of his projects involved a technically challenging charity backed by several international organizations. Unexpected shortages in the team put him in the technical lead position. As a result, Mario found himself planning the next phases, meeting with the client regularly, and renegotiating the terms. The team completed the project successfully, and after the launch, a TV campaign led millions of visitors to the website.</p>\n\n\n\n<p>As a result of the successful launch, this client invited Mario to participate in more WordPress projects, including building a custom framework.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>“I wasn’t that acquainted with WordPress back then. For me, a conventional person trained in architectural design patterns and best practices, WordPress seemed like an eccentric young hipster somewhere on the line between insane and genius at the same time. I had to spend a couple of months learning WordPress from the inside out.”</em></p><cite>Mario Peshev</cite></blockquote>\n\n\n\n<p>As his interest in WordPress grew, Mario stopped delivering other custom platforms, and converted clients to WordPress.&nbsp;</p>\n\n\n\n<h2><strong>European Community</strong></h2>\n\n\n\n<img src=\"https://i2.wp.com/wordpress.org/news/files/2020/04/20191001_144227-scaled.jpg?fit=632%2C356&ssl=1\" alt=\"Mario presenting to an audience\" class=\"wp-image-8546\" />Mario presenting at a WordCamp\n\n\n\n<p>For Mario, one of the key selling points of WordPress was the international openness. He had previously been involved with other open source communities, some of which were US-focused. He felt they were more reliant on meeting people in person. With events only taking place in the US, this made building relationships much harder for people living in other countries.</p>\n\n\n\n<p>While the WordPress project started out in the US, the WordPress community quickly globalized. Dozens of WordCamps and hundreds of Meetup events take place around the globe every year.&nbsp; All of these events bring a wide variety of people sharing their enthusiasm for WordPress together.</p>\n\n\n\n<p>For Mario, the birth of WordCamp Europe was something magical. The fact that hundreds, and later on thousands, of people from all over the world gathered around the topic of WordPress speaks for itself. Mario has been involved with organizing WordCamp Europe twice (in 2014 and 2015).&nbsp;</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>“There’s nothing like meeting WordPress enthusiasts and professionals from more than 50 countries brainstorming and working together at a WordCamp. You simply have to be there to understand how powerful it all is.”</em></p><cite>Mario Peshev</cite></blockquote>\n\n\n\n<h2><strong>Growing businesses and teams</strong></h2>\n\n\n\n<p>A key WordPress benefit is its popularity – an ever growing project currently powering <a href=\"https://w3techs.com/technologies/details/cm-wordpress\">more than 35% of the Internet [2020].</a> It’s popular enough to be a de facto standard for websites, platforms, e-commerce and blogs.&nbsp;</p>\n\n\n\n<p>WordPress has a low barrier to entry. You can achieve a lot without being an expert, meaning most people can start gaining experience without having to spend years learning how to code. That also makes it easier to build businesses and teams.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>“Being able to use a tool that is user-friendly, not overly complicated and easily extensible makes introducing it to team members faster and easier. It requires less time for adjustment, and as a result makes a team stronger and faster. The fact that this tool is cost-effective also allows more startups to enter the market. It requires&nbsp; less time and investments to launch an MVP. This boosts the entire ecosystem.”</em></p><cite>Mario Peshev</cite></blockquote>\n\n\n\n<h2><strong>Helping Others</strong></h2>\n\n\n\n<p>Mario also introduced WordPress to children and young people. He taught them how to use WordPress as a tool for homework and class assignments. By using WordPress, they were able to learn the basics of designing themes, developing plugins, marketing statistics, social media, copywriting, and so much more. This approachable introduction to the software meant technical skills were not needed.</p>\n\n\n\n<p>He was also part of a team of volunteers who helped a group of young people living at a foster home struggling to provide for themselves. The team taught the basic digital literacy skills necessary in the modern workplace and potentially pay for their rent and basic needs. This included working with Microsoft Word, Excel and WordPress, as well as some basic design and marketing skills. </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>“When you look at that from another perspective, a platform that could save lives &#8211; literally &#8211; and change the world for better is worth contributing to, in any possible manner.”</em></p><cite>Mario Peshev</cite></blockquote>\n\n\n\n<h2><strong>Contributing to the WordPress community</strong></h2>\n\n\n\n<p>From the core team to supporting and organizing WordCamps, Mario has long been an active contributor to the global WordPress project. He is passionate about the connections fostered by people who are involved in building both the WordPress software and the community around it.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>“The WordPress community consists of people of all race and color, living all around the world, working as teachers, developers, bloggers, designers, business owners. Let’s work together to help each other. Let’s stick together and show&nbsp; the world WordPress can help make it a better place.”</em></p><cite>Mario Peshev</cite></blockquote>\n\n\n\n<h2><strong>Contributors</strong></h2>\n\n\n\n<p>Thanks to Alison Rothwell (<a href=\"https://profiles.wordpress.org/wpfiddlybits/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>wpfiddlybits</a>), Yvette Sonneveld (<a href=\"https://profiles.wordpress.org/yvettesonneveld/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>yvettesonneveld</a>), Abha Thakor (<a href=\"https://profiles.wordpress.org/webcommsat/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>webcommsat</a>), Josepha Haden (<a href=\"https://profiles.wordpress.org/chanthaboune/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>chanthaboune</a>) and Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>topher1kenobe</a>). Thank you to Mario Peshev (<a href=\"https://profiles.wordpress.org/nofearinc/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>nofearinc</a>) for sharing his #ContributorStory.</p>\n\n\n\n<div class=\"wp-block-image\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?w=632&ssl=1\" alt=\"HeroPress logo\" class=\"wp-image-8409\" /></div>\n\n\n\n<p><em>This post is based on </em><a href=\"https://heropress.com/essays/wordpress-gave-perfect-identity/\"><em>an article originally published on HeroPress.com</em></a><em>, a community initiative created by </em><a href=\"https://profiles.wordpress.org/topher1kenobe/\"><em>Topher DeRosia</em></a><em>. HeroPress highlights people in the WordPress community who have overcome barriers and whose stories would otherwise go unheard.</em></p>\n\n\n\n<p><em>Meet more WordPress community members over at </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>!</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 08 Apr 2020 00:57:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Yvette Sonneveld\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Jetpack Re-launches Search Feature as Standalone Service\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:177:\"https://wptavern.com/jetpack-re-launches-search-feature-as-standalone-service?utm_source=rss&utm_medium=rss&utm_campaign=jetpack-re-launches-search-feature-as-standalone-service\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5477:\"<p class=\"has-drop-cap\">The Jetpack team announced today that its <a href=\"https://jetpack.com/2020/04/07/re-introducing-jetpack-search-for-wordpress-sites/\">search service is now available as a separate package</a> from the professional bundle it was previously under. The move should make it more affordable for small sites to use the service. Larger sites might have to shell out more money, depending on how much content is on the site.</p>\n\n\n\n<p>&ldquo;Jetpack Search had only been available as a part of the Jetpack Professional plan at $29 per month, but that pricing felt unfair: a site with one million posts costs 1,000 times as much to index as a site with one thousand posts, but both sites were paying the same amount,&rdquo; wrote Greg Brown, search wrangler at Automattic, in the announcement post. &ldquo;New pricing makes Jetpack Search more affordable for small sites and still costs big sites less than the competition.&rdquo;</p>\n\n\n\n<p>Jetpack Search now charges by the number of records:</p>\n\n\n\n<ul><li>Up to 100 records: $5 per month</li><li>Up to 1,000 records: $10 per month</li><li>Up to 10,000 records: $25 per month</li><li>Up to 100,000 records: $60 per month</li><li>Up to 1 million records: $200 per month</li><li>Over 1 million records: $200 per month per million records</li></ul>\n\n\n\n<p>&ldquo;Records&rdquo; are posts, pages, and custom post types. However, that may change in the future. &ldquo;We decided to use the term &lsquo;records&rsquo; because we think there are use cases where we may want to index comments as their own records sometime in the future,&rdquo; said Brown. &ldquo;Similarly, there are use cases for indexing authors, tags, categories, etc. as their own records.&rdquo;</p>\n\n\n\n<p>Jetpack Search combines comments and bbPress plugin replies, which are technically a custom post type, with their parent post. For now, these will not count against users&rsquo; record counts.</p>\n\n\n\n<p>One caveat with search is that media attachments are considered individual records by default. There are good reasons for some sites to expose attachments via search results. However, this could lead to unwanted records and cost more money each month for users who have a lot of media but do not wish to count those pages. Jetpack does have a filter hook that <a href=\"https://developer.jetpack.com/hooks/jetpack_sync_prevent_sending_post_data/\">controls which post types are cached</a> on the WordPress.com servers, so this can at least be configured via code.</p>\n\n\n\n<p>Version 8.4 of the <a href=\"https://wordpress.org/plugins/jetpack/\">Jetpack plugin</a> also includes an updated search interface. When a site visitor enters a search query, a fullscreen modal appears to showcase the search results. The results are snappy because they rely on the WordPress.com API and updated technology underneath. The new interface should work well with most themes out of the box on both desktop and mobile views.</p>\n\n\n\n<img />Jetpack search results modal.\n\n\n\n<p>&ldquo;This new version of Search is only available with the new plan,&rdquo; said Brown. &ldquo;The previous version of Search is still available on the Pro plan and will continue working as-is for the foreseeable future, but our focus going forward is on the new search experience.&rdquo;</p>\n\n\n\n<h2>New Architecture Behind Jetpack Search</h2>\n\n\n\n<p class=\"has-drop-cap\">The new version of Jetpack Search runs on a re-architected technology layer. The old system was an Elasticsearch wrapper around the standard WordPress search feature. While it was quicker than normal WordPress search results, it was still slower than it needed to be. There was no built-in spelling correction. Searched terms were not highlighted.</p>\n\n\n\n<p>The new system uses the same sync technology behind Jetpack features like Related Posts, Publicize, and Stats to cache content. It then builds a search index using the Elasticsearch engine from the cache.</p>\n\n\n\n<p>The team has built an optimized API, which now supports searching as the user types and uses pageview stats as part of the algorithm in result rankings. Search input also goes directly from the browser to the API on WordPress.com, which minimizes the delay in returning results.</p>\n\n\n\n<p>&ldquo;All search engines work by preprocessing the data to ensure that when a user&rsquo;s search query comes in the results can quickly be returned,&rdquo; said Brown. &ldquo;For Jetpack Search, very little of the processing time on our servers goes to processing the queries. Almost all of the server load comes from indexing the data and reindexing it as the content changes. Across our main search cluster, for instance, only 10% of the CPU time is spent processing about 850 search queries per second. Most of the time is spent on the 650 index operations per second.&rdquo;</p>\n\n\n\n<p>Brown explains this new architecture is why the new pricing tiers are based on the number of records cached from a site. &ldquo;We preprocess the data, which expands how big it is; store it on the fastest SSDs we can buy; replicate it to multiple data centers; and then can quickly serve results as soon as a search request comes to our API.&rdquo;</p>\n\n\n\n<p>For readers who are interested in a more technical breakdown of the system, Brown has written a full overview titled <a href=\"https://data.blog/2017/07/11/real-time-elasticsearch-indexing-on-wordpress-com/\">Real-Time Elasticsearch Indexing on WordPress.com</a> on the Data for Breakfast blog.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 07 Apr 2020 20:00:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 11 May 2020 01:57:03 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Mon, 11 May 2020 01:30:07 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 1\";s:16:\"content-encoding\";s:4:\"gzip\";}}s:5:\"build\";s:14:\"20180903223853\";}","no"),
("7833","_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9","1589205423","no"),
("7834","_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9","1589162223","no"),
("7835","_transient_timeout_dash_v2_d574e94acce509528fce430351f5c76a","1589205423","no"),
("7836","_transient_dash_v2_d574e94acce509528fce430351f5c76a","<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://feedproxy.google.com/~r/wp-turkiye/~3/njg5BRbUSaY/\'>WordPress Türkçe 4.9.4</a></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wptavern.com/wordcamp-spain-2020-qa-matt-mullenweg-discusses-virtual-events-decoupled-wordpress-and-the-future-of-page-builders?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=wordcamp-spain-2020-qa-matt-mullenweg-discusses-virtual-events-decoupled-wordpress-and-the-future-of-page-builders\'>WPTavern: WordCamp Spain 2020 Q&amp;A: Matt Mullenweg Discusses Virtual Events, Decoupled WordPress, and the Future of Page Builders</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/drag-and-drop-nav-menu-items-in-wordpress?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=drag-and-drop-nav-menu-items-in-wordpress\'>WPTavern: Drag and Drop Nav Menu Items in WordPress</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/bringing-back-blogs-in-the-age-of-social-media-censorship?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=bringing-back-blogs-in-the-age-of-social-media-censorship\'>WPTavern: Bringing Back Blogs in the Age of Social Media Censorship</a></li></ul></div>","no"),
("7840","admin_email_lifespan","1604714514","yes"),
("7846","can_compress_scripts","0","no"),
("7852","_site_transient_update_core","O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.4.1.zip\";s:6:\"locale\";s:5:\"tr_TR\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.4.1.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-5.4.1-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-5.4.1-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"5.4.1\";s:7:\"version\";s:5:\"5.4.1\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1589162365;s:15:\"version_checked\";s:5:\"5.4.1\";s:12:\"translations\";a:0:{}}","no"),
("7844","recovery_keys","a:0:{}","yes"),
("7853","_site_transient_update_plugins","O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1589162406;s:7:\"checked\";a:11:{s:19:\"akismet/akismet.php\";s:5:\"4.1.5\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:5:\"5.1.7\";s:53:\"customizer-export-import/customizer-export-import.php\";s:5:\"0.9.1\";s:33:\"duplicator-pro/duplicator-pro.php\";s:7:\"3.8.6.2\";s:21:\"hello-dolly/hello.php\";s:5:\"1.7.2\";s:47:\"one-click-demo-import/one-click-demo-import.php\";s:5:\"2.5.2\";s:49:\"portfolio-and-projects/portfolio-and-projects.php\";s:5:\"1.0.6\";s:35:\"redux-framework/redux-framework.php\";s:6:\"3.6.18\";s:24:\"simple-lightbox/main.php\";s:5:\"2.8.1\";s:53:\"widget-importer-exporter/widget-importer-exporter.php\";s:5:\"1.5.5\";s:35:\"wp-fastest-cache/wpFastestCache.php\";s:7:\"0.9.0.6\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:10:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:21:\"w.org/plugins/akismet\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"4.1.5\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.4.1.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:59:\"https://ps.w.org/akismet/assets/icon-256x256.png?rev=969272\";s:2:\"1x\";s:59:\"https://ps.w.org/akismet/assets/icon-128x128.png?rev=969272\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:61:\"https://ps.w.org/akismet/assets/banner-772x250.jpg?rev=479904\";}s:11:\"banners_rtl\";a:0:{}}s:36:\"contact-form-7/wp-contact-form-7.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:28:\"w.org/plugins/contact-form-7\";s:4:\"slug\";s:14:\"contact-form-7\";s:6:\"plugin\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:11:\"new_version\";s:5:\"5.1.7\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/contact-form-7/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/contact-form-7.5.1.7.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/contact-form-7/assets/icon-256x256.png?rev=2279696\";s:2:\"1x\";s:67:\"https://ps.w.org/contact-form-7/assets/icon-128x128.png?rev=2279696\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/contact-form-7/assets/banner-1544x500.png?rev=860901\";s:2:\"1x\";s:68:\"https://ps.w.org/contact-form-7/assets/banner-772x250.png?rev=880427\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"customizer-export-import/customizer-export-import.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/customizer-export-import\";s:4:\"slug\";s:24:\"customizer-export-import\";s:6:\"plugin\";s:53:\"customizer-export-import/customizer-export-import.php\";s:11:\"new_version\";s:5:\"0.9.1\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/customizer-export-import/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/customizer-export-import.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/customizer-export-import/assets/icon-256x256.jpg?rev=1049984\";s:2:\"1x\";s:77:\"https://ps.w.org/customizer-export-import/assets/icon-128x128.jpg?rev=1049984\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/customizer-export-import/assets/banner-772x250.jpg?rev=1049984\";}s:11:\"banners_rtl\";a:0:{}}s:21:\"hello-dolly/hello.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/hello-dolly\";s:4:\"slug\";s:11:\"hello-dolly\";s:6:\"plugin\";s:21:\"hello-dolly/hello.php\";s:11:\"new_version\";s:5:\"1.7.2\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/hello-dolly/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/hello-dolly.1.7.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-256x256.jpg?rev=2052855\";s:2:\"1x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-128x128.jpg?rev=2052855\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:66:\"https://ps.w.org/hello-dolly/assets/banner-772x250.jpg?rev=2052855\";}s:11:\"banners_rtl\";a:0:{}}s:47:\"one-click-demo-import/one-click-demo-import.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:35:\"w.org/plugins/one-click-demo-import\";s:4:\"slug\";s:21:\"one-click-demo-import\";s:6:\"plugin\";s:47:\"one-click-demo-import/one-click-demo-import.php\";s:11:\"new_version\";s:5:\"2.5.2\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/one-click-demo-import/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/one-click-demo-import.2.5.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/one-click-demo-import/assets/icon-256x256.png?rev=1694310\";s:2:\"1x\";s:74:\"https://ps.w.org/one-click-demo-import/assets/icon-128x128.png?rev=1694310\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/one-click-demo-import/assets/banner-1544x500.png?rev=1694310\";s:2:\"1x\";s:76:\"https://ps.w.org/one-click-demo-import/assets/banner-772x250.png?rev=1694310\";}s:11:\"banners_rtl\";a:0:{}}s:49:\"portfolio-and-projects/portfolio-and-projects.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:36:\"w.org/plugins/portfolio-and-projects\";s:4:\"slug\";s:22:\"portfolio-and-projects\";s:6:\"plugin\";s:49:\"portfolio-and-projects/portfolio-and-projects.php\";s:11:\"new_version\";s:5:\"1.0.6\";s:3:\"url\";s:53:\"https://wordpress.org/plugins/portfolio-and-projects/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/portfolio-and-projects.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:75:\"https://ps.w.org/portfolio-and-projects/assets/icon-128x128.png?rev=1566838\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:77:\"https://ps.w.org/portfolio-and-projects/assets/banner-772x250.png?rev=1987848\";}s:11:\"banners_rtl\";a:0:{}}s:35:\"redux-framework/redux-framework.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/redux-framework\";s:4:\"slug\";s:15:\"redux-framework\";s:6:\"plugin\";s:35:\"redux-framework/redux-framework.php\";s:11:\"new_version\";s:6:\"3.6.18\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/redux-framework/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/redux-framework.3.6.18.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:67:\"https://ps.w.org/redux-framework/assets/icon-256x256.png?rev=995554\";s:2:\"1x\";s:59:\"https://ps.w.org/redux-framework/assets/icon.svg?rev=995554\";s:3:\"svg\";s:59:\"https://ps.w.org/redux-framework/assets/icon.svg?rev=995554\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:69:\"https://ps.w.org/redux-framework/assets/banner-772x250.png?rev=793165\";}s:11:\"banners_rtl\";a:0:{}}s:24:\"simple-lightbox/main.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/simple-lightbox\";s:4:\"slug\";s:15:\"simple-lightbox\";s:6:\"plugin\";s:24:\"simple-lightbox/main.php\";s:11:\"new_version\";s:5:\"2.8.1\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/simple-lightbox/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/simple-lightbox.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:59:\"https://s.w.org/plugins/geopattern-icon/simple-lightbox.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:53:\"widget-importer-exporter/widget-importer-exporter.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/widget-importer-exporter\";s:4:\"slug\";s:24:\"widget-importer-exporter\";s:6:\"plugin\";s:53:\"widget-importer-exporter/widget-importer-exporter.php\";s:11:\"new_version\";s:5:\"1.5.5\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/widget-importer-exporter/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/widget-importer-exporter.1.5.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:76:\"https://ps.w.org/widget-importer-exporter/assets/icon-256x256.jpg?rev=990577\";s:2:\"1x\";s:76:\"https://ps.w.org/widget-importer-exporter/assets/icon-128x128.jpg?rev=990577\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/widget-importer-exporter/assets/banner-1544x500.jpg?rev=775677\";s:2:\"1x\";s:78:\"https://ps.w.org/widget-importer-exporter/assets/banner-772x250.jpg?rev=741218\";}s:11:\"banners_rtl\";a:0:{}}s:35:\"wp-fastest-cache/wpFastestCache.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:30:\"w.org/plugins/wp-fastest-cache\";s:4:\"slug\";s:16:\"wp-fastest-cache\";s:6:\"plugin\";s:35:\"wp-fastest-cache/wpFastestCache.php\";s:11:\"new_version\";s:7:\"0.9.0.6\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/wp-fastest-cache/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/wp-fastest-cache.0.9.0.6.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/wp-fastest-cache/assets/icon-256x256.png?rev=2064586\";s:2:\"1x\";s:69:\"https://ps.w.org/wp-fastest-cache/assets/icon-128x128.png?rev=1068904\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:71:\"https://ps.w.org/wp-fastest-cache/assets/banner-772x250.jpg?rev=1064099\";}s:11:\"banners_rtl\";a:0:{}}}}","no"),
("7854","_site_transient_update_themes","O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1589162366;s:7:\"checked\";a:3:{s:21:\"Ucretsiz-WT-discovery\";s:5:\"3.0.1\";s:14:\"twentynineteen\";s:3:\"1.5\";s:12:\"twentytwenty\";s:3:\"1.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}","no"),
("7855","_site_transient_timeout_browser_519f4adb8b5ed03bb10033203d97ecd9","1589767315","no"),
("7856","_site_transient_browser_519f4adb8b5ed03bb10033203d97ecd9","a:10:{s:4:\"name\";s:5:\"Opera\";s:7:\"version\";s:12:\"68.0.3618.63\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:22:\"https://www.opera.com/\";s:7:\"img_src\";s:42:\"http://s.w.org/images/browsers/opera.png?1\";s:11:\"img_src_ssl\";s:43:\"https://s.w.org/images/browsers/opera.png?1\";s:15:\"current_version\";s:5:\"12.18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}","no"),
("7857","_site_transient_timeout_php_check_f9714bbe413cc376a70847d9c1f86fcc","1589767316","no"),
("7858","_site_transient_php_check_f9714bbe413cc376a70847d9c1f86fcc","a:5:{s:19:\"recommended_version\";s:3:\"7.3\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}","no"),
("7862","duplicator_pro_plugin_version","3.8.6.2","yes"),
("7863","duplicator_pro_package_active","{\n    \"Created\": \"2020-05-11 02:02:55\",\n    \"Version\": \"3.8.6.2\",\n    \"VersionWP\": \"5.4.1\",\n    \"VersionDB\": \"10.2.31\",\n    \"VersionPHP\": \"7.4.5\",\n    \"VersionOS\": \"Linux\",\n    \"ID\": null,\n    \"Name\": \"kurumsaltema\",\n    \"Hash\": \"5fb33fb72f3c4dd74632_20200511020255\",\n    \"NameHash\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255\",\n    \"Type\": 0,\n    \"Notes\": \"The default template.\",\n    \"StorePath\": \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\\/tmp\",\n    \"StoreURL\": \"https:\\/\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\\/\",\n    \"ScanFile\": \"kurumsaltema_5fb33fb72f3c4dd74632_20200511020255_scan.json\",\n    \"timer_start\": -1,\n    \"Runtime\": null,\n    \"ExeSize\": null,\n    \"ZipSize\": 0,\n    \"Brand\": \"Default\",\n    \"Brand_ID\": -2,\n    \"ziparchive_mode\": null,\n    \"Archive\": {\n        \"ExportOnlyDB\": 0,\n        \"FilterDirs\": \"\",\n        \"FilterExts\": \"\",\n        \"FilterFiles\": \"\",\n        \"FilterDirsAll\": [\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/.opcache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/.tmb\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/ai1wm-backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backups-dup-pro\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/backupwordpress\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/content\\/cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/contents\\/cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/infinitewp\\/backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/managewp\\/backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/old-cache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/plugins\\/wordfence\\/tmp\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/updraft\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/aiowps_backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/backup-guard\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/backupbuddy_backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/backupbuddy_temp\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/mainwp\\/backup\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/pb_backupbuddy\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/snapshots\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/sucuri\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/wp-clone\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/wp_all_backup\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/uploads\\/wpbackitup_backups\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/wfcache\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-content\\/wishlist-backup\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-snapshots\"\n        ],\n        \"FilterExtsAll\": [],\n        \"FilterFilesAll\": [\n            \".DS_Store\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/.htaccess\",\n            \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\\/wp-config.php\",\n            \"dbcache\",\n            \"debug_log\",\n            \"error.log\",\n            \"error_log\",\n            \"objectcache\",\n            \"pgcache\",\n            \"ws_ftp.log\"\n        ],\n        \"FilterOn\": 0,\n        \"File\": null,\n        \"Format\": \"ZIP\",\n        \"PackDir\": \"\\/var\\/www\\/vhosts\\/wordpresstema.com\\/ucretsiz.wordpresstema.com\\/test1\",\n        \"Size\": 89759696,\n        \"Dirs\": null,\n        \"DirCount\": 632,\n        \"RecursiveLinks\": [],\n        \"Files\": null,\n        \"FileCount\": 4140,\n        \"file_count\": -1,\n        \"FilterInfo\": {\n            \"Dirs\": {\n                \"Warning\": [],\n                \"Unreadable\": [],\n                \"AddonSites\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": []\n            },\n            \"Files\": {\n                \"Warning\": [],\n                \"Unreadable\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": []\n            },\n            \"Exts\": {\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": []\n            },\n            \"TreeSize\": null,\n            \"TreeWarning\": null\n        },\n        \"ListDelimiter\": \"\\n\",\n        \"throttleDelayInUs\": 0\n    },\n    \"Multisite\": {\n        \"FilterSites\": \"\"\n    },\n    \"Installer\": {\n        \"File\": null,\n        \"Size\": 0,\n        \"OptsSecureOn\": 0,\n        \"OptsSecurePass\": \"\",\n        \"OptsSkipScan\": 0,\n        \"OptsDBHost\": \"\",\n        \"OptsDBName\": \"\",\n        \"OptsDBUser\": \"\",\n        \"OptsCPNLHost\": \"\",\n        \"OptsCPNLUser\": \"\",\n        \"OptsCPNLPass\": \"\",\n        \"OptsCPNLEnable\": 0,\n        \"OptsCPNLConnect\": false,\n        \"OptsCPNLDBAction\": \"create\",\n        \"OptsCPNLDBHost\": \"\",\n        \"OptsCPNLDBName\": \"\",\n        \"OptsCPNLDBUser\": \"\",\n        \"numFilesAdded\": 0,\n        \"numDirsAdded\": 0\n    },\n    \"Database\": {\n        \"info\": {\n            \"buildMode\": \"PHPCHUNKING\",\n            \"charSetList\": [\n                \"utf8mb4\",\n                \"utf8\"\n            ],\n            \"collationList\": [\n                \"utf8mb4_unicode_520_ci\",\n                \"utf8_general_ci\"\n            ],\n            \"isTablesUpperCase\": 0,\n            \"isNameUpperCase\": 0,\n            \"name\": \"wordpres_ucr1\",\n            \"tablesBaseCount\": 16,\n            \"tablesFinalCount\": 16,\n            \"tablesRowCount\": 730,\n            \"tablesSizeOnDisk\": 875793,\n            \"tablesList\": {\n                \"wp_commentmeta\": {\n                    \"rows\": \"34\",\n                    \"size\": 12008\n                },\n                \"wp_comments\": {\n                    \"rows\": \"17\",\n                    \"size\": 11132\n                },\n                \"wp_crp_portfolios\": {\n                    \"rows\": \"2\",\n                    \"size\": 16384\n                },\n                \"wp_crp_projects\": {\n                    \"rows\": \"8\",\n                    \"size\": 16384\n                },\n                \"wp_duplicator_pro_entities\": {\n                    \"rows\": \"5\",\n                    \"size\": 32768\n                },\n                \"wp_duplicator_pro_packages\": {\n                    \"rows\": \"0\",\n                    \"size\": 32768\n                },\n                \"wp_links\": {\n                    \"rows\": \"0\",\n                    \"size\": 1024\n                },\n                \"wp_options\": {\n                    \"rows\": \"184\",\n                    \"size\": 513116\n                },\n                \"wp_postmeta\": {\n                    \"rows\": \"280\",\n                    \"size\": 81240\n                },\n                \"wp_posts\": {\n                    \"rows\": \"109\",\n                    \"size\": 110356\n                },\n                \"wp_term_relationships\": {\n                    \"rows\": \"41\",\n                    \"size\": 3933\n                },\n                \"wp_term_taxonomy\": {\n                    \"rows\": \"13\",\n                    \"size\": 4632\n                },\n                \"wp_termmeta\": {\n                    \"rows\": \"0\",\n                    \"size\": 4096\n                },\n                \"wp_terms\": {\n                    \"rows\": \"13\",\n                    \"size\": 13792\n                },\n                \"wp_usermeta\": {\n                    \"rows\": \"23\",\n                    \"size\": 13684\n                },\n                \"wp_users\": {\n                    \"rows\": \"1\",\n                    \"size\": 8476\n                }\n            },\n            \"varLowerCaseTables\": \"0\",\n            \"version\": \"10.2.31\",\n            \"versionComment\": \"MariaDB Server\",\n            \"tableWiseRowCounts\": []\n        },\n        \"Type\": \"MySQL\",\n        \"Size\": null,\n        \"File\": null,\n        \"FilterTables\": \"\",\n        \"FilterOn\": 0,\n        \"DBMode\": null,\n        \"Compatible\": \"\",\n        \"Comments\": \"MariaDB Server\",\n        \"dbStorePathPublic\": null\n    },\n    \"Status\": 5,\n    \"schedule_id\": -1,\n    \"build_progress\": {\n        \"thread_start_time\": null,\n        \"initialized\": false,\n        \"installer_built\": false,\n        \"archive_started\": false,\n        \"archive_has_database\": false,\n        \"archive_built\": false,\n        \"database_script_built\": false,\n        \"failed\": false,\n        \"next_archive_file_index\": 0,\n        \"next_archive_dir_index\": 0,\n        \"retries\": 0,\n        \"current_build_mode\": -1,\n        \"current_build_compression\": true,\n        \"custom_data\": null,\n        \"warnings\": []\n    },\n    \"db_build_progress\": {\n        \"tableIndex\": 0,\n        \"tableOffset\": 0,\n        \"totalRowOffset\": 0,\n        \"chunkIndex\": null,\n        \"validationStage1\": false,\n        \"bulkOffset\": 0,\n        \"bulkSizeOffset\": 0,\n        \"doneInit\": false,\n        \"doneFiltering\": false,\n        \"doneCreates\": false,\n        \"completed\": false,\n        \"tablesToProcess\": [],\n        \"startTime\": null,\n        \"fileOffset\": 0,\n        \"wasInterrupted\": false,\n        \"errorOut\": false,\n        \"failureCount\": 0,\n        \"totalSchemaSize\": 0,\n        \"tablesSchemaSizes\": []\n    },\n    \"upload_infos\": [\n        {\n            \"storage_id\": \"-2\",\n            \"archive_offset\": 0,\n            \"copied_installer\": false,\n            \"copied_archive\": false,\n            \"progress\": 0,\n            \"num_failures\": 0,\n            \"failed\": false,\n            \"cancelled\": false,\n            \"upload_id\": null,\n            \"failure_count\": 0,\n            \"data\": \"\",\n            \"data2\": \"\",\n            \"has_started\": false,\n            \"status_message_details\": \"\",\n            \"started_timestamp\": null,\n            \"stopped_timestamp\": null\n        }\n    ],\n    \"active_storage_id\": -1,\n    \"template_id\": 4\n}","yes");


/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES 
("1","2","_wp_page_template","page-templates/custom_home.php"),
("2","3","_wp_page_template","default"),
("3","2","_edit_lock","1545683512:1"),
("4","2","_edit_last","1"),
("6","7","_wp_attached_file","2018/09/img1-e1536015506397.jpg"),
("7","7","_wp_attachment_metadata","a:5:{s:5:\"width\";i:300;s:6:\"height\";i:169;s:4:\"file\";s:31:\"2018/09/img1-e1536015506397.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"img1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"img1-300x169.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:169;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:12:\"img1-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:16:\"img1-602x300.jpg\";s:5:\"width\";i:602;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("10","7","_wp_attachment_backup_sizes","a:1:{s:9:\"full-orig\";a:3:{s:5:\"width\";i:602;s:6:\"height\";i:339;s:4:\"file\";s:8:\"img1.jpg\";}}"),
("12","9","_wp_attached_file","2018/09/img2.jpg"),
("13","9","_wp_attachment_metadata","a:5:{s:5:\"width\";i:450;s:6:\"height\";i:300;s:4:\"file\";s:16:\"2018/09/img2.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"img2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"img2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:12:\"img2-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:16:\"img2-450x300.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"4\";s:6:\"credit\";s:24:\"Getty Images/iStockphoto\";s:6:\"camera\";s:14:\"Canon EOS-1D X\";s:7:\"caption\";s:51:\"Two senior business colleagues at meeting, close-up\";s:17:\"created_timestamp\";s:10:\"1441695600\";s:9:\"copyright\";s:20:\"monkeybusinessimages\";s:12:\"focal_length\";s:3:\"165\";s:3:\"iso\";s:3:\"400\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:51:\"Two senior business colleagues at meeting, close-up\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:42:{i:0;s:19:\"White Collar Worker\";i:1;s:14:\"Digital Tablet\";i:2;s:14:\"Using Computer\";i:3;s:13:\"Businesswoman\";i:4;s:11:\"Businessman\";i:5;s:5:\"Women\";i:6;s:3:\"Men\";i:7;s:10:\"Two People\";i:8;s:10:\"Copy Space\";i:9;s:21:\"Business Relationship\";i:10;s:11:\"60-69 Years\";i:11;s:11:\"50-59 Years\";i:12;s:12:\"Senior Adult\";i:13;s:12:\"Mature Adult\";i:14;s:5:\"Adult\";i:15;s:7:\"Sitting\";i:16;s:7:\"Working\";i:17;s:7:\"Showing\";i:18;s:19:\"Caucasian Ethnicity\";i:19;s:11:\"Cooperation\";i:20;s:8:\"Teamwork\";i:21;s:11:\"Partnership\";i:22;s:10:\"Discussion\";i:23;s:10:\"Connection\";i:24;s:13:\"Communication\";i:25;s:13:\"Concentration\";i:26;s:6:\"Modern\";i:27;s:8:\"Business\";i:28;s:10:\"Technology\";i:29;s:8:\"Waist Up\";i:30;s:10:\"Horizontal\";i:31;s:7:\"Serious\";i:32;s:18:\"Professional Sport\";i:33;s:10:\"Occupation\";i:34;s:6:\"Window\";i:35;s:15:\"Office Interior\";i:36;s:6:\"Laptop\";i:37;s:12:\"Well-dressed\";i:38;s:16:\"Business Meeting\";i:39;s:17:\"Looking At Screen\";i:40;s:17:\"Business Strategy\";i:41;s:18:\"Corporate Business\";}}}"),
("14","10","_wp_attached_file","2018/09/orneklogo.png"),
("15","10","_wp_attachment_metadata","a:5:{s:5:\"width\";i:900;s:6:\"height\";i:600;s:4:\"file\";s:21:\"2018/09/orneklogo.png\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"orneklogo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"orneklogo-300x200.png\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"orneklogo-768x512.png\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:17:\"orneklogo-2x1.png\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}s:8:\"featured\";a:4:{s:4:\"file\";s:21:\"orneklogo-670x300.png\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"recent\";a:4:{s:4:\"file\";s:21:\"orneklogo-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("18","12","_menu_item_type","post_type"),
("19","12","_menu_item_menu_item_parent","0"),
("20","12","_menu_item_object_id","2"),
("21","12","_menu_item_object","page"),
("22","12","_menu_item_target",""),
("23","12","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("24","12","_menu_item_xfn",""),
("25","12","_menu_item_url",""),
("386","139","_wp_pap_gallery_id",""),
("29","14","_wp_attached_file","2018/09/LOGOSTICKY.png"),
("30","14","_wp_attachment_metadata","a:5:{s:5:\"width\";i:212;s:6:\"height\";i:40;s:4:\"file\";s:22:\"2018/09/LOGOSTICKY.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"LOGOSTICKY-150x40.png\";s:5:\"width\";i:150;s:6:\"height\";i:40;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:18:\"LOGOSTICKY-5x1.png\";s:5:\"width\";i:5;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("31","15","_wp_attached_file","2018/09/vertical-logo-dark.png"),
("32","15","_wp_attachment_metadata","a:5:{s:5:\"width\";i:163;s:6:\"height\";i:77;s:4:\"file\";s:30:\"2018/09/vertical-logo-dark.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"vertical-logo-dark-150x77.png\";s:5:\"width\";i:150;s:6:\"height\";i:77;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:26:\"vertical-logo-dark-2x1.png\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("33","16","_wp_attached_file","2018/09/logor.png"),
("34","16","_wp_attachment_metadata","a:5:{s:5:\"width\";i:153;s:6:\"height\";i:76;s:4:\"file\";s:17:\"2018/09/logor.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"logor-150x76.png\";s:5:\"width\";i:150;s:6:\"height\";i:76;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:13:\"logor-2x1.png\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("35","17","_wp_attached_file","2018/09/cropped-img1-e1536015506397.jpg"),
("36","17","_wp_attachment_context","custom-header"),
("37","17","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1040;s:6:\"height\";i:398;s:4:\"file\";s:39:\"2018/09/cropped-img1-e1536015506397.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:39:\"cropped-img1-e1536015506397-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:39:\"cropped-img1-e1536015506397-300x115.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:115;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:39:\"cropped-img1-e1536015506397-768x294.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:294;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:40:\"cropped-img1-e1536015506397-1024x392.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:392;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:35:\"cropped-img1-e1536015506397-3x1.jpg\";s:5:\"width\";i:3;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:39:\"cropped-img1-e1536015506397-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:39:\"cropped-img1-e1536015506397-700x398.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:398;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:17:\"attachment_parent\";i:7;}"),
("41","18","_wp_attachment_metadata","a:5:{s:5:\"width\";i:1170;s:6:\"height\";i:400;s:4:\"file\";s:50:\"2018/09/Spirit-of-Norfok-2016-Corporate-Cruise.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:50:\"Spirit-of-Norfok-2016-Corporate-Cruise-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:50:\"Spirit-of-Norfok-2016-Corporate-Cruise-300x103.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:103;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:50:\"Spirit-of-Norfok-2016-Corporate-Cruise-768x263.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:263;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:51:\"Spirit-of-Norfok-2016-Corporate-Cruise-1024x350.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:350;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:46:\"Spirit-of-Norfok-2016-Corporate-Cruise-3x1.jpg\";s:5:\"width\";i:3;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:50:\"Spirit-of-Norfok-2016-Corporate-Cruise-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:50:\"Spirit-of-Norfok-2016-Corporate-Cruise-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"1.2\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:20:\"Canon EOS 5D Mark II\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1472585358\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"85\";s:3:\"iso\";s:3:\"100\";s:13:\"shutter_speed\";s:5:\"0.005\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("40","18","_wp_attached_file","2018/09/Spirit-of-Norfok-2016-Corporate-Cruise.jpg"),
("42","19","_wp_attached_file","2018/09/cropped-Spirit-of-Norfok-2016-Corporate-Cruise.jpg"),
("43","19","_wp_attachment_context","custom-header"),
("44","19","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1040;s:6:\"height\";i:400;s:4:\"file\";s:58:\"2018/09/cropped-Spirit-of-Norfok-2016-Corporate-Cruise.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:58:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:58:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-300x115.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:115;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:58:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-768x295.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:295;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:59:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-1024x394.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:394;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:54:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-3x1.jpg\";s:5:\"width\";i:3;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:58:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:58:\"cropped-Spirit-of-Norfok-2016-Corporate-Cruise-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:17:\"attachment_parent\";i:18;}"),
("45","19","_wp_attachment_custom_header_last_used_Ucretsiz-WT-discovery","1536015978"),
("46","19","_wp_attachment_is_custom_header","Ucretsiz-WT-discovery"),
("47","20","_wp_attached_file","2018/09/Corporate-Card-Page-Header-Final-1b-1024x350.png"),
("48","20","_wp_attachment_metadata","a:5:{s:5:\"width\";i:1024;s:6:\"height\";i:350;s:4:\"file\";s:56:\"2018/09/Corporate-Card-Page-Header-Final-1b-1024x350.png\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:56:\"Corporate-Card-Page-Header-Final-1b-1024x350-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:56:\"Corporate-Card-Page-Header-Final-1b-1024x350-300x103.png\";s:5:\"width\";i:300;s:6:\"height\";i:103;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:56:\"Corporate-Card-Page-Header-Final-1b-1024x350-768x263.png\";s:5:\"width\";i:768;s:6:\"height\";i:263;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:57:\"Corporate-Card-Page-Header-Final-1b-1024x350-1024x350.png\";s:5:\"width\";i:1024;s:6:\"height\";i:350;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:52:\"Corporate-Card-Page-Header-Final-1b-1024x350-3x1.png\";s:5:\"width\";i:3;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}s:8:\"featured\";a:4:{s:4:\"file\";s:56:\"Corporate-Card-Page-Header-Final-1b-1024x350-670x300.png\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"recent\";a:4:{s:4:\"file\";s:56:\"Corporate-Card-Page-Header-Final-1b-1024x350-700x350.png\";s:5:\"width\";i:700;s:6:\"height\";i:350;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("49","21","_wp_attached_file","2018/09/cropped-Corporate-Card-Page-Header-Final-1b-1024x350.png"),
("50","21","_wp_attachment_context","custom-header"),
("51","21","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1040;s:6:\"height\";i:400;s:4:\"file\";s:64:\"2018/09/cropped-Corporate-Card-Page-Header-Final-1b-1024x350.png\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:64:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:64:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-300x115.png\";s:5:\"width\";i:300;s:6:\"height\";i:115;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:64:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-768x295.png\";s:5:\"width\";i:768;s:6:\"height\";i:295;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:65:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-1024x394.png\";s:5:\"width\";i:1024;s:6:\"height\";i:394;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:60:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-3x1.png\";s:5:\"width\";i:3;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}s:8:\"featured\";a:4:{s:4:\"file\";s:64:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-670x300.png\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"recent\";a:4:{s:4:\"file\";s:64:\"cropped-Corporate-Card-Page-Header-Final-1b-1024x350-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:17:\"attachment_parent\";i:20;}"),
("52","21","_wp_attachment_custom_header_last_used_Ucretsiz-WT-discovery","1536016019"),
("53","21","_wp_attachment_is_custom_header","Ucretsiz-WT-discovery"),
("54","22","_wp_attached_file","2018/09/logojpg.jpg"),
("55","22","_wp_attachment_metadata","a:5:{s:5:\"width\";i:182;s:6:\"height\";i:46;s:4:\"file\";s:19:\"2018/09/logojpg.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"logojpg-150x46.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:15:\"logojpg-4x1.jpg\";s:5:\"width\";i:4;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("56","23","_wp_attached_file","2018/09/elevator-turkey-01-44-e1536016237467.png"),
("57","23","_wp_attachment_metadata","a:5:{s:5:\"width\";i:333;s:6:\"height\";i:75;s:4:\"file\";s:48:\"2018/09/elevator-turkey-01-44-e1536016237467.png\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"elevator-turkey-01-44-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:32:\"elevator-turkey-01-44-300x68.png\";s:5:\"width\";i:300;s:6:\"height\";i:68;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:33:\"elevator-turkey-01-44-768x173.png\";s:5:\"width\";i:768;s:6:\"height\";i:173;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:34:\"elevator-turkey-01-44-1024x231.png\";s:5:\"width\";i:1024;s:6:\"height\";i:231;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:29:\"elevator-turkey-01-44-4x1.png\";s:5:\"width\";i:4;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}s:8:\"featured\";a:4:{s:4:\"file\";s:33:\"elevator-turkey-01-44-670x300.png\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"recent\";a:4:{s:4:\"file\";s:33:\"elevator-turkey-01-44-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("58","23","_edit_lock","1536016096:1"),
("59","23","_wp_attachment_backup_sizes","a:2:{s:9:\"full-orig\";a:3:{s:5:\"width\";i:3166;s:6:\"height\";i:713;s:4:\"file\";s:25:\"elevator-turkey-01-44.png\";}s:18:\"full-1536016237467\";a:3:{s:5:\"width\";i:444;s:6:\"height\";i:100;s:4:\"file\";s:40:\"elevator-turkey-01-44-e1536016212723.png\";}}"),
("60","23","_edit_last","1"),
("385","139","_thumbnail_id","93"),
("383","139","_edit_last","1"),
("384","139","_edit_lock","1536846479:1"),
("65","26","_edit_last","1"),
("66","26","_edit_lock","1536020275:1"),
("67","26","_wp_page_template","default"),
("68","28","_edit_last","1"),
("69","28","_edit_lock","1536019263:1"),
("70","28","_wp_page_template","page-templates/full-width.php"),
("73","30","_edit_last","1"),
("74","30","_edit_lock","1536016646:1"),
("75","30","_wp_page_template","default"),
("76","32","_edit_last","1"),
("77","32","_edit_lock","1536242069:1"),
("78","32","_wp_page_template","page-templates/full-width.php"),
("79","34","_menu_item_type","post_type"),
("80","34","_menu_item_menu_item_parent","0"),
("81","34","_menu_item_object_id","32"),
("82","34","_menu_item_object","page"),
("83","34","_menu_item_target",""),
("84","34","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("85","34","_menu_item_xfn",""),
("86","34","_menu_item_url",""),
("88","35","_menu_item_type","post_type"),
("89","35","_menu_item_menu_item_parent","0"),
("90","35","_menu_item_object_id","30"),
("91","35","_menu_item_object","page"),
("92","35","_menu_item_target",""),
("93","35","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("94","35","_menu_item_xfn",""),
("95","35","_menu_item_url",""),
("97","36","_menu_item_type","post_type"),
("98","36","_menu_item_menu_item_parent","0"),
("99","36","_menu_item_object_id","28"),
("100","36","_menu_item_object","page"),
("101","36","_menu_item_target",""),
("102","36","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("103","36","_menu_item_xfn",""),
("104","36","_menu_item_url",""),
("106","37","_menu_item_type","post_type"),
("107","37","_menu_item_menu_item_parent","0"),
("108","37","_menu_item_object_id","26"),
("109","37","_menu_item_object","page"),
("110","37","_menu_item_target",""),
("111","37","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("112","37","_menu_item_xfn",""),
("113","37","_menu_item_url",""),
("122","41","_wp_attached_file","2018/09/1034.jpg"),
("123","41","_wp_attachment_metadata","a:5:{s:5:\"width\";i:2000;s:6:\"height\";i:1047;s:4:\"file\";s:16:\"2018/09/1034.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"1034-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"1034-300x157.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:157;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:16:\"1034-768x402.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:402;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:17:\"1034-1024x536.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:536;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:12:\"1034-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:16:\"1034-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:16:\"1034-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:48:\"Businessman standing with arms crossed in office\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:48:\"Businessman standing with arms crossed in office\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("124","42","_wp_attached_file","2018/09/cropped-1034.jpg"),
("125","42","_wp_attachment_context","custom-header"),
("126","42","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1040;s:6:\"height\";i:399;s:4:\"file\";s:24:\"2018/09/cropped-1034.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"cropped-1034-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"cropped-1034-300x115.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:115;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"cropped-1034-768x295.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:295;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"cropped-1034-1024x393.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:393;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:20:\"cropped-1034-3x1.jpg\";s:5:\"width\";i:3;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:24:\"cropped-1034-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:24:\"cropped-1034-700x399.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:399;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:17:\"attachment_parent\";i:41;}"),
("127","42","_wp_attachment_custom_header_last_used_Ucretsiz-WT-discovery","1536016703"),
("128","42","_wp_attachment_is_custom_header","Ucretsiz-WT-discovery"),
("132","45","_wp_attached_file","2018/09/LOGORR.png"),
("133","45","_wp_attachment_metadata","a:5:{s:5:\"width\";i:153;s:6:\"height\";i:76;s:4:\"file\";s:18:\"2018/09/LOGORR.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"LOGORR-150x76.png\";s:5:\"width\";i:150;s:6:\"height\";i:76;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:14:\"LOGORR-2x1.png\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("134","46","_wp_attached_file","2018/09/robrady-r-icon.jpg"),
("135","46","_wp_attachment_metadata","a:5:{s:5:\"width\";i:620;s:6:\"height\";i:465;s:4:\"file\";s:26:\"2018/09/robrady-r-icon.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"robrady-r-icon-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"robrady-r-icon-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:22:\"robrady-r-icon-1x1.jpg\";s:5:\"width\";i:1;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:26:\"robrady-r-icon-620x300.jpg\";s:5:\"width\";i:620;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:26:\"robrady-r-icon-620x400.jpg\";s:5:\"width\";i:620;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("136","47","_wp_attached_file","2018/09/cropped-robrady-r-icon.jpg"),
("137","47","_wp_attachment_context","site-icon"),
("138","47","_wp_attachment_metadata","a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:34:\"2018/09/cropped-robrady-r-icon.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:30:\"cropped-robrady-r-icon-1x1.jpg\";s:5:\"width\";i:1;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-512x300.jpg\";s:5:\"width\";i:512;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-512x400.jpg\";s:5:\"width\";i:512;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-270x270.jpg\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-192x192.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:34:\"cropped-robrady-r-icon-180x180.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:32:\"cropped-robrady-r-icon-32x32.jpg\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("143","49","_wp_attached_file","2018/09/800px_COLOURBOX22078175.jpg"),
("144","49","_wp_attachment_metadata","a:5:{s:5:\"width\";i:800;s:6:\"height\";i:800;s:4:\"file\";s:35:\"2018/09/800px_COLOURBOX22078175.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:35:\"800px_COLOURBOX22078175-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:35:\"800px_COLOURBOX22078175-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:35:\"800px_COLOURBOX22078175-768x768.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:31:\"800px_COLOURBOX22078175-1x1.jpg\";s:5:\"width\";i:1;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:35:\"800px_COLOURBOX22078175-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:35:\"800px_COLOURBOX22078175-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("145","49","_wp_attachment_is_custom_background","Ucretsiz-WT-discovery"),
("148","51","_wp_attached_file","2018/09/602.jpg"),
("149","51","_wp_attachment_metadata","a:5:{s:5:\"width\";i:3333;s:6:\"height\";i:3333;s:4:\"file\";s:15:\"2018/09/602.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"602-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:15:\"602-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:15:\"602-768x768.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:17:\"602-1024x1024.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:11:\"602-1x1.jpg\";s:5:\"width\";i:1;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:15:\"602-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:15:\"602-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("150","51","_wp_attachment_is_custom_background","Ucretsiz-WT-discovery"),
("153","53","_wp_attached_file","2018/09/hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631.png"),
("154","53","_wp_attachment_metadata","a:5:{s:5:\"width\";i:1092;s:6:\"height\";i:631;s:4:\"file\";s:128:\"2018/09/hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631.png\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:128:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:128:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-300x173.png\";s:5:\"width\";i:300;s:6:\"height\";i:173;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:128:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-768x444.png\";s:5:\"width\";i:768;s:6:\"height\";i:444;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:129:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-1024x592.png\";s:5:\"width\";i:1024;s:6:\"height\";i:592;s:9:\"mime-type\";s:9:\"image/png\";}i:100;a:4:{s:4:\"file\";s:124:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-2x1.png\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:9:\"image/png\";}s:8:\"featured\";a:4:{s:4:\"file\";s:128:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-670x300.png\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"recent\";a:4:{s:4:\"file\";s:128:\"hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631-700x400.png\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("155","53","_wp_attachment_is_custom_background","Ucretsiz-WT-discovery"),
("163","57","_menu_item_type","post_type"),
("164","57","_menu_item_menu_item_parent","0"),
("165","57","_menu_item_object_id","32"),
("166","57","_menu_item_object","page"),
("167","57","_menu_item_target",""),
("168","57","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("169","57","_menu_item_xfn",""),
("170","57","_menu_item_url",""),
("172","58","_menu_item_type","post_type"),
("173","58","_menu_item_menu_item_parent","0"),
("174","58","_menu_item_object_id","30"),
("175","58","_menu_item_object","page"),
("176","58","_menu_item_target",""),
("177","58","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("178","58","_menu_item_xfn",""),
("179","58","_menu_item_url",""),
("181","59","_menu_item_type","post_type"),
("182","59","_menu_item_menu_item_parent","0"),
("183","59","_menu_item_object_id","28"),
("184","59","_menu_item_object","page"),
("185","59","_menu_item_target",""),
("186","59","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("187","59","_menu_item_xfn",""),
("188","59","_menu_item_url",""),
("190","60","_menu_item_type","post_type"),
("191","60","_menu_item_menu_item_parent","0"),
("192","60","_menu_item_object_id","26"),
("193","60","_menu_item_object","page"),
("194","60","_menu_item_target",""),
("195","60","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("196","60","_menu_item_xfn",""),
("197","60","_menu_item_url",""),
("205","64","_edit_last","1"),
("206","64","_edit_lock","1536018816:1"),
("207","64","_thumbnail_id","41"),
("215","66","_edit_lock","1536018096:1"),
("214","66","_edit_last","1"),
("216","66","_thumbnail_id","71"),
("393","47","_oembed_2fef4edacf518a3a9d1adf712d9363d3","{{unknown}}"),
("225","70","_wp_attached_file","2018/09/OBC8CU0.jpg"),
("226","70","_wp_attachment_metadata","a:5:{s:5:\"width\";i:2000;s:6:\"height\";i:1154;s:4:\"file\";s:19:\"2018/09/OBC8CU0.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"OBC8CU0-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"OBC8CU0-300x173.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:173;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:19:\"OBC8CU0-768x443.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:443;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:20:\"OBC8CU0-1024x591.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:591;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:15:\"OBC8CU0-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:19:\"OBC8CU0-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:19:\"OBC8CU0-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:53:\"handsome young successful man doing a welcome gesture\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:53:\"handsome young successful man doing a welcome gesture\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("229","71","_wp_attached_file","2018/09/slayt2.jpg"),
("230","71","_wp_attachment_metadata","a:5:{s:5:\"width\";i:2000;s:6:\"height\";i:1047;s:4:\"file\";s:18:\"2018/09/slayt2.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"slayt2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"slayt2-300x157.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:157;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"slayt2-768x402.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:402;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"slayt2-1024x536.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:536;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:14:\"slayt2-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:18:\"slayt2-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:18:\"slayt2-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("234","72","_edit_lock","1536018294:1"),
("233","72","_edit_last","1"),
("235","73","_wp_attached_file","2018/09/slayt2-1.jpg"),
("236","73","_wp_attachment_metadata","a:5:{s:5:\"width\";i:2000;s:6:\"height\";i:1047;s:4:\"file\";s:20:\"2018/09/slayt2-1.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"slayt2-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"slayt2-1-300x157.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:157;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:20:\"slayt2-1-768x402.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:402;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:21:\"slayt2-1-1024x536.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:536;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:16:\"slayt2-1-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:20:\"slayt2-1-670x300.jpg\";s:5:\"width\";i:670;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:20:\"slayt2-1-700x400.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("237","72","_thumbnail_id","73"),
("260","77","_edit_lock","1536018321:1"),
("242","72","_wp_old_date","2018-09-04"),
("246","1","_edit_last","1"),
("245","66","_wp_old_date","2018-09-04"),
("256","1","_thumbnail_id","9"),
("249","1","_wp_old_slug","merhaba-dunya"),
("250","1","_edit_lock","1536018231:1"),
("253","1","_wp_old_date","2018-09-05"),
("259","77","_edit_last","1"),
("261","78","_wp_attached_file","2018/09/ornek1.jpg"),
("262","78","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:18:\"2018/09/ornek1.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"ornek1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"ornek1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:14:\"ornek1-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:18:\"ornek1-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:18:\"ornek1-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"4\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:10:\"NIKON D800\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1520591939\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"50\";s:3:\"iso\";s:3:\"320\";s:13:\"shutter_speed\";s:6:\"0.0125\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("263","79","_wp_attached_file","2018/09/ornek2.jpg"),
("264","79","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:18:\"2018/09/ornek2.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"ornek2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"ornek2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:14:\"ornek2-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:18:\"ornek2-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:18:\"ornek2-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:16:\"Dmytro Sheremeta\";s:6:\"camera\";s:21:\"Canon EOS 5D Mark III\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1531305255\";s:9:\"copyright\";s:16:\"Dmytro Sheremeta\";s:12:\"focal_length\";s:2:\"85\";s:3:\"iso\";s:3:\"400\";s:13:\"shutter_speed\";s:5:\"0.002\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("265","80","_wp_attached_file","2018/09/ornek3.jpg"),
("266","80","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:349;s:4:\"file\";s:18:\"2018/09/ornek3.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"ornek3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"ornek3-300x167.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:167;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:14:\"ornek3-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:18:\"ornek3-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("267","77","_thumbnail_id","78"),
("271","82","_edit_lock","1536018414:1"),
("270","82","_edit_last","1"),
("272","82","_thumbnail_id","79"),
("276","84","_edit_lock","1536018538:1"),
("275","84","_edit_last","1"),
("277","84","_thumbnail_id","86"),
("280","86","_wp_attached_file","2018/09/ornekk.jpg"),
("281","86","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:18:\"2018/09/ornekk.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"ornekk-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"ornekk-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:14:\"ornekk-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:18:\"ornekk-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:18:\"ornekk-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("284","87","_form","<label> Adınız (gerekli)\n    [text* your-name] </label>\n\n<label> E-posta adresiniz (gerekli)\n    [email* your-email] </label>\n\n<label> Konu\n    [text your-subject] </label>\n\n<label> İletiniz\n    [textarea your-message] </label>\n\n[submit \"Gönder\"]"),
("285","87","_mail","a:9:{s:6:\"active\";b:1;s:7:\"subject\";s:53:\"Ücretsiz Wordpress Tema Demo Sitesi \"[your-subject]\"\";s:6:\"sender\";s:50:\"[your-name] <wordpress@ucretsiz.wordpresstema.com>\";s:9:\"recipient\";s:26:\"ucretsiz@wordpresstema.com\";s:4:\"body\";s:229:\"Kimden: [your-name] <[your-email]>\nKonu: [your-subject]\n\nİleti gövdesi:\n[your-message]\n\n-- \nBu e-posta, Ücretsiz Wordpress Tema Demo Sitesi (http://ucretsiz.wordpresstema.com/test1) adresindeki iletişim formundan gönderildi.\";s:18:\"additional_headers\";s:22:\"Reply-To: [your-email]\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";b:0;s:13:\"exclude_blank\";b:0;}"),
("286","87","_mail_2","a:9:{s:6:\"active\";b:0;s:7:\"subject\";s:53:\"Ücretsiz Wordpress Tema Demo Sitesi \"[your-subject]\"\";s:6:\"sender\";s:75:\"Ücretsiz Wordpress Tema Demo Sitesi <wordpress@ucretsiz.wordpresstema.com>\";s:9:\"recipient\";s:12:\"[your-email]\";s:4:\"body\";s:172:\"İleti gövdesi:\n[your-message]\n\n-- \nBu e-posta, Ücretsiz Wordpress Tema Demo Sitesi (http://ucretsiz.wordpresstema.com/test1) adresindeki iletişim formundan gönderildi.\";s:18:\"additional_headers\";s:36:\"Reply-To: ucretsiz@wordpresstema.com\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";b:0;s:13:\"exclude_blank\";b:0;}"),
("287","87","_messages","a:23:{s:12:\"mail_sent_ok\";s:45:\"Mesajınız için teşekkürler. Gönderildi.\";s:12:\"mail_sent_ng\";s:79:\"Mesajınız gönderilirken bir hata oluştu. Lütfen daha sonra tekrar deneyin.\";s:16:\"validation_error\";s:80:\"Bir veya daha fazla alanda hata bulundu. Lütfen kontrol edin ve tekrar deneyin.\";s:4:\"spam\";s:79:\"Mesajınız gönderilirken bir hata oluştu. Lütfen daha sonra tekrar deneyin.\";s:12:\"accept_terms\";s:87:\"Mesajınızı göndermeden önce şartları ve koşulları kabul etmeniz gerekmektedir.\";s:16:\"invalid_required\";s:19:\"Bu alan zorunludur.\";s:16:\"invalid_too_long\";s:18:\"Bu alan çok uzun.\";s:17:\"invalid_too_short\";s:19:\"Bu alan çok kısa.\";s:12:\"invalid_date\";s:24:\"Yanlış tarih formatı.\";s:14:\"date_too_early\";s:36:\"Bu tarih izin verilenden daha önce.\";s:13:\"date_too_late\";s:36:\"Bu tarih izin verilenden daha sonra.\";s:13:\"upload_failed\";s:47:\"Dosya yüklenirken bilinmeyen bir hata oluştu.\";s:24:\"upload_file_type_invalid\";s:53:\"Bu dosya türünü yükleme iznine sahip değilsiniz.\";s:21:\"upload_file_too_large\";s:19:\"Dosya çok büyük.\";s:23:\"upload_failed_php_error\";s:38:\"Dosya yüklenirken hata meydana geldi.\";s:14:\"invalid_number\";s:25:\"Geçersiz numara biçimi.\";s:16:\"number_too_small\";s:41:\"Bu sayı minimum değerden daha küçük.\";s:16:\"number_too_large\";s:41:\"Bu sayı maksimum değerden daha büyük.\";s:23:\"quiz_answer_not_correct\";s:35:\"Soruya verilen cevap doğru değil.\";s:17:\"captcha_not_match\";s:30:\"Girdiğiniz kod doğru değil.\";s:13:\"invalid_email\";s:33:\"Girilen e-posta adresi geçersiz.\";s:11:\"invalid_url\";s:16:\"Geçersiz adres.\";s:11:\"invalid_tel\";s:28:\"Geçersiz telefon numarası.\";}"),
("288","87","_additional_settings",""),
("289","87","_locale","tr_TR"),
("290","88","_edit_last","1"),
("291","88","_edit_lock","1536018729:1"),
("292","88","_wp_page_template","page-templates/full-width.php"),
("293","90","_wp_attached_file","2018/09/F1.jpg"),
("294","90","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F1.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F1-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F1-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F1-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F1-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("295","91","_wp_attached_file","2018/09/F2.jpg"),
("296","91","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F2.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F2-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F2-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F2-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F2-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("297","92","_wp_attached_file","2018/09/F3.jpg"),
("298","92","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F3.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F3-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F3-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F3-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F3-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("299","93","_wp_attached_file","2018/09/F4.jpg"),
("300","93","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F4.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F4-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F4-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F4-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F4-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("301","94","_wp_attached_file","2018/09/F5.jpg"),
("302","94","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F5.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F5-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F5-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F5-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F5-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F5-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("303","95","_wp_attached_file","2018/09/F6.jpg"),
("304","95","_wp_attachment_metadata","a:5:{s:5:\"width\";i:625;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F6.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F6-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F6-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F6-1x1.jpg\";s:5:\"width\";i:1;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F6-625x300.jpg\";s:5:\"width\";i:625;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F6-625x400.jpg\";s:5:\"width\";i:625;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:20:\"Canon EOS 6D Mark II\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1507742659\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"27\";s:3:\"iso\";s:3:\"250\";s:13:\"shutter_speed\";s:8:\"0.003125\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("305","96","_wp_attached_file","2018/09/F7.jpg"),
("306","96","_wp_attachment_metadata","a:5:{s:5:\"width\";i:626;s:6:\"height\";i:417;s:4:\"file\";s:14:\"2018/09/F7.jpg\";s:5:\"sizes\";a:5:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"F7-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"F7-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}i:100;a:4:{s:4:\"file\";s:10:\"F7-2x1.jpg\";s:5:\"width\";i:2;s:6:\"height\";i:1;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"featured\";a:4:{s:4:\"file\";s:14:\"F7-626x300.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"recent\";a:4:{s:4:\"file\";s:14:\"F7-626x400.jpg\";s:5:\"width\";i:626;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:27:\"A happy beard man at office\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:27:\"A happy beard man at office\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:34:{i:0;s:5:\"adult\";i:1;s:2:\"be\";i:2;s:5:\"beard\";i:3;s:5:\"break\";i:4;s:8:\"business\";i:5;s:9:\"caucasian\";i:6;s:3:\"cc0\";i:7;s:5:\"chill\";i:8;s:13:\"communication\";i:9;s:7:\"company\";i:10;s:8:\"computer\";i:11;s:17:\"creative common 0\";i:12;s:18:\"creative commons 0\";i:13;s:8:\"forehead\";i:14;s:3:\"guy\";i:15;s:5:\"happy\";i:16;s:5:\"laugh\";i:17;s:3:\"man\";i:18;s:4:\"note\";i:19;s:6:\"office\";i:20;s:6:\"people\";i:21;s:6:\"person\";i:22;s:4:\"post\";i:23;s:5:\"relax\";i:24;s:3:\"sit\";i:25;s:14:\"small business\";i:26;s:7:\"smiling\";i:27;s:7:\"startup\";i:28;s:11:\"sticky note\";i:29;s:10:\"technology\";i:30;s:4:\"work\";i:31;s:12:\"work station\";i:32;s:9:\"workplace\";i:33;s:9:\"workspace\";}}}"),
("321","99","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("320","99","_menu_item_target",""),
("319","99","_menu_item_object","page"),
("318","99","_menu_item_object_id","88"),
("317","99","_menu_item_menu_item_parent","0"),
("316","99","_menu_item_type","post_type"),
("322","99","_menu_item_xfn",""),
("323","99","_menu_item_url",""),
("326","102","cf7_style_image_preview","/admin/images/monochrome-light.png"),
("327","103","cf7_style_image_preview","/admin/images/transparent-two-columns.png"),
("328","104","cf7_style_image_preview","/admin/images/minimal-brown.png"),
("329","105","cf7_style_image_preview","/admin/images/monochrome.png"),
("330","106","cf7_style_image_preview","/admin/images/cf7_simple_twentyfifteen_pattern.jpg"),
("331","107","cf7_style_image_preview","/admin/images/cf7_xmas_classic.jpg"),
("332","108","cf7_style_image_preview","/admin/images/cf7_xmas_red.jpg"),
("333","109","cf7_style_image_preview","/admin/images/cf7_xmas_simple.jpg"),
("334","110","cf7_style_image_preview","/admin/images/cf7_vday_classic.jpg"),
("335","111","cf7_style_image_preview","/admin/images/cf7_vday_roses.jpg"),
("336","112","cf7_style_image_preview","/admin/images/cf7_vday_birds.jpg"),
("337","113","cf7_style_image_preview","/admin/images/cf7_vday_blue_birds.jpg"),
("338","106","_edit_lock","1536019182:1"),
("339","87","wpcf7cf_options","a:0:{}"),
("340","87","cf7_style_id","106"),
("344","117","_edit_lock","1536019909:1"),
("343","117","_edit_last","1"),
("345","117","_thumbnail_id","96"),
("346","117","_colio_extra_photos","a:3:{i:0;i:94;i:1;i:93;i:2;i:96;}"),
("347","117","_colio_social_links","a:0:{}"),
("348","119","_edit_last","1"),
("349","119","_edit_lock","1536019970:1"),
("350","119","_thumbnail_id","93"),
("351","119","_colio_extra_photos","a:0:{}"),
("352","119","_colio_social_links","a:0:{}"),
("353","122","_edit_last","1"),
("354","122","_edit_lock","1536019999:1"),
("355","122","_thumbnail_id","94"),
("356","122","_colio_extra_photos","a:3:{i:0;i:95;i:1;i:91;i:2;i:92;}"),
("357","122","_colio_social_links","a:0:{}"),
("358","123","_edit_last","1"),
("359","123","_edit_lock","1536020109:1"),
("360","123","_thumbnail_id","79"),
("361","123","_colio_extra_photos","a:3:{i:0;i:73;i:1;i:78;i:2;i:91;}"),
("362","123","_colio_social_links","a:0:{}"),
("363","124","_edit_last","1"),
("364","124","_edit_lock","1536020083:1"),
("365","124","_thumbnail_id","78"),
("366","124","_colio_extra_photos","a:3:{i:0;i:92;i:1;i:90;i:2;i:86;}"),
("367","124","_colio_social_links","a:0:{}"),
("368","125","_edit_last","1"),
("369","125","_edit_lock","1536020210:1"),
("370","125","_thumbnail_id","91"),
("371","125","_colio_extra_photos","a:4:{i:0;i:93;i:1;i:73;i:2;i:94;i:3;i:95;}"),
("372","125","_colio_social_links","a:0:{}"),
("373","130","_edit_last","1"),
("374","130","_edit_lock","1536846282:1"),
("375","130","_thumbnail_id","96"),
("376","130","_wp_pap_gallery_id","a:6:{i:0;s:2:\"96\";i:1;s:2:\"93\";i:2;s:2:\"94\";i:3;s:2:\"95\";i:4;s:2:\"91\";i:5;s:2:\"92\";}"),
("377","130","_wp_pap_arrow_slider",""),
("378","130","_wp_pap_pagination_slider",""),
("379","130","_wp_pap_animation_slider","slide"),
("380","130","_wp_pap_project_url","http://www.wordprestema.com"),
("387","139","_wp_pap_arrow_slider",""),
("388","139","_wp_pap_pagination_slider",""),
("389","139","_wp_pap_animation_slider","slide"),
("390","139","_wp_pap_project_url","https://www.wordpresstema.com");


/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES 
("1","2","2018-09-04 02:31:19","2018-09-03 23:31:19","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Örnek Blog Yazısı","","publish","open","open","","ornek-blog-yazisi","","","2018-09-04 02:46:13","2018-09-03 23:46:13","","0","http://ucretsiz.wordpresstema.com/test1/?p=1","0","post","","0"),
("2","2","2018-09-04 01:45:19","2018-09-03 22:45:19","","ANA SAYFA","","publish","closed","open","","ana-sayfa","","","2018-09-04 01:55:56","2018-09-03 22:55:56","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=2","0","page","","0"),
("5","2","2018-09-04 01:55:56","2018-09-03 22:55:56","","ANA SAYFA","","inherit","closed","closed","","2-revision-v1","","","2018-09-04 01:55:56","2018-09-03 22:55:56","","2","http://ucretsiz.wordpresstema.com/test1/2018/09/04/2-revision-v1/","0","revision","","0"),
("7","2","2018-09-04 01:57:38","2018-09-03 22:57:38","","img1","","inherit","open","closed","","img1","","","2018-09-04 01:57:38","2018-09-03 22:57:38","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/img1.jpg","0","attachment","image/jpeg","0"),
("3","2","2018-09-04 01:45:19","2018-09-03 22:45:19","<h2>Biz kimiz</h2><p>Web sitemizin adresi: http://ucretsiz.wordpresstema.com/test1.</p><h2>Hangi kişisel bilgileri ne amaçla topluyoruz</h2><h3>Yorumlar</h3><p>Ziyaretçiler sitede yorum bıraktığında yorum formunda gösterilen verileri ve ayrıca istenmeyen yorum tespitine yardımcı olmak için ziyaretçinin IP adresi ve tarayıcı bilgisi metnini de toplarız.</p><p>E-posta adresinizden oluşturulmuş anonimleştirilmiş bir metin (hash olarak da adlandırılır) Gravatar hizmetine, servisi kullanıp kullanmadığınızı görmek için, sağlanabilir. Gravatar servisinin gizlilik politikası şu adrestedir: https://automattic.com/privacy/. Yorumunuzun onaylanmasından sonra profil resminiz yorumunuzla birlikte herkese görünür.</p><h3>Ortam</h3><p>Görselleri web sitesine yüklerseniz, gömülmüş konum verileri (EXIF GPS) içeren görseller yüklemekten kaçınmalısınız. Web sitesi ziyaretçileri, web sitesindeki görsellerden herhangi bir konum bilgisini indirip çıkarabilir.</p><h3>İletişim formları</h3><h3>Çerezler</h3><p>Sitemize bir yorum bırakırsanız, isminizi, e-posta adresinizi ve web sitenizi çerezlerde kaydetmeyi seçebilirsiniz. Bunlar size kolaylık sağlamak içindir, böylece başka bir yorum bıraktığınızda bilgilerinizi tekrar doldurmanız gerekmez. Bu çerezler bir yıl süresince kalır.</p><p>Bir hesabınız varsa ve bu siteye giriş yaparsanız, tarayıcınızın çerezleri kabul edip etmediğini belirlemek için geçici bir çerez ayarlayacağız. Bu çerez hiçbir kişisel veri içermez ve tarayıcınızı kapattığınızda atılır.</p><p>Giriş yaptığınızda, giriş bilgilerinizi ve ekran görüntüleme seçiminizi kaydetmek için birkaç çerez kaydedeceğiz. Giriş çerezleri iki gün ve ekran seçenekleri çerezleri bir yıl boyunca kalır. &quot;Beni hatırla&quot; seçeneğini seçereniz, girişiniz iki hafta boyunca devam eder. Hesabınızdan çıkış yaparsanız, giriş çerezleri kaldırılacaktır.</p><p>Bir makaleyi düzenler veya yayınlarsanız tarayıcınıza ek bir çerez kaydedilir. Bu çerez hiçbir kişisel veri içermez ve sadece düzenlediğiniz makalenin yazı kimliğini gösterir. 1 gün sonra zaman aşımına uğrar.</p><h3>Diğer sitelerden gömülen içerik</h3><p>Bu sitedeki makaleler gömülü içerik (ör. videolar, resimler, makaleler, vb.) Içerebilir. Diğer web sitelerinden gömülen içerik, ziyaretçinin diğer web sitesini ziyaret etmiş gibi, tam olarak aynı şekilde davranır.</p><p>Bu web siteleri sizin hakkınızda veri toplayabilir, çerez kullanabilir, üçüncü taraf tarafından gömülmüş şeklide takip yapabilir ve bir hesabınız varsa ve bu web sitesinde oturum açtıysanız, gömülen içerikle etkleşiminizi takip etme dahil olmak üzere, bu gömülen içerikle etkileşiminizi izleyebilir.</p><h3>Analiz</h3><h2>Verinizi kimlerle paylaşıyoruz</h2><h2>Verilerinizi ne kadar süre tutarız</h2><p>Bir yorum bırakırsanız, yorum ve meta verileri süresiz olarak saklanır. Böylece, takip eden yorumlarınızı denetim kuyruğunda tutmak yerine otomatik olarak tanıyabilir ve onaylayabiliriz.</p><p>Web sitemize kayıt yaptıran kullanıcılar için (varsa) kullanıcı profilinde sağladıkları kişisel bilgileri de saklarız. Tüm kullanıcılar kişisel bilgilerini istedikleri zaman görebilir, düzenleyebilir veya silebilir (kullanıcı adı değiştirme hariç). Web sitesi yöneticileri de bu bilgileri görebilir ve düzenleyebilir.</p><h2>Verileriniz üzerindeki haklarınız neler</h2><p>Bu sitede bir hesabınız veya yorumlarınız varsa, bize sağladığınız veriler dahil olmak üzere, hakkınızda tuttuğumuz kişisel verilerin dışa aktarılmış bir dosyasını almayı isteyebilirsiniz. Ayrıca, hakkınızda tuttuğumuz tüm kişisel verileri de silmeyi isteyebilirsiniz. Bu, idari, yasal veya güvenlik amaçlarına uymak zorunda olduğumuz hiçbir veriyi içermez.</p><h2>Verinizi nereye gönderiyoruz</h2><p>Ziyaretçi yorumları otomatik istenmeyen yorum algılama servisi aracılığıyla kontrol edilebilir.</p><h2>İletişim bilgileriniz</h2><h2>Ek bilgi</h2><h3>Verinizi nasıl koruyoruz</h3><h3>Hangi veri ihlali prosedürlerimiz var</h3><h3>Hangi üçüncü taraflardan veri alıyoruz</h3><h3>Kullanıcı verileriyle ne tip otomatik karar verme ve/veya profilleme yapıyoruz?</h3><h3>Sanayi bakanlığı kamuyu aydınlatma yükümlülüğü</h3>","Gizlilik politikası","","draft","closed","open","","gizlilik-politikasi","","","2018-09-04 01:45:19","2018-09-03 22:45:19","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=3","0","page","","0"),
("9","2","2018-09-04 02:00:41","2018-09-03 23:00:41","","Two senior business colleagues at meeting, close-up","Two senior business colleagues at meeting, close-up","inherit","open","closed","","two-senior-business-colleagues-at-meeting-close-up","","","2018-09-04 02:00:41","2018-09-03 23:00:41","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/img2.jpg","0","attachment","image/jpeg","0"),
("10","2","2018-09-04 02:01:56","2018-09-03 23:01:56","","orneklogo","","inherit","open","closed","","orneklogo","","","2018-09-04 02:01:56","2018-09-03 23:01:56","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/orneklogo.png","0","attachment","image/png","0"),
("12","2","2018-09-04 02:03:32","2018-09-03 23:03:32"," ","","","publish","closed","closed","","12","","","2018-09-04 02:55:24","2018-09-03 23:55:24","","0","http://ucretsiz.wordpresstema.com/test1/2018/09/04/12/","1","nav_menu_item","","0"),
("14","2","2018-09-04 02:04:33","2018-09-03 23:04:33","","LOGOSTICKY","","inherit","open","closed","","logosticky","","","2018-09-04 02:04:33","2018-09-03 23:04:33","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/LOGOSTICKY.png","0","attachment","image/png","0"),
("15","2","2018-09-04 02:04:44","2018-09-03 23:04:44","","vertical-logo-dark","","inherit","open","closed","","vertical-logo-dark","","","2018-09-04 02:04:44","2018-09-03 23:04:44","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/vertical-logo-dark.png","0","attachment","image/png","0"),
("16","2","2018-09-04 02:04:52","2018-09-03 23:04:52","","logor","","inherit","open","closed","","logor","","","2018-09-04 02:04:52","2018-09-03 23:04:52","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/logor.png","0","attachment","image/png","0"),
("17","2","2018-09-04 02:05:13","2018-09-03 23:05:13","","cropped-img1-e1536015506397.jpg","","inherit","open","closed","","cropped-img1-e1536015506397-jpg","","","2018-09-04 02:05:13","2018-09-03 23:05:13","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/cropped-img1-e1536015506397.jpg","0","attachment","image/jpeg","0"),
("139","2","2018-09-13 16:47:32","2018-09-13 13:47:32","Referans açıklaması","Referans 2","","publish","closed","closed","","referans-2","","","2018-09-13 16:47:32","2018-09-13 13:47:32","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=wpos_portfolio&#038;p=139","0","wpos_portfolio","","0"),
("18","2","2018-09-04 02:06:14","2018-09-03 23:06:14","","Spirit-of-Norfok-2016-Corporate-Cruise","","inherit","open","closed","","spirit-of-norfok-2016-corporate-cruise","","","2018-09-04 02:06:14","2018-09-03 23:06:14","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/Spirit-of-Norfok-2016-Corporate-Cruise.jpg","0","attachment","image/jpeg","0"),
("19","2","2018-09-04 02:06:17","2018-09-03 23:06:17","","cropped-Spirit-of-Norfok-2016-Corporate-Cruise.jpg","","inherit","open","closed","","cropped-spirit-of-norfok-2016-corporate-cruise-jpg","","","2018-09-04 02:06:17","2018-09-03 23:06:17","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/cropped-Spirit-of-Norfok-2016-Corporate-Cruise.jpg","0","attachment","image/jpeg","0"),
("20","2","2018-09-04 02:06:53","2018-09-03 23:06:53","","Corporate-Card-Page-Header-Final-1b-1024x350","","inherit","open","closed","","corporate-card-page-header-final-1b-1024x350","","","2018-09-04 02:06:53","2018-09-03 23:06:53","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/Corporate-Card-Page-Header-Final-1b-1024x350.png","0","attachment","image/png","0"),
("21","2","2018-09-04 02:06:58","2018-09-03 23:06:58","","cropped-Corporate-Card-Page-Header-Final-1b-1024x350.png","","inherit","open","closed","","cropped-corporate-card-page-header-final-1b-1024x350-png","","","2018-09-04 02:06:58","2018-09-03 23:06:58","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/cropped-Corporate-Card-Page-Header-Final-1b-1024x350.png","0","attachment","image/png","0"),
("22","2","2018-09-04 02:07:45","2018-09-03 23:07:45","","logojpg","","inherit","open","closed","","logojpg","","","2018-09-04 02:07:45","2018-09-03 23:07:45","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/logojpg.jpg","0","attachment","image/jpeg","0"),
("23","2","2018-09-04 02:09:58","2018-09-03 23:09:58","","elevator-turkey-01-44","","inherit","open","closed","","elevator-turkey-01-44","","","2018-09-04 02:10:39","2018-09-03 23:10:39","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/elevator-turkey-01-44.png","0","attachment","image/png","0"),
("26","2","2018-09-04 02:11:41","2018-09-03 23:11:41","<div>\r\n\r\n<a href=\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/1034.jpg\"><img class=\"aligncenter wp-image-41 size-large\" src=\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/1034-1024x536.jpg\" alt=\"\" width=\"654\" height=\"342\" data-attachment=\"41\" /></a>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","HAKKIMIZDA","","publish","closed","closed","","hakkimizda","","","2018-09-04 03:20:18","2018-09-04 00:20:18","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=26","0","page","","0"),
("27","2","2018-09-04 02:11:41","2018-09-03 23:11:41","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","HAKKIMIZDA","","inherit","closed","closed","","26-revision-v1","","","2018-09-04 02:11:41","2018-09-03 23:11:41","","26","http://ucretsiz.wordpresstema.com/test1/2018/09/04/26-revision-v1/","0","revision","","0"),
("28","2","2018-09-04 02:11:48","2018-09-03 23:11:48","<div></div>\r\n<div>\r\n\r\n[contact-form-7 id=\"87\" title=\"İletişim formu 1\"]\r\n\r\n</div>","İLETİŞİM","","publish","closed","closed","","iletisim","","","2018-09-04 03:02:57","2018-09-04 00:02:57","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=28","0","page","","0"),
("115","2","2018-09-04 03:02:57","2018-09-04 00:02:57","<div></div>\r\n<div>\r\n\r\n[contact-form-7 id=\"87\" title=\"İletişim formu 1\"]\r\n\r\n</div>","İLETİŞİM","","inherit","closed","closed","","28-revision-v1","","","2018-09-04 03:02:57","2018-09-04 00:02:57","","28","http://ucretsiz.wordpresstema.com/test1/2018/09/04/28-revision-v1/","0","revision","","0"),
("117","2","2018-09-04 03:12:51","2018-09-04 00:12:51","<div>\r\n\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>","Referans 1","","publish","closed","closed","","referans-1","","","2018-09-04 03:14:12","2018-09-04 00:14:12","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=colio_item&#038;p=117","0","colio_item","","0"),
("114","2","2018-09-04 03:02:41","2018-09-04 00:02:41","<div>\r\n\r\n[caption id=\"attachment_41\" align=\"alignnone\" width=\"2000\"]<img class=\"size-full wp-image-41\" src=\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/1034.jpg\" alt=\"\" width=\"2000\" height=\"1047\" /> Businessman standing with arms crossed in office[/caption]\r\n\r\n</div>\r\n<div>\r\n\r\n[contact-form-7 id=\"87\" title=\"İletişim formu 1\"]\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","İLETİŞİM","","inherit","closed","closed","","28-revision-v1","","","2018-09-04 03:02:41","2018-09-04 00:02:41","","28","http://ucretsiz.wordpresstema.com/test1/2018/09/04/28-revision-v1/","0","revision","","0"),
("100","2","2018-09-04 02:56:22","2018-09-03 23:56:22","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>[contact-form-7 id=\"87\" title=\"İletişim formu 1\"]</h2>\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","İLETİŞİM","","inherit","closed","closed","","28-revision-v1","","","2018-09-04 02:56:22","2018-09-03 23:56:22","","28","http://ucretsiz.wordpresstema.com/test1/2018/09/04/28-revision-v1/","0","revision","","0"),
("29","2","2018-09-04 02:11:48","2018-09-03 23:11:48","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","İLETİŞİM","","inherit","closed","closed","","28-revision-v1","","","2018-09-04 02:11:48","2018-09-03 23:11:48","","28","http://ucretsiz.wordpresstema.com/test1/2018/09/04/28-revision-v1/","0","revision","","0"),
("30","2","2018-09-04 02:12:28","2018-09-03 23:12:28","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","HİZMETLERİMİZ","","publish","closed","closed","","hizmetlerimiz","","","2018-09-04 02:12:28","2018-09-03 23:12:28","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=30","0","page","","0"),
("31","2","2018-09-04 02:12:28","2018-09-03 23:12:28","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","HİZMETLERİMİZ","","inherit","closed","closed","","30-revision-v1","","","2018-09-04 02:12:28","2018-09-03 23:12:28","","30","http://ucretsiz.wordpresstema.com/test1/2018/09/04/30-revision-v1/","0","revision","","0"),
("32","2","2018-09-04 02:12:36","2018-09-03 23:12:36","[pap_portfolio]","REFERANSLARIMIZ","","publish","closed","closed","","referanslarimiz","","","2018-09-06 16:56:52","2018-09-06 13:56:52","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=32","0","page","","0"),
("121","2","2018-09-04 03:14:45","2018-09-04 00:14:45","[colio id=\"referanslar\"]","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-04 03:14:45","2018-09-04 00:14:45","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/04/32-revision-v1/","0","revision","","0"),
("123","2","2018-09-04 03:16:29","2018-09-04 00:16:29","Lorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500’lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960’larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.","Referans 4","","publish","closed","closed","","referans-4","","","2018-09-04 03:17:17","2018-09-04 00:17:17","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=colio_item&#038;p=123","0","colio_item","","0"),
("124","2","2018-09-04 03:16:51","2018-09-04 00:16:51","Lorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500’lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960’larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.","Referans 5","","publish","closed","closed","","referans-5","","","2018-09-04 03:16:51","2018-09-04 00:16:51","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=colio_item&#038;p=124","0","colio_item","","0"),
("125","2","2018-09-04 03:17:50","2018-09-04 00:17:50","Lorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500’lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960’larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.","Referans 6","","publish","closed","closed","","referans-6","","","2018-09-04 03:17:50","2018-09-04 00:17:50","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=colio_item&#038;p=125","0","colio_item","","0"),
("33","2","2018-09-04 02:12:36","2018-09-03 23:12:36","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-04 02:12:36","2018-09-03 23:12:36","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/04/32-revision-v1/","0","revision","","0"),
("34","2","2018-09-04 02:12:50","2018-09-03 23:12:50"," ","","","publish","closed","closed","","34","","","2018-09-04 02:55:24","2018-09-03 23:55:24","","0","http://ucretsiz.wordpresstema.com/test1/?p=34","3","nav_menu_item","","0"),
("35","2","2018-09-04 02:12:50","2018-09-03 23:12:50"," ","","","publish","closed","closed","","35","","","2018-09-04 02:55:24","2018-09-03 23:55:24","","0","http://ucretsiz.wordpresstema.com/test1/?p=35","4","nav_menu_item","","0"),
("36","2","2018-09-04 02:12:50","2018-09-03 23:12:50"," ","","","publish","closed","closed","","36","","","2018-09-04 02:55:24","2018-09-03 23:55:24","","0","http://ucretsiz.wordpresstema.com/test1/?p=36","6","nav_menu_item","","0"),
("37","2","2018-09-04 02:12:50","2018-09-03 23:12:50"," ","","","publish","closed","closed","","37","","","2018-09-04 02:55:24","2018-09-03 23:55:24","","0","http://ucretsiz.wordpresstema.com/test1/?p=37","2","nav_menu_item","","0"),
("41","2","2018-09-04 02:18:01","2018-09-03 23:18:01","","Businessman standing with arms crossed in office","Businessman standing with arms crossed in office","inherit","open","closed","","businessman-standing-with-arms-crossed-in-office","","","2018-09-04 03:02:38","2018-09-04 00:02:38","","28","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/1034.jpg","0","attachment","image/jpeg","0"),
("42","2","2018-09-04 02:18:05","2018-09-03 23:18:05","","cropped-1034.jpg","","inherit","open","closed","","cropped-1034-jpg","","","2018-09-04 02:18:05","2018-09-03 23:18:05","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/cropped-1034.jpg","0","attachment","image/jpeg","0"),
("45","2","2018-09-04 02:18:44","2018-09-03 23:18:44","","LOGORR","","inherit","open","closed","","logorr","","","2018-09-04 02:18:44","2018-09-03 23:18:44","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/LOGORR.png","0","attachment","image/png","0"),
("46","2","2018-09-04 02:19:05","2018-09-03 23:19:05","","robrady-r-icon","","inherit","open","closed","","robrady-r-icon","","","2018-09-04 02:19:05","2018-09-03 23:19:05","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/robrady-r-icon.jpg","0","attachment","image/jpeg","0"),
("47","2","2018-09-04 02:19:20","2018-09-03 23:19:20","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/cropped-robrady-r-icon.jpg","cropped-robrady-r-icon.jpg","","inherit","open","closed","","cropped-robrady-r-icon-jpg","","","2018-09-04 02:19:20","2018-09-03 23:19:20","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/cropped-robrady-r-icon.jpg","0","attachment","image/jpeg","0"),
("49","2","2018-09-04 02:21:42","2018-09-03 23:21:42","","800px_COLOURBOX22078175","","inherit","open","closed","","800px_colourbox22078175","","","2018-09-04 02:21:42","2018-09-03 23:21:42","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/800px_COLOURBOX22078175.jpg","0","attachment","image/jpeg","0"),
("51","2","2018-09-04 02:23:51","2018-09-03 23:23:51","","602","","inherit","open","closed","","602","","","2018-09-04 02:23:51","2018-09-03 23:23:51","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/602.jpg","0","attachment","image/jpeg","0"),
("53","2","2018-09-04 02:26:38","2018-09-03 23:26:38","","hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631","","inherit","open","closed","","hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631","","","2018-09-04 02:26:38","2018-09-03 23:26:38","","0","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/hexagon-tile-background-hexagon-tile-background-free-hexagon-pattern-02-by-black-light-studio-on-deviantart-1092x631.png","0","attachment","image/png","0"),
("57","2","2018-09-04 02:29:13","2018-09-03 23:29:13"," ","","","publish","closed","closed","","57","","","2018-09-04 02:55:16","2018-09-03 23:55:16","","0","http://ucretsiz.wordpresstema.com/test1/?p=57","1","nav_menu_item","","0"),
("58","2","2018-09-04 02:29:13","2018-09-03 23:29:13"," ","","","publish","closed","closed","","58","","","2018-09-04 02:55:16","2018-09-03 23:55:16","","0","http://ucretsiz.wordpresstema.com/test1/?p=58","3","nav_menu_item","","0"),
("59","2","2018-09-04 02:29:13","2018-09-03 23:29:13"," ","","","publish","closed","closed","","59","","","2018-09-04 02:55:16","2018-09-03 23:55:16","","0","http://ucretsiz.wordpresstema.com/test1/?p=59","4","nav_menu_item","","0"),
("60","2","2018-09-04 02:29:13","2018-09-03 23:29:13"," ","","","publish","closed","closed","","60","","","2018-09-04 02:55:16","2018-09-03 23:55:16","","0","http://ucretsiz.wordpresstema.com/test1/?p=60","2","nav_menu_item","","0"),
("64","2","2018-09-04 02:30:56","2018-09-03 23:30:56","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Pazardaki Büyüme Rakamları","","publish","open","open","","pazardaki-buyume-rakamlari","","","2018-09-04 02:32:51","2018-09-03 23:32:51","","0","http://ucretsiz.wordpresstema.com/test1/?p=64","0","post","","0"),
("65","2","2018-09-04 02:30:56","2018-09-03 23:30:56","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Pazardaki Büyüme Rakamları","","inherit","closed","closed","","64-revision-v1","","","2018-09-04 02:30:56","2018-09-03 23:30:56","","64","http://ucretsiz.wordpresstema.com/test1/2018/09/04/64-revision-v1/","0","revision","","0"),
("66","2","2018-09-02 02:33:56","2018-09-01 23:33:56","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Arge Çalışmaları ve İnovasyon Duyurusu","","publish","open","open","","arge-calismalari-ve-inovasyon-duyurusu","","","2018-09-04 02:43:59","2018-09-03 23:43:59","","0","http://ucretsiz.wordpresstema.com/test1/?p=66","0","post","","0"),
("67","2","2018-09-04 02:33:56","2018-09-03 23:33:56","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Arge Çalışmaları ve İnovasyon Duyurusu","","inherit","closed","closed","","66-revision-v1","","","2018-09-04 02:33:56","2018-09-03 23:33:56","","66","http://ucretsiz.wordpresstema.com/test1/2018/09/04/66-revision-v1/","0","revision","","0"),
("70","2","2018-09-04 02:38:31","2018-09-03 23:38:31","","handsome young successful man doing a welcome gesture","handsome young successful man doing a welcome gesture","inherit","open","closed","","handsome-young-successful-man-doing-a-welcome-gesture","","","2018-09-04 02:38:31","2018-09-03 23:38:31","","66","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/OBC8CU0.jpg","0","attachment","image/jpeg","0"),
("71","2","2018-09-04 02:39:33","2018-09-03 23:39:33","","slayt2","","inherit","open","closed","","slayt2","","","2018-09-04 02:39:33","2018-09-03 23:39:33","","66","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/slayt2.jpg","0","attachment","image/jpeg","0"),
("72","2","2018-09-03 02:43:25","2018-09-02 23:43:25","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Ekip Çalışması ve Başarı","","publish","open","open","","ekip-calismasi-ve-basari","","","2018-09-04 02:43:44","2018-09-03 23:43:44","","0","http://ucretsiz.wordpresstema.com/test1/?p=72","0","post","","0"),
("73","2","2018-09-04 02:43:23","2018-09-03 23:43:23","","slayt2","","inherit","open","closed","","slayt2-2","","","2018-09-04 02:43:23","2018-09-03 23:43:23","","72","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/slayt2-1.jpg","0","attachment","image/jpeg","0"),
("74","2","2018-09-04 02:43:25","2018-09-03 23:43:25","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Ekip Çalışması ve Başarı","","inherit","closed","closed","","72-revision-v1","","","2018-09-04 02:43:25","2018-09-03 23:43:25","","72","http://ucretsiz.wordpresstema.com/test1/2018/09/04/72-revision-v1/","0","revision","","0"),
("75","2","2018-09-04 02:44:32","2018-09-03 23:44:32","WordPress&#8217;e hoş geldiniz. Bu sizin ilk yazınız. Bu yazıyı düzenleyin ya da silin. Sonra yazmaya başlayın!","Örnek Blog Yazısı","","inherit","closed","closed","","1-revision-v1","","","2018-09-04 02:44:32","2018-09-03 23:44:32","","1","http://ucretsiz.wordpresstema.com/test1/2018/09/04/1-revision-v1/","0","revision","","0"),
("76","2","2018-09-04 02:46:13","2018-09-03 23:46:13","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Örnek Blog Yazısı","","inherit","closed","closed","","1-revision-v1","","","2018-09-04 02:46:13","2018-09-03 23:46:13","","1","http://ucretsiz.wordpresstema.com/test1/2018/09/04/1-revision-v1/","0","revision","","0"),
("77","2","2018-09-04 02:47:43","2018-09-03 23:47:43","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Blog Yazısı Örneği","","publish","open","open","","blog-yazisi-ornegi","","","2018-09-04 02:47:43","2018-09-03 23:47:43","","0","http://ucretsiz.wordpresstema.com/test1/?p=77","0","post","","0"),
("78","2","2018-09-04 02:47:40","2018-09-03 23:47:40","","ornek1","","inherit","open","closed","","ornek1","","","2018-09-04 02:47:40","2018-09-03 23:47:40","","77","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/ornek1.jpg","0","attachment","image/jpeg","0"),
("79","2","2018-09-04 02:47:41","2018-09-03 23:47:41","","ornek2","","inherit","open","closed","","ornek2","","","2018-09-04 02:47:41","2018-09-03 23:47:41","","77","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/ornek2.jpg","0","attachment","image/jpeg","0"),
("80","2","2018-09-04 02:47:41","2018-09-03 23:47:41","","ornek3","","inherit","open","closed","","ornek3","","","2018-09-04 02:47:41","2018-09-03 23:47:41","","77","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/ornek3.jpg","0","attachment","image/jpeg","0"),
("81","2","2018-09-04 02:47:43","2018-09-03 23:47:43","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Blog Yazısı Örneği","","inherit","closed","closed","","77-revision-v1","","","2018-09-04 02:47:43","2018-09-03 23:47:43","","77","http://ucretsiz.wordpresstema.com/test1/2018/09/04/77-revision-v1/","0","revision","","0"),
("82","2","2018-09-04 02:48:10","2018-09-03 23:48:10","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Bizden Haberler Blogu","","publish","open","open","","bizden-haberler-blogu","","","2018-09-04 02:48:10","2018-09-03 23:48:10","","0","http://ucretsiz.wordpresstema.com/test1/?p=82","0","post","","0"),
("83","2","2018-09-04 02:48:10","2018-09-03 23:48:10","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Bizden Haberler Blogu","","inherit","closed","closed","","82-revision-v1","","","2018-09-04 02:48:10","2018-09-03 23:48:10","","82","http://ucretsiz.wordpresstema.com/test1/2018/09/04/82-revision-v1/","0","revision","","0"),
("84","2","2018-09-04 02:48:32","2018-09-03 23:48:32","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Blog yazısı örneği","","publish","open","open","","blog-yazisi-ornegi-2","","","2018-09-04 02:49:16","2018-09-03 23:49:16","","0","http://ucretsiz.wordpresstema.com/test1/?p=84","0","post","","0"),
("85","2","2018-09-04 02:48:32","2018-09-03 23:48:32","Lorem Ipsum Nedir?\r\nLorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\nNeden Kullanırız?\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n\r\nNereden Gelir?\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.","Blog yazısı örneği","","inherit","closed","closed","","84-revision-v1","","","2018-09-04 02:48:32","2018-09-03 23:48:32","","84","http://ucretsiz.wordpresstema.com/test1/2018/09/04/84-revision-v1/","0","revision","","0"),
("86","2","2018-09-04 02:49:13","2018-09-03 23:49:13","","ornekk","","inherit","open","closed","","ornekk","","","2018-09-04 02:49:13","2018-09-03 23:49:13","","84","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/ornekk.jpg","0","attachment","image/jpeg","0"),
("87","2","2018-09-04 02:50:12","2018-09-03 23:50:12","<label> Adınız (gerekli)\r\n    [text* your-name] </label>\r\n\r\n<label> E-posta adresiniz (gerekli)\r\n    [email* your-email] </label>\r\n\r\n<label> Konu\r\n    [text your-subject] </label>\r\n\r\n<label> İletiniz\r\n    [textarea your-message] </label>\r\n\r\n[submit \"Gönder\"]\n1\nÜcretsiz Wordpress Tema Demo Sitesi \"[your-subject]\"\n[your-name] <wordpress@ucretsiz.wordpresstema.com>\nucretsiz@wordpresstema.com\nKimden: [your-name] <[your-email]>\r\nKonu: [your-subject]\r\n\r\nİleti gövdesi:\r\n[your-message]\r\n\r\n-- \r\nBu e-posta, Ücretsiz Wordpress Tema Demo Sitesi (http://ucretsiz.wordpresstema.com/test1) adresindeki iletişim formundan gönderildi.\nReply-To: [your-email]\n\n\n\n\nÜcretsiz Wordpress Tema Demo Sitesi \"[your-subject]\"\nÜcretsiz Wordpress Tema Demo Sitesi <wordpress@ucretsiz.wordpresstema.com>\n[your-email]\nİleti gövdesi:\r\n[your-message]\r\n\r\n-- \r\nBu e-posta, Ücretsiz Wordpress Tema Demo Sitesi (http://ucretsiz.wordpresstema.com/test1) adresindeki iletişim formundan gönderildi.\nReply-To: ucretsiz@wordpresstema.com\n\n\n\nMesajınız için teşekkürler. Gönderildi.\nMesajınız gönderilirken bir hata oluştu. Lütfen daha sonra tekrar deneyin.\nBir veya daha fazla alanda hata bulundu. Lütfen kontrol edin ve tekrar deneyin.\nMesajınız gönderilirken bir hata oluştu. Lütfen daha sonra tekrar deneyin.\nMesajınızı göndermeden önce şartları ve koşulları kabul etmeniz gerekmektedir.\nBu alan zorunludur.\nBu alan çok uzun.\nBu alan çok kısa.\nYanlış tarih formatı.\nBu tarih izin verilenden daha önce.\nBu tarih izin verilenden daha sonra.\nDosya yüklenirken bilinmeyen bir hata oluştu.\nBu dosya türünü yükleme iznine sahip değilsiniz.\nDosya çok büyük.\nDosya yüklenirken hata meydana geldi.\nGeçersiz numara biçimi.\nBu sayı minimum değerden daha küçük.\nBu sayı maksimum değerden daha büyük.\nSoruya verilen cevap doğru değil.\nGirdiğiniz kod doğru değil.\nGirilen e-posta adresi geçersiz.\nGeçersiz adres.\nGeçersiz telefon numarası.","İletişim formu 1","","publish","closed","closed","","iletisim-formu-1","","","2018-09-04 03:02:04","2018-09-04 00:02:04","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=wpcf7_contact_form&#038;p=87","0","wpcf7_contact_form","","0"),
("88","2","2018-09-04 02:51:57","2018-09-03 23:51:57","[gallery columns=\"5\" link=\"file\" size=\"medium\" ids=\"86,79,78,90,91,92,93,94,95,96\"]","FOTO GALERİ","","publish","closed","closed","","foto-galeri","","","2018-09-04 02:54:17","2018-09-03 23:54:17","","0","http://ucretsiz.wordpresstema.com/test1/?page_id=88","0","page","","0"),
("89","2","2018-09-04 02:51:57","2018-09-03 23:51:57","[gallery columns=\"5\" link=\"file\" size=\"medium\" ids=\"86,79,78,73,80\"]","FOTO GALERİ","","inherit","closed","closed","","88-revision-v1","","","2018-09-04 02:51:57","2018-09-03 23:51:57","","88","http://ucretsiz.wordpresstema.com/test1/2018/09/04/88-revision-v1/","0","revision","","0"),
("90","2","2018-09-04 02:53:34","2018-09-03 23:53:34","","F1","","inherit","open","closed","","f1","","","2018-09-04 02:53:34","2018-09-03 23:53:34","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F1.jpg","0","attachment","image/jpeg","0"),
("91","2","2018-09-04 02:53:35","2018-09-03 23:53:35","","F2","","inherit","open","closed","","f2","","","2018-09-04 02:53:35","2018-09-03 23:53:35","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F2.jpg","0","attachment","image/jpeg","0"),
("92","2","2018-09-04 02:53:35","2018-09-03 23:53:35","","F3","","inherit","open","closed","","f3","","","2018-09-04 02:53:35","2018-09-03 23:53:35","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F3.jpg","0","attachment","image/jpeg","0"),
("93","2","2018-09-04 02:53:36","2018-09-03 23:53:36","","F4","","inherit","open","closed","","f4","","","2018-09-04 02:53:36","2018-09-03 23:53:36","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F4.jpg","0","attachment","image/jpeg","0"),
("94","2","2018-09-04 02:53:36","2018-09-03 23:53:36","","F5","","inherit","open","closed","","f5","","","2018-09-04 02:53:36","2018-09-03 23:53:36","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F5.jpg","0","attachment","image/jpeg","0"),
("95","2","2018-09-04 02:53:36","2018-09-03 23:53:36","","F6","","inherit","open","closed","","f6","","","2018-09-04 02:53:36","2018-09-03 23:53:36","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F6.jpg","0","attachment","image/jpeg","0"),
("96","2","2018-09-04 02:54:12","2018-09-03 23:54:12","","A happy beard man at office","","inherit","open","closed","","a-happy-beard-man-at-office","","","2018-09-04 03:19:46","2018-09-04 00:19:46","","88","http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/F7.jpg","0","attachment","image/jpeg","0"),
("97","2","2018-09-04 02:54:17","2018-09-03 23:54:17","[gallery columns=\"5\" link=\"file\" size=\"medium\" ids=\"86,79,78,90,91,92,93,94,95,96\"]","FOTO GALERİ","","inherit","closed","closed","","88-revision-v1","","","2018-09-04 02:54:17","2018-09-03 23:54:17","","88","http://ucretsiz.wordpresstema.com/test1/2018/09/04/88-revision-v1/","0","revision","","0"),
("99","2","2018-09-04 02:55:24","2018-09-03 23:55:24"," ","","","publish","closed","closed","","99","","","2018-09-04 02:55:24","2018-09-03 23:55:24","","0","http://ucretsiz.wordpresstema.com/test1/?p=99","5","nav_menu_item","","0"),
("101","2","2018-09-04 02:56:36","2018-09-03 23:56:36","<div>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n\r\n[contact-form-7 id=\"87\" title=\"İletişim formu 1\"]\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","İLETİŞİM","","inherit","closed","closed","","28-revision-v1","","","2018-09-04 02:56:36","2018-09-03 23:56:36","","28","http://ucretsiz.wordpresstema.com/test1/2018/09/04/28-revision-v1/","0","revision","","0"),
("102","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Monochrome Light","","publish","closed","closed","","monochrome-light","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/monochrome-light/","0","cf7_style","","0"),
("103","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Transparent Two Columns","","publish","closed","closed","","transparent-two-columns","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/transparent-two-columns/","0","cf7_style","","0"),
("104","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Minimal Brown","","publish","closed","closed","","minimal-brown","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/minimal-brown/","0","cf7_style","","0"),
("105","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Monochrome","","publish","closed","closed","","monochrome","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/monochrome/","0","cf7_style","","0"),
("106","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Twenty Fifteen Pattern","","publish","closed","closed","","twenty-fifteen-pattern","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/twenty-fifteen-pattern/","0","cf7_style","","0"),
("107","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Christmas Classic","","publish","closed","closed","","christmas-classic","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/christmas-classic/","0","cf7_style","","0"),
("108","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Christmas Red","","publish","closed","closed","","christmas-red","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/christmas-red/","0","cf7_style","","0"),
("109","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Christmas Simple","","publish","closed","closed","","christmas-simple","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/christmas-simple/","0","cf7_style","","0"),
("110","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Valentine\'s Day Classic","","publish","closed","closed","","valentines-day-classic","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/valentines-day-classic/","0","cf7_style","","0"),
("111","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Valentine\'s Day Roses","","publish","closed","closed","","valentines-day-roses","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/valentines-day-roses/","0","cf7_style","","0"),
("112","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Valentine\'s Day Birds","","publish","closed","closed","","valentines-day-birds","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/valentines-day-birds/","0","cf7_style","","0"),
("113","2","2018-09-04 03:01:21","2018-09-04 00:01:21","","Valentine\'s Day Blue Birds","","publish","closed","closed","","valentines-day-blue-birds","","","2018-09-04 03:01:21","2018-09-04 00:01:21","","0","http://ucretsiz.wordpresstema.com/test1/cf7_style/valentines-day-blue-birds/","0","cf7_style","","0"),
("119","2","2018-09-04 03:15:01","2018-09-04 00:15:01","<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500’lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960’larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.","Referans 2","","publish","closed","closed","","referans-2","","","2018-09-04 03:15:01","2018-09-04 00:15:01","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=colio_item&#038;p=119","0","colio_item","","0"),
("122","2","2018-09-04 03:15:32","2018-09-04 00:15:32","Lorem Ipsum, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500’lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960’larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.","Referans 3","","publish","closed","closed","","referans-3","","","2018-09-04 03:15:32","2018-09-04 00:15:32","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=colio_item&#038;p=122","0","colio_item","","0"),
("120","2","2018-09-04 03:14:35","2018-09-04 00:14:35","<div>\r\n<h2>[colio id=\"referanslar\"]</h2>\r\n</div>\r\n<div>\r\n\r\nedir.\r\n\r\n</div>","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-04 03:14:35","2018-09-04 00:14:35","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/04/32-revision-v1/","0","revision","","0"),
("118","2","2018-09-04 03:13:41","2018-09-04 00:13:41","<div>\r\n<h2>[colio id=\"referanslar\"]</h2>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-04 03:13:41","2018-09-04 00:13:41","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/04/32-revision-v1/","0","revision","","0"),
("126","2","2018-09-04 03:18:23","2018-09-04 00:18:23","<div>\r\n\r\n<a href=\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/1034.jpg\"><img class=\"aligncenter wp-image-41 size-large\" src=\"http://ucretsiz.wordpresstema.com/test1/wp-content/uploads/2018/09/1034-1024x536.jpg\" alt=\"\" width=\"654\" height=\"342\" data-attachment=\"41\" /></a>\r\n<h2>Lorem Ipsum Nedir?</h2>\r\n<strong>Lorem Ipsum</strong>, dizgi ve baskı endüstrisinde kullanılan mıgır metinlerdir. Lorem Ipsum, adı bilinmeyen bir matbaacının bir hurufat numune kitabı oluşturmak üzere bir yazı galerisini alarak karıştırdığı 1500\'lerden beri endüstri standardı sahte metinler olarak kullanılmıştır. Beşyüz yıl boyunca varlığını sürdürmekle kalmamış, aynı zamanda pek değişmeden elektronik dizgiye de sıçramıştır. 1960\'larda Lorem Ipsum pasajları da içeren Letraset yapraklarının yayınlanması ile ve yakın zamanda Aldus PageMaker gibi Lorem Ipsum sürümleri içeren masaüstü yayıncılık yazılımları ile popüler olmuştur.\r\n\r\n</div>\r\n<div>\r\n<h2>Neden Kullanırız?</h2>\r\nYinelenen bir sayfa içeriğinin okuyucunun dikkatini dağıttığı bilinen bir gerçektir. Lorem Ipsum kullanmanın amacı, sürekli \'buraya metin gelecek, buraya metin gelecek\' yazmaya kıyasla daha dengeli bir harf dağılımı sağlayarak okunurluğu artırmasıdır. Şu anda birçok masaüstü yayıncılık paketi ve web sayfa düzenleyicisi, varsayılan mıgır metinler olarak Lorem Ipsum kullanmaktadır. Ayrıca arama motorlarında \'lorem ipsum\' anahtar sözcükleri ile arama yapıldığında henüz tasarım aşamasında olan çok sayıda site listelenir. Yıllar içinde, bazen kazara, bazen bilinçli olarak (örneğin mizah katılarak), çeşitli sürümleri geliştirilmiştir.\r\n\r\n</div>\r\n&nbsp;\r\n<div>\r\n<h2>Nereden Gelir?</h2>\r\nYaygın inancın tersine, Lorem Ipsum rastgele sözcüklerden oluşmaz. Kökleri M.Ö. 45 tarihinden bu yana klasik Latin edebiyatına kadar uzanan 2000 yıllık bir geçmişi vardır. Virginia\'daki Hampden-Sydney College\'dan Latince profesörü Richard McClintock, bir Lorem Ipsum pasajında geçen ve anlaşılması en güç sözcüklerden biri olan \'consectetur\' sözcüğünün klasik edebiyattaki örneklerini incelediğinde kesin bir kaynağa ulaşmıştır. Lorm Ipsum, Çiçero tarafından M.Ö. 45 tarihinde kaleme alınan \"de Finibus Bonorum et Malorum\" (İyi ve Kötünün Uç Sınırları) eserinin 1.10.32 ve 1.10.33 sayılı bölümlerinden gelmektedir. Bu kitap, ahlak kuramı üzerine bir tezdir ve Rönesans döneminde çok popüler olmuştur. Lorem Ipsum pasajının ilk satırı olan \"Lorem ipsum dolor sit amet\" 1.10.32 sayılı bölümdeki bir satırdan gelmektedir.\r\n\r\n</div>","HAKKIMIZDA","","inherit","closed","closed","","26-revision-v1","","","2018-09-04 03:18:23","2018-09-04 00:18:23","","26","http://ucretsiz.wordpresstema.com/test1/2018/09/04/26-revision-v1/","0","revision","","0"),
("127","2","2018-09-06 16:11:33","2018-09-06 13:11:33","[gkit id=1]	","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-06 16:11:33","2018-09-06 13:11:33","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/06/32-revision-v1/","0","revision","","0"),
("128","2","2018-09-06 16:51:07","2018-09-06 13:51:07","[gkit id=1]	\r\n\r\n[gkit id=2]	","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-06 16:51:07","2018-09-06 13:51:07","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/06/32-revision-v1/","0","revision","","0"),
("129","2","2018-09-06 16:51:16","2018-09-06 13:51:16","[gkit id=2]	","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-06 16:51:16","2018-09-06 13:51:16","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/06/32-revision-v1/","0","revision","","0"),
("130","2","2018-09-06 16:56:39","2018-09-06 13:56:39","dasfdsdfvdfgvdfg","Referans 1","","publish","closed","closed","","referans-1","","","2018-09-06 16:56:39","2018-09-06 13:56:39","","0","http://ucretsiz.wordpresstema.com/test1/?post_type=wpos_portfolio&#038;p=130","0","wpos_portfolio","","0"),
("131","2","2018-09-06 16:56:52","2018-09-06 13:56:52","[pap_portfolio]","REFERANSLARIMIZ","","inherit","closed","closed","","32-revision-v1","","","2018-09-06 16:56:52","2018-09-06 13:56:52","","32","http://ucretsiz.wordpresstema.com/test1/2018/09/06/32-revision-v1/","0","revision","","0"),
("144","2","2020-05-11 04:57:00","0000-00-00 00:00:00","","Otomatik taslak","","auto-draft","open","open","","","","","2020-05-11 04:57:00","0000-00-00 00:00:00","","0","http://ucretsiz.wordpresstema.com/test1/?p=144","0","post","","0"),
("145","2","2020-05-11 05:01:56","0000-00-00 00:00:00","","Otomatik taslak","","auto-draft","open","open","","","","","2020-05-11 05:01:56","0000-00-00 00:00:00","","0","http://ucretsiz.wordpresstema.com/test1/?p=145","0","post","","0");


/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES 
("1","1","0"),
("12","2","0"),
("37","2","0"),
("34","2","0"),
("35","2","0"),
("36","2","0"),
("57","3","0"),
("58","3","0"),
("59","3","0"),
("60","3","0"),
("64","1","0"),
("64","4","0"),
("64","5","0"),
("64","6","0"),
("64","7","0"),
("77","1","0"),
("66","7","0"),
("72","7","0"),
("82","1","0"),
("84","1","0"),
("99","2","0"),
("117","12","0"),
("102","9","0"),
("103","9","0"),
("104","9","0"),
("105","9","0"),
("106","9","0"),
("107","10","0"),
("108","10","0"),
("109","10","0"),
("110","11","0"),
("111","11","0"),
("112","11","0"),
("113","11","0"),
("119","12","0"),
("122","12","0"),
("123","12","0"),
("124","12","0"),
("125","12","0"),
("130","13","0"),
("139","13","0");


/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES 
("1","1","category","","0","5"),
("2","2","nav_menu","","0","6"),
("3","3","nav_menu","","0","4"),
("4","4","post_tag","","0","1"),
("5","5","post_tag","","0","1"),
("6","6","post_tag","","0","1"),
("7","7","category","","0","3"),
("8","8","style_category","","0","0"),
("9","9","style_category","","0","5"),
("10","10","style_category","","0","3"),
("11","11","style_category","","0","4"),
("12","12","colio_group","","0","6"),
("13","13","wppap_portfolio_cat","","0","2");


/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES 
("1","Blog","blog","0"),
("2","ANA MENÜ","ana-menu","0"),
("3","Footer Menü","footer-menu","0"),
("4","pazar","pazar","0"),
("5","büyüme","buyume","0"),
("6","firma","firma","0"),
("7","Ana Sayfa Slayt","ana-sayfa","0"),
("8","custom style","custom-style","0"),
("9","simple pattern style","simple-pattern-style","0"),
("10","christmas style","christmas-style","0"),
("11","valentine\'s day style","valentines-day-style","0"),
("12","Referanslar","referanslar","0"),
("13","Referanslar","referanslar","0");


/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES 
("32","2","nickname","wordpresstema"),
("33","2","first_name",""),
("34","2","last_name",""),
("35","2","description",""),
("36","2","rich_editing","true"),
("37","2","syntax_highlighting","true"),
("38","2","comment_shortcuts","false"),
("39","2","admin_color","fresh"),
("40","2","use_ssl","0"),
("41","2","show_admin_bar_front","true"),
("42","2","locale",""),
("43","2","wp_capabilities","a:1:{s:13:\"administrator\";b:1;}"),
("44","2","wp_user_level","10"),
("45","2","dismissed_wp_pointers",""),
("46","2","alternate_image",""),
("47","2","google_profile",""),
("48","2","twitter_profile",""),
("49","2","facebook_profile",""),
("50","2","linkedin_profile",""),
("51","2","session_tokens","a:1:{s:64:\"bf009f24cf22a31d430222f726721639d2dd8ea29c1df341fe2d24296324cd5c\";a:4:{s:10:\"expiration\";i:1589335311;s:2:\"ip\";s:13:\"77.111.247.62\";s:2:\"ua\";s:132:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.129 Safari/537.36 OPR/68.0.3618.63\";s:5:\"login\";i:1589162511;}}"),
("52","2","wp_dashboard_quick_press_last_post_id","145"),
("53","2","community-events-location","a:1:{s:2:\"ip\";s:12:\"77.111.247.0\";}"),
("54","2","duplicator_pro_created_format","1");


/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES 
("2","wordpresstema","$P$BgAFSNNy2ZQrOZAknX4sl8PAC2GCf6/","wordpresstema","wordpresstema@wordpresstema.com","","2020-05-11 01:58:11","1589162291:$P$B.ImkLNI6U7zhyHgDjJkNZ4987T20S0","0","wordpresstema");


 /* SQL Chunk Footer Index 1 */ 

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2020-05-11 02:03:10*/
/* DUPLICATOR_PRO_MYSQLDUMP_EOF */
